<?php

class mam_app_settings_data_manager
{

    private $database_version = 18;

    private $account_code;

    public function __construct()
    {

        $this->account_code = get_option( 'local-app-account_code' );

        add_filter( 'mam_app_settings_get_setting', array( $this, 'get_setting' ), 10, 4 );
        add_filter( 'mam_app_settings_set_setting', array( $this, 'set_setting' ), 10, 5 );
        add_filter( 'mam_app_settings_get_buttons', array( $this, 'get_buttons' ), 10, 3 );
        add_filter( 'mam_app_settings_set_button', array( $this, 'set_button' ), 10, 4 );
        add_filter( 'mam_app_settings_button_order', array( $this, 'button_order' ), 10, 3 );
        add_filter( 'mam_app_settings_delete_button', array( $this, 'delete_button' ) , 10 , 2);
        add_filter( 'mam_app_settings_get_layout_settings', array( $this, 'get_layout_settings' ), 10, 2 );
        add_filter( 'mam_app_settings_set_layout_settings', array( $this, 'set_layout_settings' ), 10, 3 );
        add_filter( 'mam_app_settings_get_content_section_settings', array( $this, 'get_content_section_settings' ), 10, 2 );
        add_filter( 'mam_app_settings_set_content_section_settings', array( $this, 'set_content_section_settings' ), 10, 3 );
        add_filter( 'mam_app_settings_get_home_screen_stack', array( $this, 'get_home_screen_stack' ), 10, 2 );
        add_filter( 'mam_app_settings_set_home_screen_stack', array( $this, 'set_home_screen_stack' ), 10, 3 );
        add_filter( 'mam_app_settings_get_home_screen_categories', array( $this, 'get_home_screen_categories' ), 10, 2 );
        add_filter( 'mam_app_settings_set_home_screen_categories', array( $this, 'set_home_screen_categories' ), 10, 3 );

        //add_filter('pre_option', array( $this, 'filter_all_options'), 10, 3);

    }

    function filter_all_options($value, $option, $default) {
        global $mam_setting_user_role;
        if( ! $mam_setting_user_role )
        {
            $mam_setting_user_role = 'mam-all';
            if( mam_user_id() > 0 ) {
                $user = mam_user();
                $all_roles = $user->roles;

                foreach($all_roles as $role ) {
                    $this_role_slug = 'mam-user-roles-to-manage-' . $role;
                    if (get_option($this_role_slug)) {
                        $mam_setting_user_role = $role;
                        break;
                    }
                }
            }
        }

        if( isset($_REQUEST['pid'] )) {
            mamdebug('optionrole', $mam_setting_user_role);
        }

        $mam_value = $this->get_setting($value, $mam_setting_user_role, 'general_settings', $option);
        if( !empty($mam_value) ){
            mamdebug('optionvalue', $mam_value);
            return $mam_value;
        }

        return $value;
    }

    function get_setting( $value, $role, $button_id,  $key )
    {

        if( $role == '' ) $role = 'mam-all';

        global $wpdb;
        $table_name = $wpdb->prefix . 'mam_app_settings_options';

        $results = $wpdb->get_results( 'SELECT * FROM ' . $table_name . ' WHERE button_id LIKE "' . $button_id .'" AND role LIKE "'.$role.'" AND setting_key LIKE "' . $key .'"' , ARRAY_A );
        if( sizeof($results) > 0 ) {
            return $results[0]['value'];
        }
        $results = $wpdb->get_results( 'SELECT * FROM ' . $table_name . ' WHERE button_id LIKE "' . $button_id .'" AND role LIKE "mam-all" AND setting_key LIKE "' . $key .'"' , ARRAY_A );
        if( sizeof($results) > 0 ) {
            return $results[0]['value'];
        }

        return $value;

    }

    function set_setting( $status, $role, $button_id, $key, $value )
    {

        if( $role == '' ) $role = 'mam-all';

        global $wpdb;
        $table_name = $wpdb->prefix . 'mam_app_settings_options';

        $type = 'unk';
        $results = $wpdb->get_results( 'SELECT * FROM ' . $table_name . ' WHERE setting_key LIKE "' . $key .'"' , ARRAY_A );
        if( sizeof($results) > 0 ) {
            $type = $results[0]['type'];
        }

        $results = $wpdb->get_results( 'SELECT * FROM ' . $table_name . ' WHERE button_id LIKE "' . $button_id .'" AND role LIKE "'.$role.'" AND setting_key LIKE "' . $key .'"' , ARRAY_A );

        if( sizeof($results) == 0 ) {
            $wpdb->insert( $table_name, array( 'acct_code' => $this->account_code, 'button_id' => $button_id, 'type' => $type, 'app_id' => 'unk', 'setting_key' => $key, 'role' => $role, 'value' => $value ) );
        } else {
            $wpdb->update( $table_name, array( 'acct_code' => $this->account_code, 'value' => $value , 'type' => $type ), array( 'button_id' => $button_id, 'role' => $role, 'setting_key' => $key ) );
        }

        return $status;

    }

    function get_layout_settings( $value, $button_id )
    {

        global $wpdb;
        $table_name = $wpdb->prefix . 'mam_app_settings_layouts';

        $results = $wpdb->get_results( 'SELECT * FROM ' . $table_name . ' WHERE button_id LIKE "' . $button_id .'"' , ARRAY_A );
        if( sizeof($results) > 0 ) {
            //mamdebug( 'layout', maybe_unserialize( $results[0]['setting_data'] ));
            return maybe_unserialize( $results[0]['setting_data'] );
        }

        return $value;

    }

    function set_layout_settings( $status, $button_id, $settings )
    {

        global $wpdb;
        $table_name = $wpdb->prefix . 'mam_app_settings_layouts';

        $layout = maybe_serialize( $settings );
        $results = $wpdb->get_results( 'SELECT * FROM ' . $table_name . ' WHERE button_id LIKE "' . $button_id .'"' , ARRAY_A );
        if( sizeof($results) == 0 ) {
            $wpdb->insert( $table_name, array( 'acct_code' => $this->account_code, 'button_id' => $button_id, 'setting_data' => $layout ) );
        } else {
            $wpdb->update( $table_name, array( 'acct_code' => $this->account_code, 'setting_data' => $layout ), array( 'button_id' => $button_id ) );
        }

        $results = $wpdb->get_results( 'SELECT * FROM ' . $table_name . ' WHERE button_id LIKE "' . $button_id .'"' , ARRAY_A );
        //mamdebug('layout', $results );


        return $status;
    }

    function get_content_section_settings( $value, $button_id )
    {

        global $wpdb;
        $table_name = $wpdb->prefix . 'mam_app_settings_content_sections';

        $results = $wpdb->get_results( 'SELECT * FROM ' . $table_name . ' WHERE button_id LIKE "' . $button_id .'"' , ARRAY_A );
        if( sizeof($results) > 0 ) {
            //mamdebug( 'layout', maybe_unserialize( $results[0]['setting_data'] ));
            return maybe_unserialize( $results[0]['setting_data'] );
        }

        return $value;

    }

    function set_content_section_settings( $status, $button_id, $settings )
    {

        global $wpdb;
        $table_name = $wpdb->prefix . 'mam_app_settings_content_sections';

        $layout = maybe_serialize( $settings );
        $results = $wpdb->get_results( 'SELECT * FROM ' . $table_name . ' WHERE button_id LIKE "' . $button_id .'"' , ARRAY_A );
        if( sizeof($results) == 0 ) {
            $wpdb->insert( $table_name, array( 'acct_code' => $this->account_code, 'button_id' => $button_id, 'setting_data' => $layout ) );
        } else {
            $wpdb->update( $table_name, array( 'acct_code' => $this->account_code, 'setting_data' => $layout ), array( 'button_id' => $button_id ) );
        }

        $results = $wpdb->get_results( 'SELECT * FROM ' . $table_name . ' WHERE button_id LIKE "' . $button_id .'"' , ARRAY_A );
        mamdebug('contentsection', $results );

        return $status;
    }

    function button_order( $button_array, $location , $role )
    {

        global $wpdb;
        $table_name = $wpdb->prefix . 'mam_app_settings_buttons';

        $order = 0;
        foreach( $button_array as $button )
        {
            $wpdb->get_results( 'UPDATE ' . $table_name . ' SET button_order = ' . $order . ' WHERE button_id LIKE "' . $button['id'] . '"' );
            $order++;
        }

        return $button_array;
    }

    function delete_button( $button_array, $button_id )
    {

        global $wpdb;
        $table_name = $wpdb->prefix . 'mam_app_settings_buttons';
        $wpdb->get_results( 'DELETE FROM ' . $table_name . ' WHERE button_id LIKE "' . $button_id . '"' );

        return $button_array;
    }

    function get_buttons( $status, $role, $location )
    {
        if( $role == '' ) $role = 'mam-all';

        global $wpdb;
        $table_name = $wpdb->prefix . 'mam_app_settings_buttons';

        $button_array = array();
        $results = $wpdb->get_results( 'SELECT * FROM ' . $table_name . ' WHERE role LIKE "'.$role.'" AND location LIKE "' . $location .'" ORDER BY button_order' , ARRAY_A );

        foreach( $results as $button )
        {
            $button_array[] = array( 'id' => $button['button_id'], 'name' => $button['name'], 'icon' => $button['icon_url'], 'type' => $button['type'],  'source' => $button['source'] );
        }

        return $button_array;
    }

    function set_button( $button_id, $role, $location, $button )
    {

        if( $role == '' ) $role = 'mam-all';

        global $wpdb;
        $table_name = $wpdb->prefix . 'mam_app_settings_buttons';

        $results = $wpdb->get_results('SELECT * FROM ' . $table_name . ' WHERE button_id LIKE "' . $button_id . '"', ARRAY_A);
        if (sizeof($results) == 0) {
            $order = $wpdb->get_var( 'SELECT MAX(button_order) FROM ' . $table_name . ' WHERE role LIKE "'.$role.'" AND location LIKE "' . $location .'"' );
            if( ! $order ) $order = 0;
            $wpdb->insert($table_name, array('acct_code' => $this->account_code, 'location' => $location, 'role' => $role, 'button_id' => $button['id'], 'name' => $button['name'], 'icon_url' => $button['icon'], 'type' => $button['type'], 'source' => $button['source'] , 'button_order' => $order ));
        } else {
            $wpdb->update($table_name, array('acct_code' => $this->account_code, 'name' => $button['name'], 'icon_url' => $button['icon'], 'type' => $button['type'], 'source' => $button['source'] ), array('button_id' => $button_id ));
        }

    }

    function migrate_buttons( $reload = false )
    {

        if( ! $reload && get_option( 'migrated_buttons' ) ) return;

        global $wpdb;

        $query = "
            SELECT option_name, option_value
            FROM {$wpdb->prefix}options
            WHERE option_name LIKE 'local-app-button-array%'";

        $results = $wpdb->get_results($query, ARRAY_A);

        $processed_options = [];
        foreach ($results as $result) {
            $role = str_replace( 'local-app-button-array', '',  $result['option_name']);
            if( strlen($role) == 0 ) $role = 'mam-all';
            $value = maybe_unserialize($result['option_value']);
            if( is_array($value) && sizeof($value) > 0 ) {
                $processed_options['main'][$role] = $value;
            }
        }

        $query = "
            SELECT option_name, option_value
            FROM {$wpdb->prefix}options
            WHERE option_name LIKE 'local-app-left-menu-array%'";

        $results = $wpdb->get_results($query, ARRAY_A);

        $table_name = $wpdb->prefix . 'mam_app_settings_buttons';

        foreach ($results as $result) {
            $role = str_replace( 'local-app-left-menu-array', '',  $result['option_name']);
            if( strlen($role) == 0 ) $role = 'mam-all';
            $value = maybe_unserialize($result['option_value']);
            if( is_array($value) && sizeof($value) > 0 ) {
                $processed_options['left'][$role] = $value;
            }
        }

        $wpdb->get_results('DELETE FROM ' . $table_name );

        foreach( $processed_options['main'] as $role => $buttons )
        {
            $order = 0;
            foreach( $buttons as $button )
            {
                $results = $wpdb->get_results('SELECT * FROM ' . $table_name . ' WHERE button_id LIKE "' . $button['id'] . '" AND role LIKE "' . $role . '"', ARRAY_A);
                if (sizeof($results) == 0) {
                    $wpdb->insert($table_name, array('acct_code' => $this->account_code, 'location' => 'main', 'role' => $role, 'button_id' => $button['id'], 'name' => $button['name'], 'icon_url' => $button['icon'], 'type' => $button['type'], 'source' => $button['source'] , 'button_order' => $order ));
                } else {
                    $wpdb->update($table_name, array('acct_code' => $this->account_code, 'name' => $button['name'], 'icon_url' => $button['icon'], 'type' => $button['type'], 'source' => $button['source'] , 'button_order' => $order), array('button_id' => $button['id'], 'role' => $role));
                }
                $order++;
            }
        }

        foreach( $processed_options['left'] as $role => $buttons )
        {
            $order = 0;
            foreach( $buttons as $button )
            {
                $results = $wpdb->get_results('SELECT * FROM ' . $table_name . ' WHERE button_id LIKE "' . $button['id'] . '" AND role LIKE "' . $role . '"', ARRAY_A);
                if (sizeof($results) == 0) {
                    $wpdb->insert($table_name, array('acct_code' => $this->account_code, 'location' => 'left', 'role' => $role, 'button_id' => $button['id'], 'name' => $button['name'], 'icon_url' => $button['icon'], 'type' => $button['type'], 'source' => $button['source'], 'button_order' => $order ));
                } else {
                    $wpdb->update($table_name, array('acct_code' => $this->account_code, 'name' => $button['name'], 'icon_url' => $button['icon'], 'type' => $button['type'], 'source' => $button['source'], 'button_order' => $order ), array('button_id' => $button['id'], 'role' => $role));
                }
                $order++;
            }
        }

        update_option( 'migrated_buttons' , true );

    }

    function migrate_sections( $reload = false )
    {
        if( ! $reload && get_option( 'migrated_sections' ) ) return;

        $layout_settings = get_option( 'mam-content-sections-options' );
        $layout_settings = maybe_unserialize( $layout_settings );

        if( !is_array($layout_settings) ) return;

        global $wpdb;
        $table_name = $wpdb->prefix . 'mam_app_settings_content_sections';

        foreach( $layout_settings as $key => $layout )
        {
            $layout = maybe_serialize( $layout['content_settings'] );
            $results = $wpdb->get_results( 'SELECT * FROM ' . $table_name . ' WHERE button_id LIKE "' . $key .'"' , ARRAY_A );
            if( sizeof($results) == 0 ) {
                $wpdb->insert( $table_name, array( 'acct_code' => $this->account_code, 'button_id' => $key, 'setting_data' => $layout ) );
            } else {
                $wpdb->update( $table_name, array( 'acct_code' => $this->account_code, 'setting_data' => $layout ), array( 'button_id' => $key ) );
            }
        }

        $results = $wpdb->get_results( 'SELECT * FROM ' . $table_name . ' WHERE button_id LIKE "' . $key .'"' , ARRAY_A );
        mamdebug('sections', $results);

        update_option( 'migrated_sections' , true );

    }

    function migrate_layouts( $reload = false )
    {

        if( ! $reload &&  get_option( 'migrated_layouts' ) ) return;

        $layout_settings = get_option( 'mam-layout-options');
        $layout_settings = maybe_unserialize( $layout_settings );

        if( !is_array($layout_settings) ) return;

        global $wpdb;
        $table_name = $wpdb->prefix . 'mam_app_settings_layouts';

        foreach( $layout_settings as $key => $layout )
        {
            $layout = maybe_serialize( $layout['layout_settings'] );
            $results = $wpdb->get_results( 'SELECT * FROM ' . $table_name . ' WHERE button_id LIKE "' . $key .'"' , ARRAY_A );
            if( sizeof($results) == 0 ) {
                $wpdb->insert( $table_name, array( 'acct_code' => $this->account_code, 'button_id' => $key, 'setting_data' => $layout ) );
            } else {
                $wpdb->update( $table_name, array( 'acct_code' => $this->account_code, 'setting_data' => $layout ), array( 'button_id' => $key ) );
            }
        }

        update_option( 'migrated_layouts' , true );
    }

    function migrate_app_settings( $reload = false )
    {

        if( ! $reload && get_option( 'migrated_app_settings' ) ) return;

        $setting_handler = new mam_app_settings_admin_page();
        $settings = $setting_handler->settings_array;

        //get display settings
        $screen_settings  = $setting_handler->get_view_controller_specific_settings();
        foreach( $screen_settings as $key => $setting )
        {
            $settings[] = $setting;
        }

        //get app_settings from content classes
        global $local_app_content;
        foreach( $local_app_content as $data_array )
        {
            if (class_exists($data_array['class'])) {
                $content_class = $data_array['class'];
                $content_class = new $content_class();
                if (method_exists($content_class, 'app_settings'))
                {
                    $settings_array = $content_class->app_settings();
                    foreach ($settings_array as $key => $setting) {
                        $settings[] = $setting;
                    }
                }
            }
        }

        global $wpdb;
        $table_name = $wpdb->prefix . 'mam_app_settings_options';

        foreach( $settings as $setting )
        {

            $value = get_option( $setting['id'] );

            if( !empty($value)) {
                if( is_array($value)) {
                    foreach( $value as $role => $role_value ) {

                        $button_id = key($role_value);
                        $this_value = $role_value[$button_id];

                        $results = $wpdb->get_results( 'SELECT * FROM ' . $table_name . ' WHERE button_id LIKE "' . $button_id .'" AND role LIKE "'.$role.'" AND setting_key LIKE "' . $setting['id'] .'"' , ARRAY_A );

                        if( sizeof($results) == 0 ) {
                            $wpdb->insert( $table_name, array( 'acct_code' => $this->account_code, 'button_id' => $button_id, 'type' => $setting['type'], 'app_id' => $setting['variable'], 'setting_key' => $setting['id'], 'role' => $role, 'value' =>  $this_value ) );
                        } else {
                            $wpdb->update( $table_name, array( 'acct_code' => $this->account_code, 'value' => $this_value ), array( 'button_id' => $button_id, 'role' => $role, 'setting_key' => $setting['id'] ) );
                        }
                    }
                }
            }
        }

        update_option( 'migrated_app_settings' , true );

    }

    function get_home_screen_stack( $stack, $role )
    {

        if( $role == '' ) $role = 'mam-all';

        global $wpdb;
        $section_table_name = $wpdb->prefix . 'mam_app_settings_home_screen_stack';
        $detail_table_name = $wpdb->prefix . 'mam_app_settings_home_screen_stack_details';

        $sections_array = array();
        $sections = $wpdb->get_results( 'SELECT * FROM ' . $section_table_name . ' WHERE role LIKE "' . $role .'" ORDER BY section_order' , ARRAY_A );
        foreach( $sections as $section )
        {
            $section_id = $section['section_id'];
            $section_details = $wpdb->get_results( 'SELECT * FROM ' . $detail_table_name . ' WHERE section_id LIKE "' . $section_id .'"' , ARRAY_A );
            $section_array = array();
            $section_array['mam-hs-section-type'] = $section['type'];
            foreach( $section_details as $detail )
            {
                $section_array[$detail['setting_key']] = maybe_unserialize( $detail['value'] );
            }
            $sections_array['section'][$section_id] = $section_array;
        }

        return $sections_array;

    }

    function set_home_screen_stack( $status, $stack, $role  )
    {

        if( $role == '' ) $role = 'mam-all';

        global $wpdb;
        $section_table_name = $wpdb->prefix . 'mam_app_settings_home_screen_stack';
        $detail_table_name = $wpdb->prefix . 'mam_app_settings_home_screen_stack_details';

        $wpdb->get_results('DELETE FROM ' . $section_table_name . ' WHERE role LIKE "' . $role .'"');
        $wpdb->get_results('DELETE FROM ' . $detail_table_name . ' WHERE role LIKE "' . $role .'"');

        foreach ($stack['section'] as $section_id => $section) {
            $order = 0;
            foreach ($section as $section_type => $section_value) {
                mamdebug('section', $section);
                if ($section_type == 'mam-hs-section-type') {
                    $wpdb->insert($section_table_name, array('acct_code' => $this->account_code, 'section_id' => $section_id, 'type' => maybe_serialize( $section_value ), 'role' => $role, 'section_order' => $order));
                    mamdebug('setting db error', $wpdb->last_error);
                    $order++;
                } else {
                    $wpdb->insert($detail_table_name, array('acct_code' => $this->account_code, 'section_id' => $section_id, 'setting_key' => $section_type, 'value' => maybe_serialize( $section_value )));
                    mamdebug('setting db error', $wpdb->last_error);
                }
            }
        }

        return true;

    }

    function migrate_homescreen_stack( $reload = false )
    {

        if( ! $reload && get_option( 'migrated_app_homes_screen_stack' ) ) return;

        $stack = get_option( '_mam_home_stack' );

        global $wpdb;
        $section_table_name = $wpdb->prefix . 'mam_app_settings_home_screen_stack';
        $detail_table_name = $wpdb->prefix . 'mam_app_settings_home_screen_stack_details';

        $wpdb->get_results('DELETE FROM ' . $section_table_name);
        $wpdb->get_results('DELETE FROM ' . $detail_table_name);

        foreach( $stack as $role => $role_sections )
        {
            $order = 0;
            foreach( $role_sections['section'] as $section_id => $section )
            {
                foreach( $section as $section_type => $section_value ) {
                    mamdebug('section', $section);
                    if($section_type == 'mam-hs-section-type') {
                        $wpdb->insert($section_table_name, array('acct_code' => $this->account_code, 'section_id' => $section_id, 'type' => maybe_serialize( $section_value ), 'role' => $role, 'section_order' => $order));
                        mamdebug('setting db error', $wpdb->last_error);
                        $order++;
                    }else {
                        $wpdb->insert($detail_table_name, array('acct_code' => $this->account_code, 'section_id' => $section_id, 'setting_key' => $section_type, 'value' => maybe_serialize( $section_value ) ));
                        mamdebug('setting db error', $wpdb->last_error);
                    }
                }
            }
        }

        update_option( 'migrated_app_homes_screen_stack' , true );

    }

    function get_home_screen_categories(  $categories, $role )
    {

        if( $role == '' ) $role = 'mam-all';

        global $wpdb;
        $table_name = $wpdb->prefix . 'mam_app_settings_home_screen_categories';
        $results = $wpdb->get_results( 'SELECT * FROM ' . $table_name . ' WHERE role LIKE "' . $role .'" ORDER BY cat_order' , ARRAY_A );
        foreach( $results as $result )
        {
            $categories[] = array( 'taxonomy' => $result['taxonomy'], 'term' => $result['term'], 'sort' => $result['sort'], 'order' => $result['sort_order'] );
        }

        return $categories;

    }

    function set_home_screen_categories( $status, $categories, $role )
    {

        if( $role == '' ) $role = 'mam-all';

        global $wpdb;
        $table_name = $wpdb->prefix . 'mam_app_settings_home_screen_categories';

        $wpdb->get_results('DELETE FROM ' . $table_name . ' WHERE role LIKE "' . $role .'"');

        foreach( $categories as $order => $category )
        {
            $wpdb->insert($table_name, array('acct_code' => $this->account_code, 'role' => $role, 'cat_order' => $order, 'taxonomy' => $category['taxonomy'], 'term' => $category['term'], 'sort' => $category['sort'], 'sort_order' => $category['order']));
            mamdebug('setting db error', $wpdb->last_error);
        }

        return $status;

    }

    function migrate_home_screen_categories( $reload = false )
    {

        if( !$reload && get_option( 'migrated_app_home_categories' ) ) return;

        $home_cat_data = get_option( '_mam_home_cat_sections', true);

        global $wpdb;
        $table_name = $wpdb->prefix . 'mam_app_settings_home_screen_categories';

        $wpdb->get_results('DELETE FROM ' . $table_name);
        foreach( $home_cat_data as $role => $role_cats )
        {
            $order = 0;
            foreach( $role_cats as $cat )
            {
                $wpdb->insert($table_name, array('acct_code' => $this->account_code, 'role' => $role, 'cat_order' => $order, 'taxonomy' => $cat['taxonomy'], 'term' => $cat['term'], 'sort' => $cat['sort'], 'sort_order' => $cat['order']));
                mamdebug('setting db error', $wpdb->last_error);
                $order++;
            }
        }

        update_option( 'migrated_app_home_categories' , true );


    }


    function manage_database()
    {

        $installed_ver = get_option( 'settings_db_version' );
        global $wpdb;

        $drop_table = false;

        if($installed_ver != $this->database_version ){

            //$drop_table = true;

            require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

            $charset_collate = $wpdb->get_charset_collate();

            $table_name = $wpdb->prefix . 'mam_app_settings_buttons';

            if($drop_table) $wpdb->get_results('DROP TABLE ' . $table_name );

            $sql = "CREATE TABLE $table_name (
                  `this_index` int(11) NOT NULL AUTO_INCREMENT,
                  `acct_code` varchar(20) NULL,
                  `location` varchar(11) NOT NULL,
                  `button_order` varchar(11) NOT NULL,
                  `role` varchar(100) NOT NULL,                  
                  `button_id` varchar(250) NULL,
                  `name` varchar(100) NULL,
                  `icon_url` varchar(250) NULL,              
                  `type` varchar(150) NULL,
                  `source` varchar(150) NULL,
                  PRIMARY KEY (`this_index`)
                ) $charset_collate;";

            dbDelta($sql);

            $table_name = $wpdb->prefix . 'mam_app_settings_layouts';

            if($drop_table) $wpdb->get_results('DROP TABLE ' . $table_name );

            $sql = "CREATE TABLE $table_name (
                  `this_index` int(11) NOT NULL AUTO_INCREMENT,
                  `acct_code` varchar(20) NULL,
                  `button_id` varchar(250) NOT NULL,
                  `setting_data` TEXT NULL,
                  PRIMARY KEY (`this_index`)
                ) $charset_collate;";

            dbDelta($sql);

            $table_name = $wpdb->prefix . 'mam_app_settings_content_sections';

            if($drop_table) $wpdb->get_results('DROP TABLE ' . $table_name );

            $sql = "CREATE TABLE $table_name (
                  `this_index` int(11) NOT NULL AUTO_INCREMENT,
                  `acct_code` varchar(20) NULL,
                  `button_id` varchar(250) NOT NULL,
                  `setting_data` TEXT NULL,
                  PRIMARY KEY (`this_index`)
                ) $charset_collate;";

            dbDelta($sql);

            $table_name = $wpdb->prefix . 'mam_app_settings_options';

            if($drop_table) $wpdb->get_results('DROP TABLE ' . $table_name );

            $sql = "CREATE TABLE $table_name (
                  `this_index` int(11) NOT NULL AUTO_INCREMENT,
                  `acct_code` varchar(20) NULL,
                  `button_id` varchar(250) NOT NULL,
                  `type` varchar(25) NOT NULL,
                  `app_id` varchar(256) NOT NULL,
                  `setting_key` varchar(256) NOT NULL,
                  `role` varchar(100) NOT NULL,              
                  `value` TEXT NULL,
                  PRIMARY KEY (`this_index`)
                ) $charset_collate;";

            dbDelta($sql);

            $table_name = $wpdb->prefix . 'mam_app_settings_home_screen_stack';

            if($drop_table) $wpdb->get_results('DROP TABLE ' . $table_name );

            $sql = "CREATE TABLE $table_name (
                  `this_index` int(11) NOT NULL AUTO_INCREMENT,
                  `acct_code` varchar(20) NULL,
                  `section_id` varchar(250) NOT NULL,
                  `type` varchar(25) NOT NULL,
                  `role` varchar(100) NOT NULL,              
                  `section_order` varchar(11) NOT NULL,
                  PRIMARY KEY (`this_index`)
                ) $charset_collate;";

            dbDelta($sql);

            $table_name = $wpdb->prefix . 'mam_app_settings_home_screen_stack_details';

            if($drop_table) $wpdb->get_results('DROP TABLE ' . $table_name );

            $sql = "CREATE TABLE $table_name (
                  `this_index` int(11) NOT NULL AUTO_INCREMENT,
                  `acct_code` varchar(20) NULL,
                  `section_id` varchar(250) NOT NULL,
                  `setting_key` varchar(100) NOT NULL,
                  `value` TEXT NULL,              
                  PRIMARY KEY (`this_index`)
                ) $charset_collate;";

            dbDelta($sql);

            $table_name = $wpdb->prefix . 'mam_app_settings_home_screen_categories';

            if($drop_table) $wpdb->get_results('DROP TABLE ' . $table_name );

            $sql = "CREATE TABLE $table_name (
                  `this_index` int(11) NOT NULL AUTO_INCREMENT,
                  `acct_code` varchar(20) NULL,
                  `role` varchar(180) NOT NULL,
                  `cat_order` varchar(11) NOT NULL,
                  `taxonomy` varchar(256) NOT NULL,
                  `term` varchar(256) NOT NULL,
                  `sort` varchar(128) NULL,
                  `sort_order` varchar(48) NULL,
                  PRIMARY KEY (`this_index`)
                ) $charset_collate;";

            dbDelta($sql);

//                mamdebug('setting db error', $wpdb->last_error);
//                mamdebug('setting db',  $wpdb->last_query);

            update_option( 'settings_db_version' , $this->database_version );

        }

        $refresh = false;
        if( $refresh )
        {
            $table_name = $wpdb->prefix . 'mam_app_settings_buttons';
            $wpdb->get_results('DELETE FROM ' . $table_name );
            delete_option( 'migrated_buttons' );
        }

        $this->migrate_buttons( $drop_table );
        $this->migrate_layouts( $drop_table );
        $this->migrate_sections( $drop_table );
        $this->migrate_app_settings( $drop_table );
        $this->migrate_homescreen_stack( $drop_table );
        $this->migrate_home_screen_categories( $drop_table );

    }
}
