<?php

class mam_app_settings_button_manager{

    public $settings_array = array();
    private $cat_array = array();
    public $global_settings_array = array();
    public $admin_handler;
//    private $vc_type_settings;
    private $detail_screen_settings = array();
    private $detail_screen_options = array();

    public $content_class;
    public $content_class_name = '';
    private $detail_screen_setup = array();
    private $detail_screen_tabs = array();

    function __construct( $button_id )
    {

        $this->admin_handler = new mam_app_settings_admin_page();
        $this->global_settings_array = $this->admin_handler->settings_array;

        $role = '';
    	if(isset($_REQUEST['role'])) $role = $_REQUEST['role'];
    	//if($role == 'mam-all' ) $role = 'mam-all';

        $button_array = apply_filters( 'mam_app_settings_get_buttons', false, $role, 'main' );
        $left_menu = apply_filters( 'mam_app_settings_get_buttons', false, $role, 'left' );

        foreach( $left_menu as $item ){
            $button_array[] =  $item;
        }

        global $local_app_content;
        $content_class = null;

        $layout_manager_classes = array( 'list', 'offDirectory', 'calendar', 'favorites' );

		foreach($button_array as $item ){

		    if( $item['id'] == $button_id ){

                $vc_type = '';

		        foreach( $local_app_content as $index => $classes ){
    	            if( $index == $item['type'] ){
                        $content_class = $classes['class'];
                        $vc_type = $classes['vc_type'];
                        $this->content_class_name = $classes['class'];
                    }
                }

                if(class_exists( $content_class ) ) {

                    $this->content_class = new $content_class();

                    if (method_exists($this->content_class, 'app_settings')) {
                        $this->settings_array = $this->content_class->app_settings();
                    }
                    if (method_exists($this->content_class, 'app_settings_catagories')) {
                        $this->cat_array = $this->content_class->app_settings_catagories();
                    }

                    $vc_settings = $this->admin_handler->get_view_controller_specific_settings( $local_app_content[$item['type']]['vc_type'] );
                    if($vc_settings){
                        foreach( $vc_settings as $setting ){
                            $this->settings_array[] = $setting;
                        }
                        $this->cat_array[] = array( 'title' => 'Screen Type' , 'slug' => $local_app_content[$item['type']]['vc_type'] );

                    }

                    if (method_exists( $this->content_class, 'detail_screen_settings' ) && method_exists( $this->content_class, 'detail_screen_options' ) ) {
                        $this->detail_screen_settings = $this->content_class->detail_screen_settings();
                        $this->detail_screen_options = $this->content_class->detail_screen_options();
                    }

                    if( in_array( $vc_type , $layout_manager_classes ) ) {
                        $this->detail_screen_setup[] = array('title' => 'Layout Manager', 'slug' => 'layout_manager' );
                        $this->detail_screen_setup[] = array('title' => 'Content Sections', 'slug' => 'content_sections_manager' );
                    }

                }
            }
        }

        if( get_option('tsl-setting-mam_theme_color_dark') ) {
            $dark_color = get_option('tsl-setting-mam_theme_color_dark');
            $light_color = get_option('tsl-setting-mam_theme_color_light');

            foreach ($this->settings_array as $index => $setting) {
                if ($setting['type'] == 'color') {
                    if( isset( $setting['no_default'] ) ) continue;
                    if (isset($setting['default'])) {
                        if ($setting['default'] == '#000000') {
                            $this->settings_array[$index]['default'] = $dark_color;
                        } else if ($setting['default'] == '#ffffff') {
                            $this->settings_array[$index]['default'] = $light_color;
                        }
                    }
                }
            }
        }

		$this->cat_array[] = array( 'title' => 'Settings' , 'slug' => 'button' );

    }

    function do_button( $button_id ){

        $html = 'No settings for this content type';

        if( sizeof( $this->settings_array ) > 0 || sizeof( $this->global_settings_array ) > 0 ){

            $this->settings_array = apply_filters( 'mam_filter_settings_for_public_use', $this->settings_array );
            $this->global_settings_array = apply_filters( 'mam_filter_settings_for_public_use', $this->global_settings_array );

            if( method_exists( $this->content_class, 'settings_content_tabs') )
            {
                $tabs = $this->content_class->settings_content_tabs();
                if( is_array($tabs) && sizeof($tabs) > 0 )
                {
                    $role = $_REQUEST['role'];
                    $subtab = 'general_settings';
                    if(isset($_REQUEST['subtab'])) $subtab = $_REQUEST['subtab'];

                    $current = $tabs[0]['content'];
                    if(isset($_REQUEST['subtab'])) $current = $_REQUEST['subtab'];

                    $actual_link = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[SCRIPT_NAME]";
                    $actual_link = str_replace('__wp__/','', $actual_link );

                    $html = '';

                    $html .= '<div id="icon-themes" class="icon32"><br></div>';
                    $html .= '<h2 class="nav-tab-wrapper">';

                    foreach( $tabs as $tab => $name ){
                        $class = ( $name['content'] == $subtab ) ? ' nav-tab-active' : '';
                        $html .= "<a class='nav-tab$class' href='".$actual_link."?page=mam-app-settings&tab=".$_REQUEST['tab']."&role=$role&subtab=".$name['content']."'>".$name['title']."</a>";

                    }

                    $html .= '</h2>';

                    $html .= '<div class="local-app-tab-separator">&nbsp;</div>';

                    switch ($current) {
                        case 'general_settings':
                            $html .= $this->display_settings();
                            break;
                        case 'layout_settings':
                            //$html .= mam_admin_settings::sub_heading('Layout Settings');
                            $html .= $this->get_screen_settings( 'layout_manager' );
                            break;
                        case 'content_sections':
                            //$html .= mam_admin_settings::sub_heading('Content Settings');
                            $html .= $this->get_screen_settings( 'content_sections_manager' );
                            break;
                        case 'add_item_settings':
                            //todo
                            break;
                        default:
                          //  $html .= $this->display_settings();
                    }

                }

                return $html;
            }else {
                return $this->display_settings();
            }
        }

        return $html;
    }

    function display_settings(){

		$html_line = '<div class="tsl-admin-settings-holder">';

		global $wp_roles;
        $all_roles = $wp_roles->roles;
        $role_array = array();
        if($_REQUEST['role'] != 'mam-all') {
            $role_array[] = array('slug' => 'mam-all', 'name' => "Any User Not Logged In");
        }
        foreach ($all_roles as $role_index => $role) {
            if (get_option('mam-user-roles-to-manage-' . $role_index) == 'yes' && $_REQUEST['role'] != $role_index) {
                $role_array[] = array('slug' => $role_index, 'name' => $role['name']);
            }
        }

        if( is_array($role_array) && sizeof($role_array) > 1 ) {

            $admin_settings_handler = new mam_app_settings_admin_page();
            $buttons_array = array();
            $role = 'mam-all';
            if(isset($_REQUEST['role'])) $role = $_REQUEST['role'];

            $button_array = apply_filters( 'mam_app_settings_get_buttons', false, $role, 'main' );

            if( is_array($button_array)) {
                foreach ($button_array as $button) {
                    if($_REQUEST['tab'] == $button['id']) continue;
                    $buttons_array[] = array('slug' => $button['id'], 'name' => 'Main - ' . $button['name']);
                }
            }

            $left_menu = apply_filters( 'mam_app_settings_get_buttons', false, $role, 'main' );

            if( is_array($left_menu)) {
                foreach ($left_menu as $button) {
                    if($_REQUEST['tab'] == $button['id']) continue;
                    $buttons_array[] = array('slug' => $button['id'], 'name' => 'Left - ' . $button['name']);
                }
            }

            $html_line .= '<div class="tsl-admin-settings-holder">';
            $html_line .= '<form method="POST">';
            $html_line .= '<input type="hidden" value="mam-app-settings" name="page">';
            $html_line .= '<input type="hidden" name="tab" id="tab" value="' . $_REQUEST['tab'] . '">';
            $html_line .= '<input type="hidden" name="clone_settings" id="clone_settings" value="1">';

            $html_line .= '<table class="tsl-admin-pref-table">';
            $html_line .= '<tr>';
            $html_line .= '<td align="right">Clone from Role: ' . $admin_settings_handler->make_dropdown('clone-settings-from-role', $role_array, '') . ' select button: ' . $admin_settings_handler->make_dropdown('clone-button', $buttons_array, '') . '</td>';
            $html_line .= '<td></td>';
            $html_line .= '<td>' . mam_admin_settings::submit_button('Clone Settings') . '</td>';
            $html_line .= '</tr>';
            $html_line .= '</table>';

            $html_line .= '</form>';
            $html_line .= '</div>';
        }
		//$html_line .= mam_admin_settings::headline('Content Type Settings');

		$html_line .= '<form method="POST">';
        $html_line .= '<input type="hidden" value="'.$_REQUEST['page'].'" name="page">';
        $html_line .= '<input type="hidden" value="'.$_REQUEST['tab'].'" name="tab">';
        $html_line .= '<input type="hidden" value="'.$_REQUEST['role'].'" name="role">';
        $html_line .= '<input type="hidden" value="'.$this->content_class_name.'" name="content_class">';

		foreach( $this->cat_array as $item ){

            $setting_line = '';
            $show_setting = false;

            foreach($this->settings_array as $setting ){
                if($setting['catagory'] == $item['slug'] ){
                    $show_setting = true;
                    $setting_line .= $this->admin_handler->create_variable_option( $setting );
                    $setting_line .= '<hr style="background-color:grey">';
                }
            }

    		if($show_setting) {
    		    $html_line .= '<br>';
                $html_line .= mam_admin_settings::sub_heading($item['title'] . ' Settings');
                $html_line .= $setting_line;
            }
    		$html_line .= '<br>';
        }

		if( sizeof( $this->detail_screen_setup ) > 0 )
		{
		    foreach( $this->detail_screen_setup as $item )
            {
                if ( $item['slug'] == 'content_sections_manager' && ! method_exists($this->content_class, 'default_content_sections')) continue;
                if ( $item['slug'] == 'layout_manager' && ! method_exists($this->content_class, 'default_layout_settings')) continue;
            }
        }


		$html_line .= '<table class="tsl-admin-pref-table">';
		$html_line .= '<tr>';
		$html_line .= '<td></td>';
		$html_line .= '<td></td>';
		$html_line .= '<td>'.mam_admin_settings::submit_button().'</td>';
		$html_line .= '</tr>';

		$html_line .= '</table>';

		$html_line .= '</form>';

		$html_line .= '</div>';

		return $html_line;

	}

    function get_screen_settings( $type )
    {
        if( $type == 'layout_manager' )
        {

            $field_titles = array();
            if (method_exists($this->content_class, 'get_layout_field_keys')) {
                $field_titles = $this->content_class->get_layout_field_keys( array() );
            }
            $dd_options = array();
            $options = $this->define_layout_options();

            foreach ($options as $index => $option )
            {
                $dd_options[] = array( 'name' => 'Layout ' . $index , 'slug' => $index );
            }

            $selected = 1;

            $settings = apply_filters( 'mam_app_settings_get_layout_settings' , false, $_REQUEST['tab'] );

            //todo with Delete After Database Migration
            if( ! $settings ) {

                $layout_settings = get_option('mam-layout-options');
                $layout_settings = maybe_unserialize($layout_settings);

                if (is_array($layout_settings)) {

                    //mamdebug('buttonid', $layout_settings[$_REQUEST['tab']]['layout_settings']);

                    if (isset($layout_settings[$_REQUEST['tab']]['layout_settings'])) {
                        $settings = $layout_settings[$_REQUEST['tab']]['layout_settings'];
                    }
                } else {
                    $settings = array();
                }
            }

            if( isset( $settings['layout_id'] )) $selected = $settings['layout_id'];
            if( isset( $_REQUEST['layout_id']) ) $selected = $_REQUEST['layout_id'];

            $html = '<form action="">';
            $html .= '<input type="hidden" value="'.$_REQUEST["page"].'" name="page">';
            $html .= '<input type="hidden" value="'.$_REQUEST["tab"].'" name="tab">';
            $html .= '<input type="hidden" value="'.$_REQUEST["role"].'" name="role">';
            $html .= '<input type="hidden" value="'.$this->content_class_name.'" name="content_class">';
            $html .= '<input type="hidden" value="'.$_REQUEST["subtab"].'" name="subtab">';
            $html .= '<table class="layout-manager-table" style="width:100%;">';
            $html .= '<tr><td style="width:15em;">List Layout</td><td>' . $this->admin_handler->make_dropdown( 'selected-layout' , $dd_options, $selected ) . '</td></tr>';

            foreach( $options[$selected] as $option )
            {
                $value ='';
                if( isset( $option['id']) && isset( $settings[$option['id']]))
                {
                    $value = $settings[$option['id']];
                }

                switch( $option['type'] )
                {
                    case 'checkbox':
                        $checked = '';
                        if( is_array( $value ) && isset($value['value']) && $value['value'] == 'on')
                        {
                            $checked = 'checked';
                        }
                        $html .= '<input name="layout_settings['.$option['id'].'][id]" type="hidden" value="'.$option['id'].'"/>';
                        $html .= '<input name="layout_settings['.$option['id'].'][type]" type="hidden" value="'.$option['type'].'"/>';
                        $html .= '<tr><td>' .$option['title'] . '</td><td><input name="layout_settings['.$option['id'].'][value]" type="checkbox" '.$checked.'/></td></tr>';
                        break;
                    case 'textfield':
                        $html .= '<input name="layout_settings['.$option['id'].'][id]" type="hidden" value="'.$option['id'].'"/>';
                        $html .= '<input name="layout_settings['.$option['id'].'][type]" type="hidden" value="'.$option['type'].'"/>';
                        if( ! is_array( $value ) ) $value = array( 'value' => '' );
                        $html .= '<tr><td>' .$option['title'] . '</td><td><input name="layout_settings['.$option['id'].'][value]" type="text" value="'.$value['value'].'"/></td></tr>';
                        break;
                    case 'fields':
                        $field = '<table style="width:100%">';
                        $field .= '<tr><td style="font-weight: bold;">Field</td><td style="font-weight: bold;">Key (case sensitive)</td><td  style="font-weight: bold;">Text Color</td><td  style="font-weight: bold;">Font Size</td><td  style="font-weight: bold;">Bold</td></tr>';

                        foreach( $option['fields'] as $item )
                        {

                            $title = '';
                            $color = '#000000';
                            $font_size = '12';
                            $font_bold = '';
                            if( isset( $settings[$item['id']] ))
                            {
                                $title = $settings[$item['id']]['title'];
                                $color = $settings[$item['id']]['color'];
                                $font_size = $settings[$item['id']]['font_size'];
                                if( isset( $settings[$item['id']]['font_bold'] ))
                                {
                                    $font_bold = 'checked';
                                }
                            }

                            $title_dd = '<select name="layout_settings['.$item['id'].'][title]">';
                            $title_dd .= '<option value="">Select Field</option>';
                            foreach( $field_titles as $key)
                            {
                                $selected = '';
                                if( $key == $title ) $selected = 'selected';
                                $title_dd .= '<option value="'.$key.'" '.$selected.'>'.$key.'</option>';
                            }
                            $title_dd .= '</select>';

                            $field .= '<input name="layout_settings['.$item['id'].'][id]" type="hidden" value="'.$item['id'].'"/>';
                            $field .= '<input name="layout_settings['.$item['id'].'][type]" type="hidden" value="'.$item['type'].'"/>';
                            $field .= '<tr><td>'.$item['title'].'</td><td>'.$title_dd.'</td><td><input class="mam-color-picker" name="layout_settings['.$item['id'].'][color]" type="color"  value="'.$color.'" /></td><td><input name="layout_settings['.$item['id'].'][font_size]" type="text" style="width: 4em;"  value="'.$font_size.'"/></td><td><input name="layout_settings['.$item['id'].'][font_bold]" type="checkbox" '.$font_bold.'/></td></tr>';
                        }
                        $field .= '</<table>';
                        $html .= '<tr><td colspan="2">'.$field.'</td></tr>';
                        break;
                    case 'color':
                        $color = '#000000';
                        if( is_array( $value ) ) $color = $value['value']; //default
                        $html .= '<input name="layout_settings['.$option['id'].'][id]" type="hidden" value="'.$option['id'].'"/>';
                        $html .= '<input name="layout_settings['.$option['id'].'][type]" type="hidden" value="'.$option['type'].'"/>';
                        $html .= '<tr><td>' .$option['title'] . '</td><td><input name="layout_settings['.$option['id'].'][value]" type="color" class="mam-color-picker" value="'.$color.'"/></td></tr>';
                        break;
                    case 'select':
                        if(is_array($value) && array_key_exists('value', $value)){
                            $value = $value['value'];
                        }else{
                            $value = '';
                        }
                        $html .= '<tr><td>' .$option['title'] . '</td><td>' . $this->admin_handler->make_dropdown( 'layout_settings['.$option["id"].'][value]' , $option['options'], $value ) . '</td></tr>';
                        break;
                    default:
                        $html .= '<tr><td>' .$option['title'] . '</td></tr>';
                        break;
                }

            }

            $html .= '</table>';
            $html .= '<table class="tsl-admin-pref-table">';
            $html .= '<tr>';
            $html .= '<td></td>';
            $html .= '<td></td>';
            $html .= '<td>'.mam_admin_settings::submit_button().'</td>';
            $html .= '</tr>';
            $html .= '</table>';

            $html .= '</form>';

            return $html;
        }
        if( $type == 'content_sections_manager' )
        {
            if (method_exists($this->content_class, 'default_content_sections')) {
                $sections = $this->content_class->default_content_sections();

                $settings = apply_filters( 'mam_app_settings_get_content_section_settings', false, $_REQUEST['tab'] );

                //todo with Delete After Database Migration
                if( ! $settings ) {
                    $layout_settings = get_option('mam-content-sections-options');
                    $layout_settings = maybe_unserialize($layout_settings);


                    if (is_array($layout_settings)) {

                        if (isset($layout_settings[$_REQUEST['tab']]['content_settings'])) {
                            $settings = $layout_settings[$_REQUEST['tab']]['content_settings'];
                        }
                    } else {
                        $settings = array();
                    }
                }

                if( is_array( $settings) && sizeof( $settings ) > 0 ) {
                    foreach ($sections as $section) {
                        if( ! isset( $settings[$section['id']]))
                        {
                            $settings[$section['id']] = $section;
                        }
                    }

                    $new_sections = array();
                    foreach ($settings as $index => $setting) {
                        foreach ($sections as $section) {
                            if ($section['id'] == $index) {
                                $new_sections[] = $section;
                            }
                        }
                    }

                    $sections = $new_sections;
                }

                $html = '<form action="">';
                $html .= '<div id="content-sections-list">';
                $html .= '<input type="hidden" value="'.$_REQUEST["page"].'" name="page">';
                $html .= '<input type="hidden" value="'.$_REQUEST["tab"].'" name="tab">';
                $html .= '<input type="hidden" value="'.$_REQUEST["role"].'" name="role">';
                $html .= '<input type="hidden" value="'.$this->content_class_name.'" name="content_class">';
                $html .= '<input type="hidden" value="'.$_REQUEST["subtab"].'" name="subtab">';

                foreach( $sections as $section )
                {
                    $value = array();
                    $checked = '';
                    $title_checked = '';
                    $title = $section['title'];
                    if( isset( $settings[$section['id']]))
                    {
                        $value = $settings[$section['id']];
                        $title = $value['title'];
                    }

                    if( isset( $value['visible'] ) && $value['visible'] == 'on')
                    {
                        $checked = 'checked';
                    }
                    if( isset( $value['title_visible'] ) && $value['title_visible'] == 'on')
                    {
                        $title_checked = 'checked';
                    }

                    $html .= '<div class="mam-content-section ui-sortable"><span style="font-weight: bold">Purpose: ' . $section['title'] . '</span>';
                    $html .= '<input type="hidden" value="'.$section['id'].'" name="content_settings['.$section['id'].'][id]" >';
                    $html .= '<table style="width:100%">';
                    $html .= '<tr><td style="width: 80%">';
                    $html .= '<table style="width:100%">';
                    $html .= '<tr><td>Title</td><td><td><input name="content_settings['.$section['id'].'][title]" type="text" value="'.$title.'"/></td>';
                    $html .= '<tr><td>Show Section</td><td><td><input name="content_settings['.$section['id'].'][visible]" type="checkbox" '.$checked.'/></td>';
                    $html .= '<tr><td>Show Section Title</td><td><td><input name="content_settings['.$section['id'].'][title_visible]" type="checkbox" '.$title_checked.'/></td>';
                    $html .= '</table>';
                    $html .= '</td>';
                    $html .= '<td class="local-app-button-section-move" id="local-app-button-move-'.uniqid().'"><span class="local-app-button-section-move-icon fa fa-arrows-alt-v">&nbsp;</span></td>';
                    $html .= '</tr>';
                    $html .= '</table>';
                    $html .= '</div>';
                }

                $html .= '</div>';

                $html .= '<table class="tsl-admin-pref-table">';
                $html .= '<tr>';
                $html .= '<td></td>';
                $html .= '<td></td>';
                $html .= '<td>'.mam_admin_settings::submit_button().'</td>';
                $html .= '</tr>';
                $html .= '</table>';
                $html .= '</form>';


                return $html;
            }
        }

        return apply_filters( 'mam_main_button_get_screen_settings', '', $type );

    }

    function define_layout_options()
    {
        $layouts = array();

        $layout_id = 1;
        $fields = array();
        $layout_settings = array();
        $fields[] = array( 'index' => 1, 'title' => 'Field 1', 'id' => 'layout_field_1' , 'type' => 'field' );
        $fields[] = array( 'index' => 2, 'title' => 'Field 2', 'id' => 'layout_field_2' , 'type' => 'field' );
        $fields[] = array( 'index' => 3, 'title' => 'Field 3', 'id' => 'layout_field_3' , 'type' => 'field' );
        $fields[] = array( 'index' => 4, 'title' => 'Field 4', 'id' => 'layout_field_4' , 'type' => 'field' );
        $fields[] = array( 'index' => 5, 'title' => 'Field 5', 'id' => 'layout_field_5' , 'type' => 'field' );
        $fields[] = array( 'index' => 'right', 'title' => 'Top Right', 'id' => 'layout_field_right' , 'type' => 'field' );
        $layout_settings[] = array( 'title' => 'Layout Fields ', 'fields' => $fields , 'type' => 'fields' );
        $layout_settings[] = array( 'title' => 'Show Image', 'id' => 'showImage' , 'type' => 'checkbox' );
        $layout_settings[] = array( 'title' => 'Is Square Image', 'id' => 'isSquareImage' , 'type' => 'checkbox' );
        $layout_settings[] = array( 'title' => 'Show Distance', 'id' => 'showDistance' , 'type' => 'checkbox' );
        $layout_settings[] = array( 'title' => 'No Left Spacing', 'id' => 'no_left_spacing', 'type' => 'checkbox' );
        $layout_settings[] = array( 'title' => 'Var Height Layout', 'id' => 'layout_var_height' , 'type' => 'checkbox' );
        $layout_settings[] = array( 'title' => 'Layout Height', 'id' => 'layout_height' , 'type' => 'textfield' );
        $layout_settings[] = array( 'title' => 'Hide Marker', 'id' => 'hide_marker' , 'type' => 'checkbox' );
        $layout_settings[] = array( 'title' => 'Background Color', 'id' => 'layout_color' , 'type' => 'color' , 'color' => '#ffffff'  );
        $layout_settings[] = array( 'title' => 'Content Type', 'id' => 'content_type' , 'type' => 'select', 'options' => array(array( 'slug' => 'blank', 'name' => 'Default' ), array( 'slug' => 'web', 'name' => 'Web')) );

        $layouts[$layout_id] = $layout_settings;
        $layouts[$layout_id+1000] = $layout_settings;

        $layout_id = 503;
        $fields = array();
        $layout_settings = array();
        $fields[] = array( 'index' => 1, 'title' => 'Field 1', 'id' => '1' , 'type' => 'field' );
        $fields[] = array( 'index' => 2,  'title' => 'Field 2', 'id' => '2' , 'type' => 'field' );
        $fields[] = array( 'index' => 3,  'title' => 'Field 3', 'id' => '3' , 'type' => 'field' );
        $layout_settings[] = array( 'title' => 'Layout Fields ', 'fields' => $fields , 'type' => 'fields' );
        $layout_settings[] = array( 'title' => 'Show Image', 'id' => 'showImage' , 'type' => 'checkbox' );
        $layout_settings[] = array( 'title' => 'No Left Spacing', 'id' => 'no_left_spacing', 'type' => 'checkbox' );
        $layout_settings[] = array( 'title' => 'Var Height Layout', 'id' => 'layout_var_height' , 'type' => 'checkbox' );
        $layout_settings[] = array( 'title' => 'Layout Height', 'id' => 'layout_height' , 'type' => 'textfield' );
        $layout_settings[] = array( 'title' => 'Hide Marker', 'id' => 'hide_marker' , 'type' => 'checkbox' );
        $layout_settings[] = array( 'title' => 'Favorite Icon Color', 'id' => 'fav_color' , 'type' => 'color' );

        $layouts[$layout_id] = $layout_settings;
        $layouts[$layout_id+1000] = $layout_settings;

        return $layouts;
    }

    function get_button_fields(){
        $button_fields = array();
        $cat_array = $this->cat_array;
        $settings_array = $this->settings_array;
        foreach ($cat_array as $item){
            foreach($settings_array as $setting ){
                if($setting['catagory'] == $item['slug'] ){
                    $button_fields[] = $setting;
                }
            }
        }
        return $button_fields;
    }
}
