<?php

class mam_app_settings_global_settings{

    public $settings_array = array();

    function process_last_json_check( $data_array )
    {

        global $initial_has_run;
        if( $initial_has_run ) return  $data_array;

        if( isset( $_REQUEST['action'] ) && $_REQUEST['action'] == 'local_app_get_phone_data' && isset( $data_array['initial_form_to_display'] ) ) {

            $initial_has_run = true;
            $user = mam_user();// get_users(array('meta_key' => 'mam_app_token', 'meta_value' => $_REQUEST['pid']));

            $exclude_fields = apply_filters( 'mam_initial_form_exclude_fields', array(), $user );
            mamdebug('test', $exclude_fields );;
            $data_array['has_initial_form_to_display'] = 'no';

            if ($user && isset($data_array['initial_form_to_display']) && $data_array['initial_form_to_display'] == get_option('woocommerce_user_billing_address_form')) {

                global $local_app_form_array;
                $form_id = get_option('woocommerce_user_billing_address_form');

                $form_mgr = new local_app_gravity_forms();
                $form = $form_mgr->get_data_for_app($form_id);

                $hasAllRequired = true;
                foreach ($form['fields'] as $index => $field) {

                    if ( ! in_array( $field['id'],  $exclude_fields ) && $field['required'] == 1 && strlen($field['value']) == 0){
                        mamdebug('field', $field );
                        $hasAllRequired = false;
                    }
                }

                if ( ! $hasAllRequired) {
                    $local_app_form_array[] = $form;
                    $data_array['initial_form_to_display'] = sizeof($local_app_form_array);
                    $data_array['has_initial_form_to_display'] = 'yes';
                } else {
                    unset($data_array['initial_form_to_display']);
                }

            } else {
                unset($data_array['initial_form_to_display']);
            }

        }

        do_action( 'add_to_tracer', 'MAIN LJ1 Phone data end ' . __LINE__ );

        return $data_array;

    }

    function get_global_settings( $data_array )
    {

        $handler = new mam_app_settings_admin_page();
        $this->settings_array = $handler->settings_array;;

        $user = mam_user();// get_users(array('meta_key' => 'mam_app_token', 'meta_value' => $_REQUEST['pid']));

        $this_value = '';

        global $mam_main_json_array;
        global $mam_user_role;
        $user_role = $mam_user_role;
        if (!$mam_user_role) $user_role = 'mam-all';

        if (is_array($mam_main_json_array)) {
            foreach ($mam_main_json_array as $index => $item) {
                $data_array[$index] = $item;
            }
        }

        if( is_array( $this->settings_array ))
        {
            foreach ($this->settings_array as $setting) {

                $this_value = null;
                $default = '';
                if (isset($setting['default'])) {
                    $default = $setting['default'];
                }
                $this_value = apply_filters( 'mam_app_settings_get_setting', $default, $user_role, 'general-settings', $setting['id'] );

                if( !is_null( $this_value ) && strlen($this_value)>0) {
                    $this_value = stripslashes($this_value);
                }

                if ( !is_null( $this_value ) && strlen($this_value) > 0) {

                    if ($setting['type'] == 'text_json') {

                        $escaped_data = json_encode($this_value, JSON_HEX_QUOT | JSON_HEX_APOS);
                        $escaped_data = str_replace("\u0022", "\\\"", $escaped_data);
                        $escaped_data = str_replace("\u0027", "\\'", $escaped_data);

                        $data_array[$setting['variable']] = $escaped_data;
                    }

                    if ($setting['type'] == 'startext' || $setting['type'] == 'rgbtext' || $setting['type'] == 'text' || ($setting['type'] != 'startext' || $setting['type'] != 'rgbtext' && $setting['type'] != 'text' && get_option($setting['id']) != '0')) {

                        $data_array[$setting['variable']] = stripslashes($this_value);

                        if( $setting['type'] == 'image' && $setting['variable'] == 'listing_placeholder_image'){
                            $data_array = $this->make_image($data_array , $data_array[$setting['variable']] , $setting['variable'] );
                            $data_array['placeholder_image']['url'] = $data_array[$setting['variable']];
                            $data_array['placeholder_image']['aspect'] = $data_array[$setting['variable'].'_aspect'];
                            $data_array['placeholder_image']['height'] = $data_array[$setting['variable'].'_height'];
                            $data_array['placeholder_image']['width'] = $data_array[$setting['variable'].'_width'];
                        }

                        if ($setting['type'] == 'startext') {
                            $parts = explode(',', $data_array[$setting['variable']]);
                            if (sizeof($parts) == 7) {
                                $data_array[$setting['variable'] . '_left'] = $parts[0];
                                $data_array[$setting['variable'] . '_star_1'] = $parts[1];
                                $data_array[$setting['variable'] . '_star_2'] = $parts[2];
                                $data_array[$setting['variable'] . '_star_3'] = $parts[3];
                                $data_array[$setting['variable'] . '_star_4'] = $parts[4];
                                $data_array[$setting['variable'] . '_star_5'] = $parts[5];
                                $data_array[$setting['variable'] . '_right'] = $parts[6];
                                unset($data_array[$setting['variable']]);
                            }
                        }

                        if ($setting['type'] == 'color') {
                            $rgb = $this->hexToRgb($data_array[$setting['variable']]);
                            if ($rgb['r'] == 0) $rgb['r'] = 1;
                            if ($rgb['g'] == 0) $rgb['g'] = 1;
                            if ($rgb['b'] == 0) $rgb['b'] = 1;

                            $data_array[$setting['variable'] . '_red'] = (string)$rgb['r'];
                            $data_array[$setting['variable'] . '_green'] = (string)$rgb['g'];
                            $data_array[$setting['variable'] . '_blue'] = (string)$rgb['b'];
                            unset($data_array[$setting['variable']]);
                        }

                        if ($setting['type'] == 'rgbtext') {
                            $parts = explode(',', $data_array[$setting['variable']]);
                            if (sizeof($parts) == 3) {
                                $data_array[$setting['variable'] . '_red'] = $parts[0];
                                $data_array[$setting['variable'] . '_green'] = $parts[1];
                                $data_array[$setting['variable'] . '_blue'] = $parts[2];
                                unset($data_array[$setting['variable']]);
                            }
                        }
                    }
                }

                if ($setting['id'] == 'tsl-home_user_profile_form') {
                    global $local_app_form_array;

                    if (class_exists('local_app_gravity_forms')) {

                        $form_id = get_option($setting['id']);

                        if ($form_id > 0) {

                            $form_mgr = new local_app_gravity_forms();
                            $form = $form_mgr->get_data_for_app($form_id);

                            $local_app_form_array[] = $form;

                            $data_array['home_nav_user_profile_form'] = sizeof($local_app_form_array);
                            unset($data_array['tsl-home_user_profile_form']);

                        }
                    }
                }
            }
        }



        if( isset( $data_array['gravity_user_profile_form'] )) {

            global $local_app_form_array;

            if (class_exists('local_app_gravity_forms')) {

                $form_id = $data_array['gravity_user_profile_form'];

                if ($form_id > 0) {

                    $form_mgr = new local_app_gravity_forms();
                    $form = $form_mgr->get_data_for_app($form_id);

                    $local_app_form_array[] = $form;

                    $data_array['user_profile_form'] = sizeof($local_app_form_array);
                    unset( $data_array['gravity_user_profile_form']);

                }
            }
        }

        //if( ! class_exists( 'tsl_mam_google_places_main' )) {
            $data_array['ajaxhandler'] = 'advanced_settings_ajax_handler';
            $data_array['ajaxurl'] = admin_url('admin-ajax.php');

        //}

//        if(get_option('tsl-setting-use_tabs_for_homepage_logged_in') != 'yes' && get_option('tsl-setting-use_tabs_for_homepage') == 'yes'){
//            if ( ! $user) {
//                $data_array['use_tabs_for_homepage'] = 'no';
//            }
//        }

        $data_array['nonce'] = $scan_code = wp_create_nonce('tsl_gp_nonce');

        if( $user ) {
            $avatar = get_user_meta($user->ID, '_user_avatar', true);
            if ($avatar) $data_array['user_avatar'] = $avatar;


            if (get_user_meta($user->ID, 'billing_first_name', true)) $data_array['user_first_name'] = get_user_meta($user->ID, 'billing_first_name', true);
            if (get_user_meta($user->ID, 'billing_last_name', true)) $data_array['user_last_name'] = get_user_meta($user->ID, 'billing_last_name', true);
        }

        $addl_fields = apply_filters( 'mam_add_fields_to_user_profile' , array() );

        foreach( $addl_fields as $field ){
            if( get_user_meta ($user->ID, $field['meta_key'], true )) $data_array[$field['meta_key']] = get_user_meta($user->ID, $field['meta_key'], true );
        }

        $data_array['user_display_name'] = '';
        if( $user ) {
            if ($user->display_name) $data_array['user_display_name'] = $user->display_name;

            $data_array['user_tag_line'] = $user->user_email;
        }

        if( !isset( $data_array['global_font']) || strlen( $data_array['global_font']) < 2 ){
            $data_array['global_font'] = 'Roboto';
        }

        foreach( $data_array as $index => $setting )
        {
            if( ! is_array( $setting ) && strlen( $setting ) == 0 ){
                unset( $data_array[$index]);
            }

        }

        if( get_option( 'tsl-google-map-styles' )){
            $data_array['map_google_map_style'] = json_encode( get_option( 'tsl-google-map-styles' ));
        }

        $stack_content = apply_filters( 'mam_app_settings_get_home_screen_stack' , array() , $user_role );

        if( isset($stack_content['section'])) {
            $stack_content = $stack_content['section'];
        }

        if( is_array( $stack_content ) && count( $stack_content ) > 0 ){

            $data_array['homescreen_stack'][] = array( 'type' => 'nav_header' );

            $data_array['homescreen_stack'] = apply_filters( 'mam_hss_stack_after_nav_header', $data_array['homescreen_stack'] );

            $pin_to_top = apply_filters( 'mam_hss_pin_to_top', array() );
            $pin_to_top[] = 'filter_bar';
            $pin_to_top[] = 'listing_search';
            $pin_to_top[] = 'geo_filters';
            $pin_to_top[] = 'tag_cloud';

            $stack_index = 0;
            foreach ( $stack_content as $index => $stack_item ) {

                if ($stack_item['mam-hs-section-type'] == 'text')
                {
                    $stack_element['type'] = $stack_item['mam-hs-section-type'];
                    $stack_element['title'] = $stack_item['mam-hs-text-section-value'];
                    $stack_element['font_size'] = str_replace( 'size_', '', $stack_item['mam-hs-text-section-font-size']);
                    $stack_element['align'] = $stack_item['mam-hs-text-section-justification'];
                    if($stack_item['mam-hs-text-section-font-style'] == 'bold') {
                        $stack_element['bold'] = 'bold';
                    }
                    if( strlen($stack_item['mam-hs-text-section-font-color']) < 4 ) {
                        $stack_item['mam-hs-text-section-font-color'] = '#000000';
                    }
                    list($r, $g, $b) = sscanf($stack_item['mam-hs-text-section-font-color'], "#%02x%02x%02x");
                    $stack_element['red'] = (string)$r;
                    $stack_element['green'] = (string)$g;
                    $stack_element['blue'] = (string)$b;
                    $data_array['homescreen_stack'][] = $stack_element;

                }else if( $stack_item['mam-hs-section-type'] == 'bottom_tabbar' ) {
                    $data_array['use_tabs_for_homepage'] = 'yes';
                    $data_array['homescreen_stack'][] = array( 'type' => $stack_item['mam-hs-section-type'] );
                    $data_array['homescreen_stack'] = apply_filters('mam_hss_stack_after_bottom_tabbar', $data_array['homescreen_stack']);
                }else if( $stack_item['mam-hs-section-type'] == 'activity_tracking' ) {
                    $data_array = $this->make_activity_tracker($data_array);
                }else if( $stack_item['mam-hs-section-type'] == 'filter_bar' ){
                    $data_array['homescreen_stack'][] = array('type' => $stack_item['mam-hs-section-type'], 'display_using_chips' => $stack_item['mam-hs-filter-bar-section-type'] );
                }else if( $stack_item['mam-hs-section-type'] == 'spacer' ){
                    $data_array['homescreen_stack'][] = array( 'type' => $stack_item['mam-hs-section-type']  , 'height_type' => $stack_item['mam-hs-spacer-section-height-type'] , 'height' => str_replace( 'size_', '', $stack_item['mam-hs-spacer-section-height']));
                }else if( $stack_item['mam-hs-section-type'] == 'image' ){
                    $data_array = $this->make_stack_image($data_array , $stack_item );
                }else if( $stack_item['mam-hs-section-type'] == 'geo_filters' ){
                    $this_stack = array( 'type' => $stack_item['mam-hs-section-type']  );
                    if( array_key_exists('mam-hs-geo-filters-section-display-label', $stack_item) ){
                        $this_stack['display_as_label'] = $stack_item['mam-hs-geo-filters-section-display-label'];
                    }if( array_key_exists('mam-hs-geo-filters-section-pin-to-top', $stack_item) ){
                        $this_stack['pin_to_top'] = $stack_item['mam-hs-geo-filters-section-pin-to-top'];
                    }if( array_key_exists('mam-hs-geo-filters-section-label-color', $stack_item) ){
                        list($r, $g, $b) = sscanf($stack_item['mam-hs-geo-filters-section-label-color'], "#%02x%02x%02x");
                        $this_stack['label_red'] = (string)$r;
                        $this_stack['label_green'] = (string)$g;
                        $this_stack['label_blue'] = (string)$b;
                    }if( array_key_exists('mam-hs-geo-filters-section-nearby-prefix', $stack_item) ){
                        $this_stack['nearby_prefix'] = $stack_item['mam-hs-geo-filters-section-nearby-prefix'];
                    }if( array_key_exists('mam-hs-geo-filters-section-prefix', $stack_item) ){
                        $this_stack['prefix'] = $stack_item['mam-hs-geo-filters-section-prefix'];
                    }
                    $data_array['homescreen_stack'][] = $this_stack;
                    $data_array['hide_geofilters'] = 'yes';
                }else if( $stack_item['mam-hs-section-type'] == 'tagged_nav' ){
                    $data_array['homescreen_stack'][] = array( 'type' => $stack_item['mam-hs-section-type']  );
                }else if( $stack_item['mam-hs-section-type'] == 'collection_view' ){
                    $data_array['homescreen_stack'][] = array( 'type' => $stack_item['mam-hs-section-type'] , 'columns' => '3' , 'layout' => '2' );
                }else if( $stack_item['mam-hs-section-type'] == 'map' ){
                    $data_array['homescreen_stack'][] = array( 'type' => $stack_item['mam-hs-section-type'] , 'show_cards_on_map' => 'yes' );
                }else if( $stack_item['mam-hs-section-type'] == 'radius_selector' ){
                    $this_stack = array( 'type' => $stack_item['mam-hs-section-type']  );
                    if(array_key_exists('default', $stack_item) && $stack_item['default'] != ''){
                        $this_stack['default'] = (string)$stack_item['default'];
                    }if(array_key_exists('values', $stack_item) && is_array($stack_item["values"])){
                        if(!empty($stack_item["values"]['label'])){
                            $radius_values = array();
                            foreach ($stack_item["values"]['label'] as $value_index=>$label){
                                if($label != "" && $stack_item["values"]['value'][$value_index] != "") {
                                    $radius_values[] = array('label' => $label, 'value' => (string)$stack_item["values"]['value'][$value_index]);
                                }
                            }
                            if(!empty($radius_values)){
                                $this_stack['values'] = $radius_values;
                            }
                        }
                        $this_stack['default'] = (string)$stack_item['default'];
                    }
                    $data_array['homescreen_stack'][] = $this_stack;
                }else if( $stack_item['mam-hs-section-type'] == 'date_time_filter' ){
                    $this_stack = array( 'type' => $stack_item['mam-hs-section-type']  );
                    foreach ($stack_item as $stack_key=>$stack_value){
                        if($stack_key == "mam-hs-section-type") continue;
                        if(is_numeric($stack_item[$stack_key]) && $stack_item[$stack_key] != "") {
                            $this_stack[$stack_key] = (string)$stack_item[$stack_key];
                        }else if($stack_key == 'show_cats')
                        {
                            if( ! is_array($stack_item[$stack_key]))
                            {
                                $stack_item[$stack_key] = array();
                            }
                        }else{
                            $this_stack[$stack_key] = $stack_item[$stack_key];
                        }
                    }
                    $data_array['homescreen_stack'][] = $this_stack;
                }else if( $stack_item['mam-hs-section-type'] == 'single_listing' ){
                    if( has_filter( 'mam_hss_single_listing' ) ) {
                        $stack_ui = apply_filters('mam_hss_single_listing', $stack_item , $stack_index );
                        if( is_array($stack_ui) && sizeof($stack_ui) > 0 ) {
                            $data_array['homescreen_stack'][] = $stack_ui;
                        }
                    }
                }else{
                    $data_array['homescreen_stack'][] = array( 'type' => $stack_item['mam-hs-section-type'] );
                }

                $data_array['homescreen_stack'][$stack_index] = apply_filters( 'mam_hss_stack_item', $data_array['homescreen_stack'][$stack_index], $stack_index );
                $stack_index++;

            }

            $data_array['homescreen_stack'] = apply_filters( 'mam_hss_end_of_stack', $data_array['homescreen_stack'] );

            foreach ($data_array['homescreen_stack'] as $index => $item )
            {
                if( in_array( $item['type'] , $pin_to_top ) ){
                    $data_array['homescreen_stack'][$index]['pin_to_top'] = 'yes';
                }
            }

        }else{
            unset( $this->stack_content );
        }

        if( ! isset($data_array['homescreen_stack'])) $data_array['homescreen_stack'] = array();
        $data_array['homescreen_stack'] = apply_filters( 'mam_hss_stack_final', $data_array['homescreen_stack'] );

        if( ! is_array($data_array['homescreen_stack']) || sizeof($data_array['homescreen_stack']) == 0 )
        {
            unset( $data_array['homescreen_stack'] );
        }

        if( isset( $data_array['map_google_map_style'] ) && strlen( $data_array['map_google_map_style'] ) < 100 ) {
            unset($data_array['map_google_map_style']);
        }

        if( get_option('google_signin_api_key')) $data_array['google_signin_api_key'] = get_option('google_signin_api_key');

        $data_array['nav_bar_icon_color_red'] = $data_array['nav_bar_text_color_red'];
        $data_array['nav_bar_icon_color_green'] = $data_array['nav_bar_text_color_green'];
        $data_array['nav_bar_icon_color_blue'] = $data_array['nav_bar_text_color_blue'];

        if( isset( $data_array['home_tagged_nav_number_of_rows'] )){
            if( isset($_REQUEST['deviceios'])){
//                $data_array['home_tagged_nav_number_of_rows'] = $data_array['home_tagged_nav_number_of_rows'];
                $data_array['home_tagged_nav_number_of_rows'] = (string)$data_array['home_tagged_nav_number_of_rows'];
            }
        }

        if( isset( $data_array['home_left_menu_bottom_image'])){
            $image_id = attachment_url_to_postid( $data_array['home_left_menu_bottom_image'] );
            if( $image_id ) {
                $image_thumb = wp_get_attachment_image_src($image_id, 'full');
                if ($image_thumb) {
                    $data_array['home_left_menu_bottom_image_aspect'] = $image_thumb[2] / $image_thumb[1];
                }
            }
        }

        if( isset( $data_array['nav_header_image_view'] )){
            $image_id = attachment_url_to_postid( $data_array['nav_header_image_view'] );
            if( $image_id ) {
                $image_thumb = wp_get_attachment_image_src($image_id, 'full');
                if ($image_thumb) {
                    $data_array['nav_header_image_view_aspect'] = $image_thumb[2] / $image_thumb[1];
                }
            }
        }

        return $data_array;

    }

    function make_image( $data_array , $image_url, $setting_key )
    {

        $image_id = attachment_url_to_postid( $image_url );
        $image_thumb = wp_get_attachment_image_src($image_id, 'full');
        if( $image_thumb ) {
            $aspect = $image_thumb[2] / $image_thumb[1];
            $data_array[$setting_key . '_aspect'] = (string)$aspect;
            $data_array[$setting_key . '_height'] = (string)$image_thumb[2];
            $data_array[$setting_key . '_width'] = (string)$image_thumb[1];
        }

        return $data_array;

    }

    function make_stack_image( $data_array , $stack_item )
    {

        $image_id = $stack_item['mam-hs-image-id'];
        $image_thumb = wp_get_attachment_image_src($image_id, 'full');
        $display_width = str_replace( 'width_','', $stack_item['mam-hs-image-section-image-width']);
        if( is_array($image_thumb) && isset($image_thumb[1]) && isset($image_thumb[2]) && $image_thumb[1] > 0 && $image_thumb[2] > 0 ) {
            $aspect = $image_thumb[2] / $image_thumb[1];
            $data_array['homescreen_stack'][] = array('type' => 'image', 'url' => $image_thumb[0] , 'img_height' => (string)$image_thumb[2], 'img_width' => (string)$image_thumb[1], 'top' => '0' , 'width' => $display_width , 'justify' => 'center' , 'aspect' => (string)$aspect);
        }

        return $data_array;

    }

    function make_activity_tracker( $data_array )
    {

        $user = mam_user();//
        if ( $user  ){

            $duty_date = get_user_meta( $user->ID , 'tsl_activity_user_active_date' , true );
            $status = get_user_meta( $user->ID , 'tsl_activity_user_is_punched_in' , true );

            $data = array();
            if( $duty_date == current_time('Y-d-m') && $status != 2 ){
                $data['label_1'] = 'Status: On Duty';
            } else {
                $data['label_1'] = 'Status: Off Duty';
            }

            if(get_option('activity_map_type') == 'hours' ) {
                $data['status_button'] = 'Start Clock';
                $data['status_button_end'] = 'End Clock';

                if (get_user_meta($user->ID, '_mam_tracker_last_hours', true)) {
                    $data['label_2'] = "Current Hours:";//. get_user_meta($user[0]->ID, '_mam_tracker_last_hours', true);
                } else {
                    $data['label_2'] = "Current Hours:";
                }
            }else{
                $data['status_button'] = 'Start Walk';
                $data['status_button_end'] = 'End Walk';

                if ( get_user_meta($user->ID, '_mam_tracker_last_dist', true) > 0 ) {
                    $data['label_2'] = "Last distance: " .number_format(get_user_meta($user->ID, '_mam_tracker_last_dist', true), 1) . ' miles';
                } else {
                    $data['label_2'] = "  ";
                }
            }



            $data_array['homescreen_stack'][] = array('type' => 'activity_tracking', 'data' => $data, 'height' => '140', 'width' => '100', 'top' => '0', 'align_bottom' => '1');

        }

        return $data_array;

    }

    function hexToRgb($hex, $alpha = false) {
       $hex      = str_replace('#', '', $hex);
       $length   = strlen($hex);
       $rgb['r'] = hexdec($length == 6 ? substr($hex, 0, 2) : ($length == 3 ? str_repeat(substr($hex, 0, 1), 2) : 0));
       $rgb['g'] = hexdec($length == 6 ? substr($hex, 2, 2) : ($length == 3 ? str_repeat(substr($hex, 1, 1), 2) : 0));
       $rgb['b'] = hexdec($length == 6 ? substr($hex, 4, 2) : ($length == 3 ? str_repeat(substr($hex, 2, 1), 2) : 0));
       if ( $alpha ) {
          $rgb['a'] = $alpha;
       }
       return $rgb;
    }

}

//chown -R ec2-user:apache wp-admin
//chown -R ec2-user:apache wp-content
//chown -R ec2-user:apache wp-includes
//
////sudo chown -R apache:apache wp-admin
//sudo  chown -R apache:apache wp-content
//sudo chown -R apache:apache wp-includes

//find wp-content/uploads/ -type f -exec chmod 664 {} \;
