<?php
/**
 * Created by PhpStorm.
 * User: Fred
 * Date: 4/28/18
 * Time: 10:12 AM
 */

class mam_app_language_manager{

    private $language = 'en';

    function get_phone_data( $this_array = array() ){

        $strings = $this->get_language_strings_array();

        $language = 'en';
        if(isset( $_REQUEST['app_lang'] ) ){
            $language_parts = explode( '-',$_REQUEST['app_lang']);

            $language = $language_parts[0];
        }

        $lang_array = $this->get_translations( $strings , $language ,true );

        foreach( $lang_array as $index => $item ){
            $this_array['languageStrings'][] = array('english' => $strings[$index] , 'string' => $item );
        }

        return $this_array;
    }

    function create_page(){

        $this->language = 'en';
        if( isset( $_REQUEST['language'])) $this->language = $_REQUEST['language'];

        $strings = $this->get_language_strings_array();
        $lang_array = $this->get_translations( $strings , $this->language );

        $html_line = '<div class="tsl-admin-settings-holder">';
        $html_line .= '<form method="GET" name="language_form" id="language_form">';
        $html_line .= '<input type="hidden" value="'.$_REQUEST['page'].'" name="page" id="page">';
        $html_line .= '<input type="hidden" value="'.$_REQUEST['tab'].'" name="tab" id="tab">';

        $html_line .= '<table class="tsl-admin-pref-table" style="margin-bottom:2em">';

        $html_line .= '<tr>';
        $html_line .= '<td class="tsl-admin-pref-table-heading">Current Language</td>';
        $html_line .= '<td class="tsl-admin-pref-table-heading">'.$this->make_dropdown( 'language' , $this->get_languages() , $this->language ).'</td>';
        $html_line .= '</tr>';

        $html_line .= '</table>';
        $html_line .= '</form>';

        $html_line .= '<form method="POST">';
        $html_line .= '<input type="hidden" value="'.$_REQUEST['page'].'" name="page" id="page">';
        $html_line .= '<input type="hidden" value="'.$_REQUEST['tab'].'" name="tab" id="tab">';
        $html_line .= '<input type="hidden" value="'.$this->language.'" name="language">';


        $html_line .= '<table class="tsl-admin-pref-table">';

        $html_line .= '<tr>';
        $html_line .= '<td class="tsl-admin-pref-table-heading">App String</td>';
        $html_line .= '<td class="tsl-admin-pref-table-heading">Translated String</td>';
        $html_line .= '</tr>';

        $html_line .= '<tr><td colspan="2">&nbsp;</td></tr>';

        foreach( $strings as $index => $string ){

            $html_line .= '<tr>';
    		$html_line .= '<td class="tsl-admin-pref-table-heading">'. $string .':</td>';
	    	$html_line .= '<td class="tsl-admin-pref-table-col">'.$this->make_textfield( 'lng_strng['.$index.']' , $lang_array[$index]).'</td>';
		    $html_line .= '</tr>';


        }

        $html_line .= '<tr><td colspan="2" align="right">'.mam_admin_settings::submit_button().'</td></tr>';

		$html_line .= '</table>';
        $html_line .= '</form>';

        $html_line .= '</div>';

        return $html_line;
    }

    function get_translations( $strings , $lang_id = 'en' , $custom_only = false ){

        $translations = array();
        $default_translations = apply_filters( 'mam-lang-get-standard-translations', array(), $lang_id );

        foreach( $strings as $index => $string ){
            $translations[$index] = $string;
            if(get_option( 'tsl-mam-lng-string-'.$lang_id.'-'.$index  )) {
                $translations[$index] = get_option('tsl-mam-lng-string-' . $lang_id . '-' . $index);
            }else{
                if( isset($default_translations[$index])){
                    $translations[$index] = $default_translations[$index];
                }
            }
//mamdebug('trans', $translations );
            if( $translations[$index] == $string ) {
                if ($custom_only) {
                    unset($translations[$index]);
                }
            }else if( strlen($translations[$index]) == 0 ) {
                if ( $custom_only) {
                    unset($translations[$index]);
                }
            }
        }



        return $translations;

    }

    function get_language_strings_array(){

        $lang = array();

        $lang['favorites'] = 'Favorites';
        $lang['map'] = 'Map';
        $lang['phone'] = 'Phone';
        $lang['username'] = 'Username';
        $lang['blog'] = 'Blog';
        $lang['check_in'] = 'Check In';
        $lang['featured'] = 'Featured';
        $lang['events'] = 'Events';
        $lang['my_tasks'] = 'My Tasks';
        $lang['order'] = 'Order';
        $lang['reviews'] = 'Reviews';
        $lang['review'] = 'Review';
        $lang['web'] = 'Web';
        $lang[str_replace(' ', '_', "select a location to see listings")] = 'Select a location to see listings';
        $lang[str_replace(' ','_', 'view all >')] = 'View All >';

        //get button names


        //get setting values


        //get gravity forms labels



        $lang =  apply_filters( 'mam-get-language-string-array' ,  $lang );
        ksort( $lang );

        return $lang;

    }

    function make_textfield( $id,  $value = ''){

        return '<input type="text" id="'.$id.'" name="'.$id.'" value="'.$value.'">';

    }

    function get_languages(){

        $languages[] = array('title' => 'Abkhazian', 'twoletter' => 'ab');
        $languages[] = array('title' => 'Afar', 'twoletter' => 'aa');
        $languages[] = array('title' => 'Afrikaans', 'twoletter' => 'af');
        $languages[] = array('title' => 'Albanian', 'twoletter' => 'sq');
        $languages[] = array('title' => 'Amharic', 'twoletter' => 'am');
        $languages[] = array('title' => 'Arabic', 'twoletter' => 'ar');
        $languages[] = array('title' => 'Aragonese', 'twoletter' => 'an');
        $languages[] = array('title' => 'Armenian', 'twoletter' => 'hy');
        $languages[] = array('title' => 'Assamese', 'twoletter' => 'as');
        $languages[] = array('title' => 'Avestan', 'twoletter' => 'ae');
        $languages[] = array('title' => 'Aymara', 'twoletter' => 'ay');
        $languages[] = array('title' => 'Azerbaijani', 'twoletter' => 'az');
        $languages[] = array('title' => 'Bashkir', 'twoletter' => 'ba');
        $languages[] = array('title' => 'Basque', 'twoletter' => 'eu');
        $languages[] = array('title' => 'Belarusian', 'twoletter' => 'be');
        $languages[] = array('title' => 'Bengali', 'twoletter' => 'bn');
        $languages[] = array('title' => 'Bihari', 'twoletter' => 'bh');
        $languages[] = array('title' => 'Bislama', 'twoletter' => 'bi');
        $languages[] = array('title' => 'Bosnian', 'twoletter' => 'bs');
        $languages[] = array('title' => 'Breton', 'twoletter' => 'br');
        $languages[] = array('title' => 'Bulgarian', 'twoletter' => 'bg');
        $languages[] = array('title' => 'Burmese', 'twoletter' => 'my');
        $languages[] = array('title' => 'Catalan', 'twoletter' => 'ca');
        $languages[] = array('title' => 'Chamorro', 'twoletter' => 'ch');
        $languages[] = array('title' => 'Chechen', 'twoletter' => 'ce');
        $languages[] = array('title' => 'Chinese', 'twoletter' => 'zh');
        $languages[] = array('title' => 'Church Slavic; Slavonic; Old Bulgarian', 'twoletter' => 'cu');
        $languages[] = array('title' => 'Chuvash', 'twoletter' => 'cv');
        $languages[] = array('title' => 'Cornish', 'twoletter' => 'kw');
        $languages[] = array('title' => 'Corsican', 'twoletter' => 'co');
        $languages[] = array('title' => 'Croatian', 'twoletter' => 'hr');
        $languages[] = array('title' => 'Czech', 'twoletter' => 'cs');
        $languages[] = array('title' => 'Danish', 'twoletter' => 'da');
        $languages[] = array('title' => 'Divehi; Dhivehi; Maldivian', 'twoletter' => 'dv');
        $languages[] = array('title' => 'Dutch', 'twoletter' => 'nl');
        $languages[] = array('title' => 'Dzongkha', 'twoletter' => 'dz');
        $languages[] = array('title' => 'English', 'twoletter' => 'en');
        $languages[] = array('title' => 'Esperanto', 'twoletter' => 'eo');
        $languages[] = array('title' => 'Estonian', 'twoletter' => 'et');
        $languages[] = array('title' => 'Faroese', 'twoletter' => 'fo');
        $languages[] = array('title' => 'Fijian', 'twoletter' => 'fj');
        $languages[] = array('title' => 'Finnish', 'twoletter' => 'fi');
        $languages[] = array('title' => 'French', 'twoletter' => 'fr');
        $languages[] = array('title' => 'Gaelic; Scottish Gaelic', 'twoletter' => 'gd');
        $languages[] = array('title' => 'Galician', 'twoletter' => 'gl');
        $languages[] = array('title' => 'Georgian', 'twoletter' => 'ka');
        $languages[] = array('title' => 'German', 'twoletter' => 'de');
        $languages[] = array('title' => 'Greek, Modern (1453-)', 'twoletter' => 'el');
        $languages[] = array('title' => 'Guarani', 'twoletter' => 'gn');
        $languages[] = array('title' => 'Gujarati', 'twoletter' => 'gu');
        $languages[] = array('title' => 'Haitian; Haitian Creole', 'twoletter' => 'ht');
        $languages[] = array('title' => 'Hausa', 'twoletter' => 'ha');
        $languages[] = array('title' => 'Hebrew', 'twoletter' => 'he');
        $languages[] = array('title' => 'Herero', 'twoletter' => 'hz');
        $languages[] = array('title' => 'Hindi', 'twoletter' => 'hi');
        $languages[] = array('title' => 'Hiri Motu', 'twoletter' => 'ho');
        $languages[] = array('title' => 'Hungarian', 'twoletter' => 'hu');
        $languages[] = array('title' => 'Icelandic', 'twoletter' => 'is');
        $languages[] = array('title' => 'Ido', 'twoletter' => 'io');
        $languages[] = array('title' => 'Indonesian', 'twoletter' => 'id');
        $languages[] = array('title' => 'Interlingue', 'twoletter' => 'ie');
        $languages[] = array('title' => 'Inuktitut', 'twoletter' => 'iu');
        $languages[] = array('title' => 'Inupiaq', 'twoletter' => 'ik');
        $languages[] = array('title' => 'Irish', 'twoletter' => 'ga');
        $languages[] = array('title' => 'Italian', 'twoletter' => 'it');
        $languages[] = array('title' => 'Japanese', 'twoletter' => 'ja');
        $languages[] = array('title' => 'Javanese', 'twoletter' => 'jv');
        $languages[] = array('title' => 'Kalaallisut', 'twoletter' => 'kl');
        $languages[] = array('title' => 'Kannada', 'twoletter' => 'kn');
        $languages[] = array('title' => 'Kashmiri', 'twoletter' => 'ks');
        $languages[] = array('title' => 'Kazakh', 'twoletter' => 'kk');
        $languages[] = array('title' => 'Khmer', 'twoletter' => 'km');
        $languages[] = array('title' => 'Kikuyu; Gikuyu', 'twoletter' => 'ki');
        $languages[] = array('title' => 'Kinyarwanda', 'twoletter' => 'rw');
        $languages[] = array('title' => 'Kirghiz', 'twoletter' => 'ky');
        $languages[] = array('title' => 'Komi', 'twoletter' => 'kv');
        $languages[] = array('title' => 'Korean', 'twoletter' => 'ko');
        $languages[] = array('title' => 'Kuanyama; Kwanyama', 'twoletter' => 'kj');
        $languages[] = array('title' => 'Kurdish', 'twoletter' => 'ku');
        $languages[] = array('title' => 'Lao', 'twoletter' => 'lo');
        $languages[] = array('title' => 'Latin', 'twoletter' => 'la');
        $languages[] = array('title' => 'Latvian', 'twoletter' => 'lv');
        $languages[] = array('title' => 'Limburgan; Limburger; Limburgish', 'twoletter' => 'li');
        $languages[] = array('title' => 'Lingala', 'twoletter' => 'ln');
        $languages[] = array('title' => 'Lithuanian', 'twoletter' => 'lt');
        $languages[] = array('title' => 'Luxembourgish; Letzeburgesch', 'twoletter' => 'lb');
        $languages[] = array('title' => 'Macedonian', 'twoletter' => 'mk');
        $languages[] = array('title' => 'Malagasy', 'twoletter' => 'mg');
        $languages[] = array('title' => 'Malay', 'twoletter' => 'ms');
        $languages[] = array('title' => 'Malayalam', 'twoletter' => 'ml');
        $languages[] = array('title' => 'Maltese', 'twoletter' => 'mt');
        $languages[] = array('title' => 'Manx', 'twoletter' => 'gv');
        $languages[] = array('title' => 'Maori', 'twoletter' => 'mi');
        $languages[] = array('title' => 'Marathi', 'twoletter' => 'mr');
        $languages[] = array('title' => 'Marshallese', 'twoletter' => 'mh');
        $languages[] = array('title' => 'Moldavian', 'twoletter' => 'mo');
        $languages[] = array('title' => 'Mongolian', 'twoletter' => 'mn');
        $languages[] = array('title' => 'Nauru', 'twoletter' => 'na');
        $languages[] = array('title' => 'Navaho, Navajo', 'twoletter' => 'nv');
        $languages[] = array('title' => 'Ndebele, North', 'twoletter' => 'nd');
        $languages[] = array('title' => 'Ndebele, South', 'twoletter' => 'nr');
        $languages[] = array('title' => 'Ndonga', 'twoletter' => 'ng');
        $languages[] = array('title' => 'Nepali', 'twoletter' => 'ne');
        $languages[] = array('title' => 'Northern Sami', 'twoletter' => 'se');
        $languages[] = array('title' => 'Norwegian', 'twoletter' => 'no');
        $languages[] = array('title' => 'Norwegian Bokmal', 'twoletter' => 'nb');
        $languages[] = array('title' => 'Norwegian Nynorsk', 'twoletter' => 'nn');
        $languages[] = array('title' => 'Nyanja; Chichewa; Chewa', 'twoletter' => 'ny');
        $languages[] = array('title' => 'Occitan (post 1500); Provencal', 'twoletter' => 'oc');
        $languages[] = array('title' => 'Oriya', 'twoletter' => 'or');
        $languages[] = array('title' => 'Oromo', 'twoletter' => 'om');
        $languages[] = array('title' => 'Ossetian; Ossetic', 'twoletter' => 'os');
        $languages[] = array('title' => 'Pali', 'twoletter' => 'pi');
        $languages[] = array('title' => 'Panjabi', 'twoletter' => 'pa');
        $languages[] = array('title' => 'Persian', 'twoletter' => 'fa');
        $languages[] = array('title' => 'Polish', 'twoletter' => 'pl');
        $languages[] = array('title' => 'Portuguese', 'twoletter' => 'pt');
        $languages[] = array('title' => 'Pushto', 'twoletter' => 'ps');
        $languages[] = array('title' => 'Quechua', 'twoletter' => 'qu');
        $languages[] = array('title' => 'Raeto-Romance', 'twoletter' => 'rm');
        $languages[] = array('title' => 'Romanian', 'twoletter' => 'ro');
        $languages[] = array('title' => 'Rundi', 'twoletter' => 'rn');
        $languages[] = array('title' => 'Russian', 'twoletter' => 'ru');
        $languages[] = array('title' => 'Samoan', 'twoletter' => 'sm');
        $languages[] = array('title' => 'Sango', 'twoletter' => 'sg');
        $languages[] = array('title' => 'Sanskrit', 'twoletter' => 'sa');
        $languages[] = array('title' => 'Sardinian', 'twoletter' => 'sc');
        $languages[] = array('title' => 'Serbian', 'twoletter' => 'sr');
        $languages[] = array('title' => 'Shona', 'twoletter' => 'sn');
        $languages[] = array('title' => 'Sichuan Yi', 'twoletter' => 'ii');
        $languages[] = array('title' => 'Sindhi', 'twoletter' => 'sd');
        $languages[] = array('title' => 'Sinhala; Sinhalese', 'twoletter' => 'si');
        $languages[] = array('title' => 'Slovak', 'twoletter' => 'sk');
        $languages[] = array('title' => 'Slovenian', 'twoletter' => 'sl');
        $languages[] = array('title' => 'Somali', 'twoletter' => 'so');
        $languages[] = array('title' => 'Sotho, Southern', 'twoletter' => 'st');
        $languages[] = array('title' => 'Spanish', 'twoletter' => 'es');
        $languages[] = array('title' => 'Sundanese', 'twoletter' => 'su');
        $languages[] = array('title' => 'Swahili', 'twoletter' => 'sw');
        $languages[] = array('title' => 'Swati', 'twoletter' => 'ss');
        $languages[] = array('title' => 'Swedish', 'twoletter' => 'sv');
        $languages[] = array('title' => 'Tagalog', 'twoletter' => 'tl');
        $languages[] = array('title' => 'Tahitian', 'twoletter' => 'ty');
        $languages[] = array('title' => 'Tajik', 'twoletter' => 'tg');
        $languages[] = array('title' => 'Tamil', 'twoletter' => 'ta');
        $languages[] = array('title' => 'Tatar', 'twoletter' => 'tt');
        $languages[] = array('title' => 'Telugu', 'twoletter' => 'te');
        $languages[] = array('title' => 'Thai', 'twoletter' => 'th');
        $languages[] = array('title' => 'Tibetan', 'twoletter' => 'bo');
        $languages[] = array('title' => 'Tigrinya', 'twoletter' => 'ti');
        $languages[] = array('title' => 'Tonga (Tonga Islands)', 'twoletter' => 'to');
        $languages[] = array('title' => 'Tsonga', 'twoletter' => 'ts');
        $languages[] = array('title' => 'Tswana', 'twoletter' => 'tn');
        $languages[] = array('title' => 'Turkish', 'twoletter' => 'tr');
        $languages[] = array('title' => 'Turkmen', 'twoletter' => 'tk');
        $languages[] = array('title' => 'Twi', 'twoletter' => 'tw');
        $languages[] = array('title' => 'Uighur', 'twoletter' => 'ug');
        $languages[] = array('title' => 'Ukrainian', 'twoletter' => 'uk');
        $languages[] = array('title' => 'Urdu', 'twoletter' => 'ur');
        $languages[] = array('title' => 'Uzbek', 'twoletter' => 'uz');
        $languages[] = array('title' => 'Vietnamese', 'twoletter' => 'vi');
        $languages[] = array('title' => 'Volapuk', 'twoletter' => 'vo');
        $languages[] = array('title' => 'Walloon', 'twoletter' => 'wa');
        $languages[] = array('title' => 'Welsh', 'twoletter' => 'cy');
        $languages[] = array('title' => 'Western Frisian', 'twoletter' => 'fy');
        $languages[] = array('title' => 'Wolof', 'twoletter' => 'wo');
        $languages[] = array('title' => 'Xhosa', 'twoletter' => 'xh');
        $languages[] = array('title' => 'Yiddish', 'twoletter' => 'yi');
        $languages[] = array('title' => 'Yoruba', 'twoletter' => 'yo');
        $languages[] = array('title' => 'Zhuang; Chuang', 'twoletter' => 'za');
        $languages[] = array('title' => 'Zulu', 'twoletter' => 'zu');

        return $languages;

    }

    function make_dropdown( $id , $options = array() , $selected = null ){

		if( ! $id || sizeof($options) == 0 ) return '';

		$html_line = '<select id="'.$id.'" name="'.$id.'" onchange="jQuery( \'#language_form\').submit()">';

		foreach($options as $option){
			$selected_item = '';
			if($option['twoletter'] == $selected ) $selected_item = 'selected';
			$html_line .= '<option  value="'.$option['twoletter'].'" '.$selected_item.'>' .$option['title'].'</option>';
		}

		$html_line .= '</select>';

		return $html_line;

	}


}
