<?php

class mam_app_settings_local_settings
{

    public $local_settings_array = array();

    public function mam_final_button_settings($data_array)
    {

        global $mam_main_json_array;

        if( $data_array['tab_location'] == 'button'){

            global $mam_user_role, $global_settings_array;

            if( ! $mam_user_role ) $mam_user_role = 'mam-all';

            $admin_handler = new mam_app_settings_admin_page();
            if( ! $global_settings_array ) {
                $global_settings_array = $admin_handler->settings_array;
            }

            foreach($global_settings_array as $setting ) {
                if ($setting['catagory'] == 'header') {
                    $this->local_settings_array[] = $setting;
                }
                if ($setting['catagory'] == 'tabbar') {
                    $this->local_settings_array[] = $setting;
                }
            }

            if (class_exists($data_array['class'])) {
                $content_class = $data_array['class'];
                $content_class = new $content_class();
                if ( method_exists($content_class, 'app_settings') ) {
                    $settings_array = $content_class->app_settings();

                    foreach( $settings_array as $setting ){
                        $this->local_settings_array[] = $setting;
                    }
                }

                $vc_type_settings = $admin_handler->get_view_controller_specific_settings( $data_array['vc_type'] );
                foreach( $vc_type_settings as $setting ){
                    $this->local_settings_array[] = $setting;
                }
            }

            if( ! isset($data_array['nodata']) &&  isset( $data_array['data'] ) && is_array( $data_array['data'] )) {

                $layout_settings = apply_filters( 'mam_app_settings_get_layout_settings' , false, $data_array['tab_button_id'] );
                if( is_array($layout_settings) )
                {
                    $layout_settings[$data_array['tab_button_id']]['layout_settings'] = $layout_settings;
                }

                //todo with Delete After Database Migration

                if( !$layout_settings ) {
                    $layout_settings = get_option('mam-layout-options');
                    $layout_settings = maybe_unserialize($layout_settings);
                }

                if( is_array( $layout_settings ) )
                {

//                    mamdebug('buttonid', $layout_settings[$data_array['tab_button_id']]['layout_settings'] );

                    if (isset( $layout_settings[$data_array['tab_button_id']]['layout_settings'] )) {

                        $layout_master = array();

                        foreach ($layout_settings[$data_array['tab_button_id']]['layout_settings'] as $layout_key => $layout_setting) {

                            if (is_array($layout_setting) && isset($layout_setting['type']) && $layout_setting['type'] == 'field' && strlen($layout_setting['title']) > 0) {
                                if (!isset($data_array[$layout_key])) $layout_master[$layout_key] = $layout_setting['title'];

                                $index = str_replace('layout_field_', '', $layout_key);

                                $layout_master['font_field_' . $index] = $layout_setting['font_size'];
                                $color = $this->hexToRgb($layout_setting['color']);;
                                $layout_master['font_color_' . $index . '_red'] = $color['r'];
                                $layout_master['font_color_' . $index . '_green'] = $color['g'];
                                $layout_master['font_color_' . $index . '_blue'] = $color['b'];
                                if (isset($layout_setting['font_bold']) && $layout_setting['font_bold'] == 'on') {
                                    $layout_master['font_bold_' . $index] = 'yes';
                                }
                            } else if ($layout_key == 'showImage') {
                                if (isset($layout_setting['value']) && $layout_setting['value'] == 'on') {
                                    $layout_master['showImage'] = 'yes';
                                }
                            } else if ($layout_key == 'isSquareImage') {
                                if (isset($layout_setting['value']) && $layout_setting['value'] == 'on') {
                                    $layout_master['isSquareImage'] = 'yes';
                                }
                            } else if ($layout_key == 'showDistance') {
                                if (isset($layout_setting['value']) && $layout_setting['value'] == 'on') {
                                    $layout_master['showDistance'] = 'yes';
                                }
                            } else if ($layout_key == 'no_left_spacing') {
                                if (isset($layout_setting['value']) && $layout_setting['value'] == 'on') {
                                    $layout_master['no_left_spacing'] = 'yes';
                                }
                            } else if ($layout_key == 'layout_var_height') {
                                if (isset($layout_setting['value']) && $layout_setting['value'] == 'on') {
                                    $layout_master['layout_var_height'] = 'yes';
                                }
                            } else if ($layout_key == 'layout_height') {
                                if (isset($layout_setting['value']) && $layout_setting['value'] > 0) {
                                    $layout_master['layout_height'] = $layout_setting['value'];
                                }
                            } else if ($layout_key == 'hide_marker') {
                                if ( isset($layout_setting['value']) && $layout_setting['value'] == 'on') {
                                    $layout_master['hide_marker'] = 'yes';
                                }
                            } else if ($layout_key == 'content_type' && strlen( $layout_setting['value'] ) > 0) {
                                if(isset($layout_setting['value']) && $layout_setting['value'] == 'web' ) $layout_master['content_type'] = $layout_setting['value'];
                            } else if ($layout_key == 'layout_color') {
                                $rgb = $this->hexToRgb($layout_setting['value']);
                                if ($rgb['r'] == 0) $rgb['r'] = 1;
                                if ($rgb['g'] == 0) $rgb['g'] = 1;
                                if ($rgb['b'] == 0) $rgb['b'] = 1;

                                $layout_master['layout_color_red'] = (string)$rgb['r'];
                                $layout_master['layout_color_green'] = (string)$rgb['g'];
                                $layout_master['layout_color_blue'] = (string)$rgb['b'];

                            } else if ($layout_key == 'layout_id') {
                                $layout_master['layout'] = $layout_setting;
                                $layout_master['layout_id'] = $layout_setting;
                            }
                        }
                        foreach( $layout_master as $key => $value ){
                            $data_array[$key] = $value;
                        }
                        foreach ($data_array['data'] as $itemIndex => $item)
                        {
                             foreach( $layout_master as $key => $value ){
                                $data_array['data'][$itemIndex][$key] = $value;
                            }
                        }
                    }
                }

                $settings = apply_filters( 'mam_app_settings_get_content_section_settings', false, $data_array['tab_button_id'] );
                if( is_array($settings))
                {
                    $layout_settings[$data_array['tab_button_id']]['content_settings'] = $settings;
                }else {
                    $layout_settings = get_option('mam-content-sections-options');
                }
                $layout_settings = maybe_unserialize( $layout_settings );

                if( is_array( $layout_settings ) ) {
                    if (isset($layout_settings[$data_array['tab_button_id']]['content_settings'])) {
                        foreach ( $data_array['data'] as $itemIndex => $item) {
                            if( isset( $item['no_mod_content_sections'])) continue;
                            unset($data_array['data'][$itemIndex]['content_sections']);

                            foreach ( $layout_settings[$data_array['tab_button_id']]['content_settings'] as $layout_key => $layout_setting)
                            {
                                if( ! isset( $layout_setting['visible'] ) ) continue;
                                if( $layout_setting['id'] == 'post_content' || $layout_setting['id'] == 'address_section' )
                                {
                                    $data_array['data'][$itemIndex]['bypass_address_info'] = 'yes';
                                }
                                if( !isset($layout_setting['title_visible']))
                                {
                                    $show_title = 'no';
                                }else{
                                    $show_title = 'yes';
                                }
                                $data_array['data'][$itemIndex] = apply_filters('mam_content_section_' . $layout_setting['id'], $data_array['data'][$itemIndex], $show_title , $layout_setting['title'] );

                            }
                        }
                    }
                }
            }

            foreach( $this->local_settings_array as $setting )
            {

                 if ($setting['catagory'] == 'header' ) continue;
                 if ($setting['catagory'] == 'tabbar' ) continue;

//                $option_value = get_option( $setting['id'] );
                $option_value = apply_filters( 'mam_app_settings_get_setting', '', $mam_user_role, $data_array['tab_button_id'], $setting['id'] );
//mamdebug('option_value', $option_value);
                if( $option_value ){

                    if( is_array( $option_value ) ){
                        if( isset( $option_value[$mam_user_role][$data_array['tab_button_id']] ) ){
                            $data_array[$setting['variable']] = $option_value[$mam_user_role][$data_array['tab_button_id']];
                        }else if( isset( $option_value['mam-all'][$data_array['tab_button_id']] ) ){
                            $data_array[$setting['variable']] = $option_value['mam-all'][$data_array['tab_button_id']];
                        }else if( isset( $setting['default'] ) ){
                            $data_array[$setting['variable']] = $setting['default'];
                        }

                    }else{
                        $data_array[$setting['variable']] = $option_value;
                    }

                    if( $setting['type'] == 'image' ){
                        $data_array = $this->make_image($data_array , $data_array[$setting['variable']] , $setting['variable'] );
                    }

                    if( $setting['variable']  == 'screen_help' )
                    {

                        if( class_exists( 'mam_lp_create_onboarding' ) && isset( $data_array[$setting['variable']] ) && $data_array[$setting['variable']] > 0 ) {
                            $handler = new mam_lp_create_onboarding();
                            $onboarding = $handler->create_onboarding($data_array[$setting['variable']]);

                            if( is_array( $onboarding ) ) {
                                $data_array[$setting['variable']] = $onboarding;
                            }
                        }else {
                            unset($data_array[$setting['variable']]);
                        }
                    }

                    if( $setting['variable'] == 'login_terms_and_conditions_text' ) {
                        $data_array[$setting['variable']] = stripslashes( $data_array[$setting['variable']] );
                    }

                    if( $setting['variable'] == 'login_background_url_1' ){

                        $image_id = mam_admin_settings::get_image_id( $data_array[$setting['variable']] );
                        if( $image_id ) {
                            $image_info = wp_get_attachment_image_src($image_id, 'full');
                            if ($image_info) {
                                $aspect = $image_info[2] / $image_info[1];
                                $data_array['login_background_url_1_aspect'] = $aspect;
                            }
                        }
                    }

                    if( $setting['variable'] == 'login_top_logo_url' ){
                        $image_id = mam_admin_settings::get_image_id( $data_array[$setting['variable']] );
                        if( $image_id ) {
                            $image_info = wp_get_attachment_image_src($image_id , 'full');
//                                $mam_main_json_array['login_top_logo_url_info'] = $image_info;
                            if ($image_info) {
                                $mam_main_json_array[ $setting['variable'] . '_width'] = (string)$image_info[1];
                                $mam_main_json_array[$setting['variable'] . '_height'] = (string)$image_info[2];
                                $aspect = $image_info[2] /  $image_info[1];
                                $mam_main_json_array[$setting['variable'] . '_aspect'] = (string)$aspect;
                            }
                        }
                    }

                    if ( isset( $data_array[$setting['variable']] ) && $setting['type'] == 'color' && strlen( $data_array[$setting['variable']] ) > 0 ) {
                        $rgb = $this->hexToRgb( $data_array[$setting['variable']] );
                        if( $rgb['r'] == 0 ) $rgb['r'] = 1;
                        if( $rgb['g'] == 0 ) $rgb['g'] = 1;
                        if( $rgb['b'] == 0 ) $rgb['b'] = 1;

                        $data_array[$setting['variable'] . '_red'] =  (string)$rgb['r'];
                        $data_array[$setting['variable'] . '_green'] = (string)$rgb['g'];
                        $data_array[$setting['variable'] . '_blue'] = (string)$rgb['b'];

                        if( isset( $setting['environment']) && $setting['environment'] == 'global' ){
                            $mam_main_json_array[$setting['variable'] . '_red'] =  (string)$rgb['r'];
                            $mam_main_json_array[$setting['variable'] . '_green'] = (string)$rgb['g'];
                            $mam_main_json_array[$setting['variable'] . '_blue'] = (string)$rgb['b'];
                        }

                        unset( $data_array[$setting['variable']] );
                    }else {
                        if ( isset( $setting['environment']) && $setting['environment'] == 'global' && strlen( $data_array[$setting['variable']] ) > 0) $mam_main_json_array[$setting['variable']] = $data_array[$setting['variable']];
                    }

                }

            }

            if( isset($data_array['use_transparent_bottom_tabbar']) && $data_array['use_transparent_bottom_tabbar'] == 'yes' ) $data_array['tabbar_color_red'] = '-1';

        }

        foreach( $data_array as $index => $setting )
        {

            if( ! isset( $setting ) || ( ! is_array( $setting ) && strlen( $setting ) == 0 )){
                unset( $data_array[$index]);
            }
        }

        return $data_array;

    }

    function make_image( $data_array , $image_url, $setting_key )
    {

        $image_id = attachment_url_to_postid( $image_url );
        $image_thumb = wp_get_attachment_image_src($image_id, 'full');
        if( $image_thumb ) {
            $aspect = $image_thumb[2] / $image_thumb[1];
            $data_array[$setting_key . '_aspect'] = (string)$aspect;
            $data_array[$setting_key . '_height'] = (string)$image_thumb[2];
            $data_array[$setting_key . '_width'] = (string)$image_thumb[1];
        }

        return $data_array;

    }

    function hexToRgb($hex, $alpha = false) {
       $hex      = str_replace('#', '', $hex);
       $length   = strlen($hex);
       $rgb['r'] = hexdec($length == 6 ? substr($hex, 0, 2) : ($length == 3 ? str_repeat(substr($hex, 0, 1), 2) : 0));
       $rgb['g'] = hexdec($length == 6 ? substr($hex, 2, 2) : ($length == 3 ? str_repeat(substr($hex, 1, 1), 2) : 0));
       $rgb['b'] = hexdec($length == 6 ? substr($hex, 4, 2) : ($length == 3 ? str_repeat(substr($hex, 2, 1), 2) : 0));
       if ( $alpha ) {
          $rgb['a'] = $alpha;
       }
       return $rgb;
    }
}
