<?php

class tsl_mam_app_settings_main
{

    private $app_version = '1.1';

    public function __construct(){

//        add_filter( 'admin_menu', array( $this , 'mam_admin_menu_manager' ));

    }

    function local_app_update_image(){

        if(current_user_can( 'manage_options' )) {

            update_option($_REQUEST['image_location'] , $_REQUEST['image_id']);
            $update_status = array('status' => 'done');

        }else{
            $update_status = array('status' => 'Shove Off.');
        }

        wp_send_json( $update_status );
    }

    function local_app_save_social(){

        $update_status = array('status' => 'Complete');

        if(current_user_can( 'manage_options' )) {

            update_option('local-app-social-facebook',$_REQUEST['facebook']);
            update_option('local-app-social-google',$_REQUEST['google']);
            update_option('local-app-social-instagram',$_REQUEST['instagram']);
            update_option('local-app-social-linkedin',$_REQUEST['linkedin']);
            update_option('local-app-social-pintrest',$_REQUEST['pintrest']);
            update_option('local-app-social-twitter',$_REQUEST['twitter']);
            update_option('local-app-social-website',$_REQUEST['website']);
            update_option('local-app-social-youtube',$_REQUEST['youtube']);

        }else{

            $update_status = array('status' => 'Shove Off.');
        }

        wp_send_json( $update_status );
        die();

    }

    function mam_main_content_class_settings( $cc_settings, $content_class_name, $type , $user = null )
    {

        $role = 'mam-all';
        if( $user )
        {
            $role = current( $user->roles );
        }

        if( $type == 'layout' ) {

            $settings = apply_filters( 'mam_app_settings_get_layout_settings' , false, $_REQUEST['tab'] );

            //todo with Delete After Database Migration
            if( ! $settings ) {
                $settings = get_option('mam-layout-settings');
            }

            if (!is_array($settings)) $settings = array();
            if (isset($settings[$content_class_name][$role])) {
                return $this->format_layout_settings( $settings[$content_class_name][$role] );
            }

            if( isset( $cc_settings[$content_class_name][$role]) ) return $this->format_layout_settings( $cc_settings[$content_class_name][$role] );
            $role = 'mam-all';
            if( isset( $cc_settings[$content_class_name][$role]) ) return $this->format_layout_settings( $cc_settings[$content_class_name][$role] );

        }else {
            $settings = get_option('mam-content-settings');
            if (!is_array($settings)) $settings = array();
            if (isset($settings[$content_class_name][$role])) {
                $settings = $settings[$content_class_name][$role];
            }else{
                return $cc_settings;
            }
            $new_sections = array();
            if( is_array( $settings) && sizeof( $settings ) > 0 ) {
                foreach ($settings as $index => $setting) {
                    foreach ($cc_settings as $section) {
                        if ($section['id'] == $index) {
                            $new_sections[] = $section;
                        }
                    }
                }
                return $new_sections;
            }
        }

        return $cc_settings;

    }

    function hexToRgb($hex, $alpha = false) {
       $hex      = str_replace('#', '', $hex);
       $length   = strlen($hex);
       $rgb['r'] = hexdec($length == 6 ? substr($hex, 0, 2) : ($length == 3 ? str_repeat(substr($hex, 0, 1), 2) : 0));
       $rgb['g'] = hexdec($length == 6 ? substr($hex, 2, 2) : ($length == 3 ? str_repeat(substr($hex, 1, 1), 2) : 0));
       $rgb['b'] = hexdec($length == 6 ? substr($hex, 4, 2) : ($length == 3 ? str_repeat(substr($hex, 2, 1), 2) : 0));
       if ( $alpha ) {
          $rgb['a'] = $alpha;
       }
       return $rgb;
    }


    function format_layout_settings( $settings )
    {

        $layout_settings = array();
        foreach ( $settings as $index => $setting )
        {
            if( is_array( $setting ))
            {
                if( $setting['type'] == 'field')
                {
                    $layout_settings['layout_field_'.$index] = $setting['title'];
                    $layout_settings['font_field_'.$index] = $setting['font_size'];
                    $color = $this->hexToRgb( $setting['color'] );;
                    $layout_settings['font_color_'.$index.'_red'] = $color['r'];
                    $layout_settings['font_color_'.$index.'_green'] = $color['g'];
                    $layout_settings['font_color_'.$index.'_blue'] = $color['b'];
                    $layout_settings['font_bold_'.$index] = str_replace( 'on', 'yes', $setting['font_bold']);

//                    $layout_settings['layout_field_'.$index] = $setting['title'];
//                    $layout_settings['font_field_'.$index] = $setting['font_size'];
//                    $color = $this->hexToRgb( $setting['color'] );;
//                    $layout_settings['font_color_'.$index.'_red'] = $color['r'];
//                    $layout_settings['font_color_'.$index.'_green'] = $color['g'];
//                    $layout_settings['font_color_'.$index.'_blue'] = $color['b'];
//                    $layout_settings['font_bold_'.$index] = str_replace( 'on', 'yes', $setting['font_bold']);


                }else if( $setting['type'] == 'checkbox')
                {
                    $layout_settings[$index] = str_replace( 'on', 'yes', $setting['value'] );
                }else if( $setting['type'] == 'color')
                {
                    $color = $this->hexToRgb( $setting['value'] );;
                    $layout_settings[$index.'_red'] = $color['r'];
                    $layout_settings[$index.'_green'] = $color['g'];
                    $layout_settings[$index.'_blue'] = $color['b'];
                }else if( $setting['type'] == 'textfield')
                {
                    $layout_settings[$index] = $setting['value'];
                }
            }else{
               $layout_settings[$index] = str_replace( 'on', 'yes', $setting );
            }
        }

        $layout_settings['layout'] = $layout_settings['layout_id'];

        if( isset( $layout_settings['layout_var_height'] ) && $layout_settings['layout_var_height'] == 'yes' )
        {
            unset( $layout_settings['layout_height'] );
        }

        return $layout_settings;
    }


    function admin_init()
    {
        if(current_user_can( 'manage_options' )) {

            if (isset($_REQUEST['page']) && $_REQUEST['page'] == 'mam-app-settings') {


                if( isset( $_REQUEST['tab'] ) && $_REQUEST['tab'] == 'mam-notifications' ) {
                    $admin_settings_page = new mam_app_settings_admin_page();
                    $reload = $admin_settings_page->do_save();
                    if( $reload ) {
                        wp_redirect(admin_url('admin.php?page=mam-app-settings&tab=' . $_REQUEST['tab'] .'&role=mam-all') );
                        exit;
                    }
                }

                if ( !isset( $_REQUEST['tab']) ) {

                    $role = 'mam-all';
                    if ( isset($_REQUEST['role'])) $role = $_REQUEST['role'];

                    wp_redirect(admin_url('admin.php?page=mam-app-settings&tab=general-settings&role='.$role));
                    exit;
                }


                if (!isset($_REQUEST['role']) && $_REQUEST['tab'] != 'mam-language') {
                    wp_redirect(admin_url('admin.php?page=mam-app-settings&tab=general-settings&role=mam-all'));
                    exit;
                }

                $admin_settings_page = new mam_app_settings_admin_page();
                $reload = $admin_settings_page->do_save();
                if ($reload) {
                    $role = '';
                    if (isset($_REQUEST['role'])) {
                        $role = '&role='.$_REQUEST['role'];
                    }
                    if( isset($_REQUEST['language'])){
                        $role .= '&language='.$_REQUEST['language'];
                    }
                    if( isset($_REQUEST['subtab'])){
                        $role .= '&subtab='.$_REQUEST['subtab'];
                    }
                    wp_redirect( admin_url('admin.php?page=mam-app-settings&tab='.$_REQUEST['tab'].$role));
                    exit;
                }
            }
        }

    }

    public function mam_admin_menu_manager(){

        add_submenu_page('local_app_setup', 'App Settings', 'App Settings', 'activate_plugins', 'mam-app-settings', array($this, 'add_settings_page'));

    }

    function add_setup_wizard_page()
    {
        //todo remove after testing
        delete_option( 'mam-setup-wizard' );

        $handler = new mam_setup_wizard();
        echo $handler->setup_wizard_screens();
    }

    function add_settings_page(){

		$admin_settings_page = new mam_app_settings_admin_page();
    	echo $admin_settings_page->create_admin_page();

	}

    public function process_last_json_check( $data_array ){

        $admin_settings_page = new mam_app_settings_global_settings();
        return $admin_settings_page->process_last_json_check( $data_array );

	}

    public function manage_phone_data( $data_array )
    {

        $admin_settings_page = new mam_app_settings_global_settings();
        $data_array = $admin_settings_page->get_global_settings( $data_array );
        $data_array = apply_filters( 'mam_main_populate_hss_categories' , $data_array );

        if (apply_filters('mam_main_populate_hss_tags', true)) {
            global $mam_home_tags;
            if( ! is_array( $mam_home_tags ) ) $mam_home_tags = array();
            if( isset( $data_array['homescreen_stack'] ) &&  is_array($data_array['homescreen_stack'])) {
                foreach ($data_array['homescreen_stack'] as $index => $item) {
                    if ($item['type'] == 'tag_cloud') {
                        $data_array['homescreen_stack'][$index]['tags'] = array();
                        foreach ($mam_home_tags as $tag) {
                            $data_array['homescreen_stack'][$index]['tags'][] = $tag;
                            $data_array['homescreen_stack'][$index]['rows'] = '3';
                        }
                    }
                }
            }
        }

        return $data_array;

	}

	public function mam_final_button_settings( $data_array )
    {

        $hander = new mam_app_settings_local_settings();
        return $hander->mam_final_button_settings( $data_array );

    }


    function admin_manager_scripts(){

        if (isset($_REQUEST['page']) && $_REQUEST['page'] == 'mam-app-settings') {
            $this->app_version = uniqid();
            wp_register_script('mam-app-settings', plugins_url('js/app-settings.js', __FILE__), array(), $this->app_version, true);
            wp_enqueue_script(array('mam-app-settings'));

            wp_register_style('tsl-general-css', plugins_url("css/tsl-general-css.css", __FILE__), array(), $this->app_version, 'screen');
            wp_enqueue_style(array('tsl-general-css'));
        }
	}

//	public function send_form_result( $form_id = null  )
//    {
//
//        if (isset($_REQUEST['formid'])) {
//            $form_id = $_REQUEST['formid'];
//        }
//
//        if (!$form_id) return;
//
//        $slug = 'woocommerce_user_billing_address_form';
//        $billing_address = get_option( $slug );
////mamdebug('test', __LINE__ );
//
//        if ($form_id == $billing_address) {
//
//            $json_data = json_decode($_REQUEST['formdata'], true);
//
//            $field_slug = 'user-first-name';
//            $first_name = get_option('mam-woocommerce-form-' . $form_id . '-' . $field_slug . '-form-field');
//            $field_slug = 'user-last-name';
//            $last_name = get_option('mam-woocommerce-form-' . $form_id . '-' . $field_slug . '-form-field');
//            $field_slug = 'user-display-name';
//            $display_name = get_option('mam-woocommerce-form-' . $form_id . '-' . $field_slug . '-form-field');
//            $field_slug = 'street';
//            $street = get_option('mam-woocommerce-form-' . $form_id . '-' . $field_slug . '-form-field');
//            $field_slug = 'city';
//            $city = get_option('mam-woocommerce-form-' . $form_id . '-' . $field_slug . '-form-field');
//            $field_slug = 'state';
//            $state = get_option('mam-woocommerce-form-' . $form_id . '-' . $field_slug . '-form-field');
//            $field_slug = 'zip';
//            $zip = get_option('mam-woocommerce-form-' . $form_id . '-' . $field_slug . '-form-field');
//            $field_slug = 'phone';
//            $phone = get_option('mam-woocommerce-form-' . $form_id . '-' . $field_slug . '-form-field');
//            $field_slug = 'notifications';
//            $notifications = get_option('mam-woocommerce-form-' . $form_id . '-' . $field_slug . '-form-field');
//            $field_slug = 'email';
//            $email = get_option('mam-woocommerce-form-' . $form_id . '-' . $field_slug . '-form-field');
//            $field_slug = 'company';
//            $company = get_option('mam-woocommerce-form-' . $form_id . '-' . $field_slug . '-form-field');
//            $field_slug = 'user-avatar';
//            $avatar = get_option('mam-woocommerce-form-' . $form_id . '-' . $field_slug . '-form-field');
//
//            $user_id_array = get_users(array('meta_key' => 'mam_app_token', 'meta_value' => $_REQUEST['pid']));
//
//            $first_name_val = null;
//            $last_name_val = null;
//            $display_name_val = null;
//            $user = 0;
//            if($user_id_array){
//                $user = $user_id_array[0]->ID;
//            }
//            if($user > 0 ) {
//
//                delete_user_meta($user, '_use_push_notifications' );
//                delete_user_meta($user, '_use_email_notifications' );
//
//                foreach ($json_data as $item) {
//
//                     if( strlen( $item['value'] ) == 0 ) continue;
//
//                    if ($item['field_id'] == $first_name && strlen( $item['value'] ) > 0 ){
//                        update_user_meta ($user, 'first_name', $item['value']);
//                        $first_name_val = $item['value'];
//                    }
//                    if ($item['field_id'] == $last_name && strlen( $item['value'] ) > 0){
//                        update_user_meta ($user, 'last_name', $item['value'] );
//                        $last_name_val = $item['value'];
//                    }
//                    if ($item['field_id'] == $display_name && strlen( $item['value'] ) > 0){
//                        update_user_meta ($user, 'display_name', $item['value'] );
//                        $display_name_val = $item['value'];
//                    }
//                    if ($item['field_id'] == $street) update_user_meta ($user, 'billing_address_1', $item['value'] );
//                    if ($item['field_id'] == $city)  update_user_meta ($user, 'billing_city', $item['value'] );
//                    if ($item['field_id'] == $state){
////                        $item['value'] = apply_filters( 'mam_convert_state_to_abbreviation', $item['value'] );
//                        update_user_meta ($user, 'billing_state', $item['value'] );
//                    }
//                    if ($item['field_id'] == $zip) update_user_meta ($user, 'billing_postcode', $item['value'] );
//                    if ($item['field_id'] == $phone) update_user_meta ($user, 'billing_phone', $item['value'] );
//                    if ($item['field_id'] == $company) update_user_meta ($user, 'billing_company', $item['value'] );
//
//                    if ($item['field_id'] == $notifications){
//                        if( $item['field_type'] == 'select' ) {
//                            update_user_meta($user, 'notification_prefs', $item['value']);
//                        }else if( $item['field_type'] == 'checkbox'){
//                            if( $item['field_label'] == 'Push Notifications' && $item['value'] == 'ON' )  update_user_meta($user, '_use_push_notifications', $item['value']);
//                            if( $item['field_label'] == 'Email' && $item['value'] == 'ON' )  update_user_meta($user, '_use_email_notifications', $item['value']);
//                        }
//                    }
//
//                    if ($item['field_id'] == $avatar) $this->save_avatar( $item['value'] , $user) ;
//
//                    if ($item['field_id'] == $email ){
//
//                        if( get_user_meta( $user , '_tsl_anon_user' ) ){
//
//                            $is_user = get_user_by('login', $item['value'] );
//
//                            if(!$is_user) {
//
//                                //change from an anon user to a user
//                                //change email address
//                                wp_update_user(array('ID' => $user, 'user_email' => $item['value']));
//
//                                //change username
//                                global $wpdb;
//                                $wpdb->update($wpdb->users, array('user_login' => $item['value']), array('ID' => $user));
//
//                                //remove anon references
//                                delete_user_meta($user, '_tsl_anon_user');
//                                delete_user_meta($user, '_tsl_anon_user_pid');
//
//
//                            }else{
//                                //todo - what to do if the user exists?
//
//
//
//                            }
//                        }
//                    }
//                }
//
//                if($first_name_val) {
//
//                    if( ! $display_name_val ){
//                        $display_name_val = $first_name_val . ' ' . $last_name_val;
//                    }
//
//                    update_user_meta ($user, 'billing_first_name', $first_name_val );
//                    update_user_meta ($user, 'billing_last_name', $last_name_val );
//                    update_user_meta ($user, 'billing_email', $user_id_array[0]->user_email );
//
//                    $args = array(
//                        'ID' => $user,
//                        'nickname' => $first_name_val . ' ' . $last_name_val,
//                        'display_name' => $display_name_val,
//                        'first_name' => $first_name_val ,
//                        'last_name' =>  $last_name_val,
//                    );
//                    wp_update_user($args);
//
//                    if( strlen( get_user_meta ($user, 'display_name', true )) == 0 ) {
//                        update_user_meta($user, 'display_name', $display_name_val);
//                    }
//
//                }
//
//                $this->geocode_address( $user_id_array[0] );
//
//                do_action( 'mam_after_update_user_profile' );
//
//                if (function_exists('local_app_get_phone_data')) {
//                    $jsonData = local_app_get_phone_data(true);
//                    return array('status' => 'success', 'process_normal' => false, 'jsonData' => $jsonData , 'send_notifcations' => false, 'type' => 'return_to_sender', 'message' => 'Your profile has been updated.' );
//
//                }
//
//                return array('status' => 'success', 'process_normal' => false, 'send_notifcations' => false, 'type' => 'return_to_sender', 'message' => 'Your profile has been updated. ');
//
//
//            }
//        }
//    }

    function geocode_address($user)
    {

        $apikey = trim( get_option('tsl-google-api-key') );

        $buyer_info = get_user_meta( $user->ID );

        if( isset( $buyer_info['billing_postcode'][0] ) || isset($buyer_info['billing_address_1']) && $apikey ) {

            $address = $buyer_info['billing_address_1'][0] . ' ' . $buyer_info['billing_city'][0] . ' ' . $buyer_info['billing_state'][0] . ' ' . $buyer_info['billing_postcode'][0];
            $address = trim( $address );

            if (strlen($address) > 4) {

                $geocode = file_get_contents("https://maps.google.com/maps/api/geocode/json?address=" . urlencode($address) . "&key=" . $apikey);

                $output = json_decode($geocode);
                $geo_array['lat'] = $output->results[0]->geometry->location->lat;
                $geo_array['lon'] = $output->results[0]->geometry->location->lng;

                if ($output->status == 'ZERO_RESULTS') {


                } else {
                    update_user_meta($user->ID, '_user_lat', $geo_array['lat']);
                    update_user_meta($user->ID, '_user_lon', $geo_array['lon']);
                }
            }
        }
    }


    function save_avatar($value , $user){

        $filename_path = md5(time() . uniqid()) . ".png";
        $decoded = base64_decode($value);
        $wp_upload_dir = wp_upload_dir();

        if (!file_exists($wp_upload_dir['path'] . '/mam-avatars/')) {
            mkdir($wp_upload_dir['path'] . '/mam-avatars/', 0777, true);
        }

        file_put_contents($wp_upload_dir['path'] . '/mam-avatars/' . $filename_path, $decoded);

        update_user_meta( $user , '_user_avatar', $wp_upload_dir['url'] . '/mam-avatars/' . $filename_path);

        $filetype = wp_check_filetype( basename( $filename_path ), null );

        $filename = $wp_upload_dir['path'].'/mam-avatars/'.$filename_path;

        // Get the path to the upload directory.
        $wp_upload_dir = wp_upload_dir();

        // Prepare an array of post data for the attachment.
        $attachment = array(
            'guid'           => $wp_upload_dir['url'] . '/mam-avatars/' . basename( $filename ),
            'post_mime_type' => $filetype['type'],
            'post_title'     => preg_replace( '/\.[^.]+$/', '', basename( $filename ) ),
            'post_content'   => '',
            'post_status'    => 'inherit'
        );

        // Insert the attachment.
        $attach_id = wp_insert_attachment( $attachment, $filename );

         // Insert the attachment.
//        $attach_data = wp_generate_attachment_metadata( $attach_id, $filename );
//        mamdebug('fileid', $attach_data );
//        wp_update_attachment_metadata( $attach_id, $attach_data );

        apply_filters( 'mam_after_update_user_avatar_saved' , $attach_id );


    }

    public function local_app_ajax_handler(){

        $update_status = array();
        $update_status['status'] = 'Nothing';
        $send_full_json = true;

        if(isset($_REQUEST['punchin'])){
            $send_full_json = true;
            $user = get_users(array('meta_key' => 'mam_app_token', 'meta_value' => $_REQUEST['pid']));
            if ( $user){

                update_user_meta($user[0]->ID, '_mam_tracking_opted_in', 1 );

                if($_REQUEST['punchin'] == 1) {
                    update_user_meta($user[0]->ID, 'tsl_activity_user_active_date', date('Y-d-m'));
                    update_user_meta($user[0]->ID, 'tsl_activity_user_is_punched_in', 1 );
                }else{
                    update_user_meta($user[0]->ID, 'tsl_activity_user_punch_out_date', date('Y-d-m'));
                    update_user_meta($user[0]->ID, 'tsl_activity_user_is_punched_in', 2 );
                }
            }
        }

          switch($_REQUEST['subaction']) {
              case 'refresh':
                  $update_status['status'] = 'success';
                  if (function_exists('local_app_get_phone_data')) {
                      $update_status['jsonData'] = local_app_get_phone_data(true);
                  }
                  break;
            case 'getPN':
                $send_full_json = false;
                $handler = new mam_notification_manager();
//                $update_status = $handler->get_notifications_for_user( );
                $get_data = local_app_get_phone_data( true );
                if( isset( $get_data['notifications'])){
                    $update_status['notifications'] = $get_data['notifications'];
                }
                break;
            case 'readPN':
                $send_full_json = false;
                $handler = new mam_notification_manager();
                $handler->mark_notification_read();
//                $update_status = $handler->get_notifications_for_user();
                $get_data = local_app_get_phone_data( true );
                if( isset( $get_data['notifications'])){
                    $update_status['notifications'] = $get_data['notifications'];
                }
                $update_status['status'] = 'success';
                break;
            case 'deletePN':
                $send_full_json = false;
                $handler = new mam_notification_manager();
                $handler->remove_notification();
//                $update_status = $handler->get_notifications_for_user();
                $get_data = local_app_get_phone_data( true );
                if( isset( $get_data['notifications'])){
                    $update_status['notifications'] = $get_data['notifications'];
                }
                $update_status['status'] = 'success';
                break;
            case 'gps_ping':

                if( isset($_REQUEST['tracking']) && $_REQUEST['tracking'] == 1 ){

                    $user = get_users(array('meta_key' => 'mam_app_token', 'meta_value' => $_REQUEST['pid']));
                    if ( $user ) {
                        $user_id = $user[0]->ID;

                        if( get_user_meta( $user_id , '_mam_tracking_opted_in' )  ){

                            if( isset($_REQUEST['lat']) && isset($_REQUEST['lon']) && get_user_meta($user_id, 'tsl_activity_user_is_punched_in', true ) == 1 ) {
                                update_user_meta($user_id, '_mam_tracker_lon', $_REQUEST['lon']);
                                update_user_meta($user_id, '_mam_tracker_lat', $_REQUEST['lat']);
                                update_user_meta($user_id, '_mam_tracker_time', date( 'u' ));
                            }
                        }
                    }
                }

                if( isset($_REQUEST['pingaction'])){
                    switch($_REQUEST['pingaction']) {
                        case 'favorite':
                            $send_full_json = false;
                            $likes = get_post_meta( $_REQUEST['id'] , '_mam_likes' , true );
                            if( ! $likes ) $likes = 0;
                            $likes++;
                            update_post_meta( $_REQUEST['id'] , '_mam_likes' , $likes );

                            break;
                        case 'unfavorite':
                            $send_full_json = false;
                            $likes = get_post_meta( $_REQUEST['id'] , '_mam_likes' , true );
                            if( $likes > 0 ) {
                                $likes--;
                                update_post_meta($_REQUEST['id'], '_mam_likes', $likes);

                            }
                            break;
                    }

                }

                if(isset($_REQUEST['deleteItem'])){

                    if($_REQUEST['pingkey'] == 'sdfh89y7f8dostogas67of87sd' ) {

                        if(has_action('tsl_delete_record')){
                            do_action('tsl_delete_record');
                        }else {

                            $user = get_users(array('meta_key' => 'mam_app_token', 'meta_value' => $_REQUEST['pid']));
                            if ($user) {

                                $delete_status = 'trash';
                                if( get_option( 'mam_delete_from_server_status') ) $delete_status = get_option( 'mam_delete_from_server_status');

                                $my_post = array(
                                    'ID' => $_REQUEST['deleteItem'],
                                    'post_status' => $delete_status,
                                );

                                wp_update_post($my_post);
                            }
                        }
                    }
                }

                if ( isset($_REQUEST['checkinloc']) ) {
                    if(has_action('tsl_do_points_check_in')){
                        do_action('tsl_do_points_check_in');
                    }
                    if(has_action('tsl_do_check_in')){
                        do_action('tsl_do_check_in');
                    }
                }

                if ( isset($_REQUEST['start']) ) {

                    update_post_meta( $_REQUEST['id'] , 'tsl_mam_activity_task_status', 'In_Progress' );
                    update_post_meta( $_REQUEST['id'] , 'tsl_mam_activity_started_status', gmdate('Y-m-dTH:i:s'));
                }
                if ( isset($_REQUEST['restart'])) {
                    update_post_meta( $_REQUEST['id'] , 'tsl_mam_activity_task_status', 'Assigned' );
                }


                $update_status['status'] = 'success';
                if( $send_full_json ) {
//                    if ((!isset($_REQUEST['deviceand']) && isset($_REQUEST['punchin'])) || isset($_REQUEST['refresh'])) {

                        if (function_exists('local_app_get_phone_data') && $send_full_json) {
                            $update_status['jsonData'] = local_app_get_phone_data(true);
                        }
//                    }
                }

                break;

            }

        wp_send_json( $update_status );
        die();

    }

    function local_app_save_file(){
        /* Getting file name */
        $filename = $_FILES['file']['name'];

        /* Location */
        $dir_path = WP_PLUGIN_DIR.'/mam-main/pemcerts/';
        if (!file_exists($dir_path)) {
            mkdir($dir_path, 0777);
        }
        $location = $dir_path.$filename;
        if(move_uploaded_file($_FILES['file']['tmp_name'],$location)){
            $response = array('status' => 200, 'msg' => 'File successfully uploaded.', 'path' => $filename);
        }else{
            $response = array('status' => 400, 'msg' => 'Error occurs while uploading file.');
        }

        wp_send_json( $response );
        die();
    }

    function local_app_save_plist_file(){
        /* Getting file name */
        $filename = $_FILES['file']['name'];
        $new_filename = 'GoogleServices-Info.plist';

        /* Location */
        $dir_path = WP_PLUGIN_DIR.'/mam-main/publishing-files/';
        if (!file_exists($dir_path)) {
            mkdir($dir_path, 0777);
        }
        $location = $dir_path.$filename;
        $file_url = plugins_url().'/mam-main/publishing-files/'.$filename;
        if(move_uploaded_file($_FILES['file']['tmp_name'],$location)){
            $response = array('status' => 200, 'msg' => 'File successfully uploaded.', 'url' => $file_url);
        }else{
            $response = array('status' => 400, 'msg' => 'Error occurs while uploading file.');
        }

        wp_send_json( $response );
        die();
    }

    function local_app_get_data()
    {
        $data = array();
        if($_REQUEST['app_type'] == 'ios'){
            $app_icon = '';
            $launch_screen1 = '';
            $launch_screen2 = '';
            $image_info = wp_get_attachment_image_src(get_option('local-app-images-app-icon'), 'full');
            if ($image_info) $app_icon = $image_info[0];

            if (is_numeric(get_option('local-app-images-launch-screen-1'))) {
                $image_info_1 = wp_get_attachment_image_src(get_option('local-app-images-launch-screen-1'), 'full');
                if ($image_info_1) $launch_screen1 = $image_info_1[0];
            } else {
                if (get_option('local-app-images-launch-screen-1')) $launch_screen1 = get_option('local-app-images-launch-screen-1');
            }

            if (is_numeric(get_option('local-app-images-launch-screen-2'))) {
                $image_info_2 = wp_get_attachment_image_src(get_option('local-app-images-launch-screen-2'), 'full');
                if ($image_info_2) $launch_screen2 = $image_info_2[0];
            } else {
                if (get_option('local-app-images-launch-screen-2')) $launch_screen2 = get_option('local-app-images-launch-screen-2');
            }

            $app_name = get_option('local-app-ios-app-name', true);
            $team_id = get_option('ios_pn_team_id', true);
            $camera_message = get_option('ios_app_camera_message', true);
            $gps_message = get_option('ios_app_gps_message', true);
            $contacts_message = get_option('ios_app_contacts_message', true);
            $nfc_message = get_option('ios_app_nfc_message');
            $submit_type = get_option('ios_app_submit_type', true);
            $google_plist = get_option('ios_app_google_plist', true);
            $google_places_api = get_option('ios_app_google_places_api', true);
            $app_channel = get_option('local-app-ios-app-channel', true);
            $bundle_id = get_option('ios_pn_app_bundle_id');
            $ios_build_number = get_option('mam_ios_build_number', true);
            $ios_version_number = get_option('mam_ios_version_number', true);


//            if($bundle_id){
//                $ios_build_number = get_option('mam_ios_build_number', true);
//                if(!is_numeric($ios_build_number)) $ios_build_number = 0;
//
//                $ios_build_number++;
//                update_option('mam_ios_build_number', $ios_build_number);
//
//                $ios_version_number = get_option('mam_ios_version_number', true);
//                if(!is_numeric($ios_version_number)) $ios_version_number = 1.0;
//
//                $ios_version_number = $ios_version_number + 0.1;
//                update_option('mam_ios_version_number', $ios_version_number);
//            }else{
//                $ios_build_number = 0;
//                $ios_version_number = 1.0;
//            }

            $data = array('app_name' => $app_name, 'bundle_id' => $bundle_id, 'team_id' => $team_id, 'version_number' => $ios_version_number, 'build_number' => $ios_build_number, 'camera_message' => $camera_message, 'gps_message' => $gps_message, 'contacts_message' => $contacts_message, 'nfc_message' => $nfc_message, 'google_plist' => $google_plist, 'app_icon' => $app_icon, 'launch_screen1' => $launch_screen1, 'launch_screen2' => $launch_screen2, 'submit_type' => $submit_type);
            if($google_places_api != ''){
                $data['google_places_api'] = $google_places_api;
            }
            if($app_channel != '' && !is_numeric($app_channel)){
                $data['channel'] = $app_channel;
            }else{
                $data['channel'] = 'Prod';
            }
        }elseif($_REQUEST['app_type'] == 'android'){
            $app_icon = '';
            $launch_screen1 = '';

            $image_info = wp_get_attachment_image_src(get_option('local-app-images-android-app-icon'), 'full');
            if ($image_info) $app_icon = $image_info[0];

            if (is_numeric(get_option('local-app-images-launch-screen-1'))) {
                $image_info_1 = wp_get_attachment_image_src(get_option('local-app-images-launch-screen-1'), 'full');
                if ($image_info_1) $launch_screen1 = $image_info_1[0];
            } else {
                if (get_option('local-app-images-launch-screen-1')) $launch_screen1 = get_option('local-app-images-launch-screen-1');
            }

            $data = array('app_icon' => $app_icon, 'launch_screen1' => $launch_screen1);
        }

        $data['use_gps'] = 'no';
        $use_gps_data = get_option('tsl-setting-use_gps', true);
        if(is_array($use_gps_data) && !empty($use_gps_data)){
            foreach ($use_gps_data as $role_data){
                if($role_data['general-settings'] == 'yes'){
                    $data['use_gps'] = 'yes';
                    break;
                }
            }
        }
        $data['use_pns'] = 'no';
        $use_push_notification_data = get_option('tsl-setting-use_push_notifications', true);
        if(is_array($use_push_notification_data) && !empty($use_push_notification_data)){
            foreach ($use_push_notification_data as $role_data){
                if($role_data['general-settings'] == 'yes'){
                    $data['use_pns'] = 'yes';
                    break;
                }
            }
        }
        $data['signup_with_platform'] = 'no';
        $sign_up_with_google_data = get_option('tsl-sign_up_with_google', true);
        if(is_array($sign_up_with_google_data) && !empty($sign_up_with_google_data)){
            foreach ($sign_up_with_google_data as $role_data) {
                foreach ($role_data as $dataValue){
                    if ($dataValue == 'yes') {
                        $data['signup_with_platform'] = 'yes';
                        break;
                    }
                }
            }
        }

        $saved_entitlements = get_option('saved_entitlements', true);
        if(!is_array($saved_entitlements)) $saved_entitlements = array();

        $data['nfc_reader'] = 'no';
        $data['background_location'] = 'no';
        if( in_array( 'nfc-reader', $saved_entitlements))
        {
            $data['nfc_reader'] = 'yes';
        }
        if( in_array( 'location-services-background', $saved_entitlements))
        {
            $data['background_location'] = 'yes';
        }

        $data = apply_filters( 'mam_publish_additional_settings', $data );
        $response = array('status' => 400, 'msg' => 'APP Data successfully fetched.', 'app_data' => $data );
        wp_send_json( $response );
        die();
    }

    function local_app_update_button_data(){

        if(current_user_can( 'manage_options' )) {

            $role = '';
            if(isset($_REQUEST['this_role'])){
                if($_REQUEST['this_role'] != 'mam-all') {
                    $role = $_REQUEST['this_role'];
                }
            }

            if(isset($_REQUEST['id'])) $this->local_app_add_button_if_not_exist();

            switch($_REQUEST['data_type']) {
                case 'content':
                    if($_REQUEST['data_location'] == 'main') {
                        $button_array = apply_filters( 'mam_app_settings_get_buttons', false, $role, 'main' );
                        $button_index = 0;
                        for ($x = 0; $x < sizeof($button_array); $x++) {
                            if ($button_array[$x]['id'] == $_REQUEST['id']) {
                                $button_array[$x]['type'] = $_REQUEST['data_name'];
                                $button_array[$x]['source'] = $_REQUEST['data_value'];
                                $button_index = $x;
                                break;
                            }
                        }
                        apply_filters( 'mam_app_settings_set_button', $_REQUEST['id'], $role, 'main', $button_array[$button_index] );
                    }else{
                        $button_array = apply_filters( 'mam_app_settings_get_buttons', false, $role, 'left' );
                        $button_index = 0;
                        for ($x = 0; $x < sizeof($button_array); $x++) {
                            if ($button_array[$x]['id'] == $_REQUEST['id']) {
                                $button_array[$x]['type'] = $_REQUEST['data_name'];
                                $button_array[$x]['source'] = $_REQUEST['data_value'];
                                $button_index = $x;
                                break;
                            }
                        }
                        apply_filters( 'mam_app_settings_set_button', $_REQUEST['id'], $role, 'left', $button_array[$button_index] );
                    }
                    break;
                case 'new_button':
                    if($_REQUEST['data_location'] == 'main') {
                        $button_array = apply_filters( 'mam_app_settings_get_buttons', false, $role, 'main' );
                        $icon = plugin_dir_url(__FILE__) . 'includes/icons/default/icon_' . $_REQUEST['data_value'] . '.png';
                        $button_array[] = array('id' => $_REQUEST['id'], 'name' => 'Button', 'icon' => $icon, 'type' => 'Web_URL', 'source' => '');
                        apply_filters( 'mam_app_settings_set_button', $_REQUEST['id'], $role, 'main', $button_array[sizeof($button_array)-1] );
                    }else{
                        $button_array = apply_filters( 'mam_app_settings_get_buttons', false, $role, 'left' );
                        $icon = plugin_dir_url(__FILE__) . 'includes/icons/default/icon_' . $_REQUEST['data_value'] . '.png';
                        $button_array[] = array('id' => $_REQUEST['id'], 'name' => 'Button', 'icon' => $icon, 'type' => 'Web_URL', 'source' => '');
                        apply_filters( 'mam_app_settings_set_button', $_REQUEST['id'], $role, 'left', $button_array[sizeof($button_array)-1] );
                    }
                    break;
                case 'button':
                    if($_REQUEST['data_location'] == 'main') {
                        $button_array = apply_filters( 'mam_app_settings_get_buttons', false, $role, 'main' );
                        $button_index = 0;
                        for ($x = 0; $x < sizeof($button_array); $x++) {
                            if ($button_array[$x]['id'] == $_REQUEST['id']) {
                                $button_array[$x][$_REQUEST['data_name']] = $_REQUEST['data_value'];
                                $button_index = $x;
                                break;
                            }
                        }
                        apply_filters( 'mam_app_settings_set_button', $_REQUEST['id'], $role, 'main', $button_array[$button_index] );
                    }else{
                        $button_array = apply_filters( 'mam_app_settings_get_buttons', false, $role, 'left' );
                        $button_index = 0;
                        for ($x = 0; $x < sizeof($button_array); $x++) {
                            if ($button_array[$x]['id'] == $_REQUEST['id']) {
                                $button_array[$x][$_REQUEST['data_name']] = $_REQUEST['data_value'];
                                $button_index = $x;
                                break;
                            }
                        }
                        apply_filters( 'mam_app_settings_set_button', $_REQUEST['id'], $role, 'left', $button_array[$button_index] );
                    }
                    break;
                case 'button_order':
                    if($_REQUEST['data_location'] == 'main') {
                        $button_array = apply_filters( 'mam_app_settings_get_buttons', false, $role, 'main' );
                        $new_button_array = array();
                        foreach ($_REQUEST['data_value'] as $index) {
                            for ($x = 0; $x < sizeof($button_array); $x++) {
                                if ($button_array[$x]['id'] == $index) {
                                    $new_button_array[] = $button_array[$x];
                                }
                            }
                        }
                        $button_array = $new_button_array;
                        $button_array = apply_filters( 'mam_app_settings_button_order', $button_array, 'main', $role );
                    }else{
                        $button_array = apply_filters( 'mam_app_settings_get_buttons', false, $role, 'left' );
                        $new_button_array = array();
                        foreach ($_REQUEST['data_value'] as $index) {
                            for ($x = 0; $x < sizeof($button_array); $x++) {
                                if ($button_array[$x]['id'] == $index) {
                                    $new_button_array[] = $button_array[$x];
                                }
                            }
                        }
                        $button_array = $new_button_array;
                        $button_array = apply_filters( 'mam_app_settings_button_order', $button_array, 'left', $role );
                    }
                    break;
                case 'button_delete':
                    if($_REQUEST['data_location'] == 'main') {
                        $button_array = apply_filters( 'mam_app_settings_get_buttons', false, $role, 'main' );
                        $new_button_array = array();
                        for ($x = 0; $x < sizeof($button_array); $x++) {
                            if ($button_array[$x]['id'] != $_REQUEST['data_value']) {
                                $new_button_array[] = $button_array[$x];
                            }
                        }
                        $button_array = $new_button_array;
                        $button_array = apply_filters( 'mam_app_settings_delete_button', $button_array, $_REQUEST['data_value'] );
                    }else{
                        $button_array = apply_filters( 'mam_app_settings_get_buttons', false, $role, 'left' );
                        $new_button_array = array();
                        for ($x = 0; $x < sizeof($button_array); $x++) {
                            if ($button_array[$x]['id'] != $_REQUEST['data_value']) {
                                $new_button_array[] = $button_array[$x];
                            }
                        }
                        $button_array = $new_button_array;
                        $button_array = apply_filters( 'mam_app_settings_delete_button', $button_array, $_REQUEST['data_value'] );
                    }
                    break;
            }
            $update_status = array('status' => 'done' , 'button_array' => $button_array);

        }else{
            $update_status = array('status' => 'Shove Off.');
        }

        wp_send_json( $update_status );
        die();
    }

    function local_app_add_button_if_not_exist(){

        $role = '';
        if(isset($_REQUEST['this_role'])) $role = $_REQUEST['this_role'];

        $button_array = apply_filters( 'mam_app_settings_get_buttons', false, $role, 'main' );
        $found = false;
        if( ! is_array( $button_array )) {
            $button_array = array();
        }else{
            for ($x = 0; $x < sizeof($button_array); $x++) {
                if ($button_array[$x]['id'] == $_REQUEST['id']) {
                    $found = true;
                }
            }
        }
        if( ! $found){
            $button_array[] = array('id' => $_REQUEST['id']);
        }

    }

    function local_app_get_new_guid()
    {
        global $wpdb;
        if (function_exists('com_create_guid') === true)
        {
            return trim(com_create_guid(), '{}');
        }
        $table_name = $wpdb->prefix . 'mam_app_settings_buttons';
        $guid = sprintf('%04X%04X-%04X-%04X-%04X-%04X%04X%04X', mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(16384, 20479), mt_rand(32768, 49151), mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(0, 65535));
        $results = $wpdb->get_results("SELECT button_id FROM $table_name WHERE button_id = '".$guid."'");

        if(sizeof($results) > 0) {
            $guid = $this->local_app_get_new_guid();
        }
        return $guid;
    }

    function mam_get_home_cat_section_term(){
        $taxonomy = $_POST['taxonomy'];
        $args = array(
            'taxonomy' => $taxonomy,
            'hide_empty' => false,
        );
        $terms = get_terms($args);
        $term_array = array();
        foreach ($terms as $term) {
            $term_array[] = array('slug' => $term->name, 'name' => $term->name);
        }

        wp_send_json( array('status' => 200, 'terms' => $term_array) );
        die();
    }

    function mam_get_role_buttons(){
        $role = $_POST['role'];
        $buttons_array = array();
        $button_array = apply_filters( 'mam_app_settings_get_buttons', false, $role, 'main' );

        if( is_array($button_array)) {
            foreach ($button_array as $button) {
                if($_REQUEST['tab'] == $button['id']) continue;
                $buttons_array[] = array('slug' => $button['id'], 'name' => 'Main - ' . $button['name']);
            }
        }
        $left_menu = apply_filters( 'mam_app_settings_get_buttons', false, $role, 'left' );

        if( is_array($left_menu)) {
            foreach ($left_menu as $button) {
                if($_REQUEST['tab'] == $button['id']) continue;
                $buttons_array[] = array('slug' => $button['id'], 'name' => 'Left - ' . $button['name']);
            }
        }
        wp_send_json( array('status' => 200, 'buttons' => $buttons_array) );
        die();
    }

    function local_app_resize_image(){
        $image_id = $_POST['image_id'];
        $size = $_POST['size'];
        $bg_color = (get_option('local-app-app-icon-bg')) ? get_option('local-app-app-icon-bg') : '#ffffff';
        $bg_color = (isset($_POST['bg']) && $_POST['bg'] != "") ? $_POST['bg'] : $bg_color;
        $image_url = wp_get_attachment_url($image_id);
        $upload_dir = wp_upload_dir();
        $inputForeground = str_replace($upload_dir['baseurl'], $upload_dir['basedir'], $image_url);
        $ext = pathinfo(basename($inputForeground), PATHINFO_EXTENSION);
        $new_file_name = str_replace('.'.$ext, '',basename($inputForeground)) . '_' . $size . '.' . $ext;
        $local_app_submit_handler = new local_app_submit();
        $local_app_submit_handler->resizeImage($inputForeground, $upload_dir['path'], $size, $new_file_name, $bg_color);
        $file_name = $upload_dir['path'].'/'.$new_file_name;
        $filetype = wp_check_filetype( basename( $file_name ), null );
        $attachment = array(
            'guid'           => $upload_dir['url'] . '/' . basename( $file_name ),
            'post_mime_type' => $filetype['type'],
            'post_title'     => preg_replace( '/\.[^.]+$/', '', basename( $file_name ) ),
            'post_content'   => '',
            'post_status'    => 'inherit'
        );

        // Insert the attachment.
        $attach_id = wp_insert_attachment( $attachment, $file_name );
        $attach_data = wp_generate_attachment_metadata( $attach_id, $file_name );
        wp_update_attachment_metadata( $attach_id, $attach_data );

        wp_send_json( array('status' => 200, 'attach_id' => $attach_id, 'attach_url' => $upload_dir['url'] . '/' . basename( $file_name ) ) );
        die();
    }

    function local_app_generate_launch_screen(){
        $bgColor = $_POST['bg_color'];
        $app_icon = $_POST['app_icon'];
        $app_icon_id = attachment_url_to_postid($app_icon);
        $upload_dir = wp_upload_dir();
        $ls_w = 640;
        $ls_h = 1136;
        $fileName_1 = 'launch_screen_1.png';
        $fileName_2 = 'launch_screen_2.png';
        $app_settings_handler = new tsl_mam_app_settings_main();
        $rgb = $app_settings_handler->hexToRgb($bgColor);

        $app_icon_src = wp_get_attachment_image_src($app_icon_id, array(300, 300));
        $app_icon_1 = $app_icon_src[0];
        $inputImage = str_replace($upload_dir['baseurl'], $upload_dir['basedir'], $app_icon_1);
        $image = imagecreatefrompng($inputImage);
        if (!$image) {
            mamdebug('android icons', "Failed to load input image: $inputImage");
        }

        // Create a blank canvas for the resized image
        $resizedImage = imagecreatetruecolor($ls_w, $ls_h);

        $transparency = imagecolorallocate($resizedImage, $rgb['r'], $rgb['g'], $rgb['b']);
        imagefill($resizedImage, 0, 0, $transparency);

        $marge_right = 170;
        $marge_bottom = 418;
        $sx = imagesx($image);
        $sy = imagesy($image);

        imagecopy($resizedImage, $image, $marge_right, $marge_bottom, 0, 0, $sx, $sy);

        // Save the resized image
        $outputFile = $upload_dir['path'] . '/' . $fileName_1;
        imagepng($resizedImage, $outputFile);

        // Free memory
        imagedestroy($resizedImage);

        $destination_url_1 = $upload_dir['url'] . '/' . $fileName_1;
        $file_name = $upload_dir['path'].'/'.$fileName_1;
        $filetype = wp_check_filetype( basename( $file_name ), null );
        $attachment = array(
            'guid'           => $upload_dir['url'] . '/' . basename( $file_name ),
            'post_mime_type' => $filetype['type'],
            'post_title'     => preg_replace( '/\.[^.]+$/', '', basename( $file_name ) ),
            'post_content'   => '',
            'post_status'    => 'inherit'
        );

        // Insert the attachment.
        $attach_id = wp_insert_attachment( $attachment, $file_name );
        $attach_data = wp_generate_attachment_metadata( $attach_id, $file_name );
        wp_update_attachment_metadata( $attach_id, $attach_data );
        $launch_screen_1_id = $attach_id;

        /* launch screen 2 starts */
        $ls_w = 1125;
        $ls_h = 2436;
        $app_icon_src = wp_get_attachment_image_src($app_icon_id, array(600, 600));
        $app_icon_2 = $app_icon_src[0];
        $inputImage = str_replace($upload_dir['baseurl'], $upload_dir['basedir'], $app_icon_2);
        $image = imagecreatefrompng($inputImage);
        if (!$image) {
            mamdebug('android icons', "Failed to load input image: $inputImage");
        }
        // Create a blank canvas for the resized image
        $resizedImage = imagecreatetruecolor($ls_w, $ls_h);
        $transparency = imagecolorallocate($resizedImage, $rgb['r'], $rgb['g'], $rgb['b']);
        imagefill($resizedImage, 0, 0, $transparency);

        $marge_right = 262;
        $marge_bottom = 918;
        $sx = imagesx($image);
        $sy = imagesy($image);

        imagecopy($resizedImage, $image, $marge_right, $marge_bottom, 0, 0, $sx, $sy);

        // Save the resized image
        $outputFile = $upload_dir['path'] . '/' . $fileName_2;
        imagepng($resizedImage, $outputFile);

        $destination_url_2 = $upload_dir['url'] . '/' . $fileName_2;
        $file_name = $upload_dir['path'].'/'.$fileName_2;
        $filetype = wp_check_filetype( basename( $file_name ), null );
        $attachment = array(
            'guid'           => $upload_dir['url'] . '/' . basename( $file_name ),
            'post_mime_type' => $filetype['type'],
            'post_title'     => preg_replace( '/\.[^.]+$/', '', basename( $file_name ) ),
            'post_content'   => '',
            'post_status'    => 'inherit'
        );

        // Insert the attachment.
        $attach_id = wp_insert_attachment( $attachment, $file_name );
        $attach_data = wp_generate_attachment_metadata( $attach_id, $file_name );
        wp_update_attachment_metadata( $attach_id, $attach_data );
        $launch_screen_2_id = $attach_id;

        // Free memory
        imagedestroy($resizedImage);
        imagedestroy($image);

        wp_send_json( array('status' => 200, 'launch_screen_1_id' => $launch_screen_1_id, 'launch_screen_1' => $destination_url_1.'?session='.time(), 'launch_screen_2_id' => $launch_screen_2_id, 'launch_screen_2' => $destination_url_2.'?session='.time() ) );
        die();
    }
}
