<?php

class mam_push_notifications_settings_manager
{

    function create_page()
    {

        $handler = new mam_app_settings_admin_page();

        $settings_array[] = array( 'title' => 'iTunes Team ID', 'variable' => 'ios_pn_team_id', 'type' => 'text' , 'id' => 'ios_pn_team_id' , 'environment' => 'all' , 'default' => 'no', 'desc' => 'This is the Team ID from iTunes' );
        $settings_array[] = array( 'title' => 'iTunes Key ID', 'variable' => 'ios_pn_key_id', 'type' => 'text' , 'id' => 'ios_pn_key_id' , 'environment' => 'all' , 'default' => 'no', 'desc' => 'This is the Key ID from iTunes' );
        $settings_array[] = array( 'title' => 'iTunes Bundle ID', 'variable' => 'ios_pn_app_bundle_id', 'type' => 'text' , 'id' => 'ios_pn_app_bundle_id' , 'environment' => 'all' , 'default' => 'no', 'desc' => 'This is the bundle ID from iTunes' );
        $settings_array[] = array( 'title' => 'Pem Certs', 'variable' => 'ios_pn_pem_certs', 'type' => 'file' , 'id' => 'ios_pn_pem_certs' , 'environment' => 'all' , 'default' => 'no', 'desc' => 'Select Pem Certificate.' );
        $settings_array[] = array( 'title' => 'Sandbox Only?', 'variable' => 'ios_pn_use_sandbox', 'type' => 'yes-no' , 'id' => 'ios_pn_use_sandbox' , 'environment' => 'all' , 'default' => 'no', 'desc' => 'Select Yes if not published yet.' );

        $settings_array[] = array( 'title' => 'Sign In with Apple Key ID', 'variable' => 'ios_sign_in_key_id', 'type' => 'text' , 'id' => 'ios_sign_in_key_id' , 'environment' => 'all' , 'default' => 'no', 'desc' => 'This is the Key ID from iTunes' );
        $settings_array[] = array( 'title' => 'Sign In Key File', 'variable' => 'ios_apple_sign_in_cert', 'type' => 'file' , 'id' => 'ios_apple_sign_in_cert' , 'environment' => 'all' , 'default' => 'no', 'desc' => 'Upload Sign In with Apple Certificate.' );

        $settings_array[] = array( 'title' => 'Firebase Project ID for Push Notifications', 'variable' => 'mam_firebase_project_id', 'type' => 'text' , 'id' => 'mam_firebase_project_id' , 'environment' => 'all' , 'default' => 'no', 'desc' => 'This is the Firebase Project ID for Firebase Cloud Messaging' );
        $settings_array[] = array( 'title' => 'Firebase Project Server JSON', 'variable' => 'android_pn_pem_certs', 'type' => 'file' , 'id' => 'android_pn_pem_certs' , 'environment' => 'all' , 'default' => 'no', 'desc' => 'This is the Firebase Project JSON for Firebase Cloud Messaging In Firebase go to Project Settings -> Service Accounts and generate a enw key. Then add the file here' );
        $settings_array[] = array( 'title' => 'Android Notification Icon (square)', 'variable' => 'android_notification_icon', 'type' => 'image' , 'id' => 'android_notification_icon' , 'environment' => 'all' , 'default' => 'no', 'desc' => 'This is the API key from Firebase Cloud Messaging' );
        $settings_array[] = array( 'title' => 'Notification Icon (square)', 'variable' => 'notification_icon', 'type' => 'image' , 'id' => 'notification_icon' , 'environment' => 'all' , 'default' => 'no', 'desc' => 'This is the icon for all types of notifications' );

        $settings_array[] = array( 'title' => 'Google Places API Key', 'variable' => 'tsl-google-api-key', 'type' => 'text' , 'id' => 'tsl-google-api-key' , 'environment' => 'all' , 'default' => 'no', 'desc' => 'This key is used to geolocate addresses' );
        $settings_array[] = array( 'title' => 'iTunes App URL', 'variable' => 'mam-itunes-app-url', 'type' => 'text' , 'id' => 'mam-itunes-app-url' , 'environment' => 'all' , 'default' => 'no', 'desc' => 'iTunes App URL' );
        $settings_array[] = array( 'title' => 'Android App URL', 'variable' => 'mam-android-app-url', 'type' => 'text' , 'id' => 'mam-android-app-url' , 'environment' => 'all' , 'default' => 'no', 'desc' => 'Android App URL' );
        $settings_array[] = array( 'title' => 'Opt Out Completion URL', 'variable' => 'mam-opt-out-complete-url', 'type' => 'text' , 'id' => 'mam-opt-out-complete-url' , 'environment' => 'all' , 'default' => 'no', 'desc' => 'URL to opt out of email messages. Leave blank to use system default. ' );
        $settings_array[] = array( 'title' => 'QR Code Dot Color', 'variable' => 'mam-qrcode_dot_color', 'type' => 'color' , 'id' => 'mam-qrcode_dot_color' , 'default' => '#000000');

        $settings_array = apply_filters( 'mam_filter_settings_for_public_use', $settings_array );


		$html_line = '<div class="tsl-admin-settings-holder">';

		$html_line .= mam_admin_settings::headline('Push Notification Settings');

		$html_line .= '<form method="POST">';
        $html_line .= '<input type="hidden" value="mam-app-settings" name="page">';
        $html_line .= '<input type="hidden" name="tab" id="tab" value="' . $_REQUEST['tab'] . '">';
        $html_line .= '<input type="hidden" value="pn-form" name="pn-form">';


        foreach($settings_array as $setting ) {
            $html_line .= $handler->create_variable_option($setting);
        }

        $html_line .= '<table class="tsl-admin-pref-table">';
		$html_line .= '<tr>';
		$html_line .= '<td></td>';
		$html_line .= '<td></td>';
		$html_line .= '<td>'.mam_admin_settings::submit_button().'</td>';
		$html_line .= '</tr>';
		$html_line .= '</table>';

        $html_line .= '</form>';

//        delete_option( 'mam_site_qrcode');

        $this->get_main_qr_code();

        if( get_option( 'mam_site_qrcode')) {
            $html_line .= '<table class="tsl-admin-pref-table">';
            $html_line .= '<tr><td style="font-size:2em;font-weight:bold;padding-bottom:1em;">QR Code to direct users to the App</td></tr>';
            $html_line .= '<tr>';
            $html_line .= "<td><img src='" . get_option( 'mam_site_qrcode' ) . "' border='0'/></td>";
            $html_line .= '</tr>';
            $html_line .= '</table>';
            $html_line .= '<p style="font-weight: bold;font-size: 1.2em;">Use this QR code to direct users to the app. You can also use this code in your marketing materials.</p>';
            $html_line .= '<p style="font-weight: bold;font-size: 1.2em;">You can alsu use this URL: '. site_url() . '/wp-admin/admin-ajax.php?action=local_app_get_app</p>';
        }

        $html_line .= '</div>';

        return $html_line;

    }

    function create_qr_code( $url , $key )
    {
mamdebug('qrcode', 'create_qr_code');
        $color = get_option( 'mam-qrcode_dot_color');
        $handler = new mam_qr_code_manager();
        $qrcode = $handler->create_qrcode($url, 1, '', $color );
        update_option( $key, $qrcode );

    }

    function get_main_qr_code( $client_id = 0)
    {
mamdebug('qrcode', 'get_main_qr_code');
        $key = 'mam_site_qrcode';
        if( $client_id > 0 ) {
            $key = 'mam_site_qrcode_' . $client_id;
        }

        if( ! get_option( $key )) {
            $color = get_option( 'mam-qrcode_dot_color');
            $url = site_url() . '/wp-admin/admin-ajax.php?action=local_app_get_app?client_code=' . $client_id;
            $handler = new mam_qr_code_manager();
            $qrcode = $handler->create_qrcode($url, 1, '', $color );
            update_option( $key, $qrcode );
        }
    }


}
