<?php

class mam_codex_manager
{

    function __construct()
    {


    }

    function update_settings_status()
    {

        delete_option( 'mam-codex-date' );

        if( ! get_option( 'mam-codex-date' ) || get_option( 'mam-codex-date' ) < strtotime('-5 minutes',  time() ))
        {

//            mamdebug('codex', 'Checking for codex updates');

            $full_url = 'https://developer.tinyscreenlabs.com/wp-admin/admin-ajax.php?action=mam_codex_update_settings';
            $response = wp_remote_get($full_url);

            // Check if the request was successful
            if (is_wp_error($response)) {
                error_log("API request failed: " . $response->get_error_message());
                return false;
            }

            // Get the status code
            $status_code = wp_remote_retrieve_response_code($response);

            // Check if the response was successful
            if ($status_code !== 200) {
                mamdebug("Codex_error" , "API request failed with status code: $status_code");
                return false;
            }

            // Get the response body
            $body = wp_remote_retrieve_body($response);

            // Parse the JSON response
            $data = json_decode($body, true);

            // Check if JSON parsing was successful
            if ($data === null && json_last_error() !== JSON_ERROR_NONE) {
                mamdebug("Codex_error" , json_last_error_msg());
                return false;
            }

            update_option( 'mam-codex-data', $data['settings'] );
//            mamdebug('codex', $data['settings']);

            update_option( 'mam-codex-date', time() );

        }

    }
}
