<?php

class mam_main_get_forum_post_comments
{

    private $user;
    private $user_id;

    function __construct()
    {
        if(isset($_REQUEST['pid'])) {
            $this->user = get_users(array('meta_key' => 'mam_app_token', 'meta_value' => $_REQUEST['pid']));

            if ($this->user) {
                $this->user_id = $this->user[0]->ID;
                $this->user = $this->user[0];
            }
        }
    }
    function get_comments( $comments, $post_id , $this_parent = 0  )
    {

        if( $post_id < 1 ) return $comments;
        if( ! is_array( $comments )) $comments = array();

        $wp_comments = get_comments( array( 'post_id' => $post_id , 'orderby'=>'comment_date', 'order'=>'ASC'));

        foreach( $wp_comments as $comment ) {

            if( $comment->comment_parent == $this_parent ) {
                $avatar = '';
                if (get_user_meta($comment->user_id, '_user_avatar', true)) {
                    $avatar = get_user_meta($comment->user_id, '_user_avatar', true);
                }
                $userdata = get_userdata($comment->user_id);
                $display_name = $userdata->display_name;

                $comment_date = date('M d g:i A', strtotime($comment->comment_date));
                $comment_record = array('id' => $comment->comment_ID, 'content' => $comment->comment_content, 'avatar' => $avatar, 'display_name' => $display_name, 'user_id' => (string)$comment->user_id, 'post_date' => $comment_date);
                $comment_record['threads'] = $this->get_comments(array(), $post_id, $comment->comment_ID);

                if ($this->user_id == $comment->user_id) {
                    $comment_record['can_edit'] = 'yes';
                } else {
                    $comment_record['can_reply'] = 'yes';
                }

                $comments[] = $comment_record;
            }
        }

        return $comments;
    }

    function mam_main_ajax()
    {

        if( apply_filters( 'mam_form_posts_manager_external' , false ) == true ) return;

        $return = false;

        if( $_REQUEST['subaction'] ==  'mam_forum_post_delete_manager' ){
            wp_delete_comment( $_REQUEST['threadid'] );
            $return = true;
        }else if( $_REQUEST['subaction'] == 'mam_forum_post_manager' ){

            if( $_REQUEST['postaction'] == 'edit' ) {
                $data = array(
                  'comment_ID'      => $_REQUEST['threadid'],
                  'comment_content'      => trim($_REQUEST['text'])
                );
              wp_update_comment( $data );

            }else if( $_REQUEST['postaction'] == 'new' ) {
                //if new comment then add new comment
                $data = array(
                  'comment_post_ID'      => $_REQUEST['id'],
                  'comment_content'      => trim($_REQUEST['text']),
                  'user_id'              => $this->user_id,
                  'comment_author'       => $this->user->data->user_login,
                  'comment_author_email' => $this->user->data->user_email,
                );

                wp_insert_comment( $data );
                /*if ( ! is_wp_error( $comment_id ) ) {

                }*/
            }else if( $_REQUEST['postaction'] == 'new_thread' ) {
                //if new comment then add new comment
                $data = array(
                  'comment_post_ID'      => $_REQUEST['id'],
                  'comment_content'      => trim($_REQUEST['text']),
                  'comment_parent'       => $_REQUEST['threadid'],
                  'user_id'              => $this->user_id,
                  'comment_author'       => $this->user->data->user_login,
                  'comment_author_email' => $this->user->data->user_email,
                );
                wp_insert_comment( $data );
            }

            $return = true;
        }

        if( $return ) {
            $data_array['jsonData'] = local_app_get_phone_data(true);
            $data_array['status'] = 'success';
            wp_send_json($data_array);
            die();
        }


    }

}
