<?php

add_filter( 'mam_main_content_element_show_shipping_status', 'mam_main_content_element_show_shipping_status' , 10, 2 );
function mam_main_content_element_show_shipping_status( $data_array, $args = array() )
{


    return $data_array;
}

add_filter( 'mam_main_content_element_add_to_cart', 'mam_main_content_element_add_to_cart' , 10, 3 );
function mam_main_content_element_add_to_cart( $data_array, $form_manager, $args = array() )
{

    $args = apply_filters( 'mam_main_content_element_add_to_cart_args', $args );

    $data_array['content_sections'][] = array('title' => $args['title'], 'content' => $args['content'], 'type' => 'add_to_cart', 'show_title' => $args['show_title'] );

    return $data_array;

}


add_filter( 'mam_main_content_element_make_offer', 'mam_main_content_element_make_offer' , 10, 2 );
function mam_main_content_element_make_offer( $data_array, $args = array() )
{

    if( apply_filters( 'mam_main_content_element_make_offer_skip', true ) ) return $data_array;

    $args = apply_filters( 'mam_main_content_element_make_offer_args', $args );

//    if( isset($args['is_not_negotiable']) ) return $data_array;
//    if( get_post_meta( $data_array['id'], 'is_not_negotiable', true )) return $data_array;

    $content['button_title'] = $args['button_title'];
    $content['message'] = $args['message'];
    $content['login_message'] = $args['login_message'];
    $content['require_login'] = $args['require_login'];

    if( isset( $args['content'] ) && is_array( $args['content'] ))
    {
        foreach( $args['content'] as $key => $item )
        {
            $content[$key] = $item;
        }
    }


    $data_array['content_sections'][] = array('title' => $args['title'], 'content' => $content, 'type' => 'make_offer', 'show_title' => $args['show_title'] );

    return $data_array;

}

add_filter( 'mam_main_content_element_show_simple_product', 'mam_main_content_element_show_simple_product' , 10, 3 );
function mam_main_content_element_show_simple_product( $data_array, $this_prod, $args = array() )
{
    $args['button_title'] = 'Buy Now';
    $args = apply_filters( 'mam_main_content_element_show_simple_product_args', $args );

    if( isset( $this_prod )) {
        $prod_array = array();
        $prod_array['title'] = $this_prod->get_title();
        $prod_array['price'] = apply_filters('mam_wc_get_approved_price_for_user', $this_prod->get_regular_price(), $data_array['id'], $args['user_id']);

        if ($this_prod->get_regular_price() > $data_array['regular_price']) {
            $prod_array['price_label'] = '<span style="text-decoration: Line-through;">$' . number_format((float)$this_prod->get_regular_price(), 2) . '</span> $' . $data_array['regular_price'];
        } else {
            $prod_array['price_label'] = '$' . number_format((float)$this_prod->get_regular_price(), 2);
        }

        $prod_array['quantity'] = (string)$this_prod->get_stock_quantity();
    }else{
        $prod_array = array();
        $prod_array['title'] = $data_array['title'];
        $prod_array['price'] = $data_array['regular_price'];

        if ($data_array['regular_price'] > $data_array['sale_price']) {
            $prod_array['price_label'] = '<span style="text-decoration: Line-through;">$' . $data_array['regular_price'] . '</span> $' . $data_array['sale_price'];
        } else {
            $prod_array['price_label'] = '$' .$data_array['regular_price'];
        }
        if( isset( $args['quantity']) ) $prod_array['quantity'] = (string)$args['quantity'];
    }

    if( isset( $args['price_type'] ) )
    {
        $prod_array['price_label'] .= $args['price_type'];
    }

    if( isset( $args['show_qty'] ) ) $prod_array['show_qty'] = $args['show_qty'];
    if( isset( $args['button_title'] ) ) $prod_array['button_title'] = $args['button_title'];
    $prod_array['id'] = $data_array['id'];
    if( isset( $args['product_attrib'] ) ) $prod_array['product_attrib'] = $args['product_attrib'];
    if( isset( $args['is_unique'] ) ) $prod_array['is_unique'] = $args['is_unique'];
    if( isset( $args['button_title_view_cart'] ) ) $prod_array['button_title_view_cart'] = $args['button_title_view_cart'];

    if( isset( $args['can_buy_with_cash'] ) && $args['can_buy_with_cash'] == true ){
        $prod_array['can_buy_with_cash'] = 'yes';
        $prod_array['buy_now_with_cash_button_red'] = '46';
        $prod_array['buy_now_with_cash_button_green'] = '149';
        $prod_array['buy_now_with_cash_button_blue'] = '180';
        $prod_array['require_login'] = 'yes';
        $prod_array['login_message'] = 'You need to login or sign-up';
    }else{
       $prod_array['simple_button'] = 'yes';
    }

    $data_array['content_sections'][] = array('title' => $args['title'], 'content' => $prod_array, 'type' => 'show_simple_product', 'show_title' => $args['show_title'] , 'simple_button' => $args['simple_button'] );

    return $data_array;

}


add_filter( 'mam_main_content_class_featured_image', 'mam_main_content_class_featured_image' , 10, 2 );
function mam_main_content_class_featured_image( $data_array , $args = array() )
{

    $image_id = 0;
    $use_image_url = false;
    $image_width = 100;
    $image_height = 100;

    if( isset( $args['image_id'] ))
    {
        $image_id = $args['image_id'];
    }else if( isset( $args['image_url'] ))
    {
        $image_id = attachment_url_to_postid( $args['image_url'] );
        if( $image_id == 0 )
        {
            $use_image_url = true;
            if( $args['image_width'] ) $image_width = $args['image_width'];
            if( $args['image_height'] ) $image_height = $args['image_height'];
        }
    }else if( isset( $args['is_avatar'] ))
    {
        $args['image_url'] = get_user_meta( $args['is_avatar'], '_user_avatar', true);
        if( $args['image_url'] ) $use_image_url = true;
    }else if( isset( $data_array['id'] ) )
    {
        $image_id = get_post_thumbnail_id( $data_array['id'] );
    }

    if( $image_id > 0 || $use_image_url ) {

        if( $use_image_url )
        {
            $featured_image = $args['image_url'];
        }else {
            $featured_image = wp_get_attachment_image_src($image_id, 'full');
            $featured_image = $featured_image[0];
        }

        $data_array['image'] = str_replace(' ', '-', str_replace('/', '-', urldecode($featured_image)));
        $data_array['imageurl'] = $featured_image;
        $parts = explode('.', $data_array['image']);
        $data_array['extension'] = $parts[sizeof($parts) - 1];
        $data_array['image_id'] = $image_id;
        if ($data_array['image_id'] < 1) {
            $data_array['image_id'] = ' ';
        }

        $ext = strtolower($data_array['extension']);
        if ($ext == 'png' || $ext == 'jpg' || $ext = 'jpeg') {
            if( $use_image_url )
            {
                $data_array['img_width'] = $image_width;
                $data_array['img_height'] = $image_height;
            }else {
                $image_data = wp_get_attachment_image_src($data_array['image_id'], 'full');
                $data_array['img_width'] = $image_data[1];
                $data_array['img_height'] = $image_data[2];
            }
        }
    }

    return $data_array;

}

add_filter( 'mam_main_content_element_chat_config', 'mam_main_content_element_chat_config' , 10, 3 );
function mam_main_content_element_chat_config( $data_array )
{


    return $data_array;
}

add_filter( 'mam_main_content_element_order_details', 'mam_main_content_element_order_details' , 10, 3 );
function mam_main_content_element_order_details( $data_array, $order, $args )
{

    $args = apply_filters( 'mam_main_content_element_order_details_args', $args );
    $order_items = $order->get_items();

    $qty = 'Qty';
    if( isset( $args['hide_qty'])) $qty  = '';

    $table = array();
    $table[] = array('cols' => '2', 'content' => array( 'Order ID', (string)$order->get_id() ) , 'text' => 'color_grey' , 'background' => 'color_lightgrey' , 'no_grid' => 'yes');
    $table[] = array('cols' => '2', 'content' => array( 'Order Date', $args['order_date'] ) , 'text' => 'color_grey' , 'background' => 'color_lightgrey' , 'no_grid' => 'yes');
    $table[] = array('cols' => '2', 'content' => array( 'Status', str_replace( '_', ' ' , ucwords( $order->get_status() )) ) , 'text' => 'color_grey' , 'background' => 'color_lightgrey' , 'no_grid' => 'yes');

    if( get_post_meta( $order->get_id() , 'delivery_date_formatted', true ) ) {
        $data_array['delivery_date'] = get_post_meta($order->get_id(), 'delivery_date_formatted', true)  . ' - ' . get_post_meta($order->get_id(), 'delivery_time_range', true);
        $table[] = array('cols' => '2', 'content' => array( $args['delivery_date_type'], get_post_meta($order->get_id(), 'delivery_date_formatted', true)), 'text' => 'color_grey', 'background' => 'color_lightgrey', 'no_grid' => 'yes');
        $table[] = array('cols' => '2', 'content' => array( $args['delivery_hour_type'], get_post_meta($order->get_id(), 'delivery_time_range', true)), 'text' => 'color_grey', 'background' => 'color_lightgrey', 'no_grid' => 'yes');
    }

    if( isset( $data_array['location'] ) && strlen( $data_array['location'] ) > 0 && ! isset( $args['hide_store_location'] ) ){
        $table[] = array('cols' => '2', 'content' => array('Location', $data_array['location']), 'text' => 'color_grey', 'background' => 'color_lightgrey' , 'no_grid' => 'yes' , 'justify' => array('left', 'wrap' ));
    }

      $table[] = array('cols' => '1', 'content' => array( '  ' ) , 'text' => 'color_grey' , 'background' => 'color_lightgrey' , 'no_grid' => 'yes' );

    $show_item_id = apply_filters( 'mam_order_details_show_item_id' , false );
    if( $show_item_id ) {
        $table[] = array('cols' => '4', 'content' => array('ID', 'Item', $qty, 'Price'), 'text' => 'color_grey', 'background' => 'color_lightgrey', 'justify' => array('left','left', 'right', 'right'), 'no_grid' => 'yes', 'width' => array('15','50', '10', '25'));
    }else{
        $table[] = array('cols' => '3', 'content' => array('Item', $qty, 'Price'), 'text' => 'color_grey', 'background' => 'color_lightgrey', 'justify' => array('left', 'right', 'right'), 'no_grid' => 'yes', 'width' => array('65', '10', '25'));
    }

    $order_addons = get_post_meta( $order->get_id(), '_order_addon_list', true);
    $i=0;
    $this_total = 0;

    $has_vendors = false;
    $vendor_array = array();
    if( has_filter( 'mam_get_vendor_for_product' ) ) {
        foreach( $order_items as $product ) {
            $vendor_array[$product["product_id"]] = apply_filters( 'mam_get_vendor_for_product', $product["product_id"]  , array() );
        }
        $has_vendors = true;
    }

    $order_item_index = 0;
    $vendor_title = '';
    foreach( $order_items as $product ) {

        if( isset( $args['product_ids']))
        {
//            mamdebug('test', $args['product_ids'] );
            if( ! in_array( $product['product_id'] , $args['product_ids'] )) continue;
        }

        if( ! isset( $data_array['product_name'] )) $data_array['product_name'] = $product['name'];

        if( isset( $args['show_product_id'] ))
        {
            $data_array['product_name'] = $product["product_id"] . ' ' . $data_array['product_name'];
        }

        if( has_filter( 'mam_get_vendor_for_product' ) ) {
            $data_array['fetch_image'] = 'yes';
            $data_array = apply_filters( 'mam_get_vendor_for_product', $product["product_id"]  , $data_array );
        }

        if( has_filter( 'mam_wc_get_product_order_detail_line_items' ) ) {
            $table = apply_filters( 'mam_wc_get_product_order_detail_line_items' , $table , $order->get_id() , $i );
            $this_total += $product['total'];
            $i++;
        }else {

            if( $has_vendors && sizeof( $vendor_array ) > 0 )
            {
                if( $vendor_title != $vendor_array[$product['product_id']]['title'] && ! isset( $args['hide_seller_name'] ) )
                {
                    $table[] = array('cols' => '1', 'content' => array( 'Seller: ' . $vendor_array[$product['product_id']]['title'] ) , 'text' => 'color_grey' , 'background' => 'color_lightgrey' , 'no_grid' => 'yes' );
                    $vendor_title = $vendor_array[$product['product_id']]['title'];
                }
            }

            $prod_qty = (string)$product['qty'];
            if( isset( $args['hide_qty'])) $prod_qty = '';
            if( $show_item_id )
            {
                $table[] = array('cols' => '4', 'content' => array((string)$product["product_id"],$product['name'], $prod_qty, '$' . number_format($product['total'], 2, '.', ',')), 'text' => 'color_grey', 'background' => 'color_lightgrey', 'justify' => array('left','wrap', 'right', 'right'), 'no_grid' => 'yes', 'width' => array('15','50', '10', '25'));
            }else {
                $table[] = array('cols' => '3', 'content' => array($product['name'], $prod_qty, '$' . number_format($product['total'], 2, '.', ',')), 'text' => 'color_grey', 'background' => 'color_lightgrey', 'justify' => array('wrap', 'right', 'right'), 'no_grid' => 'yes', 'width' => array('65', '10', '25'));
            }
            $this_total += $product['total'];

            if (!empty($order_addons) && is_array($order_addons)) {
                $i = $order_item_index;

                if (!empty($order_addons[$i]) && is_array($order_addons[$i])) {
                    if (array_key_exists('notes', $order_addons[$i]) && $order_addons[$i]['notes'] != '') {
                        $table[] = array('cols' => '1', 'content' => array("Special Instructions : " . $order_addons[$i]['notes']), 'text' => 'color_grey', 'background' => 'color_lightgrey', 'justify' => array('left', 'right', 'right'), 'no_grid' => 'yes');
                    }
                    if (array_key_exists('options', $order_addons[$i]) && !empty($order_addons[$i]['options'])) {
                        $addon_names = array();
                        foreach ($order_addons[$i]['options'] as $option) {
                            $addon_names[] = $option['description'];
                        }
                        $table[] = array('cols' => '1', 'content' => array("Add Ons : " . implode(',', $addon_names)), 'text' => 'color_grey', 'background' => 'color_lightgrey', 'justify' => array('left', 'right', 'right'), 'no_grid' => 'yes');
                    }
                }
            }
            $order_item_index++;
        }
    }

    $shipping_displayed = false;
    foreach( $order->get_items('fee') as $item_id => $item_fee ){

        $fee_name = $item_fee->get_name();
        if( $fee_name == 'Shipping' )  $shipping_displayed = true;
        $fee_total = apply_filters( 'mam_order_details_show_item_tip_amount', $item_fee->get_total(), $order , $fee_name );
        $this_total += $fee_total;

        $table[] = array('cols' => '2', 'content' => array( $fee_name, '$'.number_format( $fee_total , 2, '.' , ',' ) ) , 'text' => 'color_grey' , 'background' => 'color_lightgrey' , 'justify' => array( 'left','right') , 'no_grid' => 'yes' );

    }
    if( ! $shipping_displayed ) {
        $shipping_total = 0;
        foreach ($order->get_items('shipping') as $item_id => $shipping_item_obj) {
            $shipping_total += $shipping_item_obj->get_total(); // Get the total cost of shipping
        }
        $this_total += $shipping_total;

        if ($shipping_total > 0) {
            $table[] = array('cols' => '2', 'content' => array('Shipping', '$' . number_format($shipping_total, 2, '.', ',')), 'text' => 'color_grey', 'background' => 'color_lightgrey', 'justify' => array('left', 'right'), 'no_grid' => 'yes');
        }
    }

    $table[] = array('cols' => '1', 'content' => array( '  ' ) , 'text' => 'color_grey' , 'background' => 'color_lightgrey' , 'no_grid' => 'yes' );
    $table[] = array('cols' => '2', 'content' => array( apply_filters( 'mam_wc_pc_mam_pv_all_orders_string_order_total','Order Total' ), '$'.number_format( $this_total  , 2, '.' , ',' ) ) , 'text' => 'color_grey' , 'background' => 'color_lightgrey' , 'justify' => array( 'left','right') , 'no_grid' => 'yes');

    $data_array['order_total'] = number_format( $this_total , 2, '.' , ',' );  //'Order #: ' . $data_array['id']. '   Total: $'.

    $data_array['content_sections'][] = array('title' => 'Order Details', 'content' => $table, 'type' => 'table', 'show_title' => 'yes' );

    return $data_array;

}

add_filter( 'mam_main_content_element_seller_profile', 'mam_main_content_element_seller_profile' , 10, 2 );
function mam_main_content_element_seller_profile( $data_array, $args )
{

    $vendor_info = apply_filters( 'mam_wc_vendors_get_vendor_data_by_id', array(), $args['vendor_id'] );
    $term_metas = apply_filters( 'mam_wc_vendors_get_vendor_meta_by_id', array(),  $vendor_info['term_id'] );
    if( $vendor_info['name'] ){
        $data_array['seller_name'] = $vendor_info['name'];
    }
    $data_array['seller_city'] = $term_metas['city'];
    $data_array['seller_state'] = $term_metas['state'];
    $data_array['seller_id'] = $vendor_info['term_id'];

    $handler = new tsl_user_profile_content();
    if( isset( $args['profile_user'] ) ) $seller_profile = $handler->create_profile_data_for_user( $args['profile_user'] );
    $seller_profile['user_rating'] = 0;
    $seller_profile['user_rating_count'] = 0;
    $seller_profile['seller_name'] = $vendor_info['name'];
    $seller_profile['user_first_name'] = $vendor_info['name'];
    $seller_profile['seller_id'] = $vendor_info['term_id'];

    $seller_profile['name_font_size'] = '24';
    $seller_profile['name_only'] = 'yes';

    $seller_profile = apply_filters( 'mam_main_content_element_seller_profile_vals', $seller_profile , $data_array );

    $args = apply_filters( 'mam_main_content_element_seller_profile_args', $args , $data_array );

    if( isset( $args['skip_profile'])) return $data_array;

    $data_array['content_sections'][] = array('title' => $args['title'], 'content' => $seller_profile, 'type' => 'show_profile', 'show_title' => $args['show_title'] );

    return $data_array;

}

add_filter( 'mam_main_content_element_html', 'mam_main_content_element_html' , 10, 2 );
function mam_main_content_element_html( $data_array, $args )
{

    $data_array['content_sections'][] = array('title' => $args['title'], 'content' => $args['html'], 'type' => 'html', 'show_title' => $args['show_title'] );

    return $data_array;

}

add_filter( 'mam_main_content_element_spacer', 'mam_main_content_element_spacer' , 10, 2 );
function mam_main_content_element_spacer( $data_array, $height )
{
    $data_array['content_sections'][] = array('title' => 'spacer', 'height' => (string)$height, 'type' => 'spacer', 'show_title' => 'no');

    return $data_array;
}

add_filter( 'mam_main_content_element_check_in', 'mam_main_content_element_check_in' , 10, 2 );
function mam_main_content_element_check_in( $data_array, $args )
{
    $args = apply_filters( 'mam_main_content_element_check_in_args', $args );
    if( ! isset( $args['background'] ) ) $args['background'] = 'clear';

    $data_array['content_sections'][] = apply_filters( 'mam_main_content_element_check_in_section', array('title' => $args['title'], 'content' => $args['content'], 'button_title' => $args['button_title'], 'type' => 'check_in', 'show_title' => $args['show_title'], 'background' => $args['background'] , 'require_login' => $args['require_login']), $data_array );

    return $data_array;
}

add_filter( 'mam_main_content_element_social_media', 'mam_main_content_element_social_media' , 10, 2 );
function mam_main_content_element_social_media( $data_array, $args )
{
    $args = apply_filters('mam_main_content_element_social_media_args', $args);

    if( is_array( $args['social_array'] ) && sizeof( $args['social_array'] ) > 0 ) {
        local_app_sksort($args['social_array'], 'name',true);
        $data_array['content_sections'][] = array('title' => 'Social Media', 'content' => $args['social_array'], 'type' => 'social_media', 'show_title' => $args['show_title']);
    }

    return $data_array;

}

add_filter( 'mam_main_content_element_shipping_status', 'mam_main_content_element_shipping_status' , 10, 2 );
function mam_main_content_element_shipping_status( $data_array, $args )
{
    $args = apply_filters('mam_main_content_element_shipping_status_args', $args);

    $data_array['content_sections'][] = array('title' => 'Shipping Status', 'content' => $args['shipping_info'], 'type' => 'shipping_status', 'show_title' => $args['show_title']);

    return $data_array;

}

add_filter( 'mam_add_featured_image' , 'mam_add_featured_image', 10, 3 );
function mam_add_featured_image( $data_array, $image , $alt_image = null  )
{

    if( is_numeric( $image ) ){
        $image_id = $image;
    }else{
        $image_id = attachment_url_to_postid( $image );
    }

    if( ! $image_id && $alt_image ) {
        if( is_numeric( $alt_image ) ){
            $image_id = $alt_image;
        }else{
            $image_id = attachment_url_to_postid( $alt_image );
        }
    }

    if( ! $image_id )
    {
        return $data_array;
    }

    $featured_image = wp_get_attachment_image_src($image_id, 'large');
    $featured_image = $featured_image[0];

    $data_array['image'] = str_replace(' ', '-', str_replace('/', '-', urldecode($featured_image)));
    $data_array['imageurl'] = $featured_image;
    $parts = explode('.', $data_array['image']);
    $data_array['extension'] = $parts[sizeof($parts) - 1];
    $data_array['image_id'] = $image_id;
    if ($data_array['image_id'] < 1) {
        $data_array['image_id'] = ' ';
    }

    $ext = strtolower($data_array['extension']);
    if ($ext == 'png' || $ext == 'jpg' || $ext = 'jpeg') {
        $image_data = wp_get_attachment_image_src($data_array['image_id'], 'full');
        if ($image_data[1] > 0 && $image_data[2] > 0) {
            $data_array['img_width'] = $image_data[1];
            $data_array['img_height'] = $image_data[2];
            $data_array['imageSizeFactor'] = $image_data[2] / $image_data[1];
            $data_array['imageurl_aspect'] = $image_data[2] / $image_data[1];
            $data_array['featuredRespectAspectRatio'] = 'yes';
        }
    }

    return $data_array;

}

add_filter( 'mam_main_content_class_reviews', 'mam_main_content_class_reviews' , 10, 2 );
function mam_main_content_class_reviews( $data_array , $args = array() ){
    if(array_key_exists('post_id', $args)){
        $show_stars = 'no';
        if( get_option( 'mam_reviews_mam_review_add_review_form_review-rating') > 0 ){
            $show_stars = 'yes';
        }
        $comment_args = array ('post_type' => get_post_type( $args['post_id'] ), 'post_id' => $args['post_id']);
        $comments = get_comments( $comment_args );

        if(!empty($comments)){
            $comment_array = $photos_array = $comment_cat_array = $reviews_array = array();
            foreach ($comments as $comment){
                if( $comment->user_id > 0 ) {
                    $post_id = $comment->comment_post_ID;
                    $comment_array[$post_id]['id'] = $post_id;

                    if (get_comment_meta($comment->comment_ID, 'rating', true)) {
                        $comment_array[$post_id]['stars'] = get_comment_meta($comment->comment_ID, 'rating', true);
                    }
                    $review_stars = $comment_array[$post_id]['stars'];
                    $reviewed_by = " ";
                    $comment_user = get_userdata($comment->user_id);
                    if ($comment_user) {
                        if ($comment_user->first_name || $comment_user->last_name) {
                            $reviewed_by = $comment_user->first_name . ' ' . substr($comment_user->last_name, 0, 1);
                        } else {
                            $reviewed_by = $comment_user->data->display_name;
                        }
                    }

                    $comment_category = get_comment_meta($comment->comment_ID, 'mam_review_item_cat', true);
                    $comment_item = get_comment_meta($comment->comment_ID, 'mam_review_item_name', true);

                    if (strlen($comment_category) == 0){
                        $comment_category = '  ';
                    }
                    if (strlen($comment_item) == 0){
                        $comment_item = '  ';
                    }else{
//                    mamdebug('item', $post_id . ' - ' . $comment_category . ' - ' . $comment_item );
                        if( !in_array( $comment_item , $comment_cat_array[$post_id]  )) {
                            $comment_cat_array[$post_id] = $comment_item;
                        }
                    }

                    $comment_date_string = strtotime($comment->comment_date);

                    $my_review = 'no';
                    if ($comment->user_id == $args['user_id']) {
                        $reviewed_by = 'My Review';
                        $my_review = 'yes';
                    }

                    $comment_array[$post_id]['user_id'] = $comment->user_id;
                    $comment_photos = array();
                    if ($comment->comment_approved) {
                        if( isset( $comment_photos )) $photos_array[$post_id][] = $comment_photos;
                        $comment_array[$post_id]['reviews'][] = array('id' => $comment->comment_ID, 'content' => $comment->comment_content, 'date' => date('M d, Y', $comment_date_string), 'stars' => $review_stars, 'my_review' => $my_review, 'reviewer' => $reviewed_by, 'category' => $comment_category, 'item_name' => $comment_item , 'datestamp' => (string)$comment_date_string, 'photos' => $comment_photos);
                        if ($my_review == 'no') {
                            $comment_array[$post_id]['not_my_reviews'][] = array('id' => $comment->comment_ID, 'content' => $comment->comment_content, 'date' => date('M d, Y', $comment_date_string), 'stars' => $review_stars, 'my_review' => $my_review, 'reviewer' => $reviewed_by, 'category' => $comment_category, 'item_name' => $comment_item ,  'datestamp' => (string)$comment_date_string, 'photos' => $comment_photos);
                        } else {
                            $comment_array[$post_id]['my_reviews'][] = array('id' => $comment->comment_ID, 'content' => $comment->comment_content, 'date' => date('M d, Y', $comment_date_string), 'stars' => $review_stars, 'my_review' => $my_review, 'reviewer' => $reviewed_by, 'category' => $comment_category, 'item_name' => $comment_item ,  'datestamp' => (string)$comment_date_string, 'photos' => $comment_photos);
                        }
                    } else if ($comment->user_id == $args['user_id']) {
                        if( isset( $comment_photos )) $photos_array[$post_id][] = $comment_photos;
                        $comment_array[$post_id]['reviews'][] = array('id' => $comment->comment_ID, 'content' => $comment->comment_content, 'date' => date('M d, Y', $comment_date_string), 'stars' => $review_stars, 'my_review' => $my_review, 'reviewer' => $reviewed_by, 'category' => $comment_category, 'item_name' => $comment_item ,  'photos' => $comment_photos);
                        $comment_array[$post_id]['my_reviews'][] = array('id' => $comment->comment_ID, 'content' => $comment->comment_content, 'date' => date('M d, Y', $comment_date_string), 'stars' => $review_stars, 'my_review' => $my_review, 'reviewer' => $reviewed_by, 'category' => $comment_category, 'item_name' => $comment_item ,  'photos' => $comment_photos);
                    }

                    if( isset($comment_array[$post_id]['my_reviews']) && is_array($comment_array[$post_id]['my_reviews']) && sizeof($comment_array[$post_id]['my_reviews']) > 0) $reviews_array[$post_id]['content'][] = array('title' => 'My Reviews', 'content' => $comment_array[$post_id]['my_reviews'], 'type' => 'reviews' , 'show_title' => 'yes' , 'show_stars' => $show_stars );
                    if( isset( $comment_array[$post_id]['not_my_reviews'] ) && is_array( $comment_array[$post_id]['not_my_reviews'] ) && sizeof($comment_array[$post_id]['not_my_reviews']) > 0) $reviews_array[$post_id]['content'][] = array('title' => 'Reviews', 'content' => $comment_array[$post_id]['not_my_reviews'], 'type' => 'reviews' , 'show_title' => 'yes' , 'show_stars' => $show_stars );
                }
            }

            if(!empty($reviews_array)){
                if( isset( $reviews_array[$args['post_id']]['content'] )) {
                    $review_sections = $reviews_array[$args['post_id']]['content'];
                    foreach( $review_sections as $item )
                    {
                        $data_array[sizeof($data_array) - 1]['content_sections'][] = $item;
                    }
                    foreach ( $reviews_array[$args['post_id']]['content'][0]['content'] as $reviewItem ){
                        $data_array[sizeof($data_array) - 1]['total_ratings']++;
                        $data_array[sizeof($data_array) - 1]['rating'] += $reviewItem['stars'];
                        $data_array[sizeof($data_array) - 1]['latest_review_date'] = max( $data_array[sizeof($data_array) - 1]['latest_review_date'] , $reviewItem['datestamp']);
                        $data_array[sizeof($data_array) - 1]['testrating'][] = $reviewItem;
                    }
                    $data_array[sizeof($data_array) - 1]['rating'] = $data_array[sizeof($data_array) - 1]['rating'] / $data_array[sizeof($data_array) - 1]['total_ratings'];
                    $data_array[sizeof($data_array) - 1]['review_stars'] = $data_array[sizeof($data_array) - 1]['rating'];
                    $data_array[sizeof($data_array) - 1]['latest_review_date'] = (string)$data_array[sizeof($data_array) - 1]['latest_review_date'];
                }
            }
        }
    }

    return $data_array;
}
