<?php
if ( !function_exists('get_plugins') ){
    require_once( ABSPATH . '/wp-admin/includes/plugin.php' );
}
if( is_plugin_active( 'geodirectory/geodirectory.php' ) || is_plugin_active( 'the-events-calendar/the-events-calendar.php') || is_plugin_active( 'all-in-one-event-calendar/all-in-one-event-calendar.php' ) || is_plugin_active( 'events-manager/events-manager.php' ) ) {
    global $local_app_content;
    $local_app_content['Calendar'] = array('content_type' => 'Calendar', 'class' => 'local_app_calendar', 'vc_type' => 'calendar');
}

if (!class_exists('local_app_calendar')) {

    class local_app_calendar{

        function __construct(){


        }
        public function update_cursor(){

            //no action

        }

        function get_blank_content_html(){

            $html_line = '<div class="local-app-content-type-parent" data-id="BLANK_ID">';
            $html_line .= '<select class="local-app-content-source-dd" data-type="Calendar" data-id="' . 'BLANK_ID' . '">';

            global $local_app_content;

            foreach($local_app_content as $class => $value ){
                if($value['vc_type'] == 'list') {
                    $content_class = $value['class'];
                    if (class_exists($content_class)) {
                        $content_class = new $content_class();
                        if (method_exists($content_class, 'get_content_type_form') && $content_class->use_for_events )  {
                            $html_line .= $content_class->get_content_type_form('BLANK_ID', '' , '' , false, true);
                        }
                    }
                }
            }

            $html_line .= '</select>';
            $html_line .= '</div>';

            return $html_line;

        }

        function get_content_type_form($id, $content_source){

            return 'No settings required';

        }

        public function create_initial_buttons($this_array ){

            return $this_array;
        }

        public function get_data_for_app($catagory = null, $events_only = false , $button_name = '', $single_listing = null){

            global $local_app_content;

            $event_array = array();
            $event_ids = array();

            foreach($local_app_content as $class => $value ){
                if($value['vc_type'] == 'list') {
                    $content_class = $value['class'];
                    if (class_exists($content_class)) {
                        $content_class = new $content_class();
                        if (method_exists($content_class, 'get_events_only'))  {
                            $this_array = $content_class->get_events_only( $catagory );
                            foreach($this_array as $item){
                                if( ! in_array( $item['id'], $event_ids )) {
                                    $event_ids[] = $item['id'];
                                    $event_array[] = $item;
                                }
                            }
                        }
                    }
                }
            }

            $final_event_array = array();
            $record_id = 0;

            foreach( $event_array as $index => $value ){

                foreach($value['event_records'] as $e_index => $e_value ){

                    $final_event_array[$record_id] = array_merge($value , $e_value );
                    unset($final_event_array[$record_id]['event_records']);
                    $record_id++;

                }
            }

            foreach ($final_event_array as $key => $row) {
                $timestamp[$key]  = $row['timestamp'];
                $title[$key] = $row['title'];
            }

            if( is_array( $timestamp ) && is_array($final_event_array)) {
                array_multisort($timestamp, SORT_ASC, $title, SORT_ASC, $final_event_array);
            }

            return $final_event_array;

        }
    }
}
?>
