<?php
global $local_app_content;
$local_app_content['WP_Content'] = array('content_type' => 'WordPress Page Content' , 'class' => 'local_app_wp_content', 'vc_type' => 'html');


if (!class_exists('local_app_wp_content')) {

    class local_app_wp_content{

        function __construct(){


        }

        function get_blank_content_html(){

            $html_line = '<div class="local-app-content-type-parent" data-id="BLANK_ID">';

            $html_line .= $this->get_content_type_form('BLANK_ID', '');

            $html_line .= '</div>';

            return $html_line;

        }

        function get_content_type_form($id, $content_source){

            $html_line = '<select class="local-app-content-source-dd" data-type="WP_Content" data-id="' . $id . '">';

            if( ! $content_source){
                $html_line .= '<option value="0" selected>Select WordPress Page...</option>';
            }

            $args = array(
                'sort_column' => 'post_title',
                'post_type' => 'page',
                'post_status'      => 'publish'
            );


            $post_types = get_pages( $args );

            foreach ($post_types as $index => $posts) {
                $selected_item = '';
                if ($posts->ID == $content_source) $selected_item = 'selected';
                $html_line .= '<option value="' . $posts->ID . '" ' . $selected_item . '>' . $posts->post_title . '</option>';
            }

            $html_line .= '</select>';

            return $html_line;

        }

        public function create_initial_buttons($this_array ){

            return $this_array;
        }

        public function get_data_for_app($page_id , $this_post){

            $post = get_post($page_id);
            remove_filter('the_content', 'wptexturize');
            $content =  apply_filters( 'the_content', $post->post_content );
            $this_post['data'] = $content;

            if(has_post_thumbnail( $post->ID ) ) {

                $image = get_post_thumbnail_id($post->ID);

                $featured_image = wp_get_attachment_image_src($image , 'full');
                $featured_image = $featured_image[0];

                $this_post['post_image'] = str_replace(' ', '-', str_replace('/', '-', urldecode($featured_image)));
                $this_post['post_imageurl'] = $featured_image;
                $parts = explode('.', $this_post['post_image']);
                $this_post['post_extension'] = $parts[sizeof($parts) - 1];
                $this_post['post_image_id'] = $image;
                if ($this_post['post_image_id'] < 1) {
                    $this_post['post_image_id'] = ' ';
                }
            }

            return $this_post;

        }

    }
}
?>
