<?php
global $local_app_content;
$local_app_content['WP_Post_Category'] = array('content_type' => 'WordPress Post Category' , 'class' => 'local_app_wp_post_category', 'vc_type' => 'post_cat');


if (!class_exists('local_app_wp_post_category')) {

    class local_app_wp_post_category{

        function __construct(){


        }

        function get_blank_content_html(){

            $html_line = '<div class="local-app-content-type-parent" data-id="BLANK_ID">';

            $html_line .= $this->get_content_type_form('BLANK_ID', '');

            $html_line .= '</div>';

            return $html_line;

        }

        function get_content_type_form($id, $content_source){

            $html_line = '<select class="local-app-content-source-dd" data-type="WP_Post_Category" data-id="' . $id . '">';

            if( ! $content_source){
                $html_line .= '<option value="0" selected>Select WordPress Post Category...</option>';
            }

            $categories = get_categories( array(
                'orderby' => 'name',
                'order'   => 'ASC'
            ) );

            foreach( $categories as $category ) {

                $selected_item = '';
                if ($category->cat_ID == $content_source) $selected_item = 'selected';

                $title = $category->name;
                $hover_title = '';

                if(strlen($title) > 50 ){
                    $title = substr( $title ,0 , 47 ) . '...';
                    $hover_title = 'title="'.$category->name.'"';
                }

                $html_line .= '<option '.$hover_title.' value="' . $category->cat_ID . '" ' . $selected_item . '>' . $title . '</option>';
            }

            $html_line .= '</select>';

            return $html_line;

        }

        public function create_initial_buttons($this_array ){

            if (sizeof($this_array) > 11) return $this_array;

            $icon_id = sizeof($this_array) + 1;

            $post_types = get_categories( array(
                'orderby' => 'name',
                'order'   => 'ASC'
            ) );

            foreach ($post_types as $index => $posts) {
                if ($icon_id < 13) {

                    $args = array(
                        'posts_per_page'   => 500,
                        'offset'           => 0,
                        'category'         => $posts->ID,
                        'orderby'          => 'date',
                        'order'            => 'DESC',
                        'post_type'        => 'post',
                        'post_status'      => 'publish'
                    );

                    $posts_array = get_posts( $args );

                    $rec_count = sizeof($posts_array);

                    if($rec_count > 0 && $posts->slug != 'uncategorized') {

                        $parent = '';
                        if($posts->category_parent > 0 ){
                            $parent = $this->get_category_name( $posts->category_parent ) . ' - ';
                        }

                        $base_dir = plugin_dir_url(__FILE__) . 'icons/default/';
                        $this_array[] = array('id' => uniqid(), 'name' => $parent . $posts->name, 'icon' => $base_dir . 'icon_' . $icon_id . '.png', 'type' => 'WP_Post_Category', 'source' => $posts->slug);
                        $icon_id++;
                        if (sizeof($this_array) > 11) return $this_array;
                    }
                }
            }


            return $this_array;
        }

        public function get_data_for_app($posts_array){

            $posts_per_page = 30;

            $args = array(
                'posts_per_page'   => $posts_per_page,
                'offset'           => 0,
                'category'         => $posts_array,
                'orderby'          => 'date',
                'order'            => 'DESC',
                'post_type'        => 'post',
                'post_status'      => 'publish'
            );

            $posts_array = get_posts( $args );

            foreach($posts_array as $post) {

                $this_post = array();
                $post = get_post($post->ID);
                $this_content['status'] = 'published';

                $this_post['subcategories'] = array();

                $all_categories =  get_the_category( $post->ID ) ;

                foreach($all_categories as $cat_index => $subcat){
                    $this_post['subcategories'][] = $subcat->name;
                }


                if(has_post_thumbnail( $post->ID ) ) {

                    $image = get_post_thumbnail_id($post->ID);

                    $featured_image = wp_get_attachment_image_src($image , 'full');
                    $featured_image = $featured_image[0];

                    $this_post['image'] = str_replace(' ', '-', str_replace('/', '-', urldecode($featured_image)));
                    $this_post['imageurl'] = $featured_image;
                    $parts = explode('.', $this_post['image']);
                    $this_post['extension'] = $parts[sizeof($parts) - 1];
                    $this_post['image_id'] = $image;
                    if ($this_post['image_id'] < 1) {
                        $this_post['image_id'] = ' ';
                    }

                }

                remove_filter('the_content', 'wptexturize');
                $this_post['content'] = apply_filters( 'the_content', $post->post_content );

//                $this_post['content'] =  mb_convert_encoding( $this_content , "HTML-ENTITIES", "UTF-8" );


                $this_post['id'] = $post->ID;
                $this_post['title'] = $post->post_title;
                $this_post['post_modified'] = $post->post_modified;

                $post_array[] = $this_post;

            }
            return $post_array;

        }

    }
}
?>
