<?php
global $local_app_content;
$local_app_content['WP_Post_Content'] = array('content_type' => 'WordPress Post Content' , 'class' => 'local_app_wp_post_content', 'vc_type' => 'html');

if (!class_exists('local_app_wp_post_content')) {

    class local_app_wp_post_content{

        function __construct(){


        }

        function get_blank_content_html(){

            $html_line = '<div class="local-app-content-type-parent" data-id="BLANK_ID">';

            $html_line .= $this->get_content_type_form('BLANK_ID', '');

            $html_line .= '</div>';

            return $html_line;

        }

        function get_content_type_form($id, $content_source){

            $html_line = '<select class="local-app-content-source-dd" data-type="WP_Post_Content" data-id="' . $id . '">';

            if( ! $content_source){
                $html_line .= '<option value="0" selected>Select WordPress Post...</option>';
            }

            $args = array(
                'orderby'           => 'title',
                'offset'            => 0,
                'posts_per_page'    => 800,
                'order'            => 'ASC',
                'post_status'       => 'publish'
            );


            $post_types = get_posts( $args );

            foreach ($post_types as $index => $posts) {
                $selected_item = '';
                if ($posts->ID == $content_source) $selected_item = 'selected';

                $title = $posts->post_title;
                $hover_title = '';

                if(strlen($title) > 50 ){
                    $title = substr( $title ,0 , 47 ) . '...';
                    $hover_title = 'title="'.$posts->post_title.'"';
                }

                $html_line .= '<option '.$hover_title.' value="' . $posts->ID . '" ' . $selected_item . '>' . $title . '</option>';
            }

            $html_line .= '</select>';

            return $html_line;

        }

        public function create_initial_buttons($this_array ){

            return $this_array;
        }

        public function get_data_for_app($page_id , $this_post){

            $post = get_post($page_id);
            remove_filter('the_content', 'wptexturize');
            $content =  apply_filters( 'the_content', $post->post_content );

//            $search = array(chr(145),
//                    chr(146),
//                    chr(147),
//                    chr(148),
//                    chr(151));
//
//            $replace = array("'",
//                             "'",
//                             '"',
//                             '"',
//                             '-');
//
//            $content = str_replace($search, $replace, $content);

            $content = iconv('UTF-8', 'ASCII//TRANSLIT', $post->post_content );

            $this_post['data'] =  $content;

            $this_post['post_image'] = ' ';
            $this_post['post_imageurl'] = ' ';
            $this_post['post_extension'] = ' ';
            $this_post['post_image_id'] = ' ';

            if(has_post_thumbnail( $post->ID ) ) {

                $image = get_post_thumbnail_id($post->ID);

                $featured_image = wp_get_attachment_image_src($image , 'full');
                $featured_image = $featured_image[0];

                $this_post['post_image'] = str_replace(' ', '-', str_replace('/', '-', urldecode($featured_image)));
                $this_post['post_imageurl'] = $featured_image;
                $parts = explode('.', $this_post['post_image']);
                $this_post['post_extension'] = $parts[sizeof($parts) - 1];
                $this_post['post_image_id'] = $image;
                if ($this_post['post_image_id'] < 1) {
                    $this_post['post_image_id'] = ' ';
                }
            }

            return $this_post;

        }

    }
}
?>
