<?php
class mam_main_database_manager
{

    private $db_version = 20;

    function manage_tables()
    {

        $installed_ver = get_option('mam_main_db_version');

        if ($installed_ver != $this->db_version) {

            require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
            update_option('mam_geocoding_db_version', $this->db_version);

            global $wpdb;

            $charset_collate = $wpdb->get_charset_collate();
            $table_name = $wpdb->prefix . 'mam_address_db';

            $sql = "CREATE TABLE IF NOT EXISTS $table_name (
              `this_index` int(11) NOT NULL AUTO_INCREMENT,
              `address` varchar(500) NOT NULL,
              `lat` varchar(32) NOT NULL,
              `lon` varchar(32) NOT NULL,
              PRIMARY KEY (`this_index`)
            ) $charset_collate;";

            dbDelta($sql);

            $table_name = $wpdb->prefix . 'tsl_mail_queue';

            $sql = "CREATE TABLE $table_name (
              `this_index` int(11) NOT NULL AUTO_INCREMENT,
              `email` varchar(500) NOT NULL,
              `subject` varchar(500) NOT NULL,
              `content` varchar(50000) NULL,
              `headers` varchar(2000) NULL,
              `send_status` int(2),
              `from_email` varchar(500) NULL,
              `from_name` varchar(500) NULL,
              `modified` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
              `last_error` varchar(200) NULL,
              `retry_count` int(2) NULL,
              `sender_id` int(11),              
              PRIMARY KEY (`this_index`)
            ) $charset_collate;";

            dbDelta($sql);

            $table_name = $wpdb->prefix . 'tsl_mail_attachments';

            $sql = "CREATE TABLE $table_name (
              `this_index` int(11) NOT NULL AUTO_INCREMENT,
              `email_index` int(11) NOT NULL,
              `attachment` varchar(1000) NULL,
              PRIMARY KEY (`this_index`)
            ) $charset_collate;";

            dbDelta($sql);

            $table_name = $wpdb->prefix . 'tsl_pn_text_queue';

            $sql = "CREATE TABLE $table_name (
              `this_index` int(11) NOT NULL AUTO_INCREMENT,
              `subject` varchar(500) NULL,
              `content` varchar(50000) NULL,
              `target` varchar(2000) NULL,              
              `send_text` varchar(1) NULL,
              `send_pn` varchar(1) NULL,
              `recipient_id` int(11) NOT NULL,
              `send_status` int(2),
              `is_silent` int(2),
              PRIMARY KEY (`this_index`)
            ) $charset_collate;";

            dbDelta($sql);

            $table_name = $wpdb->prefix . 'mam_notifications_manager';

            $sql = "CREATE TABLE $table_name (
              `this_index` int(11) NOT NULL AUTO_INCREMENT,
              `user_id` int(11) DEFAULT 0,
              `notification_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
              `title` varchar(50) NULL,
              `message` varchar(150) NULL,
              `pn_status` int(11) DEFAULT 0,
              `target` varchar(150) NULL,
              `nonce` varchar(50) NULL,
              `data_json` varchar(50000) NULL,
              `is_silent` int(2) DEFAULT 0,
              PRIMARY KEY (`this_index`)
            ) $charset_collate;";

            dbDelta($sql);


            $table_name = $wpdb->prefix . 'mam_email_manager';

            $sql = "CREATE TABLE $table_name (
              `this_index` int(11) NOT NULL AUTO_INCREMENT,
              `user_id` int(11) DEFAULT 0,
              `notification_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
              `title` varchar(50) NULL,
              `message` varchar(150) NULL,
              `email_status` int(11) DEFAULT 0,
              `email` varchar(150) NULL,
              `nonce` varchar(50) NULL,
              `data_json` varchar(50000) NULL,
              PRIMARY KEY (`this_index`)
            ) $charset_collate;";

            dbDelta($sql);


            $table_name = $wpdb->prefix . 'mam_email_opted_out';

            $sql = "CREATE TABLE $table_name (
              `this_index` int(11) NOT NULL AUTO_INCREMENT,
              `email` varchar(150) NULL,
              `email_code` varchar(150) NOT NULL,
              `opted_out` varchar(50) NULL, 
              PRIMARY KEY (`this_index`)
            ) $charset_collate;";

            dbDelta($sql);

            $table_name = $wpdb->prefix . 'local_app_scans';

            $sql = "CREATE TABLE IF NOT EXISTS $table_name (
              `this_index` int(11) NOT NULL AUTO_INCREMENT,
              `scan_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
              `os_type` varchar(32) NOT NULL,
              `campaign` int(11) DEFAULT NULL,
              `prod` int(2) DEFAULT NULL,
              PRIMARY KEY (`this_index`)
            ) $charset_collate;";

            $table_name = $wpdb->prefix . 'tsl_local_app_notifications_history';

            dbDelta($sql);

            $sql = "CREATE TABLE $table_name (
              `this_index` int(11) NOT NULL AUTO_INCREMENT,
              `message` varchar(300) NOT NULL,
              `trans_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
              `send_date` varchar(25) NOT NULL,
              `target_type` varchar(25) NOT NULL,
              `target_source` varchar(25) NULL,
              `ios_phones` varchar(25) NULL,
              `android_phones` varchar(25) NULL,
              `sent_by_name` varchar(250) NULL,
              PRIMARY KEY (`this_index`)
            ) $charset_collate;";

            dbDelta($sql);

            $table_name = $wpdb->prefix . 'local_app_phone_ids';

            $sql = "CREATE TABLE IF NOT EXISTS $table_name (
              `this_index` int(11) NOT NULL AUTO_INCREMENT,
              `add_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
              `pid` varchar(256) NOT NULL,
              `user_id` int(11) NOT NULL,
              PRIMARY KEY (`this_index`)
            ) $charset_collate;";

            dbDelta($sql);

            $table_name = $wpdb->prefix . 'mam_email_opted_out';

            $sql = "CREATE TABLE $table_name (
              `this_index` int(11) NOT NULL AUTO_INCREMENT,
              `email` varchar(150) NULL,
              `email_code` varchar(150) NOT NULL,
              `opted_out` varchar(150) NULL,
              PRIMARY KEY (`this_index`)
            ) $charset_collate;";

            dbDelta($sql);

            $table_name = $wpdb->prefix . 'tsl_local_app_cached_json';

            $sql = "CREATE TABLE $table_name (
              `this_index` int(11) NOT NULL AUTO_INCREMENT,
              `cursor_code` varchar(50) NOT NULL,
              `cache_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
              `json_data` MEDIUMTEXT NOT NULL,
              PRIMARY KEY (`this_index`)
            ) $charset_collate;";

            dbDelta($sql);

            $table_name = $wpdb->prefix . 'local_app_phone_data_status';

            $sql = "CREATE TABLE IF NOT EXISTS $table_name (
              `this_index` int(11) NOT NULL AUTO_INCREMENT,
              `pid` varchar(256) NOT NULL,
              `lat` varchar(25) NULL,
              `lon` varchar(25) NULL,
              PRIMARY KEY (`this_index`)
            ) $charset_collate;";

            dbDelta($sql);

            $table_name = $wpdb->prefix . 'tsl_phone_tokens';

            $sql = "CREATE TABLE $table_name (
              `this_index` int(11) NOT NULL AUTO_INCREMENT,
              `connect_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
              `os_type` varchar(56) NOT NULL,
              `token` varchar(256) NOT NULL,
              `account_code` varchar(256) NULL,
              PRIMARY KEY (`this_index`)
            ) $charset_collate;";

            dbDelta($sql);

            $table_name = $wpdb->prefix . 'mam_object_cache_data';

            $sql = "CREATE TABLE IF NOT EXISTS $table_name (
              `this_index` int(11) NOT NULL AUTO_INCREMENT,
              `post_id` int(11),          
              `cache_group` varchar(500) NOT NULL,
              `object_data` MEDIUMTEXT NULL,
              `expires` int(12) NULL,
              PRIMARY KEY (`this_index`)    
            ) $charset_collate;";

            dbDelta($sql);

            $wpdb->get_results( 'ALTER TABLE '.$table_name.' ADD INDEX `post_index` (`post_id` );');
            $wpdb->get_results( 'ALTER TABLE '.$table_name.' ADD INDEX `group_index` (`cache_group` );');
            $wpdb->get_results( 'ALTER TABLE '.$table_name.' ADD INDEX `post_group_index` (`post_id`, `cache_group`);');

            $table_name = $wpdb->prefix . 'mam_email_history';

            $sql = "CREATE TABLE $table_name (
              `this_index` int(11) NOT NULL AUTO_INCREMENT,
              `user_id` int(11) DEFAULT 0,
              `recipient_id` int(11) DEFAULT 0,
              `notification_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
              `title` varchar(250) NULL,
              `message` varchar(50000) NULL,
              `to_email` varchar(150) NULL,              
              `msg_type` varchar(50) NULL,
              PRIMARY KEY (`this_index`)
            ) $charset_collate;";

            dbDelta($sql);

            $table_name = $wpdb->prefix . 'mam_custom_notifications';

            $sql = "CREATE TABLE IF NOT EXISTS $table_name (
              `id` int(11) NOT NULL AUTO_INCREMENT,
              `title` varchar(255) NOT NULL,
              `slug` varchar(255) NOT NULL,
              `trigger` varchar(225) NOT NULL,
              `trigger_days` int(11) DEFAULT NULL,
              `frequency` varchar(255) NOT NULL,
              `frequency_days` int(11) DEFAULT NULL,
              `next_run` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
              `created_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
              PRIMARY KEY (`id`)
            ) $charset_collate;";

            $wpdb->query($sql);

            $table_name = $wpdb->prefix . 'tsl_debug_items';

            $sql = "CREATE TABLE $table_name (
              `this_index` int(11) NOT NULL AUTO_INCREMENT,
              `this_date` varchar(256) DEFAULT 0, 
              `message_from` varchar(256) DEFAULT 0,
              `message_info` mediumtext DEFAULT '',
              `message_plugin` varchar(256) DEFAULT '',
              PRIMARY KEY (`this_index`)
            ) $charset_collate;";

            dbDelta($sql);

            update_option( 'mam_main_db_version', $this->db_version );

//      mamdebug('last_error', $wpdb->last_error);
//      mamdebug('last sql', $wpdb->last_query);


        }

    }

}
