<?php

//this class is 2.0 compoliant as of Feb 2024

add_action( 'plugins_loaded', array( 'tsl_mam_debug_main', 'init' ));

class tsl_mam_debug_main
{

    private $app_version = '1.9';

    public static function init()
    {
        $class = __CLASS__;
        new $class;
    }

    public function __construct()
    {

        add_filter('admin_init', array($this, 'delete_history'));
        add_filter('admin_menu', array($this, 'mam_admin_menu_manager'), 100 );

    }

    function delete_history()
    {

        if( isset($_REQUEST['clearlog'])  ){
            global $wpdb;
            $table_name = $wpdb->prefix . 'tsl_debug_items';

            if( isset($_REQUEST['tag'] ) && $_REQUEST['tag'] != 'No Filter' ){
                $wpdb->get_results("DELETE FROM $table_name WHERE message_from LIKE '".$_REQUEST['tag']."'", ARRAY_A);
            }else {
                $wpdb->get_results("DELETE FROM $table_name", ARRAY_A);
            }

            wp_redirect( '?page=mam-debug-logger-manager-settings' );
            die;

        }

    }

    public function mam_admin_menu_manager()
    {
        add_submenu_page('local_app_setup', 'Admin Log', 'Admin Log', 'manage_options', 'mam-debug-logger-manager-settings', array($this, 'add_settings_page'));
    }

    function add_settings_page()
    {
        $this->create_admin_page();
    }

    function create_admin_page()
    {

        $html_line = '<div class="tsl-admin-settings-holder-debug">';

        $html_line .= mam_admin_settings::headline('App Manager Debug Log');
        $html_line .= '<table class="tsl-admin-pref-table">';

        global $wpdb;
        $table_name = $wpdb->prefix . 'tsl_debug_items';

        $limit = 2000;
        $result = $wpdb->get_results("SELECT * FROM $table_name", ARRAY_A);
        if( sizeof($result)>$limit){
            $result = $wpdb->get_results("SELECT * FROM $table_name ORDER BY this_index DESC LIMIT $limit", ARRAY_A);
            if( sizeof( $result ) > 0 ) {
                $wpdb->get_results( "DELETE FROM $table_name WHERE this_index <= " . $result[$limit - 1]['this_index'] , ARRAY_A);
            }
        }

//        $wpdb->get_results("DELETE FROM $table_name WHERE this_date < DATE_SUB(CURDATE(), INTERVAL 7 DAY" );


        $result = $wpdb->get_results("SELECT * FROM $table_name ORDER BY this_index DESC LIMIT 1000", ARRAY_A);

        if( sizeof($result)>0){
            $protocol = isset($_SERVER["HTTPS"]) ? 'https' : 'http';

            $message = ' Clear Log';
            if( isset($_REQUEST['tag'] ) && $_REQUEST['tag'] != 'No Filter' ){
                $message = 'Clear ' . $_REQUEST['tag'] . ' Items';
            }

            $html_line .= '<tr><td colspan="3" ><a style="float:right" href="'.$protocol.'://'."$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]".'&clearlog=1">'.$message.'</a></td></tr>';
        }

        $html_line .= '</table>';

        $list = new mam_debug_grid();
        $list->prepare_items();
        ob_start();
        echo $list->views();
        echo $list->display();
        $html_line .= ob_get_contents();
        ob_end_clean();

        $html_line .= '</div>';

        echo $html_line;

    }

    function admin_manager_scripts()
    {
        wp_register_style('tsl-general-css', plugins_url("css/tsl-general-css.css", __FILE__), array(), $this->app_version, 'screen');
        wp_enqueue_style(array('tsl-general-css'));
    }
}


if(!function_exists('mamdebug')) {
	function mamdebug( $from, $message , $plugin = '' ) {
        mam_log_item( $from, $message , $plugin);
	}
}
if(!function_exists('mam_log_item')) {
	function mam_log_item( $from, $message , $plugin = '' )
    {

		global $wpdb;
		$table_name = $wpdb->prefix . 'tsl_debug_items';

		if($from == 'delete' ){
            $wpdb->get_results("DELETE FROM $table_name", ARRAY_A);
        }

		if( $from == 'admin_alert' )
        {
            update_option('local-app-admin-message_nag', true );
            $results = $wpdb->get_results("SELECT * FROM $table_name WHERE message_info LIKE '".$message."'");
            if( sizeof( $results ) > 0 ) return;
        }

		$wpdb->insert( $table_name, array( 'message_from' => $from, 'message_info' => print_r( $message, true ) , 'message_plugin' => $plugin, 'this_date' => date( 'Y-m-d H:i:s' )) );

	}
}
