<?php

class mam_get_icons_after_install
{

    function download_file($source, $dest) {
        $fp = fopen($dest, 'wb');
        $ch = curl_init($source);
        curl_setopt($ch, CURLOPT_FILE, $fp);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_exec($ch);
        curl_close($ch);
        fclose($fp);
    }

    // Function to extract zip file
    function extract_zip($zip_file, $destination) {
        $zip = new ZipArchive;
        if ($zip->open($zip_file) === TRUE) {
            $zip->extractTo($destination);
            $zip->close();
            return true;
        } else {
            return false;
        }
    }

    function mam_main_get_icons()
    {

        global $tsl_local_app_dir_path;
        $directory = $tsl_local_app_dir_path . 'images/icons';

        try {
            if (!is_dir($directory)) {
                mkdir($directory, 0755, true);
            }
            if (!is_readable($directory)) {
                mamdebug( 'files',   "Error: Directory '$directory' is not readable.");
                return;
            }

            $files = glob($directory . '/*');
            $fileCount = count($files);
            if( $fileCount > 0 ) return;

        } catch (Exception $e) {
            mamdebug( 'files',   "Error: " . $e->getMessage() );
            return;
        }

        $source_file = 'https://tinyscreenlabs.com/wp-content/plugins/tsl-traffic-manager/images/icons.zip';
        $destination_folder = $tsl_local_app_dir_path . 'images';

        try {
            // Create destination directory if it doesn't exist
            if (!is_dir($destination_folder)) {
                mkdir($destination_folder, 0755, true);
            }

            // Temporary file path
            $temp_file = sys_get_temp_dir() . '/icons.zip';

            // Download the zip file
            $this->download_file($source_file, $temp_file);

            // Extract the zip file
            if ($this->extract_zip($temp_file, $destination_folder)) {
                mamdebug( 'MAM icon Library', "Icons added" );
            } else {
                mamdebug( 'MAM icon Library', "Failed to add icon library");
            }

            unlink($temp_file);

        } catch (Exception $e) {
            mamdebug( 'admin_alert', "An error occurred downloading the icon library: " . $e->getMessage() );
        }
    }


}
