<?php

class mam_admin_settings{

    static function get_mam_user_info( $user_id )
    {

        $user_array = array();
        $user_array['first_name'] = '';
        $user_array['last_name'] = '';

        if( get_user_meta( $user_id , 'first_name', true ) ) $user_array['first_name'] = get_user_meta( $user_id , 'first_name', true );
        if( get_user_meta( $user_id , 'billing_first_name', true ) ) $user_array['first_name'] = get_user_meta( $user_id , 'billing_first_name', true );
        if( get_user_meta( $user_id , 'last_name', true ) ) $user_array['last_name'] = get_user_meta( $user_id , 'last_name', true );
        if( get_user_meta( $user_id , 'billing_last_name', true ) ) $user_array['last_name'] = get_user_meta( $user_id , 'billing_last_name', true );


        $user_array['full_name'] = trim( trim( $user_array['first_name'] ) . ' ' . trim( $user_array['last_name'] ) );

        if(get_user_meta( $user_id , '_user_avatar' , true )){
            if(get_user_meta( $user_id , '_user_avatar' , true )){
                $user_array['user_avatar'] = get_user_meta( $user_id , '_user_avatar' , true );
                $user_array['imageurl'] = $user_array['user_avatar'];
                $image_id = attachment_url_to_postid( $user_array['imageurl'] );

                if( $image_id ) {
                    $image_data = wp_get_attachment_image_src($image_id, 'full');
                    if( $image_data[1] > 0 && $image_data[2] > 0 ) {
                        $user_array['image_width'] = $image_data[1];
                        $user_array['image_height'] = $image_data[2];
                        $user_array['imageSizeFactor'] = $image_data[2] / $image_data[1];
                    }
                }
            }
        }

        return $user_array;

    }



    static function create_settings_html( $settings_array , $category = 'all' )
    {

        $html = '';

        $handler = new mam_admin_settings();

		foreach( $settings_array as $setting ){
		    if($setting['catagory'] == 'all' || $setting['catagory'] == $category ){
		        $html .= $handler->create_variable_option( $setting );
            }
        }

        return $html;

    }
// mam_admin_settings::save_attachment_for_post( $post_id, $type , $base64, $revision = 0)
    static function save_attachment_for_post( $post_id, $type , $base64, $revision = 0){

        $filename_path = md5(time().uniqid()).".jpg";
        $decoded=base64_decode( $base64 );
        $wp_upload_dir = wp_upload_dir();
        file_put_contents($wp_upload_dir['path'].'/'.$filename_path,$decoded);

        $filename = $wp_upload_dir['path'].'/'.$filename_path;
        $file_url = $wp_upload_dir['url'].'/'.$filename_path;

        // The ID of the post this attachment is for.
        $parent_post_id = $post_id;

        // Check the type of file. We'll use this as the 'post_mime_type'.
        $filetype = wp_check_filetype( basename( $filename ), null );

        // Get the path to the upload directory.
        $wp_upload_dir = wp_upload_dir();

        // Prepare an array of post data for the attachment.
        $attachment = array(
            'guid'           => $wp_upload_dir['url'] . '/' . basename( $filename ),
            'post_mime_type' => $filetype['type'],
            'post_title'     => preg_replace( '/\.[^.]+$/', '', basename( $filename ) ),
            'post_content'   => '',
            'post_status'    => 'inherit'
        );

        // Insert the attachment.
        $attach_id = wp_insert_attachment( $attachment, $filename, $parent_post_id );

         // Insert the attachment.
//        set_post_thumbnail( $post_id, $attach_id );
        $attach_data = wp_generate_attachment_metadata( $attach_id, $filename );
        wp_update_attachment_metadata( $attach_id, $attach_data );

        $attachments = get_post_meta( $post_id , '_tsl_post_attachments' , true );

        if(!$attachments) $attachments = array();

        $addFile = true;

        foreach ( $attachments as $index => $item ){
            if($item['file_type'] == $type ){
                $attachments[$index] = array( 'file_id' => $attach_id , 'file_type' => $type , 'revision' => $revision );
                $addFile = false;
            }
        }

        if( $addFile ) $attachments[] = array( 'file_id' => $attach_id , 'file_type' => $type , 'revision' => 0 );

        update_post_meta( $post_id , '_tsl_post_attachments' , $attachments );

        return array( 'id' => $attach_id , 'src' => $file_url );

    }

    function create_variable_option( $variable = array() ){

        switch( $variable['type'] ){
            case 'yes-no':
            case 'black-white':
            case 'buttons-demo':
            case 'buttons-prod':
            case 'none-20':
            case 'button-content':
            case 'none-5':
            case 'post_type':
            case 'user-roles':
            case 'form-list':
            case 'defined-in-data':
            case 'home_page_views':
                return mam_admin_settings::do_dropdown( $variable );
            break;
            case 'text':
            case 'rgbtext':
            case 'startext':
                return mam_admin_settings::do_text_field( $variable );
                break;
            case 'image':
                return mam_admin_settings::do_image_field( $variable );
                break;
            case 'text_json':
                return mam_admin_settings::do_text_area_json( $variable );
                break;
            case 'gravity_form':
                return mam_admin_settings::create_gravity_form( $variable );
                break;
            case 'header':
                return mam_admin_settings::display_header( $variable );
                break;
            case 'color':
                return mam_admin_settings::do_single_var_color( $variable );
                break;
            case 'checkbox':
                return mam_admin_settings::do_checkbox( $variable );
                break;

        }

    }




    static function display_header( $settings )
    {

        $html_line = '<table class="tsl-admin-pref-table">';
		$html_line .= '<tr>';
		$html_line .= '<td class="tsl-admin-pref-table-heading"><br>'.$settings['title'].'</td>';
		$html_line .= '</tr>';
		$html_line .= '</table>';

		return $html_line;

    }

    static function create_gravity_form( $settings )
    {

        $html = '';

        $slug = $settings['data']['root'] . $settings['data']['slug'];
		$html .= mam_admin_settings::assign_form( $slug , $settings['data']['title'] );

		if( get_option( $slug ) ) {
		    foreach( $settings['data']['fields'] as $field ) {
                $field_slug = $slug . '_' . $field['slug'];
                $html .= mam_admin_settings::assign_form_field( $field_slug, $field['title'] . ' Field', get_option( $slug ));
            }
        }

		$html .= '<br>';

        return $html;

    }

	static function assign_form( $slug , $title )
    {

		$selected = get_option( $slug );

		$html_line = '<table class="tsl-admin-pref-table">';
		$html_line .= '<tr>';
		$html_line .= '<td class="tsl-admin-pref-table-heading">'.$title.':</td>';
		$html_line .= '<td class="tsl-admin-pref-table-heading" align="right">'.mam_admin_settings::make_dropdown( $slug , mam_admin_settings::make_form_list(), $selected , '' , '' ,true ).'</td>';
		$html_line .= '</tr>';
		$html_line .= '</table>';

		return $html_line;

	}

    static function assign_form_field( $slug , $title , $form_id )
    {

		$selected = get_option( $slug );

		$html_line = '<table class="tsl-admin-pref-table">';
		$html_line .= '<tr>';
		$html_line .= '<td class="tsl-admin-pref-table-heading">'.$title.':</td>';
		$html_line .= '<td class="tsl-admin-pref-table-heading" align="right">'. mam_admin_settings::make_dropdown( $slug , mam_admin_settings::make_form_field_list( $form_id ), $selected , '' , '' , true ).'</td>';
		$html_line .= '</tr>';
		$html_line .= '</table>';

		return $html_line;

	}

    static function make_form_field_list( $form_id )
    {

		$forms = array();

        $form_list = apply_filters('mam_gf_get_form', array(), $form_id);
        foreach( $form_list['fields'] as $form ){
            $forms[] = array('slug' => $form['id'] , 'name' => $form['label'] );
        }

		return $forms;

	}

	static function make_form_list(){

		$forms = array();

        $form_list = apply_filters( 'mam_gf_get_all_forms', array());
    	foreach( $form_list as $form ){
            $forms[] = array('slug' => $form['id'] , 'name' => $form['title'] );
        }

        local_app_sksort( $forms, 'name', true);

		return $forms;

	}

    static function headline($headline )
    {

		$html_line = '<div class="tsl-admin-headline">';
		$html_line .= $headline;
		$html_line .= '</div>';

		return $html_line;

    }

    static function sub_heading( $sub_heading , $anchor = '' ){

		$html_line = '<div class="tsl-admin-subheading">';
		$html_line .= $sub_heading;
        if( ! is_null($anchor) && strlen( $anchor ) > 0 )
        {
            $html_line .= '  ' . $anchor;
        }
		$html_line .= '</div>';

		return $html_line;

	}


    static function section_seperator()
    {
		return '<hr class="tsl-admin-settings-seperator">';
	}

	static function submit_button( $value = 'Save Changes')
    {
		return '<input name="submit" id="submit" style="float:right" class="button button-primary button-large" value="'.$value.'" type="submit">';
	}

	static function do_checkbox( $variable )
    {

        $value = get_option( $variable['id'] );

        $selected = '';
        if( strtolower( $value  ) == 'yes' ) $selected = 'checked';

        $html_line = '<table class="tsl-admin-pref-table">';
        $html_line .= '<tr>';
        $html_line .= '<td class="tsl-admin-pref-table-heading">'.$variable['title'].':</td>';
        $html_line .= '<td class="tsl-admin-pref-table-heading" align="right"><input type="checkbox" id="'.$variable['id'].'" name="'.$variable['id'].'" value="yes" '.$selected.'/></td>';
        $html_line .= '</tr>';
        $html_line .= '</table>';

        if( isset( $variable['add_line'] )) $html_line .= '<hr>';

       return $html_line;

    }

    static function make_textfield( $id,  $value = '', $title = '' )
    {

        $html_line = '<table class="tsl-admin-pref-table">';
        $html_line .= '<tr>';
        $html_line .= '<td class="tsl-admin-pref-table-heading">'.$title.':</td>';
        $html_line .= '<td class="tsl-admin-pref-table-heading" align="right"><input style="width:25em" type="text" id="'.$id.'" name="'.$id.'" value="'.$value.'"/></td>';
        $html_line .= '</tr>';
        $html_line .= '</table>';

       return $html_line;

    }

    static function do_image_field( $variable , $right_justify = false ){

        $css = 'class="mam-image-setting"';
		if( $right_justify ) $css = 'style:"text-align:right;" class="mam-image-setting"';

		$selected = stripslashes(get_option($variable['id']));

        $desc = apply_filters( 'mam_settings_set_help_desc',  $variable );

        $image = '';
        if( strlen( $selected ) > 0 ){
            $image = '<img src="'.$selected.'" style="height:25px;padding-right:5px;vertical-align : middle;">';
        }

        $html_line = '<table class="tsl-admin-pref-table">';
		$html_line .= '<tr>';
		$html_line .= '<td class="tsl-admin-pref-table-heading">'.$variable['title'].':</td>';
		$html_line .= '<td class="tsl-admin-pref-table-heading" align="right" style="vertical-align : middle;">'. $desc .$image.'<input style="width:25em" type="text" id="'.$variable['id'].'" name="'.$variable['id'].'" value="'.$selected.'" '.$css.'/></td>';
		$html_line .= '</tr>';
		$html_line .= '</table>';

		return $html_line;
    }

    static function make_standard_submit_html()
    {

        $html_line = '<table class="tsl-admin-pref-table">';
        $html_line .= '<tr>';
        $html_line .= '<td></td>';
        $html_line .= '<td></td>';
        $html_line .= '<td>' . mam_admin_settings::submit_button() . '</td>';
        $html_line .= '</tr>';
        $html_line .= '</table>';

        return $html_line;

    }

    static function make_checkbox_html( $id , $checked , $value, $title )
    {

        $html_line = '<table class="tsl-admin-pref-table">';
        $html_line .= '<tr>';
        $html_line .= '<td class="tsl-admin-pref-table-heading">'.$title.'</td>';
        $html_line .= '<td class="tsl-admin-pref-table-heading" align="right"><input type="checkbox" id="'.$id.'" name="'.$id.'" value="'.$value.'" '.$checked.'/></td>';
        $html_line .= '</tr>';
        $html_line .= '</table>';

        return $html_line;

    }

    static function make_checkbox_row( $id , $checked , $value,  $title ){

        $html_line = '<tr>';
        $html_line .= '<td class="tsl-admin-pref-table-heading">'.$title.'</td>';
        $html_line .= '<td class="tsl-admin-pref-table-heading" align="right"><input type="checkbox" id="'.$id.'" name="'.$id.'" value="'.$value.'" '.$checked.'></td>';
        $html_line .= '</tr>';

        return $html_line;

    }

    static function make_font_dropdown_list(){

        $dropdown[] = array('slug' => 'standard', 'name' => 'Standard');
        $dropdown[] = array('slug' => 'historical_roman', 'name' => 'Historical Roman');
        $dropdown[] = array('slug' => 'Lemon', 'name' => 'Lemon');
        $dropdown[] = array('slug' => 'rounded_elegance', 'name' => 'Rounded Elegance');
        $dropdown[] = array('slug' => 'serfia', 'name' => 'Serfia');


        return $dropdown;

    }

    static function make_dropdown( $id , $options = array() , $selected = null , $title = null , $css = '' , $dd_only = false ){

		if( ! $id || sizeof($options) == 0 ) return '';

		if(strlen( $css) > 0 && $dd_only ) $css = 'class="'.$css.'"';

		$dd_html = '<select id="'.$id.'" name="'.$id.'" '.$css.'>';

		if( ! $selected ){
		    $dd_html .= '<option value="0" selected>Select...</option>';
        }else{
		    $dd_html .= '<option value="0" >Select...</option>';
        }

		foreach($options as $option){
			$selected_item = '';
			if($option['slug'] == $selected ) $selected_item = 'selected';
			$dd_html .= '<option  value="'.$option['slug'].'" '.$selected_item.'>' .$option['name'].'</option>';
		}

		$dd_html .= '</select>';

		if($dd_only) return $dd_html;

		$title .= ':';

		$html_line = '<table class="tsl-admin-pref-table" '.$css.'>';
		$html_line .= '<tr>';
		$html_line .= '<td class="tsl-admin-pref-table-heading">'.$title.'</td>';
		$html_line .= '<td class="tsl-admin-pref-table-heading" align="right">'.$dd_html.'</td>';
		$html_line .= '</tr>';
		$html_line .= '</table>';

		return $html_line;

	}

    static function do_dropdown( $variable ){


        if( $variable['type'] == 'defined-in-data') {

            $dropdown = $variable['data'];

        }

        if( $variable['type'] == 'post_type') {
            $categories = get_post_types();
            $dropdown = array();
            $dropdown[] = array( 'slug' => 'none', 'name' => 'None' );

            foreach ($categories as $index => $category) {
                $post_type = get_post_type_object($index);
                $dropdown[] = array('name' => $post_type->labels->singular_name, 'slug' => $index);
            }
        }

        if( $variable['type'] == 'none-20') {
            $dropdown[] = array('slug' => 'never', 'name' => 'Never');
            for($x=1;$x<21;$x++) {
                $dropdown[] = array('slug' => $x, 'name' => $x);
            }
        }

        if( $variable['type'] == 'button-content') {
            $dropdown[] = array('slug' => 'never', 'name' => 'None');
            for($x=1;$x<11;$x++) {
                $dropdown[] = array('slug' => $x, 'name' => 'Main ' . $x);
            }
            for($x=1;$x<11;$x++) {
                $y = $x + 20;
                $dropdown[] = array('slug' => $y, 'name' => 'Left ' . $x);
            }
        }

        if( $variable['type'] == 'none-5') {
            $dropdown[] = array('slug' => 'never', 'name' => 'Never');
            for($x=1;$x<6;$x++) {
                $dropdown[] = array('slug' => $x, 'name' => $x);
            }
        }

        if( $variable['type'] == 'yes-no') {
            $dropdown[] = array('slug' => 'yes', 'name' => 'Yes');
            $dropdown[] = array('slug' => 'no', 'name' => 'No');
        }

        if( $variable['type'] == 'black-white') {
            $dropdown[] = array('slug' => 'black', 'name' => 'Black');
            $dropdown[] = array('slug' => 'white', 'name' => 'White');
        }

        if( $variable['type'] == 'user-roles') {
            global $wp_roles;

            $all_roles = $wp_roles->roles;

            foreach($all_roles as $role_index => $role ) {
                 $dropdown[] = array('slug' => $role_index, 'name' => $role['name']);
            }
        }

        if( $variable['type'] == 'form-list') {
            if(class_exists('mam_for_gravity_forms_forms_manager')){
                $form_handler = new mam_for_gravity_forms_forms_manager();
                $forms = $form_handler->get_all_gravity_forms();

                foreach( $forms as $form ) {
                    $dropdown[] = array( 'slug' => $form['id'], 'name' => $form['title'] );
                }
            }else{
                return 'No Forms';
            }
        }

        if( $variable['type'] == 'buttons-demo' )
        {
            $dropdown[] = array('slug' => 'home', 'name' => 'Home Screen');
            $dropdown[] = array('slug' => 'map', 'name' => 'Map');
        }

        if( isset($_REQUEST[$variable['id']]) && !empty($_REQUEST[$variable['id']]) ){
			update_option($variable['id'] , $_REQUEST[$variable['id']] );
		}

		$selected = stripslashes(get_option($variable['id']));

		return mam_admin_settings::make_dropdown( $variable['id'] , $dropdown, $selected , $variable['title'] );

    }

    static function do_text_field( $variable , $right_justify = false ){

        if(  isset($_REQUEST[$variable['id']]) ){
			update_option($variable['id'] , $_REQUEST[$variable['id']] );
		}
        $css = '';
		if( $right_justify ) $css = 'style:"text-align:right;"';

		$selected = stripslashes(get_option($variable['id']));

		return mam_admin_settings::make_textfield( $variable['id'] , $selected , $variable['title'] );
    }


	static function make_textarea( $id,  $value = '', $title = '' )
    {

        $html_line = '<table class="tsl-admin-pref-table">';
        if( strlen( $title ) > 0 ) {
            $html_line .= '<tr>';
            $html_line .= '<td class="tsl-admin-pref-table-heading">' . $title . ':</td>';
            $html_line .= '</tr>';
        }
        $html_line .= '<tr>';
        $html_line .= '<td class="tsl-admin-pref-table-heading"><textarea id="'.$id.'" name="'.$id.'" rows="4" style="width:100%">'.$value.'</textarea></td>';
        $html_line .= '</tr>';
        $html_line .= '</table>';

       return $html_line;

    }

    static function do_text_area_json( $variable ){

        $value = '';
        if($variable['id'] == 'tsl-google-map-styles'){
            $value = json_encode( get_option($variable['id']) );
            if(strlen($value) < 15 ) $value = '';
        }

        $html_line = '<table class="tsl-admin-pref-table">';
        $html_line .= '<tr>';
        $html_line .= '<td class="tsl-admin-pref-table-heading">'.$variable['title'].':</td>';
        $html_line .= '<td class="tsl-admin-pref-table-heading" align="right"><textarea id="'.$variable['id'].'" name="'.$variable['id'].'" rows="4" cols="50">'.$value.'</textarea></td>';
        $html_line .= '</tr>';
        $html_line .= '</table>';

       return $html_line;

    }

    static function do_single_var_color( $variable )
    {

        $selected = get_option( $variable['id'] );

        if( ! $selected ){
            if( isset( $variable['default'] )) $selected = $variable['default'];
        }else {
            if (strpos($selected, ',') > 0) {
                $selected = sprintf("#%02x%02x%02x", 13, 0, 255);
            }
        }

        $desc = apply_filters( 'mam_settings_set_help_desc',  $variable );

        $html_line = '<table class="tsl-admin-pref-table">';
		$html_line .= '<tr>';
		$html_line .= '<td class="tsl-admin-pref-table-heading">'.$variable['title'].':</td>';
		$html_line .= '<td class="tsl-admin-pref-table-heading" align="right"><div class="flex-container" style="display: flex;justify-content: flex-end;align-items: center;">'. $desc .'<input class="mam-color-picker" type="color" name="'.$variable['id'].'" value="'.$selected.'"/></div></td>';
		$html_line .= '</tr>';
		$html_line .= '</table>';

		return $html_line;


    }

    static function do_color( $id, $value, $title , $description = null )
    {

        $selected = get_option( $id );

        if( $selected ){
            if ( strpos( $selected, ',' ) > 0 ) {
                $selected = sprintf("#%02x%02x%02x", 13, 0, 255 );
            }
        }

        $desc = '';
        if( $description ){
            $desc = '<span title="' . $description . '" class="local-app-help-button fa fa-question-circle"></span>';
        }

        $html_line = '<table class="tsl-admin-pref-table">';
		$html_line .= '<tr>';
		$html_line .= '<td class="tsl-admin-pref-table-heading">'.$title.':</td>';
		$html_line .= '<td class="tsl-admin-pref-table-heading" align="right">'. $desc .'<input class="mam-color-picker" type="color" name="'.$id.'" value="'.$selected.'"/></td>';
		$html_line .= '</tr>';
		$html_line .= '</table>';

		return $html_line;

    }

    static function get_image_id( $image_url ) {


        return attachment_url_to_postid( $image_url );

//        $image_url = wp_make_link_relative( $image_url );
//        global $wpdb;
//        $attachment = $wpdb->get_col($wpdb->prepare("SELECT ID FROM $wpdb->posts WHERE guid RLIKE '%s';", $image_url ));
//        if( $attachment ) return $attachment[0];
//        return false;

    }

    static function setup_image_parameters_for_content( $image , $this_post )
    {

        if( is_numeric( $image ) ){
            $image_id = $image;
        }else{
            $image_id = attachment_url_to_postid( $image );
        }

        if( ! $image_id ){
            return false;
        }

        $featured_image = wp_get_attachment_image_src($image_id, 'full');
        $featured_image = $featured_image[0];

        $this_post['image'] = str_replace(' ', '-', str_replace('/', '-', urldecode($featured_image)));
        $this_post['imageurl'] = $featured_image;
        $parts = explode('.', $this_post['image']);
        $this_post['extension'] = $parts[sizeof($parts) - 1];
        $this_post['image_id'] = $image_id;
        if ($this_post['image_id'] < 1) {
            $this_post['image_id'] = ' ';
        }

        $ext = strtolower($this_post['extension']);
        if ($ext == 'png' || $ext == 'jpg' || $ext = 'jpeg') {
            $image_data = wp_get_attachment_image_src($this_post['image_id'], 'full');
            if ( $image_data[1] > 800 || $image_data[2] > 800) {
                $aspect = $image_data[2] / $image_data[1];
                if ( $image_data[1] > 800 ){
                    $width = 800;
                    $height = 800 / $aspect;
                }else{
                    $height = 800;
                    $width = 800 * $aspect;
                }
                $size = array( $width, $height );
                $image_data = wp_get_attachment_image_src( $image_id , $size );
                $this_post['imageurl']  = $image_data[0];
                $this_post['img_width'] = $image_data[1];
                $this_post['img_height'] = $image_data[2];
                $this_post['imageSizeFactor'] = $image_data[2] / $image_data[1];
                $this_post['imageurl_aspect'] = $image_data[2] / $image_data[1];
                $this_post['featuredRespectAspectRatio'] = 'yes';
            }else {
                if ($image_data[1] > 0 && $image_data[2] > 0) {
                    $this_post['img_width'] = $image_data[1];
                    $this_post['img_height'] = $image_data[2];
                    $this_post['imageSizeFactor'] = $image_data[2] / $image_data[1];
                    $this_post['imageurl_aspect'] = $image_data[2] / $image_data[1];
                    $this_post['featuredRespectAspectRatio'] = 'yes';
                }
            }
        }
//if( $this_post['id']== 131 ) mamdebug('image', $this_post );
        return $this_post;

    }

}
