<?php

class mam_geocoding_manager
{

    private $api_key = '';
    private $username = '';
    private $password = '';
    private $mapbox_token = '';
    private $db_version = 1;

    function __construct()
    {


    }

    function mapbox_geocode_address($address)
    {

        global $wpdb;
        $table_name = $wpdb->prefix . 'mam_address_db';

        $result = $wpdb->get_results("SELECT * FROM $table_name WHERE address = '" . $address . "'", ARRAY_A);
        if (sizeof($result) > 0) {
            mamdebug('database', $result[0]);
            return $result[0];
        }

        $coords = array();
        $method = '/geocoding/v5/mapbox.places/' . $address . '.json?types=address';
        $coordinates = json_decode($this->curl_manager('GET', $method), true);
        $coordinates = $coordinates['features'];
        if (sizeof($coordinates) > 0) {
            if (isset($coordinates[0]['geometry']['coordinates'])) {
                $coords['address'] = $address;
                $coords['lat'] = $coordinates[0]['geometry']['coordinates'][1];
                $coords['lon'] = $coordinates[0]['geometry']['coordinates'][0];

                $wpdb->insert($table_name, $coords);
            }
        }

        mamdebug('MB coords', $coords);

        return $coordinates;
    }

    function geocode_address( $address = null  )
    {

        global $wpdb;
        $table_name = $wpdb->prefix . 'mam_address_db';

        $result = $wpdb->get_results("SELECT * FROM $table_name WHERE address = '" . $address . "'", ARRAY_A);
        if (sizeof($result) > 0) {
            mamdebug('database', $result[0]);
            return $result[0];
        }

        $apikey = get_option('tsl-google-api-key');

        if ($apikey && strlen($address) > 4 ) {

            if( get_option( 'geocode_' . $address ) ){
                return get_option( 'geocode_' . $address );
            }

            $geocode = file_get_contents("https://maps.google.com/maps/api/geocode/json?address=" . urlencode($address) . "&key=" . $apikey);
            $output = json_decode($geocode);

            $geo_array['lat'] = $output->results[0]->geometry->location->lat;
            $geo_array['lon'] = $output->results[0]->geometry->location->lng;
            $geo_array['country'] = $output->results[0]->address_components[5]->long_name;

            if ( $output->status == 'ZERO_RESULTS' || $output->status == 'REQUEST_DENIED' ) {
                mamdebug('Failed to GeoCode', $output->status . ' - ' . $address );

            } else {

                $geo_array['address'] = $address;
                $wpdb->insert( $table_name, $geo_array );

                return $geo_array;

            }


        }

        return array();
    }

    function curl_manager( $method, $service, $body_params = array() )
    {

        $token = $this->mapbox_token;

        $api_endpoint = 'https://api.mapbox.com';


        $url = $api_endpoint . $service;

        if( strpos( $url , '?' )){
            $url .= '&access_token='.$token;
        }else{
            $url .= '?access_token='.$token;
        }

        $curl = curl_init();

        switch ($method) {
            case "POST":
                curl_setopt($curl, CURLOPT_POST, 1);

                if ($body_params)
                    curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($body_params));
                break;
            case "PUT":
                curl_setopt($curl, CURLOPT_PUT, 1);

                if ($body_params)
                    curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($body_params));
                break;
            default:
                if ($body_params)
                    $url = sprintf("%s?%s", $url, http_build_query($body_params));
        }

        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);

        curl_setopt($curl, CURLOPT_HTTPHEADER, array('Content-Type: application/json'));

        $result = curl_exec($curl);

        if (curl_errno($curl)) {
            mamdebug('Mapbox curl error', curl_error($curl));
        }

        curl_close($curl);

        return $result;
    }


}
