<?php


class mam_home_screen_stack
{

    private $stack_content = array();

    function __construct()
    {

        if( ! isset($_REQUEST['role'])) $_REQUEST['role'] = 'mam-all';

    }

    function setting_html()
    {

        $stack_content = apply_filters( 'mam_app_settings_get_home_screen_stack' , array() , $_REQUEST['role'] );
        if( is_array( $stack_content ) && count( $stack_content ) > 0 ){
            $this->stack_content = $stack_content;
        }else{
            unset( $this->stack_content );
        }

        $html = '<div class="mam-hs-template-holder-div">';

        $html .= $this->build_content();

        $html .= '</div>';

        $html .= $this->add_prototype_sections();

        return $html;

    }

    function build_content()
    {

        $html = '<table class="mam-hs-slide-table-content">';
        $html .= '<tr>';
        $html .= '<td class="mam-hs-content-left" valign="top">';
        $html .= $this->content_left();
        $html .= '</td>';
        $html .= '<td class="mam-hs-content-left" valign="top">';
        $html .= '';//$this->content_right();
        $html .= '</td>';
        $html .= '</tr>';
        $html .= '</table>';

        return $html;

    }

    function content_left()
    {

        $item_array = array();

        $html = '<table class="mam-hs-slide-table-content-left">';

        foreach( $item_array as $item ) {

            $value = '';
            $object_html = '';

            $showLine = true;

            switch( $item['type'] ){
                case 'textfield':
                    $object_html = '<input class="'.$item['slug'].'" style="width:25em" type="text" id="'.$item['slug'].'" name="'.$item['slug'].'" value="'.$value.'"/>';
                    break;
                case 'select-font':
                    $options = mam_admin_settings::make_font_dropdown_list();
                    if( ! $value ) $value = 'standard';
                    $object_html = mam_admin_settings::make_dropdown( $item['slug'] , $options , $value , null , $item['slug'] , true );
                    break;
                case 'select-color':
                    $color = $value;
                    if( ! $value ) $color = $item['default'];

                    $object_html = '<input class="mam-color-picker '.$item['slug'].'" type="color" id="'.$item['slug'].'" name="'.$item['slug'].'" value="'.$color.'""/>';
                    break;

            }

            if( $showLine ) {

                $html .= '<tr>';
                $html .= '<td>';
                $html .= '<span class="mam-hs-content-title">' . $item['title'] . '</span>';
                $html .= '</td>';
                $html .= '<td>';
                $html .= $object_html;
                $html .= '</td>';
                $html .= '</tr>';

                $html .= '<tr>';
                $html .= '<td colspan="2">';
                $html .= '<hr>';
                $html .= '</td>';
                $html .= '</tr>';

            }else{
                $html .= $object_html;
            }

        }

        $html .= '<tr>';
        $html .= '<td colspan="2">';
        $html .= '<div class="mam-hs-sections" >';
        foreach( $this->stack_content['section'] as $index => $section )
        {

            switch( $section['mam-hs-section-type'] ){
                case 'spacer':
                    $html .= $this->create_spacer_section( $index  ,$section['mam-hs-spacer-section-value'] , $section['mam-hs-spacer-section-height'],  $section['mam-hs-spacer-section-height-type'] );
                    break;
                case 'text': //aka label
                    $html .= $this->create_text_section( $index ,  $section['mam-hs-text-section-value'] , $section['mam-hs-text-section-justification'] , $section['mam-hs-text-section-font-style'] , $section['mam-hs-text-section-font-size'] , $section['mam-hs-text-section-font-color'] );
                    break;
                case 'graph':
                    $html .= $this->create_graph_section( $index   );
                    break;
                case 'image':
                    $html .= $this->create_image_section( $index, $section['mam-hs-image'], $section['mam-hs-image-section-image-width'] , $section['mam-hs-image-section-justification'], $section['mam-hs-image-id'] );
                    break;
                case 'single_listing':
                    $html .= $this->create_single_listing_section( $index , $section['mam-hs-image'], $section['mam-hs-image-section-image-width'] , $section['mam-hs-image-section-justification'] , $section['mam-hs-image-id']);
                    break;
                case 'qr_code_scanner':
                    $html .= $this->create_config_via_filter_section( $index , $section['mam-hs-section-type'] );
                    break;
                case 'profile_stats':
                    $html .= $this->create_config_via_filter_section( $index , $section['mam-hs-section-type'] );
                    break;
                case 'sign_in_sign_up':
                    $html .= $this->create_config_via_filter_section( $index , $section['mam-hs-section-type'] );
                    break;
                case 'date_time_filter':
                    $html .= $this->create_date_time_filter_section( $index , $section );
                    break;
                case 'user_profile':
                    $html .= $this->create_config_via_filter_section( $index , $section['mam-hs-section-type'] );
                    break;
                case 'in_app_purchase_prompt':
                    $html .= $this->create_config_via_filter_section( $index , $section['mam-hs-section-type'] );
                    break;
                case 'horizontal_scrollers':
                    $html .= $this->create_config_via_filter_section( $index , $section['mam-hs-section-type'] );
                    break;
                case 'task_button_scroller':
                    $html .= $this->create_config_via_filter_section( $index , $section['mam-hs-section-type'] );
                    break;
                case 'open_onboarding':
                    $html .= $this->create_config_via_filter_section( $index , $section['mam-hs-section-type'] );
                    break;
                case 'user_checkin':
                    $html .= $this->create_config_via_filter_section( $index , $section['mam-hs-section-type'] );
                    break;
                case 'std_button':
                    $html .= $this->create_config_via_filter_section( $index , $section['mam-hs-section-type'] );
                    break;
                case 'toggle_hss_button':
                    $html .= $this->create_config_via_filter_section( $index , $section['mam-hs-section-type'] );
                    break;
                case 'button':
                    $html .= $this->create_config_via_filter_section( $index , $section['mam-hs-section-type'] );
                    break;
                case 'form_field':
                    $html .= $this->create_config_via_filter_section( $index , $section['mam-hs-section-type'] );
                    break;
                case 'form_button_bar':
                    $html .= $this->create_config_via_filter_section( $index , $section['mam-hs-section-type'] );
                    break;
                case 'filter_bar':
                    $html .= $this->create_filter_bar_section( $index ,$section );
                    break;
                case 'map':
                    $html .= $this->create_map_section( $index  );
                    break;
                case 'listing_table':
                    $html .= $this->create_listing_table_section( $index  );
                    break;
                case 'geo_filters':
                    $html .= $this->create_geo_filters_section( $index, $section  );
                    break;
                case 'listing_search':
                    $html .= $this->create_listing_search_section( $index  );
                    break;
                case 'tagged_nav':
                    $html .= $this->create_tagged_nav_section( $index  );
                    break;
                case 'tag_cloud':
                    $html .= $this->create_tag_cloud_section( $index  );
                    break;
                case 'special_offers':
                    $html .= $this->create_special_offers_section( $index  );
                    break;
                case 'bottom_tabbar':
                    $html .= $this->create_bottom_tabbar_section( $index  );
                    break;
                case 'collection_view':
                    $html .= $this->create_collection_view_section( $index  );
                    break;
                case 'storefront':
                    $html .= $this->create_storefront_section( $index  );
                    break;
                case 'radius_selector':
                    $html .= $this->create_radius_selector_section( $index, $section  );
                    break;

            }

        }

        $html .= '</div>';
        $html .= '</td>';
        $html .= '</tr>';

        $html .= '<tr>';
        $html .= '<td colspan="2" align="right">';
        $html .= '<p>&nbsp;</p>';
        $html .= '</td>';
        $html .= '</tr>';

        if ( ! function_exists( 'get_plugins' ) ) {
           require_once( ABSPATH . '/wp-admin/includes/plugin.php' );
        }

        $options = array();
        $options[] = array( 'name' => 'Bottom Tab bar' , 'slug' => 'bottom_tabbar' );
        $options[] = array( 'name' => 'Button' , 'slug' => 'button' ); //stacked_button
        $options[] = array( 'name' => 'Button with Config' , 'slug' => 'std_button' );
        $options[] = array( 'name' => 'Category Scroller' , 'slug' => 'category_scroll' );
        $options[] = array( 'name' => 'Collection View Section' , 'slug' => 'collection_view' );
        $options[] = array( 'name' => 'Category Filter Bar' , 'slug' => 'filter_bar' );
        $options[] = array( 'name' => 'Date and Time Filter' , 'slug' => 'date_time_filter' );
        $options[] = array( 'name' => 'Form Button Bar' , 'slug' => 'form_button_bar' );
        $options[] = array( 'name' => 'Form Field' , 'slug' => 'form_field' );
        $options[] = array( 'name' => 'Geofilters' , 'slug' => 'geo_filters' );
        $options[] = array( 'name' => 'Graph' , 'slug' => 'graph' );
        $options[] = array( 'name' => 'Horizontal Scrollers' , 'slug' => 'horizontal_scrollers' );
        $options[] = array( 'name' => 'Image Section' , 'slug' => 'image' );
        $options[] = array( 'name' => 'In App Purchase Prompt' , 'slug' => 'in_app_purchase_prompt' );
        $options[] = array( 'name' => 'Label Section' , 'slug' => 'text' );
        $options[] = array( 'name' => 'Listing Table' , 'slug' => 'listing_table' );
        $options[] = array( 'name' => 'Listing Search' , 'slug' => 'listing_search' );
        $options[] = array( 'name' => 'Map Section' , 'slug' => 'map' );
        $options[] = array( 'name' => 'Open Onboarding' , 'slug' => 'open_onboarding' );
        $options[] = array( 'name' => 'Profile Stats' , 'slug' => 'profile_stats' );
        $options[] = array( 'name' => 'QR Code Scanner' , 'slug' => 'qr_code_scanner' );
        $options[] = array( 'name' => 'Single Listing' , 'slug' => 'single_listing' );
        $options[] = array( 'name' => 'Sign In or Sign Up' , 'slug' => 'sign_in_or_sign_up' );
        $options[] = array( 'name' => 'Spacer Section' , 'slug' => 'spacer' );
        $options[] = array( 'name' => 'Special Offers' , 'slug' => 'special_offers' );
        $options[] = array( 'name' => 'Tagged Navigation' , 'slug' => 'tagged_nav' );
        $options[] = array( 'name' => 'Tag Cloud' , 'slug' => 'tag_cloud' );
        $options[] = array( 'name' => 'Task Button Scroller' , 'slug' => 'task_button_scroller' );
        $options[] = array( 'name' => 'Toggle Home Screen UI' , 'slug' => 'toggle_hss_button' );
        $options[] = array( 'name' => 'Quotes Section' , 'slug' => 'quotes' );
        $options[] = array( 'name' => 'Check In' , 'slug' => 'user_checkin' );
        $options[] = array( 'name' => 'User Profile' , 'slug' => 'user_profile' );
        $options[] = array( 'name' => 'Radius Selector' , 'slug' => 'radius_selector' );

        if( has_filter( 'mam_home_screen_stack_options' )){
            $options = apply_filters( 'mam_home_screen_stack_options' , $options );
        }

        local_app_sksort( $options, 'name' , true  );

        $html .= '<tr class="mam-hs-add-section-controls">';
        $html .= '<td colspan="2" align="right">';
        $html .= mam_admin_settings::make_dropdown( 'new_section_dropdown' , $options, null, null, '', true);
        $html .= '&nbsp;<input name="mam-hs-add-section" id="mam-hs-add-section" class="button button-primary button-large mam-hs-add-section" value="Add" type="button">';
        $html .= '</td>';
        $html .= '</tr>';

        $html .= '<tr>';
        $html .= '<td colspan="2" align="right">';
        $html .= '<p>&nbsp;</p>';
        $html .= '</td>';
        $html .= '</tr>';

        $html .= '</table>';

        return $html;

    }

    function content_right( $slide = array() )
    {

        $image_url = '';

        if( isset( $slide['mam-hs-background-image'])) {
            $image = '<img src="' . $slide['mam-hs-background-image'] . '" style="width:225px;height:400px;">';
            $image_url = $slide['mam-hs-background-image'];
        }else{
            global $tsl_local_app_image_url;
            $image = '<img src="'.$tsl_local_app_image_url.'images/backgrounds/500WHITEFFFFFF.png" style="width:225px;height:400px;">';
        }

        $html = '<table class="local-app-table-launch-screen">';
        $html .= '<tr>';
        $html .= '<td>';
        $html .= '<div class="mam-hs-background-image">' . $image . '</div>';
        $html .= '<input type="hidden" class="mam-hs-background-image" id="mam-hs-background-image" name="mam-hs-background-image" value="'.$image_url.'"/>';
        $html .= '<div class="local-app-images-launch-screen-subtitle">Click Image to Upload</div>';
        $html .= '</td>';
        $html .= '</tr>';

        $html .= '</table>';

        return $html;

    }

    function add_prototype_sections()
    {

        $html = '<div class="mam-hs-spacer-section-proto">';
        $html .= $this->create_spacer_section();
        $html .= '</div>';
        $html .= '<div class="mam-hs-text-section-proto">';
            $html .= $this->create_text_section();
        $html .= '</div>';
        $html .= '<div class="mam-hs-graph-section-proto">';
            $html .= $this->create_graph_section();
        $html .= '</div>';
        $html .= '<div class="mam-hs-single-listing-section-proto">';
            $html .= $this->create_single_listing_section();
        $html .= '</div>';

        $filter_config_sections = array();
        $filter_config_sections[] = 'qr_code_scanner';
        $filter_config_sections[] = 'profile_stats';
        $filter_config_sections[] = 'sign_in_sign_up';
        $filter_config_sections[] = 'user_profile';
        $filter_config_sections[] = 'in_app_purchase_prompt';
        $filter_config_sections[] = 'horizontal_scrollers';
        $filter_config_sections[] = 'task_button_scroller';
        $filter_config_sections[] = 'open_onboarding';
        $filter_config_sections[] = 'user_checkin';
        $filter_config_sections[] = 'std_button';
        $filter_config_sections[] = 'toggle_hss_button';
        $filter_config_sections[] = 'button';
        $filter_config_sections[] = 'form_field';
        $filter_config_sections[] = 'form_button_bar';

        foreach( $filter_config_sections as $section ){
            $html .= '<div class="mam-hs-'.$section.'-section-proto">';
                $html .= $this->create_config_via_filter_section( null, $section , ucfirst( str_replace( '_', ' ', $section )));
            $html .= '</div>';
            $html .= '<style>.mam-hs-'.$section.'-section-proto { display: none; }</style>';
        }

        $html .= '<div class="mam-hs-listing-table-section-proto">';
            $html .= $this->create_listing_table_section();
        $html .= '</div>';
        $html .= '<div class="mam-hs-tagged-nav-section-proto">';
            $html .= $this->create_tagged_nav_section();
        $html .= '</div>';
        $html .= '<div class="mam-hs-tag-cloud-section-proto">';
            $html .= $this->create_tag_cloud_section();
        $html .= '</div>';
        $html .= '<div class="mam-hs-special-offers-section-proto">';
            $html .= $this->create_special_offers_section();
        $html .= '</div>';
        $html .= '<div class="mam-hs-bottom-tabbar-section-proto">';
            $html .= $this->create_bottom_tabbar_section();
        $html .= '</div>';
        $html .= '<div class="mam-hs-geo-filters-section-proto">';
            $html .= $this->create_geo_filters_section();
        $html .= '</div>';
        $html .= '<div class="mam-hs-listing-search-section-proto">';
            $html .= $this->create_listing_search_section();
        $html .= '</div>';
        $html .= '<div class="mam-hs-collection-view-section-proto">';
            $html .= $this->create_collection_view_section();
        $html .= '</div>';
        $html .= '<div class="mam-hs-storefront-section-proto">';
            $html .= $this->create_storefront_section();
        $html .= '</div>';
        $html .= '<div class="mam-hs-image-section-proto">';
            $html .= $this->create_image_section();
        $html .= '</div>';
        $html .= '<div class="mam-hs-filter-bar-section-proto">';
            $html .= $this->create_filter_bar_section();
        $html .= '</div>';
        $html .= '<div class="mam-hs-map-section-proto">';
            $html .= $this->create_map_section();
        $html .= '</div>';
        $html .= '<div class="mam-hs-radius-selector-section-proto">';
            $html .= $this->create_radius_selector_section();
        $html .= '</div>';
        $html .= '<div class="mam-hs-date-time-filter-section-proto">';
            $html .= $this->create_date_time_filter_section();
        $html .= '</div>';

        return $html;

    }

    function create_filter_bar_section( $id = 'MAMLPSECTIONID' , $values = array() )
    {
        $type = 'no';
        if(array_key_exists('mam-hs-filter-bar-section-type', $values)){
            $type = $values['mam-hs-filter-bar-section-type'];
        }
        $html = '<table class="mam-hs-content-section">';
        $html .= '<tr>';
        $html .= '<td valign="top">';

            $html .= '<table class="mam-hs-content-section-child">';

            $html .= '<tr>';
            $html .= '<td colspan="2">';
            $html .= '<span style="font-weight: bold">Category Filter Bar</span>';
            $html .= '<input type="hidden" class="mam-hs-section-id" name="mam-hs-section-id[]" value="'.$id.'"/>';
            $html .= '<input type="hidden" class="mam-hs-section-type" name="mam-hs-section-type['.$id.']" value="filter_bar"/>';
            $html .= '</td>';
            $html .= '</tr>';

            $html .= '<tr>';
            $html .= '<td>';
            $html .= 'Use Chips for Filter Bar:';
            $html .= '</td>';
            $html .= '<td>';

            $options = array();
            $options[] = array( 'slug' => 'yes' , 'name' => 'Multiple Row' );
            $options[] = array( 'slug' => 'single' , 'name' => 'Single Row' );
            $options[] = array( 'slug' => 'no' , 'name' => 'No' );

            $html .= mam_admin_settings::make_dropdown( 'mam-hs-filter-bar-section-type['.$id.']' , $options , $type , null , 'mam-hs-filter-bar-section-type-dd' , true );

            $html .= '</td>';
            $html .= '</tr>';

            $html .= '<tr>';
            $html .= '<td>Background color</td>';
            $html .= '<td>';
            if( $values['mam-hs-filter-bar-section-bg-color'] != ""){
                if ( strpos( $values['mam-hs-filter-bar-section-bg-color'], ',' ) > 0 ) {
                    $values['mam-hs-filter-bar-section-bg-color'] = sprintf("#%02x%02x%02x", 13, 0, 255 );
                }
            }
            $html .= '<input type="color" name="mam-hs-filter-bar-section-bg-color['.$id.']" value="'.$values["mam-hs-filter-bar-section-bg-color"].'" />';
            $html .= '</td>';
            $html .= '</tr>';

            $html .= '</table>';

        $html .= '</td>';

        $html .= '<td valign="top" align="right">';

        global $tsl_local_app_image_url;

        $html .= '<img class="mam-hs-sort-arrow" src="'.$tsl_local_app_image_url.'images/arrow.png" style="width:25px;height:75px;">';
        $html .= '<br>';
        $html .= '<img class="mam-hs-item-delete" src="'.$tsl_local_app_image_url.'images/trashcan.png" style="width:25px;height:25px;">';

        $html .= '</td>';
        $html .= '</tr>';

        $html .= '</table>';

        return $html;

    }

    function create_map_section( $id = 'MAMLPSECTIONID' )
    {
        $html = '<table class="mam-hs-content-section">';
        $html .= '<tr>';
        $html .= '<td valign="top">';

            $html .= '<table class="mam-hs-content-section-child">';

            $html .= '<tr>';
            $html .= '<td colspan="2">';
            $html .= '<span style="font-weight: bold">Map Section</span>';
            $html .= '<input type="hidden" class="mam-hs-section-id" name="mam-hs-section-id[]" value="'.$id.'"/>';
            $html .= '<input type="hidden" class="mam-hs-section-type" name="mam-hs-section-type['.$id.']" value="map"/>';
            $html .= '</td>';
            $html .= '</tr>';

            $html .= '</table>';

        $html .= '</td>';

        $html .= '<td valign="top" align="right">';

        global $tsl_local_app_image_url;

        $html .= '<img class="mam-hs-sort-arrow" src="'.$tsl_local_app_image_url.'images/arrow.png" style="width:25px;height:75px;">';
        $html .= '<br>';
        $html .= '<img class="mam-hs-item-delete" src="'.$tsl_local_app_image_url.'images/trashcan.png" style="width:25px;height:25px;">';

        $html .= '</td>';
        $html .= '</tr>';

        $html .= '</table>';

        return $html;

    }

    function create_storefront_section( $id ='MAMLPSECTIONID' )
    {
        $html = '<table class="mam-hs-content-section">';
        $html .= '<tr>';
        $html .= '<td valign="top">';

            $html .= '<table class="mam-hs-content-section-child">';

            $html .= '<tr>';
            $html .= '<td colspan="2">';
            $html .= '<span style="font-weight: bold">Storefront Section</span>';
            $html .= '<input type="hidden" class="mam-hs-section-id" name="mam-hs-section-id[]" value="'.$id.'"/>';
            $html .= '<input type="hidden" class="mam-hs-section-type" name="mam-hs-section-type['.$id.']" value="storefront"/>';
            $html .= '</td>';
            $html .= '</tr>';

            $html .= '</table>';

        $html .= '</td>';

        $html .= '<td valign="top" align="right">';

        global $tsl_local_app_image_url;

        $html .= '<img class="mam-hs-sort-arrow" src="'.$tsl_local_app_image_url.'images/arrow.png" style="width:25px;height:75px;">';
        $html .= '<br>';
        $html .= '<img class="mam-hs-item-delete" src="'.$tsl_local_app_image_url.'images/trashcan.png" style="width:25px;height:25px;">';

        $html .= '</td>';
        $html .= '</tr>';

        $html .= '</table>';

        return $html;

    }

    function create_collection_view_section( $id ='MAMLPSECTIONID' )
    {
        $html = '<table class="mam-hs-content-section">';
        $html .= '<tr>';
        $html .= '<td valign="top">';

            $html .= '<table class="mam-hs-content-section-child">';

            $html .= '<tr>';
            $html .= '<td colspan="2">';
            $html .= '<span style="font-weight: bold">Collection View Section</span>';
            $html .= '<input type="hidden" class="mam-hs-section-id" name="mam-hs-section-id[]" value="'.$id.'"/>';
            $html .= '<input type="hidden" class="mam-hs-section-type" name="mam-hs-section-type['.$id.']" value="collection_view"/>';
            $html .= '</td>';
            $html .= '</tr>';

            $html .= '</table>';

        $html .= '</td>';

        $html .= '<td valign="top" align="right">';

        global $tsl_local_app_image_url;

        $html .= '<img class="mam-hs-sort-arrow" src="'.$tsl_local_app_image_url.'images/arrow.png" style="width:25px;height:75px;">';
        $html .= '<br>';
        $html .= '<img class="mam-hs-item-delete" src="'.$tsl_local_app_image_url.'images/trashcan.png" style="width:25px;height:25px;">';

        $html .= '</td>';
        $html .= '</tr>';

        $html .= '</table>';

        return $html;

    }

    function create_listing_table_section( $id = 'MAMLPSECTIONID' )
    {
        $html = '<table class="mam-hs-content-section">';
        $html .= '<tr>';
        $html .= '<td valign="top">';

            $html .= '<table class="mam-hs-content-section-child">';

            $html .= '<tr>';
            $html .= '<td colspan="2">';
            $html .= '<span style="font-weight: bold">Listing Table Section</span>';
            $html .= '<input type="hidden" class="mam-hs-section-id" name="mam-hs-section-id[]" value="'.$id.'"/>';
            $html .= '<input type="hidden" class="mam-hs-section-type" name="mam-hs-section-type['.$id.']" value="listing_table"/>';
            $html .= '</td>';
            $html .= '</tr>';

            $html .= '</table>';

        $html .= '</td>';

        $html .= '<td valign="top" align="right">';

        global $tsl_local_app_image_url;

        $html .= '<img class="mam-hs-sort-arrow" src="'.$tsl_local_app_image_url.'images/arrow.png" style="width:25px;height:75px;">';
        $html .= '<br>';
        $html .= '<img class="mam-hs-item-delete" src="'.$tsl_local_app_image_url.'images/trashcan.png" style="width:25px;height:25px;">';

        $html .= '</td>';
        $html .= '</tr>';

        $html .= '</table>';

        return $html;


    }

    function create_listing_search_section( $id = 'MAMLPSECTIONID' )
    {
        $html = '<table class="mam-hs-content-section">';
        $html .= '<tr>';
        $html .= '<td valign="top">';

            $html .= '<table class="mam-hs-content-section-child">';

            $html .= '<tr>';
            $html .= '<td colspan="2">';
            $html .= '<span style="font-weight: bold">Listing Search</span>';
            $html .= '<input type="hidden" class="mam-hs-section-id" name="mam-hs-section-id[]" value="'.$id.'"/>';
            $html .= '<input type="hidden" class="mam-hs-section-type" name="mam-hs-section-type['.$id.']" value="listing_search"/>';
            $html .= '</td>';
            $html .= '</tr>';

            $html .= '</table>';

        $html .= '</td>';

        $html .= '<td valign="top" align="right">';

        global $tsl_local_app_image_url;

        $html .= '<img class="mam-hs-sort-arrow" src="'.$tsl_local_app_image_url.'images/arrow.png" style="width:25px;height:75px;">';
        $html .= '<br>';
        $html .= '<img class="mam-hs-item-delete" src="'.$tsl_local_app_image_url.'images/trashcan.png" style="width:25px;height:25px;">';

        $html .= '</td>';
        $html .= '</tr>';

        $html .= '</table>';

        return $html;

    }

    function create_geo_filters_section( $id = 'MAMLPSECTIONID', $values = array() )
    {
        $html = '<table class="mam-hs-content-section">';
        $html .= '<tr>';
        $html .= '<td valign="top">';

            $html .= '<table class="mam-hs-content-section-child">';

            $html .= '<tr>';
            $html .= '<td colspan="2">';
            $html .= '<span style="font-weight: bold">GeoFilters Section</span>';
            $html .= '<input type="hidden" class="mam-hs-section-id" name="mam-hs-section-id[]" value="'.$id.'"/>';
            $html .= '<input type="hidden" class="mam-hs-section-type" name="mam-hs-section-type['.$id.']" value="geo_filters"/>';
            $html .= '</td>';
            $html .= '</tr>';

            $html .= '<tr>';
            $html .= '<td>Display as Label</td>';
            $html .= '<td>';
            $display_as_label = (array_key_exists('mam-hs-geo-filters-section-display-label', $values)) ? $values['mam-hs-geo-filters-section-display-label'] : '';
            $options = array();
            $options[] = array( 'slug' => 'yes' , 'name' => 'Yes' );
            $options[] = array( 'slug' => 'no' , 'name' => 'No' );

            $html .= mam_admin_settings::make_dropdown( 'mam-hs-geo-filters-section-display-label['.$id.']' , $options , $display_as_label , null , 'mam-hs-geo-filters-section-display-height-dd' , true );

            $html .= '</td>';
            $html .= '</tr>';

            $html .= '<tr>';
            $html .= '<td>Pin to  Top</td>';
            $html .= '<td>';
            $selected = (array_key_exists('mam-hs-geo-filters-section-pin-to-top', $values)) ? 'checked="checked"' : '';
            $html .= '<input type="checkbox" name="mam-hs-geo-filters-section-pin-to-top['.$id.']" '.$selected.' value="yes">';
            $html .= '</td>';
            $html .= '</tr>';

            $html .= '<tr>';
            $html .= '<td>Label color</td>';
            $html .= '<td>';
            if( $values['mam-hs-geo-filters-section-label-color'] != ""){
                if ( strpos( $values['mam-hs-geo-filters-section-label-color'], ',' ) > 0 ) {
                    $values['mam-hs-geo-filters-section-label-color'] = sprintf("#%02x%02x%02x", 13, 0, 255 );
                }
            }
            $html .= '<input type="color" name="mam-hs-geo-filters-section-label-color['.$id.']" value="'.$values["mam-hs-geo-filters-section-label-color"].'" />';
            $html .= '</td>';
            $html .= '</tr>';

            $html .= '<tr>';
            $html .= '<td>Nearby Prefix</td>';
            $html .= '<td>';
            $html .= '<input type="text" name="mam-hs-geo-filters-section-nearby-prefix['.$id.']" value="'.$values["mam-hs-geo-filters-section-nearby-prefix"].'">';
            $html .= '</td>';
            $html .= '</tr>';


            $html .= '<tr>';
            $html .= '<td>Prefix</td>';
            $html .= '<td>';
            $html .= '<input type="text" name="mam-hs-geo-filters-section-prefix['.$id.']" value="'.$values['mam-hs-geo-filters-section-prefix'].'">';
            $html .= '</td>';
            $html .= '</tr>';

            $html .= '</table>';

        $html .= '</td>';

        $html .= '<td valign="top" align="right">';

        global $tsl_local_app_image_url;

        $html .= '<img class="mam-hs-sort-arrow" src="'.$tsl_local_app_image_url.'images/arrow.png" style="width:25px;height:75px;">';
        $html .= '<br>';
        $html .= '<img class="mam-hs-item-delete" src="'.$tsl_local_app_image_url.'images/trashcan.png" style="width:25px;height:25px;">';

        $html .= '</td>';
        $html .= '</tr>';

        $html .= '</table>';

        return $html;

    }

    function create_bottom_tabbar_section( $id = 'MAMLPSECTIONID' )
    {
        $html = '<table class="mam-hs-content-section">';
        $html .= '<tr>';
        $html .= '<td valign="top">';

            $html .= '<table class="mam-hs-content-section-child">';

            $html .= '<tr>';
            $html .= '<td colspan="2">';
            $html .= '<span style="font-weight: bold">Bottom Tabbar Section</span>';
            $html .= '<input type="hidden" class="mam-hs-section-id" name="mam-hs-section-id[]" value="'.$id.'"/>';
            $html .= '<input type="hidden" class="mam-hs-section-type" name="mam-hs-section-type['.$id.']" value="bottom_tabbar"/>';
            $html .= '</td>';
            $html .= '</tr>';

            $html .= '</table>';

        $html .= '</td>';

        $html .= '<td valign="top" align="right">';

        global $tsl_local_app_image_url;

        $html .= '<img class="mam-hs-sort-arrow" src="'.$tsl_local_app_image_url.'images/arrow.png" style="width:25px;height:75px;">';
        $html .= '<br>';
        $html .= '<img class="mam-hs-item-delete" src="'.$tsl_local_app_image_url.'images/trashcan.png" style="width:25px;height:25px;">';

        $html .= '</td>';
        $html .= '</tr>';

        $html .= '</table>';

        return $html;

    }

    function create_tag_cloud_section( $id = 'MAMLPSECTIONID' )
    {
        $html = '<table class="mam-hs-content-section">';
        $html .= '<tr>';
        $html .= '<td valign="top">';

            $html .= '<table class="mam-hs-content-section-child">';

            $html .= '<tr>';
            $html .= '<td colspan="2">';
            $html .= '<span style="font-weight: bold">Tag Cloud Section</span>';
            $html .= '<input type="hidden" class="mam-hs-section-id" name="mam-hs-section-id[]" value="'.$id.'"/>';
            $html .= '<input type="hidden" class="mam-hs-section-type" name="mam-hs-section-type['.$id.']" value="tag_cloud"/>';
            $html .= '</td>';
            $html .= '</tr>';

            $html .= '</table>';

        $html .= '</td>';

        $html .= '<td valign="top" align="right">';

        global $tsl_local_app_image_url;

        $html .= '<img class="mam-hs-sort-arrow" src="'.$tsl_local_app_image_url.'images/arrow.png" style="width:25px;height:75px;">';
        $html .= '<br>';
        $html .= '<img class="mam-hs-item-delete" src="'.$tsl_local_app_image_url.'images/trashcan.png" style="width:25px;height:25px;">';

        $html .= '</td>';
        $html .= '</tr>';

        $html .= '</table>';

        return $html;

    }

    function create_tagged_nav_section( $id = 'MAMLPSECTIONID' )
    {
        $html = '<table class="mam-hs-content-section">';
        $html .= '<tr>';
        $html .= '<td valign="top">';

            $html .= '<table class="mam-hs-content-section-child">';

            $html .= '<tr>';
            $html .= '<td colspan="2">';
            $html .= '<span style="font-weight: bold">Tagged Navigation Section</span>';
            $html .= '<input type="hidden" class="mam-hs-section-id" name="mam-hs-section-id[]" value="'.$id.'"/>';
            $html .= '<input type="hidden" class="mam-hs-section-type" name="mam-hs-section-type['.$id.']" value="tagged_nav"/>';
            $html .= '</td>';
            $html .= '</tr>';

            $html .= '</table>';

        $html .= '</td>';

        $html .= '<td valign="top" align="right">';

        global $tsl_local_app_image_url;

        $html .= '<img class="mam-hs-sort-arrow" src="'.$tsl_local_app_image_url.'images/arrow.png" style="width:25px;height:75px;">';
        $html .= '<br>';
        $html .= '<img class="mam-hs-item-delete" src="'.$tsl_local_app_image_url.'images/trashcan.png" style="width:25px;height:25px;">';

        $html .= '</td>';
        $html .= '</tr>';

        $html .= '</table>';

        return $html;

    }

    function create_special_offers_section( $id = 'MAMLPSECTIONID' )
    {
        $html = '<table class="mam-hs-content-section">';
        $html .= '<tr>';
        $html .= '<td valign="top">';

            $html .= '<table class="mam-hs-content-section-child">';

            $html .= '<tr>';
            $html .= '<td colspan="2">';
            $html .= '<span style="font-weight: bold">Special Offers Section</span>';
            $html .= '<input type="hidden" class="mam-hs-section-id" name="mam-hs-section-id[]" value="'.$id.'"/>';
            $html .= '<input type="hidden" class="mam-hs-section-type" name="mam-hs-section-type['.$id.']" value="special_offers"/>';
            $html .= '</td>';
            $html .= '</tr>';

            $html .= '</table>';

        $html .= '</td>';

        $html .= '<td valign="top" align="right">';

        global $tsl_local_app_image_url;

        $html .= '<img class="mam-hs-sort-arrow" src="'.$tsl_local_app_image_url.'images/arrow.png" style="width:25px;height:75px;">';
        $html .= '<br>';
        $html .= '<img class="mam-hs-item-delete" src="'.$tsl_local_app_image_url.'images/trashcan.png" style="width:25px;height:25px;">';

        $html .= '</td>';
        $html .= '</tr>';

        $html .= '</table>';

        return $html;

    }

    function create_spacer_section( $id = 'MAMLPSECTIONID' , $slide_id = 'MAMLPSLIDEID', $height = 'size_50' , $height_type = 'pixels' )
    {
        $html = '<table class="mam-hs-content-section">';

        $html .= '<tr>';
        $html .= '<td valign="top">';

            $html .= '<table class="mam-hs-content-section-child">';

            $html .= '<tr>';
            $html .= '<td colspan="2">';
            $html .= '<span style="font-weight: bold">Spacer Section</span>';
            $html .= '<input type="hidden" class="mam-hs-section-id" name="mam-hs-section-id['.$slide_id.'][]" value="'.$id.'"/>';
            $html .= '<input type="hidden" class="mam-hs-section-type" name="mam-hs-section-type['.$id.']" value="spacer"/>';
            $html .= '</td>';
            $html .= '</tr>';

            $html .= '<tr>';
            $html .= '<td>';
            $html .= 'Section Height Type:';
            $html .= '</td>';
            $html .= '<td>';

            $options = array();
            $options[] = array( 'slug' => 'pixels' , 'name' => 'Pixels' );
            $options[] = array( 'slug' => 'percent' , 'name' => 'Percent of Screen Height' );

            $html .= mam_admin_settings::make_dropdown( 'mam-hs-spacer-section-height-type['.$id.']' , $options , $height_type , null , 'mam-hs-spacer-section-height-type-dd' , true );

            $html .= '</td>';
            $html .= '</tr>';

            $html .= '<tr>';
            $html .= '<td>';
            $html .= 'Section Height:';
            $html .= '</td>';
            $html .= '<td>';

            $options = array();

            for($x=1;$x<100;$x++){
                $options[] = array( 'slug' => 'size_' . $x , 'name' => $x );
            }
            $html .= '&nbsp;'. mam_admin_settings::make_dropdown( 'mam-hs-spacer-section-height['.$id.']' , $options , $height , null , 'mam-hs-spacer-section-height-dd' , true );

            $html .= '</td>';
            $html .= '</tr>';


            $html .= '</table>';

        $html .= '</td>';
        $html .= '<td valign="top" align="right">';

        global $tsl_local_app_image_url;

        $html .= '<img class="mam-hs-sort-arrow" src="'.$tsl_local_app_image_url.'images/arrow.png" style="width:25px;height:75px;">';
        $html .= '<br>';
        $html .= '<img class="mam-hs-item-delete" src="'.$tsl_local_app_image_url.'images/trashcan.png" style="width:25px;height:25px;">';

        $html .= '</td>';
        $html .= '</tr>';
        $html .= '</table>';

        return $html;

    }

    function create_text_section( $id = 'MAMLPSECTIONID' , $text = '', $justification = 'left', $style = 'normal' , $size = 'size_12' , $color = '#000000' )
    {

        $html = '<table class="mam-hs-content-section">';

        $html .= '<tr>';
        $html .= '<td valign="top">';

            $html .= '<table class="mam-hs-content-section-child">';

            $html .= '<tr>';
            $html .= '<td colspan="2">';
            $html .= '<span style="font-weight: bold">Label Section</span>';
            $html .= '<input type="hidden" class="mam-hs-section-id" name="mam-hs-section-id[]" value="'.$id.'"/>';
            $html .= '<input type="hidden" class="mam-hs-section-type" name="mam-hs-section-type['.$id.']" value="text"/>';
            $html .= '</td>';
            $html .= '</tr>';

            $html .= '<tr>';
            $html .= '<td colspan="2">';
            $html .= '<input type="text" name="mam-hs-text-section-value['.$id.']" style="width:100%" value="'.$text.'">';
            $html .= '</td>';
            $html .= '</tr>';

            $html .= '<tr>';
            $html .= '<td>';
            $html .= 'Section Justification:';
            $html .= '</td>';
            $html .= '<td>';

            $options = array();
            $options[] = array( 'slug' => 'left' , 'name' => 'Left' );
            $options[] = array( 'slug' => 'center' , 'name' => 'Center' );
            $options[] = array( 'slug' => 'right' , 'name' => 'Right' );

            $html .= mam_admin_settings::make_dropdown( 'mam-hs-text-section-justification['.$id.']' , $options , $justification , null , 'mam-hs-section-justification-dd' , true );

            $html .= '</td>';
            $html .= '</tr>';

            $html .= '<tr>';
            $html .= '<td>';
            $html .= 'Section Font Style:';
            $html .= '</td>';
            $html .= '<td>';

            $options = array();
            $options[] = array( 'slug' => 'normal' , 'name' => 'Normal' );
            $options[] = array( 'slug' => 'bold' , 'name' => 'Bold' );
            $options[] = array( 'slug' => 'italics' , 'name' => 'Italics' );

            $html .= mam_admin_settings::make_dropdown( 'mam-hs-text-section-font-style['.$id.']' , $options , $style , null , 'mam-hs-section-justification-dd' , true );
            $html .= '&nbsp;<input class="mam-color-picker" type="color" name="mam-hs-text-section-font-color['.$id.']" value="'.$color.'"/>';
            $options = array();

            for($x=10;$x<40;$x++){
                $options[] = array( 'slug' => 'size_' . $x , 'name' => $x . ' points' );
            }
            $html .= '&nbsp;'. mam_admin_settings::make_dropdown( 'mam-hs-text-section-font-size['.$id.']' , $options , $size , null , 'mam-hs-section-font-size-dd' , true );

            $html .= '</td>';
            $html .= '</tr>';

            $html .= '</table>';

        $html .= '</td>';
        $html .= '<td valign="top" align="right">';

        global $tsl_local_app_image_url;

        $html .= '<img class="mam-hs-sort-arrow" src="'.$tsl_local_app_image_url.'images/arrow.png" style="width:25px;height:75px;">';
        $html .= '<br>';
        $html .= '<img class="mam-hs-item-delete" src="'.$tsl_local_app_image_url.'images/trashcan.png" style="width:25px;height:25px;">';

        $html .= '</td>';
        $html .= '</tr>';
        $html .= '</table>';

        return $html;

    }

    function create_image_section( $id = 'MAMLPSECTIONID' , $image_url = '', $width = 'width_100', $justification = 'left' , $image_id = 0 )
    {

        $html = '<table class="mam-hs-content-section">';
        $html .= '<tr>';
        $html .= '<td valign="top">';

        $html .= '<table class="mam-hs-content-section-child">';

            $html .= '<tr>';
            $html .= '<td colspan="2">';
            $html .= '<span style="font-weight: bold">Image Section</span>';
            $html .= '<input type="hidden" class="mam-hs-section-id" name="mam-hs-section-id[]" value="'.$id.'"/>';
            $html .= '<input type="hidden" class="mam-hs-section-type" name="mam-hs-section-type['.$id.']" value="image"/>';
            $html .= '</td>';
            $html .= '</tr>';

            $html .= '<tr>';
            $html .= '<td>';
            $html .= 'Image Width:';
            $html .= '</td>';
            $html .= '<td>';

            $options = array();

            for($x=10;$x<110;$x = $x + 10){
                $options[] = array( 'slug' => 'width_' . $x , 'name' => $x . ' %' );
            }
            $html .= '&nbsp;'. mam_admin_settings::make_dropdown( 'mam-hs-image-section-image-width['.$id.']' , $options , $width , null , 'mam-hs-section-image-width-dd' , true );

            $html .= '</td>';
            $html .= '</tr>';

            $html .= '<tr>';
            $html .= '<td>';
            $html .= 'Image Justification:';
            $html .= '</td>';
            $html .= '<td>';

            $options = array();
            $options[] = array( 'slug' => 'left' , 'name' => 'Left' );
            $options[] = array( 'slug' => 'center' , 'name' => 'Center' );
            $options[] = array( 'slug' => 'right' , 'name' => 'Right' );

            $html .= mam_admin_settings::make_dropdown( 'mam-hs-image-section-justification['.$id.']' , $options , $justification , null , 'mam-hs-section-justification-dd' , true );

            $html .= '</td>';
            $html .= '</tr>';

            $html .= '<tr>';
            $html .= '<td colspan="2">';
            $html .= '<p>The entire image will be displayed and the aspect ratio will be correct on the app.</p>';
            $html .= '</td>';
            $html .= '</tr>';

            $html .= '</table>';

        $html .= '</td>';
        $html .= '<td style="width:25%;height:100%" align="right" valign="top">';

        $image = '&nbsp;';
        if( strlen($image_url ) > 1 ){
            $image = '<img src="'.$image_url.'" style="width:100px;">';
        }

        $html .= '<div class="mam-hs-section-image">'.$image.'</div>';
        $html .= '<input type="hidden" class="mam-hs-image" id="mam-hs-image['.$id.']" name="mam-hs-image['.$id.']" value="'.trim($image_url).'"/>';
        $html .= '<input type="hidden" class="mam-hs-image-id" id="mam-hs-image-id['.$id.']" name="mam-hs-image-id['.$id.']" value="'.trim($image_id).'"/>';

        $html .= '</td>';
        $html .= '<td valign="top" align="right">';

        global $tsl_local_app_image_url;

        $html .= '<img class="mam-hs-sort-arrow" src="'.$tsl_local_app_image_url.'images/arrow.png" style="width:25px;height:75px;">';
        $html .= '<br>';
        $html .= '<img class="mam-hs-item-delete" src="'.$tsl_local_app_image_url.'images/trashcan.png" style="width:25px;height:25px;">';

        $html .= '</td>';
        $html .= '</tr>';

        $html .= '</table>';

        return $html;
    }



    function create_config_via_filter_section( $id = 'MAMLPSECTIONID' , $var = '' , $name = '')
    {
        if( ! $id )
        {
            $id = 'MAMLPSECTIONID';
        }
        $html = '<table class="mam-hs-content-section hide">';
        $html .= '<tr>';
        $html .= '<td valign="top">';

            $html .= '<table class="mam-hs-content-section-child">';

            $html .= '<tr>';
            $html .= '<td colspan="2">';
            $html .= '<span style="font-weight: bold">'.$name.' Section</span>';
            $html .= '<input type="hidden" class="mam-hs-section-id" name="mam-hs-section-id[]" value="'.$id.'"/>';
            $html .= '<input type="hidden" class="mam-hs-section-type" name="mam-hs-section-type['.$id.']" value="'.$var.'"/>';
            $html .= '</td>';
            $html .= '</tr>';

            $html .= '<tr>';
            $html .= '<td>';
            $html .= 'Settings:';
            $html .= '</td>';
            $html .= '<td>';
            $html .= 'Configure via Filter';
            $html .= '</td>';
            $html .= '</tr>';

            $html .= '</table>';

        $html .= '</td>';

        $html .= '<td valign="top" align="right">';

        global $tsl_local_app_image_url;

        $html .= '<img class="mam-hs-sort-arrow" src="'.$tsl_local_app_image_url.'images/arrow.png" style="width:25px;height:75px;">';
        $html .= '<br>';
        $html .= '<img class="mam-hs-item-delete" src="'.$tsl_local_app_image_url.'images/trashcan.png" style="width:25px;height:25px;">';

        $html .= '</td>';
        $html .= '</tr>';

        $html .= '</table>';

        return $html;

    }

    function create_graph_section( $id = 'MAMLPSECTIONID'  )
    {

        $html = '<table class="mam-hs-content-section">';
        $html .= '<tr>';
        $html .= '<td valign="top">';

            $html .= '<table class="mam-hs-content-section-child">';
            $html .= '<tr>';
            $html .= '<td colspan="2">';
            $html .= '<span style="font-weight: bold">Graph Section</span>';
            $html .= '<input type="hidden" class="mam-hs-section-id" name="mam-hs-section-id['.$id.'][]" value="'.$id.'"/>';
            $html .= '<input type="hidden" class="mam-hs-section-type" name="mam-hs-section-type['.$id.']" value="graph"/>';
            $html .= '</td>';
            $html .= '</tr>';

            $html .= '<tr>';
            $html .= '<td>';
            $html .= 'Settings:';
            $html .= '</td>';
            $html .= '<td>';
            $html .= 'Configure via Filter';
            $html .= '</td>';
            $html .= '</tr>';

            $html .= '</table>';

        $html .= '</td>';

        $html .= '<td valign="top" align="right">';

        global $tsl_local_app_image_url;

        $html .= '<img class="mam-hs-sort-arrow" src="'.$tsl_local_app_image_url.'images/arrow.png" style="width:25px;height:75px;">';
        $html .= '<br>';
        $html .= '<img class="mam-hs-item-delete" src="'.$tsl_local_app_image_url.'images/trashcan.png" style="width:25px;height:25px;">';

        $html .= '</td>';
        $html .= '</tr>';

        $html .= '</table>';

        return $html;
    }

    function create_single_listing_section( $id = 'MAMLPSECTIONID'  )
    {

        $html = '<table class="mam-hs-content-section">';
        $html .= '<tr>';
        $html .= '<td valign="top">';

            $html .= '<table class="mam-hs-content-section-child">';
            $html .= '<tr>';
            $html .= '<td colspan="2">';
            $html .= '<span style="font-weight: bold">Single Listing Section</span>';
            $html .= '<input type="hidden" class="mam-hs-section-id" name="mam-hs-section-id['.$id.'][]" value="'.$id.'"/>';
            $html .= '<input type="hidden" class="mam-hs-section-type" name="mam-hs-section-type['.$id.']" value="single_listing"/>';
            $html .= '</td>';
            $html .= '</tr>';

            $html .= '<tr>';
            $html .= '<td>';
            $html .= 'Settings:';
            $html .= '</td>';
            $html .= '<td>';
            $html .= 'Configure via Filter';
            $html .= '</td>';
            $html .= '</tr>';

            $html .= '</table>';

        $html .= '</td>';

        $html .= '<td valign="top" align="right">';

        global $tsl_local_app_image_url;

        $html .= '<img class="mam-hs-sort-arrow" src="'.$tsl_local_app_image_url.'images/arrow.png" style="width:25px;height:75px;">';
        $html .= '<br>';
        $html .= '<img class="mam-hs-item-delete" src="'.$tsl_local_app_image_url.'images/trashcan.png" style="width:25px;height:25px;">';

        $html .= '</td>';
        $html .= '</tr>';

        $html .= '</table>';

        return $html;
    }

    function create_radius_selector_section( $id = 'MAMLPSECTIONID', $values = array() ){

        global $tsl_local_app_image_url;

        $html = '<table class="mam-hs-content-section">';
        $html .= '<tr>';
        $html .= '<td valign="top">';

        $html .= '<table class="mam-hs-content-section-child">';

        $html .= '<tr>';
        $html .= '<td colspan="2">';
        $html .= '<span style="font-weight: bold">Radius Selector Section</span>';
        $html .= '<input type="hidden" class="mam-hs-section-id" name="mam-hs-section-id[]" value="'.$id.'"/>';
        $html .= '<input type="hidden" class="mam-hs-section-type" name="mam-hs-section-type['.$id.']" value="radius_selector"/>';
        $html .= '</td>';
        $html .= '</tr>';

        $html .= '<tr>';
        $html .= '<td>Default</td>';
        $html .= '<td>';
        if( !isset($values["default"])) $values["default"] = 30;
        $html .= '<input type="text" name="mam-hs-radius-selector-section-default['.$id.']" value="'.$values["default"].'">';
        $html .= '</td>';
        $html .= '</tr>';

        $html .= '<tr>';
        $html .= '<td>Filter Values</td>';
        $html .= '<td>';
        $html .= '<div class="radius-selector-values-container">';
        $html .= '<div class="radius-selector-action"><input type="button" value="Add New" class="button button-primary button-medium mam-hs-add-radius-selector-values"></div>';
        $html .= '<div class="radius-selector-values-list">';
        $html .= '<table class="tsl-admin-pref-table">';
        $html .= '<thead><tr><th>Label</th><th>Value</th><th>&nbsp;</th></tr></thead>';
        $html .= '<tbody>';
        $values_array = (array_key_exists("values", $values) && is_array($values["values"])) ? $values["values"] : array();
        if(!empty($values_array)){
            foreach ($values_array['label'] as $value_index=>$label){
                if($label != "" && $values_array['value'][$value_index] != "") {
                    $html .= '<tr><td><input type="text" name="mam-hs-radius-selector-section-values[' . $id . '][label][]" value="'.$label.'"></td><td><input type="text" name="mam-hs-radius-selector-section-values[' . $id . '][value][]" value="'.$values_array['value'][$value_index].'"></td><td><img class="mam-hs-radius-values-item-delete" src="' . $tsl_local_app_image_url . 'images/trashcan.png" style="width:20px;height:20px;"></td></tr>';
                }
            }
        }else {
            $html .= '<tr><td><input type="text" name="mam-hs-radius-selector-section-values[' . $id . '][label][]" value=""></td><td><input type="text" name="mam-hs-radius-selector-section-values[' . $id . '][value][]" value=""></td><td><img class="mam-hs-radius-values-item-delete" src="' . $tsl_local_app_image_url . 'images/trashcan.png" style="width:20px;height:20px;"></td></tr>';
        }
        $html .= '</tbody>';
        $html .= '</table>';
        $html .= '</div>';
        $html .= '</div>';
        $html .= '</td>';
        $html .= '</tr>';

        $html .= '</table>';

        $html .= '</td>';

        $html .= '<td valign="top" align="right">';

        $html .= '<img class="mam-hs-sort-arrow" src="'.$tsl_local_app_image_url.'images/arrow.png" style="width:25px;height:75px;">';
        $html .= '<br>';
        $html .= '<img class="mam-hs-item-delete" src="'.$tsl_local_app_image_url.'images/trashcan.png" style="width:25px;height:25px;">';

        $html .= '</td>';
        $html .= '</tr>';

        $html .= '</table>';
        return $html;
    }

    function create_date_time_filter_section( $id = 'MAMLPSECTIONID', $values = array() )
    {

        $html = '<table class="mam-hs-content-section">';
        $html .= '<tr>';
        $html .= '<td valign="top">';

        $html .= '<table class="mam-hs-content-section-child">';

        $html .= '<tr>';
        $html .= '<td colspan="2">';
        $html .= '<span style="font-weight: bold">Date Time Filter Section</span>';
        $html .= '<input type="hidden" class="mam-hs-section-id" name="mam-hs-section-id[]" value="' . $id . '"/>';
        $html .= '<input type="hidden" class="mam-hs-section-type" name="mam-hs-section-type[' . $id . ']" value="date_time_filter"/>';
        $html .= '</td>';
        $html .= '</tr>';

        $html .= '<tr>';
        $html .= '<td>Days</td>';
        $html .= '<td>';
        $options = array();
        for ($i = 1; $i <= 31; $i++){
            $options[] = array('slug' => $i, 'name' => $i);
        }
        if( ! isset($values['days'])) $values['days'] = 14;

        $html .= mam_admin_settings::make_dropdown( 'mam-hs-date-time-filter-section-days['.$id.']' , $options , $values['days'] , null , 'mam-hs-date-time-filter-section-days-dd' , true );

        $html .= '</td>';
        $html .= '</tr>';

        $html .= '<tr>';
        $html .= '<td>Show Start Date</td>';
        $html .= '<td>';
        $options = array();
        $options[] = array('slug' => 'yes', 'name' => 'Yes');
        $options[] = array('slug' => 'no', 'name' => 'No');
        if( ! isset($values['show_date_start'])) $values['show_date_start'] = 'no';

        $html .= mam_admin_settings::make_dropdown( 'mam-hs-date-time-filter-section-show-start-date['.$id.']' , $options , $values['show_date_start'] , null , 'mam-hs-date-time-filter-section-show-start-date-dd' , true );

        $html .= '</td>';
        $html .= '</tr>';

        $html .= '<tr>';
        $html .= '<td>Use Explicit Days</td>';
        $html .= '<td>';
        $options = array();
        $options[] = array('slug' => 'yes', 'name' => 'Yes');
        $options[] = array('slug' => 'no', 'name' => 'No');
        if( ! isset($values['use_explicit_days'])) $values['use_explicit_days'] = 'no';

        $html .= mam_admin_settings::make_dropdown( 'mam-hs-date-time-filter-section-use-explicit-days['.$id.']' , $options , $values['use_explicit_days'] , null , 'mam-hs-date-time-filter-section-use-explicit-days-dd' , true );

        $html .= '</td>';
        $html .= '</tr>';

        $html .= '<tr>';
        $html .= '<td>Categories</td>';
        $html .= '<td>';
        $options = array();

        $home_cats = apply_filters( 'mam_app_settings_get_home_screen_categories', array() , $_REQUEST['role'] );
        if(sizeof($home_cats) > 0){
            foreach ($home_cats as $cat){
                $options[] = array('slug' => $cat['term'], 'name' => $cat['term']);
            }
        }

        $html .= '<select name="mam-hs-date-time-filter-section-show-cats['.$id.'][]" class="mam-hs-date-time-filter-section-show-cats-dd" multiple>';
        $html .= '<option value="">Select Category</option>';
        if(!empty($options)){
            if( !isset($values['show_cats']) ) $values['show_cats'] = array();
            $values['show_cats'] = (is_array($values['show_cats'])) ? $values['show_cats'] : array();
            foreach ($options as $option){
                $selected = (in_array($option['slug'], $values['show_cats'])) ? 'selected="selected"' : '';
                $html .= '<option value="'.$option['slug'].'" '.$selected.'>'.$option['name'].'</option>';
            }
        }
        $html .= '</select>';

        $html .= '</td>';
        $html .= '</tr>';

        $html .= '</table>';

        $html .= '</td>';

        $html .= '<td valign="top" align="right">';

        global $tsl_local_app_image_url;
        $html .= '<img class="mam-hs-sort-arrow" src="'.$tsl_local_app_image_url.'images/arrow.png" style="width:25px;height:75px;">';
        $html .= '<br>';
        $html .= '<img class="mam-hs-item-delete" src="'.$tsl_local_app_image_url.'images/trashcan.png" style="width:25px;height:25px;">';

        $html .= '</td>';
        $html .= '</tr>';

        $html .= '</table>';
        return $html;
    }

    function save_home_screen_stack()
    {

        if ( !current_user_can( 'manage_options' ) ) return false;

        if( ! isset( $_REQUEST['mam-hs-section-id'] )) return false;

        $reload = false;

        $slideArray = array();

//        $slideArray['mam-hs-background-image'] = $_REQUEST['mam-hs-background-image'];

        foreach( $_REQUEST['mam-hs-section-id'] as $section ){

            if( is_array( $section ) ) $section = $section[0];

            if( $section == 'MAMLPSECTIONID' ) continue;

            $slideArray['section'][$section]['mam-hs-section-type'] = $_REQUEST['mam-hs-section-type'][$section];

            //text section
            if( isset( $_REQUEST['mam-hs-text-section-justification'][$section] )) {
                $slideArray['section'][$section]['mam-hs-text-section-justification'] = $_REQUEST['mam-hs-text-section-justification'][$section];
            }
            if( isset( $_REQUEST['mam-hs-text-section-font-style'][$section] )) {
                $slideArray['section'][$section]['mam-hs-text-section-font-style'] = $_REQUEST['mam-hs-text-section-font-style'][$section];
            }
            if( isset( $_REQUEST['mam-hs-text-section-font-size'][$section] )) {
                $slideArray['section'][$section]['mam-hs-text-section-font-size'] = $_REQUEST['mam-hs-text-section-font-size'][$section];
            }
            if( isset( $_REQUEST['mam-hs-text-section-font-color'][$section] )) {
                $slideArray['section'][$section]['mam-hs-text-section-font-color'] = $_REQUEST['mam-hs-text-section-font-color'][$section];
            }
            if( isset( $_REQUEST['mam-hs-text-section-value'][$section] )) {
                $slideArray['section'][$section]['mam-hs-text-section-value'] = $_REQUEST['mam-hs-text-section-value'][$section];
            }
            if( isset( $_REQUEST['mam-hs-service-checker-section-value'][$section] )) {
                $slideArray['section'][$section]['mam-hs-service-checker-section-value'] = $_REQUEST['mam-hs-service-checker-section-value'][$section];
            }
            if( isset( $_REQUEST['mam-hs-spacer-section-value'][$section] )) {
                $slideArray['section'][$section]['mam-hs-spacer-section-value'] = $_REQUEST['mam-hs-spacer-section-value'][$section];
            }
            if( isset( $_REQUEST['mam-hs-filter-bar-section-value'][$section] )) {
                $slideArray['section'][$section]['mam-hs-filter-bar-section-value'] = $_REQUEST['mam-hs-filter-bar-section-value'][$section];
            }
            if( isset( $_REQUEST['mam-hs-bottom-tabbar-section-value'][$section] )) {
                $slideArray['section'][$section]['mam-hs-bottom-tabbar-section-value'] = $_REQUEST['mam-hs-bottom-tabbar-section-value'][$section];
            }
            if( isset( $_REQUEST['mam-hs-geo-filters-section-value'][$section] )) {
                $slideArray['section'][$section]['mam-hs-geo-filters-section-value'] = $_REQUEST['mam-hs-geo-filters-section-value'][$section];
            }
            if( isset( $_REQUEST['mam-hs-geo-filters-section-display-label'][$section] )) {
                $slideArray['section'][$section]['mam-hs-geo-filters-section-display-label'] = $_REQUEST['mam-hs-geo-filters-section-display-label'][$section];
            }
            if( isset( $_REQUEST['mam-hs-geo-filters-section-pin-to-top'][$section] )) {
                $slideArray['section'][$section]['mam-hs-geo-filters-section-pin-to-top'] = $_REQUEST['mam-hs-geo-filters-section-pin-to-top'][$section];
            }
            if( isset( $_REQUEST['mam-hs-geo-filters-section-label-color'][$section] )) {
                $slideArray['section'][$section]['mam-hs-geo-filters-section-label-color'] = $_REQUEST['mam-hs-geo-filters-section-label-color'][$section];
            }
            if( isset( $_REQUEST['mam-hs-geo-filters-section-nearby-prefix'][$section] )) {
                $slideArray['section'][$section]['mam-hs-geo-filters-section-nearby-prefix'] = $_REQUEST['mam-hs-geo-filters-section-nearby-prefix'][$section];
            }
            if( isset( $_REQUEST['mam-hs-geo-filters-section-prefix'][$section] )) {
                $slideArray['section'][$section]['mam-hs-geo-filters-section-prefix'] = $_REQUEST['mam-hs-geo-filters-section-prefix'][$section];
            }
            if( isset( $_REQUEST['mam-hs-listing-search-section-value'][$section] )) {
                $slideArray['section'][$section]['mam-hs-listing-search-section-value'] = $_REQUEST['mam-hs-listing-search-section-value'][$section];
            }
            if( isset( $_REQUEST['mam-hs-special-offers-section-value'][$section] )) {
                $slideArray['section'][$section]['mam-hs-special-offers-section-value'] = $_REQUEST['mam-hs-special-offers-section-value'][$section];
            }

            //next button section
            if( isset( $_REQUEST['mam-hs-next-button-section-button-color'][$section] )) {
                $slideArray['section'][$section]['mam-hs-next-button-section-button-color'] = $_REQUEST['mam-hs-next-button-section-button-color'][$section];
            }
            if( isset( $_REQUEST['mam-hs-next-button-section-button-text-color'][$section] )) {
                $slideArray['section'][$section]['mam-hs-next-button-section-button-text-color'] = $_REQUEST['mam-hs-next-button-section-button-text-color'][$section];
            }
            if( isset( $_REQUEST['mam-hs-next-button-section-button-text'][$section] )) {
                $slideArray['section'][$section]['mam-hs-next-button-section-button-text'] = $_REQUEST['mam-hs-next-button-section-button-text'][$section];
            }


            //image section
            if( isset( $_REQUEST['mam-hs-image-section-justification'][$section] )) {
                $slideArray['section'][$section]['mam-hs-image-section-justification'] = $_REQUEST['mam-hs-image-section-justification'][$section];
            }
            if( isset( $_REQUEST['mam-hs-image-section-image-width'][$section] )) {
                $slideArray['section'][$section]['mam-hs-image-section-image-width'] = $_REQUEST['mam-hs-image-section-image-width'][$section];
            }
            if( isset( $_REQUEST['mam-hs-image'][$section] )) {
                $slideArray['section'][$section]['mam-hs-image'] = $_REQUEST['mam-hs-image'][$section];
            }
            if( isset( $_REQUEST['mam-hs-image-id'][$section] )) {
                $slideArray['section'][$section]['mam-hs-image-id'] = $_REQUEST['mam-hs-image-id'][$section];
            }
            //spacer section
            if( isset( $_REQUEST['mam-hs-spacer-section-height-type'][$section] )) {
                $slideArray['section'][$section]['mam-hs-spacer-section-height-type'] = $_REQUEST['mam-hs-spacer-section-height-type'][$section];
            }

            ///filterbar type
            if( isset( $_REQUEST['mam-hs-filter-bar-section-type'][$section] )) {
                $slideArray['section'][$section]['mam-hs-filter-bar-section-type'] = $_REQUEST['mam-hs-filter-bar-section-type'][$section];
            }
            if( isset( $_REQUEST['mam-hs-filter-bar-section-bg-color'][$section] )) {
                $slideArray['section'][$section]['mam-hs-filter-bar-section-bg-color'] = $_REQUEST['mam-hs-filter-bar-section-bg-color'][$section];
            }

            if( isset( $_REQUEST['mam-hs-spacer-section-height'][$section] )) {
                $slideArray['section'][$section]['mam-hs-spacer-section-height'] = $_REQUEST['mam-hs-spacer-section-height'][$section];
            }

            /* Radius Selector Section */
            if( isset( $_REQUEST['mam-hs-radius-selector-section-default'][$section] )) {
                $slideArray['section'][$section]['default'] = $_REQUEST['mam-hs-radius-selector-section-default'][$section];
            }
            if( isset( $_REQUEST['mam-hs-radius-selector-section-values'][$section] )) {
                $slideArray['section'][$section]['values'] = $_REQUEST['mam-hs-radius-selector-section-values'][$section];
            }
            if( isset( $_REQUEST['mam-hs-date-time-filter-section-days'][$section] )) {
                $slideArray['section'][$section]['days'] = $_REQUEST['mam-hs-date-time-filter-section-days'][$section];
            }
            if( isset( $_REQUEST['mam-hs-date-time-filter-section-show-start-date'][$section] )) {
                $slideArray['section'][$section]['show_date_start'] = $_REQUEST['mam-hs-date-time-filter-section-show-start-date'][$section];
            }
            if( isset( $_REQUEST['mam-hs-date-time-filter-section-use-explicit-days'][$section] )) {
                $slideArray['section'][$section]['use_explicit_days'] = $_REQUEST['mam-hs-date-time-filter-section-use-explicit-days'][$section];
            }
            if( isset( $_REQUEST['mam-hs-date-time-filter-section-show-cats'][$section] )) {
                $slideArray['section'][$section]['show_cats'] = $_REQUEST['mam-hs-date-time-filter-section-show-cats'][$section];
            }

            $reload = true;

        }

        apply_filters( 'mam_app_settings_set_home_screen_stack' , false, $slideArray , $_REQUEST['role'] );

        return $reload;

    }

}
