<?php

function mam_user_is( $role, $user_id = 0 )
{
    if( $user_id == 0 ) $user_id = mam_user_id();
    if( $user_id == 0 ) return false;
    $user = get_userdata( $user_id );
    if( $user )
    {
        if( !is_array( $role ) ) $role = array( $role );
        foreach( $role as $user_role  ) {
            if (in_array($user_role, $user->roles)) return true;
        }
    }
    return false;
}

function mam_user()
{

    do_action( 'mam_update_current_user' );
    global $mam_user;
    return $mam_user;

}

function mam_user_id()
{

    do_action( 'mam_update_current_user' );
    global $mam_user_id;
    return $mam_user_id;

}

function mam_convert_gmt_to_user_date( $date_stamp, $date_format = 'm/d/Y' , $original_timezone = 'Europe/London' )
{

    try{
        if(isset( $_REQUEST['gmtoffset'] )){

            $dst = 0;
            if(isset( $_REQUEST['dst'] )) $dst = (int)$_REQUEST['dst'];
            $seconds =  $_REQUEST['gmtoffset']*60*60;
            $tz = timezone_name_from_abbr("", $seconds, $dst );

            $dateTime = new DateTime("@$date_stamp", new DateTimeZone($original_timezone));
            $dateTime->setTimezone(new DateTimeZone($tz));

            return $dateTime->format($date_format );

        }
    }catch (Exception $e ){
        mamdebug('date error', $date_stamp );
        mamdebug('date error', $e->getMessage());
    }

    return date( $date_format, $date_stamp );

}

add_filter( 'mam_convert_state_to_abbreviation', 'mam_convert_state_to_abbreviation' , 10 , 2 );
function mam_convert_state_to_abbreviation( $stateName , $from_abbrev = false )
{

    $states = array(
        "Alabama" => "AL",
        "Alaska" => "AK",
        "Arizona" => "AZ",
        "Arkansas" => "AR",
        "California" => "CA",
        "Colorado" => "CO",
        "Connecticut" => "CT",
        "Delaware" => "DE",
        "Florida" => "FL",
        "Georgia" => "GA",
        "Hawaii" => "HI",
        "Idaho" => "ID",
        "Illinois" => "IL",
        "Indiana" => "IN",
        "Iowa" => "IA",
        "Kansas" => "KS",
        "Kentucky" => "KY",
        "Louisiana" => "LA",
        "Maine" => "ME",
        "Maryland" => "MD",
        "Massachusetts" => "MA",
        "Michigan" => "MI",
        "Minnesota" => "MN",
        "Mississippi" => "MS",
        "Missouri" => "MO",
        "Montana" => "MT",
        "Nebraska" => "NE",
        "Nevada" => "NV",
        "New Hampshire" => "NH",
        "New Jersey" => "NJ",
        "New Mexico" => "NM",
        "New York" => "NY",
        "North Carolina" => "NC",
        "North Dakota" => "ND",
        "Ohio" => "OH",
        "Oklahoma" => "OK",
        "Oregon" => "OR",
        "Pennsylvania" => "PA",
        "Rhode Island" => "RI",
        "South Carolina" => "SC",
        "South Dakota" => "SD",
        "Tennessee" => "TN",
        "Texas" => "TX",
        "Utah" => "UT",
        "Vermont" => "VT",
        "Virginia" => "VA",
        "Washington" => "WA",
        "West Virginia" => "WV",
        "Wisconsin" => "WI",
        "Wyoming" => "WY"
    );

    if( $from_abbrev )
    {
        foreach ( $states as $index => $state )
        {
            if( $state == $stateName ) return $index;
        }
    }
    if( isset( $states[$stateName] )) return $states[$stateName];

    return $stateName;
}
