<?php

class mam_user_manager_functions
{

    function mam_get_user( $user = null )
    {

        do_action( 'mam_update_current_user' );
        global $mam_user;
        return $mam_user;

    }

    function mam_get_user_id( $user_id = 0 )
    {

        do_action( 'mam_update_current_user' );
        global $mam_user_id;
        return $mam_user_id;

    }

    function mam_update_current_user()
    {
        if( isset( $_REQUEST['pid'] )) {
            $this->check_for_clone();
            global $mam_user, $mam_user_id, $current_user;
            $mam_user_id = 0;
            $mam_user = null;
            $user = get_users(array('meta_key' => 'mam_app_token', 'meta_value' => $_REQUEST['pid']));
            if ($user){
                $current_user = $user[0];
                $mam_user = $user[0];
                $mam_user_id = $user[0]->ID;
            }
        }
    }

    function check_for_clone()
    {

        if( isset( $_REQUEST['pid'] )) {
            $user = get_users(array('meta_key' => 'mam_app_token', 'meta_value' => $_REQUEST['pid']));
            if ($user) {

                $user_id = $user[0]->ID;

                $args = array(
                    'meta_query' => array(
                        array(
                            'key' => 'admin_is_cloning',
                            'value' => $user_id,
                        )
                    )
                );
                $all_users = get_users($args);

                if (!empty($all_users))
                {
//                    if( ! isset( $_REQUEST['original_pid'] ) ) {
//                        $_REQUEST['original_pid'] = $_REQUEST['pid'];
//                    }
                    $_REQUEST['pid'] = get_user_meta($all_users[0]->ID, 'mam_app_token', true);
                    global $is_cloning;
                    $is_cloning = true;
                }
            }
        }

    }

    function convert_datetime_to_user_date_time( $date, $format = 'Y/M/d', $origin_timezone = 'UTC', $user_id = 0 )
    {

        if( $user_id == 0 ) $user_id = mam_user_id();

        $gmtoffset = 0;
        $dst = 0;
        if( $user_id > 0 ) {
            $gmtoffset = get_user_meta( $user_id, '_mam_gmtoffset', true);
            $dst = get_user_meta( $user_id, '_mam_dst', true);
        }
        if( ! $dst ) $dst = 0;
        if(isset( $_REQUEST['gmtoffset'] )) $gmtoffset = $_REQUEST['gmtoffset'];
        if(isset( $_REQUEST['dst'] )) $dst = $_REQUEST['dst'];

        if( strlen( $gmtoffset ) < 2 ) $gmtoffset = '-5.0000';
        if( ! $dst ) $dst = 0;

        $seconds =  $gmtoffset*60*60;
        $tz = timezone_name_from_abbr("", $seconds, $dst );
        $timezone = new DateTimeZone($tz);

        $dt = new DateTime( $date , new DateTimeZone( $origin_timezone ));
        $dt->setTimezone( $timezone );

        return $dt->format( $format );

    }

    function mam_ping_item_view()
    {

        if( mam_user_id() > 0 ){
            $reads = get_user_meta(mam_user_id(), 'read_history', true);
            if (!is_array($reads)) $reads = array();
            $reads['read_' . $_REQUEST['id']] = time();
            update_user_meta(mam_user_id(), 'read_history', $reads);
            $result['read_history'] = $reads;
            $result['user_id'] = mam_user_id();
            do_action( 'mam_ping_item_view_updated' );
        }

        $author_id = get_post_field('post_author', $_REQUEST['id']);
        if ($author_id != mam_user_id()) {
            $total = get_post_meta($_REQUEST['id'], 'total_views', true);
            if ($total) {
                $total++;
            } else {
                $total = 1;
            }
            update_post_meta($_REQUEST['id'], 'total_views', $total);
        }

        $result['success'] = 'yes';
        wp_send_json( $result );
        die();

    }

    function add_logout_user_link( $actions, $user )
    {
        if( isset( $_REQUEST['logout-app-user'] ) && $_REQUEST['logout-app-user'] == $user->ID ) {
            delete_user_meta( $user->ID, 'mam_app_token' );
            wp_redirect( admin_url('users.php') );
            die();
        }
        if( isset( $_REQUEST['view-as-app-user'] ) && $_REQUEST['view-as-app-user'] == $user->ID ) {
            $users = get_users(array('meta_key' => 'admin_is_cloning', 'meta_compare' => 'EXISTS' ));
            foreach( $users as $app_user ) {
                delete_user_meta( $app_user->ID, 'admin_is_cloning' );
            }
            update_user_meta( $user->ID, 'admin_is_cloning', get_current_user_id() );
            wp_redirect( admin_url('users.php') );
            die();
        }
        if( isset( $_REQUEST['remove-view-as-app'] ) && $_REQUEST['remove-view-as-app'] == $user->ID ) {
            delete_user_meta( $user->ID, 'admin_is_cloning' );
            wp_redirect( admin_url('users.php') );
            die();
        }

        if( get_user_meta( $user->ID, 'mam_app_token' , true )) {
            $actions['log_user_out_of_app'] = '<a href="' . admin_url('users.php?logout-app-user=' . $user->ID) . '">' . esc_html__('Log user out of app', 'mam-main') . '</a>';
            if( get_user_meta( $user->ID , 'admin_is_cloning', true ) == get_current_user_id())
            {
                $actions['remove_view_as_user_on_app'] = '<a href="' . admin_url('users.php?remove-view-as-app=' . $user->ID) . '">' . esc_html__('Stop view as user on App', 'mam-main') . '</a>';
            }else{
                $actions['view_as_user_on_app'] = '<a href="' . admin_url('users.php?view-as-app-user=' . $user->ID) . '">' . esc_html__('View as user on app', 'mam-main') . '</a>';
            }
        }

        return $actions;
    }


}
