<?php
if (!class_exists('local_app_setup')) {

    class local_app_setup
    {

        function __construct()
        {

            global $local_app_content;
            local_app_sksort( $local_app_content, 'content_type', true );

        }

        public function local_app_app_setup_content_page(){

            $current = 'homepage';

            if (isset($_REQUEST['tab'])) $current = $_REQUEST['tab'];

            $html_line = '<div class="local-app-main-content-area">';

            switch ($current) {
                case 'homepage':
                    $saved_message = '';
                    $left_content = $this->local_app_setup_content_page_left();
                    $html_line = '<table class="local-app-button-table">';
                    $html_line .= '<tr><td class="local-app-button-table-left">' . $left_content . '</td><td class="local-app-button-table-center">&nbsp;</td><td class="local-app-button-table-right">' . $saved_message . '</td></tr>';
                    $html_line .= '</table>';

                    wp_localize_script( 'localapp', 'localapp_tsl_location', 'main' );
                    wp_localize_script( 'localapp', 'localapp_tsl_media_icons', $this->get_media_library_images() );
                    wp_localize_script( 'localapp', 'localapp_tsl_media_icons_sets', $this->get_media_library_icon_sets() );
                    break;
                case 'plugin_settings':
                    $html_line .= $this->display_plugin_settings();
                    break;
                case 'left_menu':
                    wp_localize_script( 'localapp', 'localapp_tsl_location', 'left' );
                    wp_localize_script( 'localapp', 'localapp_tsl_media_icons', $this->get_media_library_images() );
                    wp_localize_script( 'localapp', 'localapp_tsl_media_icons_sets', $this->get_media_library_icon_sets() );
                    $html_line .= $this->create_left_menu();
                    break;
                case 'support':
                    $dashboard = new local_app_dashboard();
                    $html_line .= $dashboard->local_app_metrics_support_page();
                    break;
            }

            $html_line .= '</div>'; //end of main content area

            return $html_line;
        }

        function create_left_menu(){

            $html_line = '<div class="local-app-left-menu-holder">';
            $html_line .= '<div class="local-app-button-section-title">Left Menu Design&nbsp;<span title="' . local_app_get_qtip_message('home_page_left_menu_message') . '" class="local-app-help-button fa fa-question-circle"></span><br><span class="local-app-content-subheader">Manage content for the left menu for each role.</span></div>';

            if(get_option( 'mam-user-roles-has-managed-roles' )) {
                if (get_option('mam-user-roles-has-managed-roles') == 'yes') {

                    $html_line .= '<form id="mam-user-role-change" method="GET">';
                    $html_line .= '<input type="hidden" name="page" id="page" value="local_app_setup">';
                    $html_line .= '<input type="hidden" name="tab" id="tab" value="left_menu">';

                    global $wp_roles;
                    $all_roles = $wp_roles->roles;
                    $role_array = array();

                    $role_array[] = array('slug' => 'mam-all', 'name' => "Any User Not Logged In");

                    foreach ($all_roles as $role_index => $role) {

                        if (get_option('mam-user-roles-to-manage-' . $role_index) == 'yes') {
                            $role_array[] = array('slug' => $role_index, 'name' => $role['name']);
                        }

                    }

                    $role_selected = 'mam-all';
                    if (isset($_REQUEST['this-role'])) {
                        $role_selected = $_REQUEST['this-role'];
                        $button_array_to_manage_role = $role_selected;  //done with role
                        if ($button_array_to_manage_role == 'mam-all') $button_array_to_manage_role = '';
                    }

                    $html_line .= '<div class="local-app-button-section-select-user-role"><table style="width:100%"><tr><td>Content for Role: </td><td align="right">' . $this->make_dropdown('this-role', $role_array, $role_selected) . '</td></tr></table></div>';

                    $html_line .= '</form>';

                }
            }

            if( isset($_REQUEST['this-role']))
            {
                $button_array_to_manage_role = $_REQUEST['this-role'];
            }else{
                if (get_option('mam-user-roles-has-managed-roles') == 'yes') {
                    $button_array_to_manage_role = 'mam-all';
                }else{
                    $button_array_to_manage_role = '';
                }
            }

            $html_line .= '<div id="local-app-buttons-sort">';

            if($button_array_to_manage_role == '') $button_array_to_manage_role = 'mam-all';
            $button_array = apply_filters( 'mam_app_settings_get_buttons', false, $button_array_to_manage_role, 'left' );

            $is_first_button = true;

            if ($button_array) {
                //iterate through the buttons and build the button interface
                foreach ($button_array as $posts) {
                    $this_array = array('id' => $posts['id'], 'name' => $posts['name'], 'icon' => $posts['icon'], 'type' => $posts['type'], 'source' => $posts['source']);
                    $html_line .= $this->local_app_create_button_section($this_array , $is_first_button, 'left' );
                    $is_first_button = false;
                }
            }

            $html_line .= '</div>';  //end of buttons div

            $button_count = 1;
            if( is_array( $button_array ) ) $button_count = sizeof($button_array);

            $html_line .= $this->local_app_create_new_button_section( $button_count , 'left' );

            if(get_option( 'mam-user-roles-has-managed-roles' )) {
                if (get_option('mam-user-roles-has-managed-roles') == 'yes') {
                    global $wp_roles;
                    $all_roles = $wp_roles->roles;
                    $role_array = array();

                    $role_array[] = array('slug' => 'mam-all', 'name' => "Any User Not Logged In");

                    foreach ($all_roles as $role_index => $role) {

                        if (get_option('mam-user-roles-to-manage-' . $role_index) == 'yes') {
                            $role_array[] = array('slug' => $role_index, 'name' => $role['name']);
                        }

                    }

                    $role_selected = 'mam-all';
                    if (isset($_REQUEST['this-role'])) {
                        $role_selected = $_REQUEST['this-role'];
                    }

                    $html_line .= '<form action="" method="post">';
                    $html_line .= '<input type="hidden" name="location" value="left">';
                    $html_line .= '<input type="hidden" name="role" value="'.$role_selected.'">';
                    $html_line .= '<div class="local-app-button-section-select-user-role"><table style="width:100%"><tr><td>Clone from Role: </td><td align="right">'.$this->make_dropdown( 'clone-content-from-role', $role_array, '' ).'</td><td><input type="button" class="button-primary" id="mam-clone-role-content" value="Clone"></td></tr></table></div>';
                    $html_line .= '</form>';
                }
            }

            $html_line .= '</div>';

            return $html_line;
        }

        function display_plugin_settings(){

            $publish_button = '';

            if(!local_app_get_api_key()){
                $publish_button = tsl_publish_your_app_button('local-app-update-content-button');
            }

            $html_line = '<div class="local-app-button-table" >';
            $html_line .= '<table class="local-app-view-rights-table" >';
//            $html_line .= '<tr><td><div class="local-app-button-section-title">Settings for Installed Plugins&nbsp;</div></td><td align="right">'.$publish_button.'</td></tr>';


            global $local_app_content;
            $has_locations = false;

            local_app_sksort($local_app_content, 'content_type', true);

            foreach($local_app_content as $plugin) {

                if (method_exists($plugin['class'] , 'location_manager')) {
                    $has_locations = true;
                }

                if (method_exists($plugin['class'] , 'settings')) {
                    $content_class = $plugin['class'];
                    $content_class = new $content_class();
                    if(strlen($content_class->settings()) > 0) {
                        $html_line .= '<tr><td colspan="2"><div class="local-app-member-header">' . $plugin['content_type'] . ' Settings</div></td></tr>';
                        $html_line .= '<tr><td colspan="2">' . $content_class->settings() . '</td></tr>';
                    }
                }
            }


            if(has_filter( 'mam_for_plugin_settings_section' )) {
			    $html_line = apply_filters( 'mam_for_plugin_settings_section'  , $html_line );
    		}

            $html_line .= '</table></div>';

            return $html_line;

        }

        function display_social(){


            $html_line = '<div class="local-app-social-content">';
            $html_line .= '<table style="width:100%;max-width:70em;">';
            $publish_button = '';
            if(!local_app_get_api_key()) $publish_button = tsl_publish_your_app_button('local-app-update-content-button');
            $html_line .= '<tr><td colspan="2"><div class="tsl-admin-headline">Social Media Features&nbsp;</div></td><td align="right">&nbsp;</td></tr>';
//            $html_line .= '<tr><td colspan="3"><div class="local-app-button-section-sub-title">Social media profile icons are displayed in a footer menu on the bottom of the mobile app.</div></td></tr>';
            $html_line .= '<tr><td colspan="3">&nbsp;</td></tr>';

            $facebook = '';
            $instagram = '';
            $linkedin = '';
            $pintrest = '';
            $twitter = '';
            $website = '';
            $youtube = '';

            if(get_option('local-app-social-facebook')) $facebook = get_option('local-app-social-facebook');
            if(get_option('local-app-social-instagram')) $instagram = get_option('local-app-social-instagram');
            if(get_option('local-app-social-linkedin')) $linkedin = get_option('local-app-social-linkedin');
            if(get_option('local-app-social-pintrest')) $pintrest = get_option('local-app-social-pintrest');
            if(get_option('local-app-social-twitter')) $twitter = get_option('local-app-social-twitter');
            if(get_option('local-app-social-website')) $website = get_option('local-app-social-website');
            if(get_option('local-app-social-youtube')) $youtube = get_option('local-app-social-youtube');

            $button = '<a id="local-app-update-social-media-button" class="button-primary" onclick="local_app.save_social_media()" disabled>Save</a>';

            $html_line .= '<tr><td class="local-app-social-left-column">Facebook:</td><td align="right">https://www.facebook.com/</td><td><input class="local-app-social-field" type="text" id="local-app-facebook" value="'.$facebook.'">&nbsp;<span title="' . local_app_get_qtip_message('home_page_social_media_facebook') . '" class="local-app-help-button fa fa-question-circle"></span></td></tr>';
            $html_line .= '<tr><td class="local-app-social-left-column">Instagram:</td><td align="right">https://www.instagram.com/</td><td><input class="local-app-social-field" type="text" id="local-app-instagram" value="'.$instagram.'">&nbsp;<span title="' . local_app_get_qtip_message('home_page_social_media_instagram') . '" class="local-app-help-button fa fa-question-circle"></span></td></tr>';
            $html_line .= '<tr><td class="local-app-social-left-column">LinkedIn:</td><td align="right">https://www.linkedin.com/company/</td><td><input class="local-app-social-field" type="text" id="local-app-linkedin" value="'.$linkedin.'">&nbsp;<span title="' . local_app_get_qtip_message('home_page_social_media_linkedin') . '" class="local-app-help-button fa fa-question-circle"></span></td></tr>';
            $html_line .= '<tr><td class="local-app-social-left-column">Pinterest:</td><td align="right">https://www.pinterest.com/</td><td><input class="local-app-social-field" type="text" id="local-app-pintrest" value="'.$pintrest.'">&nbsp;<span title="' . local_app_get_qtip_message('home_page_social_media_pintrest') . '" class="local-app-help-button fa fa-question-circle"></span></td></tr>';
            $html_line .= '<tr><td class="local-app-social-left-column">Twitter:</td><td align="right">https://www.twitter.com/</td><td><input class="local-app-social-field" type="text" id="local-app-twitter" value="'.$twitter.'">&nbsp;<span title="' . local_app_get_qtip_message('home_page_social_media_twitter') . '" class="local-app-help-button fa fa-question-circle"></span></td></tr>';
            $html_line .= '<tr><td class="local-app-social-left-column">YouTube:</td><td align="right">http://www.youtube.com/user/</td><td><input class="local-app-social-field" type="text" id="local-app-youtube" value="'.$youtube.'">&nbsp;<span title="' . local_app_get_qtip_message('home_page_social_media_youtube') . '" class="local-app-help-button fa fa-question-circle"></span></td></tr>';
            $html_line .= '<tr><td class="local-app-social-left-column">Website:</td><td align="right">&nbsp;</td><td><input placeholder="http://" class="local-app-social-field" type="text" id="local-app-website" value="'.$website.'">&nbsp;<span title="' . local_app_get_qtip_message('home_page_social_media_website') . '" class="local-app-help-button fa fa-question-circle"></span></td></tr>';
            $html_line .= '<tr><td class="local-app-social-left-column">&nbsp;</td><td align="right">&nbsp;</td><td><span id="local-app-source-error" class="local-app-source-error local-app-hide" data-id="social-website-error"> </span>&nbsp;</td></tr>';



            $html_line .= '<tr><td class="local-app-social-left-column-button" colspan="3">&nbsp;</td></tr>';
            $html_line .= '<tr><td class="local-app-social-left-column-button" colspan="3">'.$button.'</td></tr>';
            $html_line .= '</table>';
            $html_line .= '</div>';

            return $html_line;
        }

        function get_media_library_icon_sets(){

            $icon_array = array();

            $icon_array[] = array('name' => 'Font Awesome',  'dir' => 'fontawesome/' , 'background' => 'white');
            $icon_array[] = array('name' => 'Ionic', 'dir' => 'ionic/', 'background' => 'white');
            $icon_array[] = array('name' => 'Popular', 'dir' => 'set_3/', 'background' => 'white');

            return $icon_array;
        }

        function get_media_library_images(){

            $images_array = array();
            $images_array['icons'] = $this->get_media_library_images_in_directory(1);
            return $images_array;

        }

        function get_media_library_images_in_directory($image_type){

            $image_array = array();
            global $tsl_local_app_image_url;
            global $tsl_local_app_dir_path;

            switch($image_type){
                case 1:
                    //icons
                    $image_path = $tsl_local_app_dir_path . 'images/icons/';
                    $image_url = $tsl_local_app_image_url . 'images/icons/';

                    $dir_array = $this->get_media_library_icon_sets();

                    for($x=0;$x<sizeof($dir_array);$x++) {

                        $files = array_diff(scandir($image_path . $dir_array[$x]['dir'] ), array('.', '..'));

                        foreach ($files as $index => $file) {
                            if (strpos($file, '.png') > 0) {
                                $image_array[] = array('image_url' => $image_url . $dir_array[$x]['dir']  . $file, 'set_id' => $x, 'image_name' => str_replace( '-','',str_replace( 'black_','',str_replace('.png','',$file))) );
                            }
                        }
                    }

                    return $image_array;
                    break;
            }

            return $image_array;

        }

        public static function make_dropdown( $id, $options = array(), $selected = null ) {

            if ( ! $id || sizeof( $options ) == 0 ) {
                return '';
            }

            $html_line = '<select id="' . $id . '" name="' . $id . '">';

            if ( ! $selected ) {
                $html_line .= '<option value="0" selected>Select...</option>';
            }

            foreach ( $options as $option ) {
                $selected_item = '';
                if ( $option['slug'] == $selected ) {
                    $selected_item = 'selected';
                }
                $html_line .= '<option  value="' . $option['slug'] . '" ' . $selected_item . '>' . $option['name'] . '</option>';
            }

            $html_line .= '</select>';

            return $html_line;

        }

        function local_app_setup_content_page_left()
        {

            $html_line = '<div class="local-app-button-section-title">Home Page Design&nbsp;<span title="' . local_app_get_qtip_message('home_page_icons_message') . '" class="local-app-help-button fa fa-question-circle"></span><br><span class="local-app-content-subheader">Add a button. Pick your content. Change the background. Add social media. Publish.</span></div>';

            $button_array_to_manage_role = '';

            if(get_option( 'mam-user-roles-has-managed-roles' )=='yes') {

                $html_line .= '<form id="mam-user-role-change" method="GET">';
                $html_line .= '<input type="hidden" name="page" id="page" value="local_app_setup">';
                $html_line .= '<input type="hidden" name="tab" id="tab" value="homepage">';

                global $wp_roles;
                $all_roles = $wp_roles->roles;
                $role_array = array();

                $role_array[] = array('slug' => 'mam-all', 'name' => "Any User Not Logged In" );

                foreach($all_roles as $role_index => $role ) {

                    if (get_option('mam-user-roles-to-manage-' . $role_index) == 'yes') {
                        $role_array[] = array('slug' => $role_index, 'name' => $role['name'] );
                    }

                }

                $role_selected = 'mam-all';
                if(isset($_REQUEST['this-role'])){
                    $role_selected = $_REQUEST['this-role'];
                    $button_array_to_manage_role = $role_selected;  //done with role
                    if($button_array_to_manage_role == 'mam-all') $button_array_to_manage_role = '';
                }

                $html_line .= '<div class="local-app-button-section-select-user-role"><table style="width:100%"><tr><td>Content for Role: </td><td align="right">'.$this->make_dropdown( 'this-role', $role_array, $role_selected ).'</td></tr></table></div>';

                $html_line .= '</form>';

            }

            $html_line .= '<div id="local-app-buttons-sort">';

            if($button_array_to_manage_role == '') $button_array_to_manage_role = 'mam-all';

            $button_array = apply_filters( 'mam_app_settings_get_buttons', false, $button_array_to_manage_role, 'main' );
            $is_first_button = true;

            if ($button_array) {
                //iterate through the buttons and build the button interface
                foreach ($button_array as $index => $posts) {
                    $this_array = array('id' => $posts['id'], 'name' => $posts['name'], 'icon' => $posts['icon'], 'type' => $posts['type'], 'source' => $posts['source']);
                    $html_line .= $this->local_app_create_button_section($this_array , $is_first_button);
                    $is_first_button = false;
                }
            }

            $html_line .= '</div>';  //end of buttons div
            $html_line .= $this->local_app_create_new_button_section(sizeof($button_array));

            if(get_option( 'mam-user-roles-has-managed-roles' )=='yes') {
                global $wp_roles;
                $all_roles = $wp_roles->roles;
                $role_array = array();

                $role_array[] = array('slug' => 'mam-all', 'name' => "Any User Not Logged In");

                foreach ($all_roles as $role_index => $role) {

                    if (get_option('mam-user-roles-to-manage-' . $role_index) == 'yes') {
                        $role_array[] = array('slug' => $role_index, 'name' => $role['name']);
                    }

                }

                $role_selected = 'mam-all';
                if (isset($_REQUEST['this-role'])) {
                    $role_selected = $_REQUEST['this-role'];
                }

                $html_line .= '<form action="" method="post">';
                $html_line .= '<input type="hidden" name="location" value="main">';
                $html_line .= '<input type="hidden" name="role" value="' . $role_selected . '">';
                $html_line .= '<div class="local-app-button-section-select-user-role"><table style="width:100%"><tr><td>Clone from Role: </td><td align="right">' . $this->make_dropdown('clone-content-from-role', $role_array, '') . '</td><td><input type="button" class="button-primary" id="mam-clone-role-content" value="Clone"></td></tr></table></div>';
                $html_line .= '</form>';
            }

            return $html_line;
        }

        function local_app_create_new_button_section($button_count , $location = '' ){

            $hide_class = '';
            if($button_count > 11) $hide_class = 'local-app-hide';

            $html_line = '<div class="local-app-new-button-section">';
            //make button section header
            $html_line .= '<table class="local-app-button-section-new-button-header">';
            $html_line .= '<tr><td class="local-app-button-section-new-icon-left"><span id="local-app-button-section-new-icon-message" class="'.$hide_class.'" style="float:right;margin-right:2em;font-size: 1.2em;">Click the + to add a button to your app</span></td><td class="local-app-button-section-new-icon '.$hide_class.'"><span style="color:red" class="fa fa-plus-circle fa-3x"></span></td>';
            $html_line .= '</tr></table>';
            $html_line .= '</div>';

            $html_line .= '<div class="local-app-blank-content-type local-app-hide" >' . $this->local_app_content_type_dd('blank_type_id', 'Web_URL', $location ) . '</div>';
            $html_line .= '<div class="local-app-blank-content-source local-app-hide" >' . $this->local_app_content_type_form('blank', 'Web_URL', '') . '</div>';

            global $local_app_content;
            foreach($local_app_content as $index => $value){
                $content_class = $value['class'];
                $content_class = new $content_class();
                if( method_exists( $value['class'], 'get_blank_content_html' )) {
                    $html_line .= '<div class="local-app-blank-content-' . $index . ' local-app-hide" >' . $content_class->get_blank_content_html() . '</div>';
                }
            }

            return $html_line;
        }

        function local_app_create_button_section($button_array , $is_first = false , $location = 'home' ){

            $icon = '<span class="local-app-button-icon-placeholder fa fa-plus">&nbsp;</span>';
            $image_holder_class = '';
            if ($button_array['icon']) {
                $icon = '<img title="'.local_app_get_lang('page-bar-icon').'" src="' . $button_array['icon'] . '" class="local-app-icon-image-frame" >';
                $image_holder_class = 'local-app-icon-image-no-frame';
            }

            $html_line = '<div class="local-app-button-section" id="local-app-button-section-' . $button_array['id'] . '" data-id="' . $button_array['id'] . '" >';
            //make button section header
            $html_line .= '<table class="local-app-button-section-header">';
            $html_line .= '<tr class="local-app-background">';
            $html_line .= '<td  class="local-app-button-section-expand" data-id="' . $button_array['id'] . '" id="local-app-button-expand-' . $button_array['id'] . '"><span title="'.local_app_get_lang('page-bar-expand').'" data-id="' . $button_array['id'] . '" class="local-app-button-section-expand-icon fa fa-angle-down">&nbsp;</span></td>';
            $html_line .= '<td  class="local-app-button-section-title local-app-background" ><input title="'.local_app_get_lang('page-bar-title').'" data-button_name="'.$button_array['name'].'" data-id="' . $button_array['id'] . '" class="local-app-button-title" id="local-app-button-title-' . $button_array['id'] . '" type="text" value="' . $button_array['name'] . '"></td>';
            $html_line .= '<td  class="local-app-button-section-icon" id="local-app-button-icon-' . $button_array['id'] . '"><div data-id="'.$button_array['id'].'" class="local-app-button-section-icon-holder ' . $image_holder_class . '">' . $icon . '</div></td>';
            $html_line .= '<td class="local-app-button-section-options" id="local-app-button-options-' . $button_array['id'] . '">';
            $html_line .= '<table class="local-app-button-table-options">';
            $html_line .= '<tr>';
            $html_line .= '<td>Text:</td><td>&nbsp;<input type="checkbox" id="local-app-button-show-text-' . $button_array['id'] . '" value="1"></td>';
            $html_line .= '</tr>';
            $html_line .= '<tr>';
            $html_line .= '<td>Image:</td><td>&nbsp;<input type="checkbox" id="local-app-button-show-icon-' . $button_array['id'] . '" value="1"></td>';
            $html_line .= '</tr>';
            $html_line .= '</table></td>';
            $html_line .= '<td title="'.local_app_get_lang('page-bar-reorder').'" class="local-app-button-section-move" id="local-app-button-move-' . $button_array['id'] . '"><span class="local-app-button-section-move-icon fa fa-arrows-alt-v">&nbsp;</span></td>';
            $html_line .= '</tr></table>';

            $show_options = '';
            if($is_first) $show_options = 'style="display: block; height: 10em"';

            $html_line .= '<div id="local-app-button-options-section-' . $button_array['id'] . '" class="local-app-button-section-options" '.$show_options.'>';

            global $local_app_content;

            if ( ! isset($local_app_content[$button_array['type']])) {
                $html_line .= '<div class="local-app-warning-text">'.$button_array['type'].' Not Installed!</div>';
            }
            $html_line .= '<table class="local-app-button-content-table">';
            $html_line .= '<tr><td>Content Type:</td><td>' . $this->local_app_content_type_dd($button_array['id'], $button_array['type'], $location ) . '</td></tr>';
            $html_line .= '<tr><td>Content Source:</td><td>' . $this->local_app_content_type_form($button_array['id'], $button_array['type'], $button_array['source']) . '</td></tr>';

            if($this->is_list_type_button($button_array['type'] )) {
                $html_line .= '<tr class="local-app-listing-count" data-id="'.$button_array['id'].'"><td>Total Listings:</td><td>' . $this->local_app_content_type_form($button_array['id'], $button_array['type'], $button_array['source'], true) . '</td></tr>';
            }else{
                $html_line .= '<tr class="local-app-listing-count local-app-hide" data-id="'.$button_array['id'].'"><td>Total Listings:</td><td>' . $this->local_app_content_type_form($button_array['id'], $button_array['type'], $button_array['source'], true) . '</td></tr>';
            }

            $html_line .= '</table>';


            $html_line .= '<div class="local-app-button-delete-message"><span id="local-app-source-error" data-id="'.$button_array['id'].'" class="local-app-source-error local-app-hide">&nbsp;</span><a class="local-app-button-delete-message-text" onclick="local_app.remove_button(\'' . $button_array['id'] . '\')" >Delete Button</a></div>';

            $html_line .= '</div>'; //end of options
            $html_line .= '</div>';

            return $html_line;
        }

        function is_list_type_button( $type ){

            if($type == 'GeoDirectory') return true;
            if($type == 'BusinessDirectory') return true;
            if($type == 'ChamberDashboard') return true;
            if($type == 'Connections') return true;
            if($type == 'LddDirectoryLite') return true;
            if($type == 'wp_store_locator') return true;
            if($type == 'simple_map') return true;
            if($type == 'MapsMarker') return true;
            if($type == 'theEventsCalendar') return true;

            return false;

        }
        function local_app_content_type_dd($id, $selected, $location = 'home' ){

            global $local_app_content;
            $content_array = array();

            foreach($local_app_content as $index => $value){
                if( $location== 'home' && isset( $value['left_menu_only'] ) ) continue;
                $content_array[] = array('id' => $index , 'title' => $value['content_type']);;
            }
            $html_line = '<select data-id="' . $id . '" class="local-app-content-type">';

            if (!$selected) {
                $html_line .= '<option value="0" Selected>Select...</option>';
            }

            foreach ($content_array as $index => $value) {
                $selected_item = '';
                if ($value['id'] == $selected){
                    $selected_item = 'selected';
                }
                $html_line .= '<option value="' . $value['id'] . '" ' . $selected_item . '>' . $value['title'] . '</option>';
            }

            $html_line .= '</select>';

            return $html_line;
        }

        function local_app_content_type_form($id, $content_type, $content_source = null, $listing_only = false){

            $html_line = '<div class="local-app-content-type-parent" data-id="' . $id . '">';

            global $local_app_content;

            if(isset($local_app_content[$content_type])) {
                $content_class = $local_app_content[$content_type]['class'];
                $content_class = new $content_class();

                $html_line .= $content_class->get_content_type_form($id, $content_source , '' , $listing_only);

                if($listing_only) return $content_class->get_content_type_form($id, $content_source , '' , $listing_only);
            }

            $html_line .= '</div>';

            return $html_line;
        }

    }
}
