<?php
if ( ! class_exists( 'WP_List_Table' ) )
	require_once( ABSPATH . 'wp-admin/includes/class-wp-list-table.php' );

class local_app_campaign_grid extends WP_List_Table {

	public $current_page;

    function __construct() {
		parent::__construct( array(
			'singular' => 'post',
			'plural' => 'posts',
			'ajax' => true,
			'screen' => 'interval_list') );
	}

    function prepare_items() {

		$per_page = 5;
        $columns = $this->get_columns();
        $hidden = array();
        $sortable = array();

        $this->_column_headers = array($columns, $hidden, $sortable);

		$args = array(
			'posts_per_page' => $per_page,
			'orderby' => 'plugin',
			'order' => 'ASC',
			'offset' => ( $this->get_pagenum() - 1 ) * $per_page );

		if ( ! empty( $_REQUEST['s'] ) )
			$args['s'] = $_REQUEST['s'];

		if ( ! empty( $_REQUEST['orderby'] ) ) {
			if ( 'apple_column' == $_REQUEST['apple_column'] )
				$args['orderby'] = 'apple_column';
		}

		if ( ! empty( $_REQUEST['order'] ) ) {
			if ( 'asc' == strtolower( $_REQUEST['order'] ) )
				$args['order'] = 'ASC';
			elseif ( 'desc' == strtolower( $_REQUEST['order'] ) )
				$args['order'] = 'DESC';
		}

        $per_page     = $this->get_items_per_page( 'analytics_per_page', $per_page );
        $current_page = $this->get_pagenum();

		$total_items = $this->get_grid_data_count();
		$total_pages = ceil( $total_items / $per_page );
/**
		$this->set_pagination_args( array(
			'total_items' => $total_items,
			'total_pages' => $total_pages,
			'per_page' => $per_page ) );
**/
        $this->items = $this->get_grid_data( $total_items , 1);

	}

	function get_columns() {
        $columns = array(
                'campaign_column' => __( 'Campaign', 'local-app' ),
                'date_column' => __( 'Start Date', 'local-app' ),
                'apple_column' => __( 'iOS Scans', 'local-app' ),
                'android_column' => __( 'Android Scans', 'local-app' )
        );

        return $columns;

	}

	function get_sortable_columns() {
		$columns = array(
			'apple_column' => array( 'apple_column', true ) );

		return $columns;
	}

	function get_bulk_actions() {
		$actions = array();

		return $actions;
	}

	function column_default( $item, $column_name )
    {
        switch ($column_name) {
            case 'campaign_column':
            case 'apple_column':
            case 'android_column':
            case 'date_column':
                return $item[$column_name];
        }
    }

    function get_grid_data( $per_page , $current_page){

        //create items list
//delete_option('local-app-current-campaign-id');
		$options = get_option('local-app-current-campaign-id');
//print_r($options);
		if( ! $options) return array();

        $start = ($current_page * $per_page) - $per_page;
        $end = $start + $per_page;
        $current_item = 0;

        $items = array();

		foreach ($options as $index => $temp_array) {

            $go_to_url = str_replace('step=1','step=3',$_SERVER['REQUEST_URI']) . '&step=3&campaign='.$index;

            $items[] = array(
                'campaign_column' => '<strong><a href="'.$go_to_url.'">'.$temp_array['name'].'</a></strong>',
                'date_column' => $temp_array['start_date'],
                'apple_column' => $temp_array['apple'],
                'android_column' => $temp_array['android']
            );
			$current_item++;
		}

        return $items;
    }

	function get_grid_data_count(){

		$options = get_option('local-app-current-campaign-id');
		return sizeof($options);

	}

}