<?php
if (!class_exists('local_app_dashboard')) {

    require_once 'local-app-qrcode.php';
    require_once 'local-app-campaign-grid.php';


    class local_app_dashboard
    {

        function __construct()
        {


        }

        function local_app_setup_metrics_page()
        {

            $current = 'homepage';

            if (isset($_REQUEST['tab'])) $current = $_REQUEST['tab'];

            $html_line = '<div class="local-app-main-content-area">';

            switch ($current) {
                case 'homepage':
                    $html_line .= $this->local_app_metrics_homepage();
                    break;
                case 'campaigns':
                    $html_line .= $this->local_app_metrics_campaigns_page();
                    break;
                case 'support':
                    $html_line .= $this->local_app_metrics_support_page();
                    break;
            }

            $html_line .= '</div>';

            return $html_line;

        }

        public function local_app_metrics_support_page(){

            $html_line = '';

            if(!local_app_get_api_key()) {
                $html_line = '<table class="local-app-help-holder-main-publish-app">';
                $html_line .= '<tr><td colspan="4" align="right">' . tsl_publish_your_app_button('local-app-update-content-button') . '</td></tr>';
                $html_line .= '<tr><td colspan="4">&nbsp;</td></tr>';
                $html_line .= '</table>';
            }
            $html_line .= '<br>';

            $html_line .= '<div class="local-app-help-holder-main">';
            $html_line .= '<div class="local-app-help-holder-content-print"><a title="Print this page." onclick="local_app.print_help()" class="fa fa-print fa-3"></a></div>';
            $html_line .= '<div class="local-app-modal" style="display: none;"><div class="local-app-modal-icon"><span class="fa fa-refresh fa-spin fa-3x fa-fw"></span></div></div>';
//            $html_line .= '<table>';
//            $html_line .= '<tr><td class="local-app-help-holder-topics-col">';
            $html_line .= '<div class="local-app-help-holder-topics">';
            $html_line .= $this->local_app_get_help_content('topics');
            $html_line .= '</div>';
//            $html_line .= '</td><td>';
            $html_line .= '<div class="local-app-help-holder-content-info">';
            $html_line .= $this->local_app_get_help_content('info' , 0);
            $html_line .= '</div>';
//            $html_line .= '</td></tr>';
//            $html_line .= '</table>';

            $html_line .= '</div>';

            return $html_line;
        }

        public function local_app_get_help_content($type = 'topics' , $topic_id = null){

            $help_array = array();
            $help_array[] = array('topic' => 'Mobile App Manager' , 'type' => 'header', 'content' => $this->get_overview());
            $help_array[] = array('topic' => 'Getting Started' , 'type' => 'chapter', 'content' => $this->get_getting_started() );
            $help_array[] = array('topic' => 'Dashboard' , 'type' => 'header', 'content' => $this->get_dashboard());
            $help_array[] = array('topic' => 'App Metrics' , 'type' => 'chapter', 'content' => $this->get_app_metrics() );
            $help_array[] = array('topic' => 'QR Code Marketing' , 'type' => 'chapter', 'content' => $this->get_qr_code_campaigns() );
            $help_array[] = array('topic' => 'App Setup' , 'type' => 'header', 'content' => $this->get_app_setup() );
            $help_array[] = array('topic' => 'TSL Previewer App' , 'type' => 'chapter', 'content' => $this->get_app_setup_demo_app() );
            $help_array[] = array('topic' => 'Content' , 'type' => 'chapter', 'content' => $this->get_app_setup_content() );
            $help_array[] = array('topic' => 'GeoFilters' , 'type' => 'chapter', 'content' => $this->get_app_setup_geofilters() );
            $help_array[] = array('topic' => 'Images' , 'type' => 'chapter', 'content' => $this->get_app_setup_images() );
            $help_array[] = array('topic' => 'Member / Private Content' , 'type' => 'chapter', 'content' => $this->get_app_setup_private_content() );
//            $help_array[] = array('topic' => 'Member Card' , 'type' => 'chapter', 'content' => $this->get_app_setup_member_card() );

            $help_array[] = array('topic' => 'Submit App' , 'type' => 'header', 'content' => $this->get_submit_app() );
            $help_array[] = array('topic' => 'API Keys' , 'type' => 'chapter', 'content' => $this->get_submit_app_api_keys() );
            $help_array[] = array('topic' => 'Apple' , 'type' => 'chapter', 'content' => $this->get_submit_app_apple() );
            $help_array[] = array('topic' => 'Android' , 'type' => 'chapter', 'content' => $this->get_submit_app_android());
            $help_array[] = array('topic' => 'Smart Banner' , 'type' => 'header', 'content' => $this->get_smart_banner() );
            $help_array[] = array('topic' => 'Push Notifications' , 'type' => 'header', 'content' => $this->get_push_notifications() );
            $help_array[] = array('topic' => 'Contact TSL' , 'type' => 'header', 'content' => $this->contact_tsl() );

            if($type == 'topics'){
                $html_line = '';
                for($x=0;$x<sizeof($help_array);$x++){
                    $class = '';
                    if($x==0) $class = 'local-app-help-topic-item-active';
                    if($x == sizeof($help_array) - 1) $class = 'local-app-help-topic-item-last';
                    $html_line .= '<div onclick="local_app.get_help('.$x.');" id="local_app_help_topic_item_'.$x.'" class="local_app_help_topic_item '.$class.'"><span class="local_app_help_topic_'.$help_array[$x]['type'].'">' . $help_array[$x]['topic'] .'</a></div>';
                }
            }else{
                $html_line = $help_array[$topic_id]['content'];
                $html_line .= $this->print_footer();
            }

            return $html_line;

        }

        public function get_app_setup_member_card(){

            $html_line = '<p><span class="local-app-help-header">Member Card Setup</span></p>';

            return $html_line;

        }
        public function get_app_setup_private_content(){

            $html_line = '<p><span class="local-app-help-header">Member / Private Content Setup</span></p>';
            $html_line .= '<p><span class="local-app-help-text">There are several plugins that you can use to restrict some or all of your app content to subscribers or registered users. Note that only one plugin can be used for content management.</span></p>';


            $html_line .= '<ul style="list-style-type:disc;margin-left:2em;">';
            $html_line .= '<li><a href="https://wordpress.org/plugins/paid-memberships-pro/" target="_blank">Paid Memberships Pro</a></li>';
            $html_line .= '<li><a href="https://wordpress.org/plugins/s2member/" target="_blank">S2 Member</a></li>';
//            $html_line .= '<li><a href="https://wordpress.org/plugins/simple-membership/" target="_blank">Simple Membership</a></li>';
//            $html_line .= '<li><a href="https://wordpress.org/plugins/user-access-manager/" target="_blank">User Access Manager</a></li>';
//            $html_line .= '<li><a href="https://wordpress.org/plugins/users-ultra/" target="_blank">Users Ultra Membership Plugin</a></li>';
            $html_line .= '<li><a href="https://wordpress.org/plugins/wp-members/" target="_blank">WP-Members</a>&trade;</li>';
            $html_line .= '</ul><br>';

            if ( !function_exists('get_plugins') ){
                require_once( ABSPATH . '/wp-admin/includes/plugin.php' );
            }

            $html_line .= $this->member_content_pages_with_shortcodes();

            if( is_plugin_active( 'paid-memberships-pro/paid-memberships-pro.php' ) ) {
                $html_line .= $this->paid_memberships_pro();
            }

            if( is_plugin_active( 'wp-members/wp-members.php' ) ) {
                $html_line .= $this->wp_members();
            }

            if( is_plugin_active( 's2member/s2member.php' ) ) {
                $html_line .= $this->s2_members();
            }


            return $html_line;

        }

        public function get_app_setup_geofilters(){

            $html_line = '<p><span class="local-app-help-text"><strong>GeoFilters for Directory Listings</strong></span></p>';
            $html_line .= '<p><span class="local-app-help-text">GeoFilters limit the display of listings on the app to a specified area. You can set the default radius on the App Setup->Content page in the plugin.</p>';
            $html_line .= '<p><span class="local-app-help-text">When the user views directory listings with GeoFilters on, then the list of listsings are limited to those listings within the specified radius.  The user can change their filtered are on the app by changing the GeoFilter location on the app.</p>';
            $html_line .= '<p><span class="local-app-help-text">GeoFilter settings also apply to the maps and deals screens.</p>';

            $html_line .= '<br>';

            return $html_line;

        }

        public function member_content_pages_with_shortcodes(){

            $html_line = '<p><span class="local-app-help-text"><strong>Pages Created to Support Member / Private Content</strong></span></p>';
            $html_line .= '<p><span class="local-app-help-text">When one of the member content plugins that we support is installed, then we create two pages in your WordPress installation. You can edit these pages to provide messaging to your users, however, the shortcode that is automatically added to the page must remain somewhere on the page. These pages, and their [shortcodes] are:</span></p>';

            $html_line .= '<ul style="list-style-type:disc;margin-left:2em;">';
            $html_line .= '<li><strong>App Login Succcess Message</strong> [local-app-login-success] - when a user logs in from their mobile device the see this page before the app refreshed to include their content.</li>';
            $html_line .= '<li><strong>App Login Upgrade Message</strong> [local-app-login-upgrade] - if a user does not have privileges to view the content then they see an upgrade page.  For example, if a user is at the Basic level and the content is for Premium levels only, then they see an upgrade message that you create on this page.</li>';
            $html_line .= '</ul>';

            $html_line .= '<br>';

            return $html_line;

        }

        public function paid_memberships_pro(){

            $html_line = '<p><span class="local-app-help-text"><strong>Paid Memberships Pro</strong></span></p>';
            $html_line .= '<p><span class="local-app-help-text">You currently have Paid Membership Pro installed.  Below are the details about how content is managed using this plugin.</span></p>';
            $html_line .= '<ul style="list-style-type:disc;margin-left:2em;">';
            $html_line .= '<li>Content restriction settings are at the app button level. Individual pages and post settings are not used for mobile app content. You set access for a button to be available for all users or for each membership level that you have setup.</li>';
            $html_line .= '<li>Each button can be set to public or limited to one or more membership levels on the App->Setup->Paid Memberships Pro tab</li>';
            $html_line .= '<li>For restricted content. If a user is a registered user but they do not have access to the content due to their user level, then the app displays an upgrade required screen when they touch the button on their phone.</li>';
            $html_line .= '</ul>';

            $html_line .= '<br>';

            return $html_line;
        }

        public function wp_members(){

            $html_line = '<p><span class="local-app-help-text"><strong>WP-Members&trade;</strong></span></p>';
            $html_line .= '<p><span class="local-app-help-text">You currently have WP-Members&trade; installed.  Below are the details about how content is managed using this plugin.</span></p>';
            $html_line .= '<ul style="list-style-type:disc;margin-left:2em;">';
            $html_line .= '<li>Content restriction settings are at the app button level. Individual pages and post settings are not used for mobile app content. You set access for a button to be available for all users, registerd users or subscriber levels only.</li>';
            $html_line .= '<li>Access is limited to Public or Registered Users Only unless you use the <a href="http://rocketgeek.com/plugins/wp-members/extensions/wp-members-subscription-module-with-paypal-integration/" target="_blank">WP-Members&trade; PayPal Integration</a> to set trial membership and paid subscriber member access.</li>';
            $html_line .= '<li>Each button can be set to public, registered users only or subscribers only on the App->Setup->WP-Members&trade; tab</li>';
            $html_line .= '</ul>';

            $html_line .= '<br>';

            return $html_line;

        }

        public function s2_members(){

            $html_line = '<p><span class="local-app-help-text"><strong>S2 Member</strong></span></p>';
            $html_line .= '<p><span class="local-app-help-text">You currently have S2 Member installed.  Below are the details about how content is managed using this plugin.</span></p>';
            $html_line .= '<ul style="list-style-type:disc;margin-left:2em;">';
            $html_line .= '<li>Content restriction settings are at the app button level. Individual pages and post settings are not used for mobile app content. You set access for a button to be available for all users, registerd users or subscriber levels only.</li>';
            $html_line .= '<li>Each button can be set to public, registered users only or subscribers only on the App->Setup->S2 Member tab</li>';
            $html_line .= '<li>For restricted content. If a user is a registered user but they do not have access to the content due to their user level, then the app displays an upgrade required screen when they touch the button on their phone.</li>';
            $html_line .= '</ul>';

            $html_line .= '<br>';

            return $html_line;

        }

        public function contact_tsl(){

            $current_user = wp_get_current_user();
            $email_address = $current_user->user_email;

            $html_line = '<p><span class="local-app-help-header">Contact Tiny Screen Labs for Help, Support or to Request a New Feature</span></p>';
            $html_line .= '<p><span class="local-app-help-text">Contact us via email at <a href=mailto:info@tinyscreenlabs.com">info@tinyscreenlabs.com</a></span></p>';
            $html_line .= '<p><span class="local-app-help-text">Or send us a message and we will get back to you</span></p>';
            $html_line .= '<table>';
            $html_line .= '<tr><td style="padding-right: 40px;"><strong>Email Address:</strong></td><td><input type="text" id="tsl_contact_form_email" value="'.$email_address.'" style="width:300px"/></td></tr>';
            $html_line .= '<tr><td><strong>Subject:</strong></td><td><input type="text" id="tsl_contact_form_subject" style="width:300px"/></td></tr>';
            $html_line .= '<tr><td><strong>Message:</strong></td><td><textarea rows="6" id="tsl_contact_form_message" style="width:300px"></textarea></td></tr>';
            $html_line .= '<tr><td>&nbsp;</td><td><a style="float:right;" onclick="local_app.send_feedback();" class="button-primary" >Submit</a></td></tr>';
            $html_line .= '<tr><td colspan="2"><span class="tsl_message_confirmation local-app-hide">Message Sent</span></td>';
            $html_line .= '</table>';

            return $html_line;
        }

        public function print_footer(){

            $html_line = '<div class="tsl-print-footer"><br><br><br><br><br><br>Tiny Screen Labs, LLC is located in Chicago.  We help people use WordPress to create and manage mobile apps for iPhone and Android.  Visit us at tinyscreenlabs.com.</div>';

            return $html_line;
        }

        public function get_overview(){

            $html_line = '<p><span class="local-app-help-header">Mobile App Manager Overview</span></p>';
            $html_line .= '<p><span class="local-app-help-text">TSL Mobile App Manager is a WordPress plugin and cloud based service, which means that you can design a mobile app and complete the submission process right inside your WordPress dashboard.</span></p>';
            $html_line .= '<p><span class="local-app-help-text">TSL Mobile App Manager has the features you’ll need to use your WordPress content to design and customize your mobile app. Preview your design on the TSL Previewer App Previewer, available for download on both Google and Apple smartphones. </span></p>';

            $html_line .= '<ul style="list-style-type:disc;margin-left:2em;">';
            $html_line .= '<li>WordPress administrators have the ability to manage content for their website and mobile apps in one place</li>';
            $html_line .= '<li>App Setup is a drag and drop interface where you design your mobile app before you purchase a TSL Plan</li>';
            $html_line .= '<li>The TSL Previewer App is a WYSIWYG viewer that connects to your website </li>';
            $html_line .= '<li>Updates to app page content are automatic</li>';
            $html_line .= '<li>TSL publishes your app when you purchase the TSL Plan</li>';
            $html_line .= '</ul>';

            $html_line .= '<p><span class="local-app-help-text">You start paying when you subscribe to the TSL Plan to publish your app. Purchase the TSL Plan to have your app available in the app stores for download. For more information go to the Tiny Screen Labs (TSL) website.</span></p>';

            $html_line .= '<ul style="list-style-type:disc;margin-left:2em;">';
            $html_line .= '<li>TSL handles publishing under our developer license. No developer account required</li>';
            $html_line .= '<li>TSL will provide the tools to make it easy to manage the submission process</li>';
            $html_line .= '<li>You complete the submission forms and we handle the rest. (Must adhere to the policies and terms of service for each store) </li>';
            $html_line .= '<li>There is no TSL logo branding and all apps are white label, meaning your logo only</li>';
            $html_line .= '<li>There are no additional hosting costs</li>';
            $html_line .= '<li>There are no ads</li>';
            $html_line .= '</ul>';

            return $html_line;
        }

        private function get_push_notifications(){

            $html_line = '<p><span class="local-app-help-header">Push Notifications</span></p>';
            $html_line .= '<p><span class="local-app-help-text">The TSL Mobile App enables push notifications to be sent from published pages, posts, listings, as well as the Push Notification tab in Mobile App Manager.</span></p>';
            $html_line .= '<p><span class="local-app-help-text"><strong>Pages, Posts, Directory Listings</strong></span></p>';
            $html_line .= '<p><span class="local-app-help-text">The Mobile App Notifications metabox appears on the WordPress page, post or directory listing just above the Publish metabox and only after the status changes to published.</span></p>';
            $html_line .= '<p><span class="local-app-help-text"><strong>Mobile App Manager - Push Notifications Tab</strong></span></p>';
            $html_line .= '<p><span class="local-app-help-text"><strong>Notifications that you Schedule or Send Now </strong></span></p>';
            $html_line .= '<p><span class="local-app-help-text">Messages you send can go now or you can schedule them for a future day and time. Set the date and time then press Send. The notification timezone setting is the same as your website timezone setting.</span></p>';
            $html_line .= '<p><span class="local-app-help-text"><strong>Message History Log</strong></span></p>';
            $html_line .= '<p><span class="local-app-help-text">A list of all sent or pending messages can be found under the Push Notifications Page in History and Metrics. History shows message summary, date sent, author and app page as target link. The number of users who have opted in for notifications by type of mobile device, either iOS or Android.</span></p>';

            return $html_line;

        }

        private function get_dashboard(){

            $html_line = '<p><span class="local-app-help-header">Dashboard</span></p>';
            $html_line .= '<p><span class="local-app-help-text">The Dashboard provides you with metrics separately for iOS and Android mobile apps. Data becomes visible when you purchase the TSL Plan. </span></p>';
            $html_line .= '<p><span class="local-app-help-text"><strong>App Metrics:</strong> Data is provided for mobile apps that are submitted, approved and published under the TSL Plan. Get updates on the status of your app in the app store, total number of users and completed scans for each QR code campaign.</span></p>';
            $html_line .= '<p><span class="local-app-help-text"><strong>QR Code Marketing:</strong> Generate more users by adding QR codes to marketing campaigns. Our QR Code Marketing tool includes a QR Code generator and campaign manager.</span></p>';


            return $html_line;

        }

        private function get_app_metrics(){

            $html_line = '<p><span class="local-app-help-header">App Metrics</span></p>';
            $html_line .= '<p><span class="local-app-help-text">Metrics are reported separately for iOS and Android. Data is provided for mobile apps that are submitted, approved and published under the TSL Plan. Metrics include:</span></p>';
            $html_line .= '<p><span class="local-app-help-text"><strong>App Store Status:</strong> This is the published status and will be provided only after you purchase the subscription plan and submit the application to TSL. Your status will change from “Not published yet” to “Published” A notification email will also alert you to App Store Status updates.</span></p>';
            $html_line .= '<p><span class="local-app-help-text"><strong>App Installs:</strong> Apple and Google report your total installs for your mobile app. The number of installs is updated daily. </span></p>';
            $html_line .= '<p><span class="local-app-help-text"><strong>QR Code Scans:</strong> This is the total number of scans completed. You must generate the QR code and add it to your marketing campaign. Use it in email, print or online marketing campaigns.</span></p>';

            return $html_line;
        }

        private function get_qr_code_campaigns(){

            $html_line = '<p><span class="local-app-help-header">QR Code Marketing</span><p>';
            $html_line .= '<p><span class="local-app-help-text">QR Code Marketing includes a QR Code generator and campaign manager. Each QR code you generate is unique and allows you to track the number of scans for each campaign.</span></p>';
            $html_line .= '<p><span class="local-app-help-text">When a user scans the code they will see your app page where they can install the app on their phone. Scans are directed to the app store based on the users phone type and works for both Android or iOS. </span></p>';

            return $html_line;
        }

        private function get_app_setup(){

            $html_line = '<p><span class="local-app-help-header">App Setup</span><p>';
            $html_line .= '<p><span class="local-app-help-text">The App Setup features a drag-and-drop interface to design your mobile app. Use the tools to format, preview and update your mobile app.  The TSL Mobile App Manager extends WordPress to manage content for your website and mobile app.</span></p>';
            $html_line .= '<p><span class="local-app-help-text"><strong>Format</strong> content and design such as app pages, global settings, background, home page layout and icons.  </span></p>';
//            $html_line .= '<p><span class="local-app-help-text"><strong>Update</strong> your mobile app with a new design. Edit your design then click the Push to App button to update the app when you chose to.  </span></p>';
            $html_line .= '<p><span class="local-app-help-text">Preview your app with the <strong>TSL Previewer App</strong>, which is available on iTunes and Google Play. When you click the “Preview in Phone” button on the App Setup page, we will send you an email with a link to these apps along with a link to load your data into the TSL Previewer App. You can also use this app to preview changes before you make updates to a published mobile app. </span></p>';

//            $html_line .= '<p><img style="max-width:100%" class="gifplayer" src=" https://tinyscreenlabs.com/wp-content/plugins/tsl-traffic-manager/images/appsetup.gif" /></p>';

            return $html_line;
        }

        private function get_app_setup_demo_app(){

            $html_line = '<p><span class="local-app-help-header">TSL Previewer App</span><p>';
            $html_line .= '<p><span class="local-app-help-text">Installing the TSL Previewer App, available in iTunes and Google Play.  The TSL Previewer App enables you to preview the design and content of your mobile app before it is published. When you click the “Preview in Phone” button on the App Setup page, we will send you an email with a link to these apps along with a link to load your data into the TSL Previewer App.</span></p>';
            $html_line .= '<p><span class="local-app-help-text"><strong>The TSL Previewer App can be installed on multiple phones.</strong> Share the TSL Previewer App with your team members, customers and developers. For directory listings, a subset consisting of up to 15 listings for each button is displayed. All of the listings are displayed in a published app. </span></p>';
            $html_line .= '<p><span class="local-app-help-text">To share the TSL Previewer App, go to App Setup > click Preview On Your Phone > add the email address. Your email message includes instructions to install the app and get data for your website. </span></p>';

            return $html_line;

        }

        private function get_app_setup_content(){

            $html_line = '<p><span class="local-app-help-header">Content Management</span><p>';
            $html_line .= '<p><span class="local-app-help-text">Using the drag-and-drop interface, select the content from the dropdown list on each icon bar. Up to 12 icons can be added to the home page. Anytime content is updated, it is automatically updated in the TSL Previewer App.  After you purchase a TSL Plan, your app will be updated each time you click the "Push to App" button.  This lets you preview changes using the TSL Previewer App before you publish them on your app.</span></p>';

            $html_line .= '<p><span class="local-app-help-text">Use the <strong>Plus</strong> button to add an <strong>Icon Bar</strong>. The type of content available includes:</span></p>';

            $html_line .= '<ul style="list-style-type:disc;margin-left:2em;">';
            $html_line .= '<li><strong>Directory categories and sub categories</strong> will show you a list of all the post types you created. For example, Restaurants, Shopping and Attractions. You can add content from the <a href="https://wordpress.org/plugins/business-directory-plugin/" target="_blank">Business Directory</a>, <a href="https://wordpress.org/plugins/chamber-dashboard-business-directory/" target="_blank">Chamber Dashboard</a>, <a href="https://wordpress.org/plugins/connections/" target="_blank">Connections Directory</a> or <a href="https://wordpress.org/plugins/geodirectory/" target="_blank">GeoDirectory</a> plugins.</li>';
            $html_line .= '<li><strong>Events and Event Calendar</strong> will show you a list of all the events you created. You can add a list of events or an events calendar (or both). You can add content from the <a href="https://wpgeodirectory.com/downloads/events/" target="_blank">GeoDirectory Events</a>, <a href="https://wordpress.org/plugins/the-events-calendar/" target="_blank">The Events Calendar</a>, <a href="https://wordpress.org/plugins/all-in-one-event-calendar/" target="_blank">All In One Event Calendar</a>, <a href="https://wordpress.org/plugins/my-calendar/" target="_blank">My Calendar</a> or <a href="https://wordpress.org/plugins/events-manager/" target="_blank">Events Manager</a> plugins.</li>';
            $html_line .= '<li><strong>Favorites</strong> adds a button on the app to enable the user to access a list of all of the listings that they have favorited in the app. If you do not add a button, then the Favorites button will appear on the bottom toolbar in the app.</li>';
            $html_line .= '<li><strong>Special Offers and Deals</strong> you can add a list of deals to the mobile app when you use the free <a href="https://wordpress.org/plugins/geodeals-for-geodirectory/" target="_blank">GeoDeals plugin</a> or <a href="https://wordpress.org/plugins/connections-business-directory-offers/" target="_blank">Connections Offers</a>. If you do not add a button, then the Deals button will appear on the bottom toolbar in the app</li>';
            $html_line .= '<li><strong>Web URL</strong> to enter a web address to display a web page in the app, for example, https://metrarail.com or http://www.deutschebahn.com, to provide access to train scheduled in Chicago or Germany.</li>';
            $html_line .= '<li><strong>Map</strong> creates a map view of all of your directory listings, which arde filterable by catagory and subcatagory.</li>';
            $html_line .= '<li><strong>WordPress Pages</strong> will show you a list of your website pages. For example, About Us, Blog, Home Page. </li>';
            $html_line .= '<li><strong>WordPress Post Content</strong> will show you a list of your WordPress posts. You can then choose one post to be assigned as content for the the button. </li>';
            $html_line .= '<li><strong>WordPress Post Category</strong> will show posts that are in the specified category.  On the app, unread posts are indicated as a badge on the button and are highlighted in the listsing of posts when the user touches the button.</li>';
            $html_line .= '</ul>';

            $html_line .= '<p><span class="local-app-help-text"></span></p>';

            return $html_line;
        }

        private function get_app_setup_images(){

            $html_line = '<p><span class="local-app-help-header">Image Management</span><p>';
            $html_line .= '<p><span class="local-app-help-text">Images give your mobile app a unique identity.  You can use the default white background, select from the TSL image library or upload your own. </span></p>';

            $html_line .= '<p><span class="local-app-help-text">The Mobile App Manager provides a set of images that can be used for backgrounds, splash screens, placeholders and icons. You can also upload your own images into the media library.  Just click any image to open the image library.</span></p>';

            return $html_line;
        }


        private function get_submit_app(){

            $html_line = '<p><span class="local-app-help-header">Submit your App to iTunes and Google Play</span><p>';
            $html_line .= '<p><span class="local-app-help-text">You will need to use the TSL Plan to get your mobile app published in the app stores for both iTunes and Google Play. Your mobile app gets submitted under the TSL Developer Account.  With the subscription plan you get access to an automated publishing platform with only an application form to complete for Apple and Google. TSL manages the rest of the process after you publish the forms. Approval usually occurs within 1 to 2 days. Notifications by email update with regard to status including approval and declines. Declined apps will usually include problem and fix.</span></p>';
            $html_line .= '<p><span class="local-app-help-text">Purchase the TSL Plan then enable your account by entering your unique API key in the Mobile App Manager. The API key is valid for one WordPress website and mobile app. Your API keys are delivered to you after you purchase and can be found in the email receipt. The API keys can also be found when you login to your account located on <a href="'.TSL_AFF_URL.'"  target="_blank">tinyscreenlabs.com</a>.</span></p>';
            $html_line .= '<p><span class="local-app-help-text">Your API key is good for one install. You can move the API key to another WordPress install, however, if you have an app but no API key, it will no longer get data updates and will be removed from the store in four weeks.</span></p>';

            return $html_line;
        }


        private function get_submit_app_apple(){

            $html_line = '<p><span class="local-app-help-header">Submit to iTunes</span><p>';
            $html_line .= '<p><span class="local-app-help-text">What happens after you complete your mobile app design?</span></p>';
            $html_line .= '<p><span class="local-app-help-text">You will submit the mobile app to TSL by completing all the required information for an Apple application. It is recommended that you submit the last design that you completed and previewed on the TSL Previewer App. </span></p>';
            $html_line .= '<p><span class="local-app-help-text">TSL manages the process for creating all the metadata and screenshots for your app so that you don’t have to develop this information. All that is required from you is the completion of the store listing application. </span></p>';
            $html_line .= '<p><span class="local-app-help-text">TSL prepares your app for submission and manages the process to:</span><ol><li>Verify your project</li><li>Upload your app listing</li><li>Submit your app for review</li><li>Notify you when your app is released in the store</li></ol></p>';
            $html_line .= '<p><span class="local-app-help-text">After the app is submitted, TSL will contact you when it is approved or rejected. If it is rejected, they will describe what is wrong. You fix the issue and notify us of the update. We will resubmit the project and wait for review. When the mobile app is ready for release, you can search for your app on the App Store, and celebrate!</span></p>';
            $html_line .= '<p><span class="local-app-help-text">Program Guidelines</span></p>';
            $html_line .= '<p><span class="local-app-help-text"><a href="https://developer.apple.com/library/content/documentation/iPhone/Conceptual/iPhoneOSProgrammingGuide/Introduction/Introduction.html#//apple_ref/doc/uid/TP40007072" target="_blank">App Guide</a></span></p>';
            $html_line .= '<p><span class="local-app-help-text"><a href="https://developer.apple.com/app-store/review/guidelines/" target="_blank">App Store Guide</a></span></p>';

            return $html_line;
        }

        private function get_submit_app_android(){

            $html_line = '<p><span class="local-app-help-header">Submit to Android</span><p>';
            $html_line .= '<p><span class="local-app-help-text">What happens after you complete your mobile app design?</span></p>';
            $html_line .= '<p><span class="local-app-help-text">You will submit the mobile app to TSL by completing all the required information for an Android application. It is recommended that you submit the last design that you completed and previewed on the TSL Previewer App.</span></p>';
            $html_line .= '<p><span class="local-app-help-text">TSL manages the process for creating all the metadata and screenshots about your app so that you don’t have to develop this information. All that is required from you is the completion of the store listing application.</span></p>';
            $html_line .= '<p><span class="local-app-help-text"></span></p>';
            $html_line .= '<p><span class="local-app-help-text">Program Guidelines</span></p>';
            $html_line .= '<p><span class="local-app-help-text"><a href="https://support.google.com/googleplay/android-developer/answer/188189" target="_blank">Content Ratings Guide</a></span></p>';
            $html_line .= '<p><span class="local-app-help-text"><a href="https://play.google.com/about/developer-content-policy/" target="_blank">Content Policy</a></span></p>';
            return $html_line;
        }

        private function get_submit_app_api_keys(){

            $html_line = '<p><span class="local-app-help-header">API Keys</span><p>';
            $html_line .= '<p><span class="local-app-help-text">You will need an API key, available upon purchase of the TSL Plan, to activate your TSL account. The API key is valid for one WordPress install and mobile app. Get your TSL Plan on <a href="'.TSL_AFF_URL.'" target="_blank">tinyscreenlabs.com</a>.</span></p>';
            $html_line .= '<p><span class="local-app-help-text"><strong>Enter Your API Key:</strong> Purchase the TSL Plan and enter your unique API key in the Mobile App Manager under Submit App tab. This will activate your TSL account and enable you to use the TSL service to publish your app on the app stores for both iOS and Android.</span></p>';
            $html_line .= '<p><span class="local-app-help-text"><strong>Find Your API Key:</strong> Your API keys can be found in the email receipt for the TSL Plan purchase. They are also located when you login to your account located on <a href="'.TSL_AFF_URL.'"  target="_blank">tinyscreenlabs.com</a>.</span></p>';
            $html_line .= '<p><span class="local-app-help-text"><strong>API Key Renewal:</strong> Your API key is valid for one year with purchase of the TSL Plan. Renew the plan each year to validate your license. </span></p>';
            $html_line .= '<p><span class="local-app-help-text"><strong>1 API Key for 1 WordPress Install:</strong> You can use it in one install or move the API key to another WordPress install. However, if you have an app but no API key, then it will no longer get updates. The app store will remove the app within four weeks. </span></p>';


            return $html_line;
        }

        private function get_getting_started(){

            global $tsl_local_app_image_url;

            $html_line = '<p><span class="local-app-help-header">Getting Started</span><p>';
            $html_line .= '<p><span class="local-app-help-text">Use this getting started guide to learn how to setup your mobile app with TSL Mobile App Manager.</span></p>';
            $html_line .= '<p><span class="local-app-help-text"><img class="local-app-help-image" src="'.$tsl_local_app_image_url . "/images/getting_started.png".'"></span></p>';
            $html_line .= '<p><span class="local-app-help-text"><strong>Install the TSL Previewer App:</strong> You can get started by installing the TSL Previewer App to preview the app on your phone. You can see it live using TSL demo data. If your website is ready, then you can also connect to your data. Get the TSL Previewer App via email.</span></p>';
            $html_line .= '<p><span class="local-app-help-text"><strong>Design Your Home Page:</strong> The app setup features a drag-and-drop interface to design your mobile app. Design app page content, edit icons and images.</span></p>';
            $html_line .= '<p><span class="local-app-help-text"><strong>Home Page Layout:</strong> The home page includes a place for your logo and up to 12 icons. Use the TSL Icon library or upload your own icons. Global settings manage text visibility, font styles and status bar color.</span></p>';
            $html_line .= '<p><span class="local-app-help-text"><strong>App Page Content:</strong> Select up to 12 different content categories for your mobile app. The TSL Mobile App Manager uses WordPress content to update your app in real-time. <ol><li> Use WordPress pages and posts as app pages, such as About Us.</li><li>Select a web URL to be display a web page, such as a train scheduled from a regional rail website.</li><li>Select directory categories or subcategories. From the <a href="https://wordpress.org/plugins/business-directory-plugin/" target="_blank">Business Directory</a>, <a href="https://wordpress.org/plugins/chamber-dashboard-business-directory/" target="_blank">Chamber Dashboard</a>, <a href="https://wordpress.org/plugins/connections/" target="_blank">Connections Directory</a> or <a href="https://wordpress.org/plugins/geodirectory/" target="_blank">GeoDirectory</a> plugins. </li><li>Favorites List - users can favorite a listing and their selected listings appear in Favorites.</li><li>Deals & Special Offers - (requires the <a href="https://wordpress.org/plugins/geodeals-for-geodirectory/" target="_blank">GeoDeals plugin</a>) - all the listings with special deals appear in Deals. </li><li>Map - adds a map for directions.</li></ol></span></p>';
            $html_line .= '<p><span class="local-app-help-text"><strong>Images:</strong> The TSL Image Library includes images that are formatted for both iOS and Android screens. Select from the supplied images or upload your own. </span></p>';
            $html_line .= '<p><span class="local-app-help-text"><strong>Publish your app on ITunes and Google Play:</strong> Get your app published by subscribing to the TSL Plan. Our plan includes everything you need to submit your application. We handle the rest.</span></p>';
            $html_line .= '<p><span class="local-app-help-text">You can design and preview your app and publish it when you are ready to launch. The TSL Plan gives you access to the application when you activate your API key. The TSL Plan is billed monthly or annually and the cost to renew is half the first year’s subscription price.</span></p>';
            $html_line .= '<p><span class="local-app-help-text">Enter the app information in the Apple and Android Forms then click Publish. TSL will manage the rest, including communications, files, certificates and screenshots. TSL will notify you when your mobile app is approved. If declined, you will be notified of the changes needed for approval. Approvals typically take up to 2 days. </span></p>';

            return $html_line;
        }

        private function get_smart_banner(){

            global $tsl_local_app_image_url;

            $html_line = '<p><span class="local-app-help-header">Smart Banner</span><p>';
            $html_line .= '<p><span class="local-app-help-text">The Smart Banner is a feature that provides a banner on your website for users on mobile devices.  The banner tells them how to open the native app or install it if they don’t have it yet. The link includes all the features to open if installed or go to the app store page if not. For new users, this banner provides an easy way for people to chose to use your mobile website as well as encouraging users to install the app.</span></p>';
            $html_line .= '<p>&nbsp;</p>';
            $html_line .= '<div class="local-app-help-smartbanner-image">';
            $html_line .= '<img style="border:solid 1px black;max-width:25em;" src="' . $tsl_local_app_image_url .'/images/smartbanner_2x.png">';
            $html_line .= '<p>Example Smart Banner</p>';
            $html_line .= '</div>';

            return $html_line;
        }

        public function local_app_metrics_homepage(){

            $html_line = '';

            if(!local_app_get_api_key()) {
                $publish_button =  tsl_publish_your_app_button('local-app-update-content-button');
                $html_line .= '<div class="local-app-content-width-info">';
                $html_line .= '<table style="width:100%">';
                $html_line .= '<tr><td align="right">' . $publish_button . '</td></tr>';
                $html_line .= '<tr><td>&nbsp;</td></tr>';
                $html_line .= '</table>';
                $html_line .= '</div>';

            }

            if(!local_app_get_api_key()) $html_line .= '<div class="local-app-content-width-info"><p class="local-app-smart-banner-text">' . local_app_get_lang('app-metrics-purchase-message') . '</p><hr></div>';

            $appleStatus =      get_option( 'local_app_apple_status' );
            $appleInstalls =    get_option( 'local_app_apple_installs' );
            $androidStatus =    get_option( 'local_app_android_status' );
            $androidInstalls =  get_option( 'local_app_android_installs' );

            global $wpdb;
            $table_name = $wpdb->prefix . 'local_app_scans';
            $result = $wpdb->get_results("SELECT * FROM $table_name WHERE os_type = 'iOS'");
            $appleQRScans = sizeof($result);
            $result = $wpdb->get_results("SELECT * FROM $table_name WHERE os_type = 'Android'");
            $androidQRScans = sizeof($result);

            if(empty($appleStatus))     $appleStatus     = 'Not published yet';
            if(empty($androidStatus))   $androidStatus   = 'Not published yet';
            if(empty($appleInstalls))   $appleInstalls   = '0';
            if(empty($androidInstalls)) $androidInstalls = '0';

            $html_line .= '<div class="local-app-content-width-info"><h3>'.local_app_get_lang('app-metrics-headline').'</h3></div>';

            $html_line .= '<div class="local-app-grid-holder local-app-grey-border local-app-content-margin-small">';
            $html_line .= '<table>';
            $html_line .= '<tr>';
            $html_line .= '<td><h3>iOS App</h3>&nbsp;&nbsp;</td><td style="padding-bottom:1em;">' . $appleStatus . '<br></td>';
            $html_line .= '</tr>';
            $html_line .= '<tr>';
            $html_line .= '<td><span class="local-app-medium-bold" title="'.local_app_get_qtip_message('apple_install_message').'">'.local_app_get_lang('app-metrics-app-installs').'&nbsp;<span class="local-app-help-button fa fa-question-circle"></span></span></td><td style="text-align:right"> ' . $appleInstalls . '</td>';
            $html_line .= '</tr>';
            $html_line .= '<tr>';
            $html_line .= '<td><span class="local-app-medium-bold" title="'.local_app_get_qtip_message('qr_scans_message').'">'.local_app_get_lang('app-metrics-qr-code-scans').'&nbsp;<span class="local-app-help-button fa fa-question-circle"></span> </span></td><td style="text-align:right">' . $appleQRScans . '</td>';
            $html_line .= '</tr>';
            $html_line .= '</table>';
            $html_line .= '</div>';

            $html_line .= '<br>';

            $html_line .= '<div class="local-app-grid-holder local-app-grey-border  local-app-content-margin-small">';
            $html_line .= '<table>';
            $html_line .= '<tr>';
            $html_line .= '<td><h3>Android App</h3>&nbsp;&nbsp;</td><td style="padding-bottom:1em;">' . $androidStatus . '<br></td>';
            $html_line .= '</tr>';
            $html_line .= '<tr>';
            $html_line .= '<td><span class="local-app-medium-bold" title="'.local_app_get_qtip_message('android_install_message').'">'.local_app_get_lang('app-metrics-app-installs').'&nbsp;<span class="local-app-help-button fa fa-question-circle"></span>  </span></td><td style="text-align:right">' . $androidInstalls . '</td>';
            $html_line .= '</tr>';
            $html_line .= '<tr>';
            $html_line .= '<td><span class="local-app-medium-bold" title="'.local_app_get_qtip_message('qr_scans_message').'">'.local_app_get_lang('app-metrics-qr-code-scans').'&nbsp;<span class="local-app-help-button fa fa-question-circle"></span> </span></td><td style="text-align:right">' . $androidQRScans . '</td>';
            $html_line .= '</tr>';
            $html_line .= '</table>';
            $html_line .= '</div>';


            $html_line .= '</div>';

            return $html_line;

        }

        public function local_app_metrics_campaigns_page()
        {

            $step = 1;
            if (isset($_REQUEST['step'])) $step = $_REQUEST['step'];

            $no_internet = '';

            if(!local_app_is_connected_to_internet()){
                $no_internet = '<p>'.local_app_get_lang('local-app-not-vis-qr-code').'</p>';
            }

            $html_line = '';

            switch ($step) {
                case '1':
                    $publish_button =  tsl_publish_your_app_button('local-app-update-content-button');
                    $no_published_apps = '<div><p class="local-app-smart-banner-text">Your app is not yet published. Once you publish your app this page will provide metrics for QR Code scan activity. In the meantime, you can checkout the functionality for creating QR Code marketing campaigns.</p></div>';
                    $appleStatus =      get_option( 'local_app_apple_status' );
                    $androidStatus =    get_option( 'local_app_android_status' );
                    if($appleStatus == 'Published' || $androidStatus == 'Published'){
                    $no_published_apps = '';
                    }

                    $button = '<a style="margin-left:2em;" class="button-primary" href="' . $_SERVER['REQUEST_URI'] . '&step=2">Add QR Code Campaign</a>';

                    $html_line .= '<div class="local-app-grid-column">
                                '.$no_internet;

                    $html_line .= '<table class="local-app-help-holder-main-publish-app">';

                    if(!local_app_get_api_key()) {
                        $html_line .= '<tr><td><div class="local-app-grid-column-header local-app-div-inline" >Campaign Activity&nbsp;&nbsp;<span title="' . local_app_get_qtip_message('campaign_message') . '" class="local-app-help-button fa fa-question-circle"></span></div><td align="right">' . $button . '</td><td align="right">' . $publish_button . '</td></tr>';
                    }else{
                        $html_line .= '<tr><td><div class="local-app-grid-column-header local-app-div-inline" >Campaign Activity&nbsp;&nbsp;<span title="' . local_app_get_qtip_message('campaign_message') . '" class="local-app-help-button fa fa-question-circle"></span></div><td align="right" colspan="2">'.$button.'</td></tr>';
                    }
                    $html_line .= '<tr><td colspan="3">&nbsp;</td></tr>';
                    $html_line .= '</table>
                                <p class="local-app-smart-banner-text">The QR Code generator creates a qr code that links to the app store and your mobile app page when scanned.</p>
                                <p  class="local-app-smart-banner-text"> ' .$no_published_apps.'</p>
                                <div class="local-app-grid-column-inner">' . $this->local_app_create_campaign_grid() . '</div>
                          </div>';
                    break;
                case '2':
                    $options = get_option('local-app-current-campaign-id');
                    $current_campaign_id = 1;
                    if($options) {
                        foreach ($options as $index => $value) {
                            $current_campaign_id = max($current_campaign_id, $index);
                        }
                    $current_campaign_id++;
                    }
                    $html_line .= $this->local_app_show_campaign($current_campaign_id, '', false);
                    $go_to_url = str_replace('step=2', 'step=3', $_SERVER['REQUEST_URI']) . '&campaign=' . $current_campaign_id;
                    $cancel_to_url = str_replace('&step=2', '', $_SERVER['REQUEST_URI']) ;
                    $html_line .= '<div class="local-app-campaign-button-div"><a style="float:right;margin-right:.5em;" href="' . $cancel_to_url . '" class="button-primary" >Cancel</a>&nbsp;&nbsp;<a id="local-app-campaign-save-button-div" style="float:right;margin-right:.5em;"  onclick="local_app.save_campaign()"  class="button-primary" >Save</a></div>&nbsp;&nbsp;';
                    $html_line .= '<input type="hidden" id="local-app-campaign-root-url" value="' . $go_to_url . '">';
                    break;
                case '3':
                    $options = get_option('local-app-current-campaign-id');
                    if ($options) {

                        global $wpdb;
                        $table_name = $wpdb->prefix . 'local_app_scans';

                        $stats = $wpdb->get_results("SELECT * FROM $table_name WHERE campaign = " . $_REQUEST['campaign'] . " ORDER BY scan_date ASC", ARRAY_A);
                        $scan_array = array();
                        $label_array = array();
                        $scans = array();
                        $has_date = null;
                        $has_scans = false;

                        foreach ($stats as $value) {
                            if(!$has_date) $has_date = substr($value['scan_date'], 0, 10);
                            $scan_array[strtolower($value['os_type'])][substr($value['scan_date'], 0, 10)]++;
                        }
                        if($has_date) {
                            $start_date = new DateTime($has_date);
                            $date_now = new DateTime();
                            while($start_date < $date_now ){
                                if(!$scan_array['ios'][$start_date->format('Y-m-d')]){
                                    $scan_array['ios'][$start_date->format('Y-m-d')] = 0;
                                }
                                if(!$scan_array['android'][$start_date->format('Y-m-d')]){
                                    $scan_array['android'][$start_date->format('Y-m-d')] = 0;
                                }
                                $scans['ios'][] = $scan_array['ios'][$start_date->format('Y-m-d')];
                                $scans['android'][] = $scan_array['android'][$start_date->format('Y-m-d')];
                                $label_array[] = '';
                                $has_scans = true;

                                $start_date->add(new DateInterval('P1D'));
                            }
                        }
                        $params['scan_data'] = $scans;
                        $params['labels'] = $label_array;

                        wp_localize_script('localapp', 'local_app_params', $params);

                        $html_line .= '<div class="local-app-campaign-details">';
                        $go_to_url = str_replace('step=3', 'step=1', $_SERVER['REQUEST_URI']);
                        $html_line .= $this->local_app_show_campaign($_REQUEST['campaign'], $options[$_REQUEST['campaign']]['name']);

                        if(!$has_scans) $delete_button = '<a id="local-app-campaign-delete-button-div" style="float:right;margin-right:.5em;"  onclick="local_app.delete_campaign()"  class="button-secondary" >Delete</a>&nbsp;&nbsp;';

                        $html_line .= '<div class="local-app-campaign-button-div">'.$delete_button.'<a style="float:right;margin-right:.5em;" href="' . $go_to_url . '" class="button-primary" >Back</a>&nbsp;&nbsp;<a id="local-app-campaign-save-button-div" style="float:right;margin-right:.5em;"  onclick="local_app.save_campaign()"  class="button-primary" >Save</a></div>';
                        $html_line .= '<input type="hidden" id="local-app-campaign-root-url" value="' . $go_to_url . '">';
                        $html_line .= '</div>';
                        $html_line .= '<div class="local-app-campaign-details">';
                        $html_line .= '<div class="local-app-qr-code-campaign-header">';
                        $html_line .= '<br><p><h3>QR Code Scan History for this Campaign</h3></p><br>';
                        if (sizeof($scan_array) > 0) {
                            $html_line .= '<div ><canvas id="local-app-scan-chart" width="400" height="200" ></canvas></div>';
                        } else {
                            $html_line .= 'No scans yet for this campaign';
                        }
                        if($has_date){
                            $date = date_create($has_date);
                            $has_date = date_format($date,"M d, Y");
                            $html_line .= '<div style="width:100%;text-align:center;">Daily scans from ' . $has_date . ' to present</div>';
                        }else {
//                            $html_line .= '<div style="width:100%;text-align:center;">No scans yet for this campaign</div>';
                        }
                        $html_line .= '<br><br><div id="local-app-legend" class="chart-legend"><table><tr><td class="local-app-scan-cell-title">iOS Scans</td><td class="local-app-ios-cell"></td></tr><tr><td class="local-app-scan-cell-title">Android Scans</td><td class="local-app-android-cell"></td></tr></table></div>';
                        $html_line .= '</div>';
                        $html_line .= '</div>';
                    }
                    break;
            }


            return $html_line;

        }


        function local_app_show_campaign($campaign_id, $campaign_name, $show_code = true)
        {

            $url = admin_url('admin-ajax.php') . '?action=local_app_get_app&c=' . $campaign_id;
            $html_line = '<div class="local-app-qr-code-campaign-header">';
            if ($show_code) {
                $html_line .= '<br><p><h3>QR Code for Campaign</h3></p>';
                $html_line .= $this->local_app_qr_code($url);
            }
            $html_line .= '<p><strong>Campaign Name:&nbsp;</strong><input type="text" id="local-app-campaign-name" value="' . $campaign_name . '">';
            $html_line .= '</div>';
            $html_line .= '<input type="hidden" value="' . $campaign_id . '" id="local-app-campaign-id">';


            return $html_line;
        }

        function local_app_create_campaign_grid()
        {

            $grid = new local_app_campaign_grid();
            $grid->prepare_items();
            ob_start();
            echo $grid->display();
            $outstring = ob_get_contents();
            ob_end_clean();

            return $outstring;

        }

        function local_app_qr_code($content)
        {

            $qr = new qrcode();
            $qr->text($content);

            return "<p class='local-app-qr-code-image'><img src='" . $qr->get_link() . "' border='0'/></p><p class='local-app-qr-code-image-message'>[Right Click to Save Image]</p>";

        }

    }
}