<?php
if ( !class_exists('local_app_notifications') ) {

    class local_app_notifications{

        function __construct(){


        }

        function local_app_get_account_code(){

            $local_host = 0;
            if(!local_app_is_connected_to_internet()) $local_host = 1;

            if(!get_option('local-app-account_code') && $local_host == 0){

            $querystring = 'https://tinyscreenlabs.com/wp-admin/admin-ajax.php?action=tsl_is_connected&local_host=' . $local_host . '&acct_only=1&ajax_url=' . admin_url('admin-ajax.php');

            $response = wp_remote_get($querystring);

            if (is_array($response) && !is_wp_error($response)) {
                $data = json_decode(wp_remote_retrieve_body($response), true);

                if (isset($data['account_code'])) update_option('local-app-account_code', $data['account_code']);

            }
            }
        }

        function local_app_setup_notifications_page(){

            $this->local_app_get_account_code();

            $current = 'homepage';

            if (isset($_REQUEST['tab'])) $current = $_REQUEST['tab'];

            $html_line = '<div class="local-app-main-content-area">';

            switch ($current) {
                case 'homepage':
                    $html_line .= $this->create_general_notification();
                    break;
                case 'random_push':
                    $html_line .= $this->create_random_notifications();
                    break;
                case 'history':
                    $html_line .= $this->create_history_tab();
                    break;
                case 'support':
                    $dashboard = new local_app_dashboard();
                    $html_line .= $dashboard->local_app_metrics_support_page();
                    break;
            }


            $html_line .= '</div>'; //end of main content area

            return $html_line;



        }

        function display_settings(){

            $html_line = '<div class="local-app-main-content-area" style="max-width:50em;padding-top:2em;padding-left:1em;">';

            $html_line .= 'Who can send notifications - pages & posts, listings, general notifications';

            $html_line .= '</div>';

            return $html_line;
        }

        function buy_now_header(){

            $html_line = '';

            if(!local_app_get_api_key()) {
                $publish_button =  tsl_publish_your_app_button('local-app-update-content-button');
                $html_line .= '<table style="width:100%">';
                $html_line .= '<tr><td align="right">' . $publish_button . '</td></tr>';
                $html_line .= '<tr><td>&nbsp;</td></tr>';
                $html_line .= '</table>';

            }
            return $html_line;

        }

        function create_random_notifications(){

            return $this->create_general_notification(true);

        }

        function create_general_notification($is_random = false){

            $html_line = '<div class="local-app-main-content-area" style="max-width:50em;padding-top:2em;padding-left:1em;">';

//            $html_line .= $this->buy_now_header();

            if( isset( $_REQUEST['send_pn'])) {

                $_REQUEST['title'] = $_REQUEST['local-app-notification-title'];
                $_REQUEST['message'] = $_REQUEST['local-app-notification-message'];
                $_REQUEST['internal'] = 'yes';

                local_app_send_notification();

                wp_redirect( '/wp-admin/admin.php?page=local_app_notifications' );
                die();
            }

            if( isset( $_REQUEST['message_sent']))
            {
                $html_line .= 'Total Push Notifications sent: '. $_REQUEST['message_sent'];
            }

            $html_line .= '<form method="post">';
            $html_line .= '<input type="hidden" name="page" value="local_app_notifications">';
            $html_line .= '<input type="hidden" name="tab" value="homepage">';
            $html_line .= '<input type="hidden" name="send_pn" value="true">';
            $html_line .= '<span style="margin-left:.25em;margin-top:2em;margin-right:2em;margin-bottom:2em;"><table style="width:100%"><tr><td style="font-weight: bold">Message Title:</td><td><input style="width:100%;" type="text" name="local-app-notification-title"></td></tr></table></span>';
            $html_line .= '<br>';
            $html_line .= '<span style="margin-left:.25em;margin-top:2em;font-weight: bold">Enter Message (250 characters maximium):</span>';
            $html_line .= '<textarea name="local-app-notification-message" rows="4" style="width:100%;" maxlength="250"></textarea>';
            $html_line .= '<div style="text-align:right;margin-top:1em;" ><input type="submit" style="width:7em;text-align: center" id="local-app-notify" class="button button-primary button-large" name="Send" value="Send"></div>';

            $html_line .= '</form>';

            $html_line .= '</div>';

            return $html_line;
        }

        function get_random_user_count(){

            $html_line = '<select id="local-app-notification-random-count">';

            for ($x=1;$x<10;$x++) {
                $html_line .= '<option value="'.$x.'" >'.$x.'</option>';

            }
            $html_line .= '</select>';

            return $html_line;


        }

        function create_history_tab(){

            require_once 'local-app-notifications-grid.php';

            $html_line = '<div class="local-app-main-content-area">';

            $form_list = new local_app_notifications_grid();
            $form_list->prepare_items();
            ob_start();
            echo $form_list->display();
            $outstring=ob_get_contents();
            ob_end_clean();

            $html_line .= '<div class="local-app-grid-holder-notifications"><br>' . $this->buy_now_header().$outstring . '</div>';

            $html_line .= '</div>';

            return $html_line;
        }

    }
}
