<?php
/**
 * Created by PhpStorm.
 * User: fred
 * Date: 3/8/17
 * Time: 4:07 PM
 */


add_action('add_meta_boxes' , 'local_app_add_notification_metabox');

if ( !function_exists('get_plugins') ){
    require_once( ABSPATH . '/wp-admin/includes/plugin.php' );
}

if( is_plugin_active( 'connections/connections.php' ) ) {
    if(isset($_REQUEST['page']) && $_REQUEST['page'] != 'connections_add' ) {
        add_action('cn_metabox', 'local_app_add_notification_metabox_connectinos');
    }
}

function local_app_add_notification_metabox_connectinos()
{
    if(current_user_can('install_plugins')) {

        $notification_mgr = new local_app_notifications();
        $notification_mgr->local_app_get_account_code();

        $field = array(
            'id' => 'tsl-local-app-metabox-connections',
            'title' => 'Mobile Notifications',
            'context' => 'side',
            'priority' => 'high',
            'callback' => 'local_app_meta_box_callback'
        );

        cnMetaboxAPI::add($field);
    }
}

function local_app_add_notification_metabox()
{

    if(current_user_can('install_plugins')) {

        $notification_mgr = new local_app_notifications();
        $notification_mgr->local_app_get_account_code();

        $LDDLITE_POST_TYPE = '';
        $LDDLITE_TAX_CAT = '';

        if(defined('LDDLITE_POST_TYPE')) $LDDLITE_POST_TYPE = LDDLITE_POST_TYPE;
        if(defined('LDDLITE_TAX_CAT')) $LDDLITE_TAX_CAT = LDDLITE_TAX_CAT;

        $screens = array('custom_post_type', 'page', 'post', 'ajde_events', 'wpbdp_listing', 'business', 'store_page', 'sm-location', $LDDLITE_POST_TYPE , $LDDLITE_TAX_CAT , 'wpsl_stores' , 'lv_listing', 'tribe_events', 'ai1ec_event', 'event', 'event-recurring');

        if ( !function_exists('get_plugins') ){
            require_once( ABSPATH . '/wp-admin/includes/plugin.php' );
        }

        if (is_plugin_active('geodirectory/geodirectory.php')) {
            $post_types = geodir_get_posttypes('object');

            foreach ($post_types as $index => $posts) {

                $screens[] = $index;
            }
        }

        $meta_box_added = false;
        $current_screen = get_current_screen();

        foreach ($screens as $screen) {

            if( get_p8_file() )
            {
                if (get_the_ID() > 0) {
                    if (get_post_status(get_the_ID()) == 'publish') {
                        if (!$meta_box_added && $current_screen->post_type == $screen) {
                            add_meta_box('a-local-app-notifications-' . $screen, 'Mobile App Notifications', 'local_app_meta_box_callback', $screen, "side", 'high');
                            $meta_box_added = true;
                        }
                    }
                }
            }
        }
    }

}

function local_app_add_excerpt_support_for_pages() {
	add_post_type_support( 'sm-location', 'thumbnail' );
}
add_action( 'init', 'local_app_add_excerpt_support_for_pages' );

function local_app_meta_box_callback(){

    $disabled = '';
    $message = '';

//    if(!get_option('local-app-account_code') || get_option('local-app-account_code') == 'LOCALHOST' ){
//        $disabled = ' disabled';
//        $message = 'title="Push notifications feature is only available for apps visible on the internet."';
//    }else{
//        if(!get_option( 'local_app_apple_status' )) $message = 'title="Your app is not yet published. These notifications will go to those users who are connected to your data using the TSL Previewer app."';
//    }

    $html_line = '<table style="width:100%;">';
    $html_line .= '<tr><td colspan="2">Enter Message:</td></tr>';
    $html_line .= '<tr><td colspan="2"><textarea id="local-app-notification-message" rows="4" style="width:100%;"  maxlength="250"></textarea></td></tr>';
//    $html_line .= '<tr><td colspan="2">Send Date & Time:</td></tr>';
//    $html_line .= '<tr><td><input style="width:100%" type="text" id="local-app-send-date" class="local-app-datepicker" ></td><td>'.local_app_make_hours().'</td></tr>';

    $timezone = 'GMT';
    if(get_option('timezone_string')) {
        $timezone = get_option('timezone_string');
    }
    $html_line .= '<tr><td colspan="2" style="color:grey;font-size: .8em;">Timezone: ' . $timezone . '</td></tr>';
    $html_line .= '<tr><td>&nbsp;</td><td><div style="text-align:right;margin-top:1em;"><input '.$message.' type="button" style="width:7em;text-align: center" id="local-app-notify" class="button button-primary button-large" name="Send" value="Send" onclick="local_app.local_app_confirm_notification(1);" '.$disabled.'></div></td></tr>';

    if(!local_app_get_api_key()){
        $html_line .= '<tr><td colspan="2" align="right"><p>'.tsl_publish_your_app_button('tsl-publish-app').'</p></td></tr>';
    }

    $html_line .= '</table>';

    echo $html_line;
}



function local_app_make_hours(){

    $html_line = '<select id="local-app-send-hours">';

    $html_line .= '<option value="0" selected>Now</option>';

    for($i = 1; $i < 25; $i++){
        if($i<12){
            $hours = $i . ' am';
        }else{
            if($i == 24) {
                $hours = 12 . ' am';
            }elseif($i==12){
                $hours = $i . ' pm';
            }else{
                $t = $i - 12;
                $hours = $t . ' pm';
            }
        }

    $html_line .= '<option value="'. $i . '">'. $hours .'</option>';
}
    $html_line .= '</select>';

    return $html_line;
}


add_action( 'wp_ajax_local_app_get_notification_history', 'local_app_get_notification_history' );
add_action( 'wp_ajax_nopriv_local_app_get_notification_history', 'local_app_get_notification_history' );

function local_app_get_notification_history($source = null, $type = null, $ajax = true){

    global $wpdb;
    $table_name = $wpdb->prefix . 'tsl_local_app_notifications_history';


    $limit = '';
    $where = '';
    if($ajax) {
        $limit = 'LIMIT 10';
        $where = 'WHERE target_source = "' . $_REQUEST['source'] . '" AND target_type = "' . $_REQUEST['type'] . '"';
    }else{
        if(isset($source) && strlen($source)>0) $where = 'WHERE target_source = "' . $source . '" AND target_type = "' . $type . '"';
    }

    $result = $wpdb->get_results("SELECT * FROM $table_name $where ORDER BY this_index DESC $limit", ARRAY_A);

    //$result['dfdf'] = "SELECT * FROM $table_name $where ORDER BY this_index DESC $limit";

    if($ajax) {
        wp_send_json($result);
        die();
    }else{
        return $result;
    }

}


add_action( 'wp_ajax_local_app_send_notification', 'local_app_send_notification' );
add_action( 'wp_ajax_nopriv_local_app_send_notification', 'local_app_send_notification' );


function local_app_send_notification(){

    $this_target = 'post';
    $title = '';
    if( isset( $_REQUEST['title'] )) {
        $title = $_REQUEST['title'];
    }

//    if($_REQUEST['type'] == 'button'){
//        if(isset($_REQUEST['source']) && $_REQUEST['source'] > 0) {
//            $this_target = site_url() . '?tsl_button=' . $_REQUEST['source'];
//        }else{
//            $this_target = site_url() . '?tsl_button=1000';
//        }
//        if(strlen($_REQUEST['target_name'])>0) $title = $_REQUEST['target_name'];
//    }

    if($_REQUEST['type'] == 'posts'){
        $this_target = get_permalink($_REQUEST['source']);
        $title = get_the_title($_REQUEST['source']);
    }

//    if($_REQUEST['type'] == 'connections'){
//        $connections = new local_app_connections_dir();
//        $this_array = $connections->get_notification_info($_REQUEST['source']);
//        $this_target = $this_array['url'];
//        $title = $this_array['title'];
//    }

    $post_array['message'] = html_entity_decode( $_REQUEST['message'] );
    $post_array['title'] = html_entity_decode($title);
    $post_array['target'] = $this_target;
//    $post_array['schedule'] = $schedule;
//    $post_array['tz'] = $timezone_offset;

    global $wpdb;

    $table_name = $wpdb->prefix . 'tsl_phone_tokens';
    $result = $wpdb->get_results("SELECT * FROM $table_name", ARRAY_A);

    $android_phone_count = 0;
    $ios_phone_count = 0;
    $ios_phones = array();
    $android_phones = array();
    foreach( $result as $item) {
        if( $item['os_type'] == 'ios' && strlen( $item['token'] ) > 0 ) {
            if( strpos( $item['token'] , '=' )) continue;
            $ios_phone_count++;
            $ios_phones[] = $item['token'];
        }else if( strlen( $item['token'] ) > 0 ){
            $android_phone_count++;
            $android_phones[] = $item['token'];
        }
    }

    $handler = new mam_main_send_ios_push_notification();
    $handler->sendiosPush( $_REQUEST['message'], $this_target, $title, $ios_phones );
    $handler->SendAndroidPushNotifications( $_REQUEST['message'], $this_target, $title, $android_phones );
mamdebug('testpn', __LINE__);

    global $wpdb;
    $table_name = $wpdb->prefix . 'tsl_local_app_notifications_history';
mamdebug('testpn', __LINE__);
    $user_info = get_userdata(get_current_user_id());
mamdebug('testpn', __LINE__);
    $sent_by_name = $user_info->user_firstname;
    if (empty($sent_by_name)) {
        $sent_by_name = $user_info->nickname;
    } else {
        $sent_by_name = $sent_by_name . ' ' . $user_info->user_lastname;
    }
    if (empty($sent_by_name)) {
        $sent_by_name = $user_info->user_email;
    }
mamdebug('testpn', __LINE__);
    if(strlen($post_array['title']) > 0) $_REQUEST['message'] = $post_array['title'] . ': ' . $_REQUEST['message'];
mamdebug('testpn', __LINE__);
    $wpdb->insert($table_name, array('message' => $_REQUEST['message'], 'trans_date' => current_time('mysql'), 'send_date' => $_REQUEST['date'], 'target_type' => $_REQUEST['type'], 'target_source' => $_REQUEST['source'], 'sent_by_name' => $sent_by_name, 'ios_phones' => $ios_phone_count, 'android_phones' => $android_phone_count ));
    $update_status['status'] = 'done';
mamdebug('testpn', __LINE__);
    if( isset($_REQUEST['internal'])) return $update_status;
mamdebug('testpn', __LINE__);
    wp_send_json( $update_status );
    die();


}
