<?php

class mam_mail_manager_admin_settings
{

    public $settings_array = array();
    public $plugin_slug = 'mam-mail-manager';
    public $plugin_name = 'Mail Manager';

    public function __construct()
    {

        $this->create_settings_array();

    }

    public function create_settings_array()
    {
        $this->settings_array[] = array('catagory' => 'general' , 'title' => __( 'Number of Retries before stopping attempts' , 'mam-main' ), 'variable' => 'none', 'type' => 'none-5' , 'id' => 'mam-mail-num-retries' , 'environment' => 'backend' , 'data' => '' );
        $this->settings_array[] = array('catagory' => 'general' , 'title' => __( 'Retry Interval (Minutes)' , 'mam-main' ), 'variable' => 'none', 'type' => 'none-20' , 'id' => 'mam-mail-retry-interval' , 'environment' => 'backend' , 'data' => '' );
    }

    function check_save()
    {

        $reload = false;

        if( isset( $_REQUEST['mam-mail-actions'])){

            global $wpdb;
            $email_table = $wpdb->prefix . 'tsl_mail_queue';

            if( $_REQUEST['mam-mail-actions'] == 'resend' ){

                foreach( $_REQUEST['tsl-selected-email'] as $index =>  $email ){
                    $wpdb->update($email_table, array( 'send_status' => 20 , 'retry_count' => 0 , 'modified' =>  current_time( 'mysql' )), array('this_index' => $index ));
                }

            }else if( $_REQUEST['mam-mail-actions'] == 'delete' ) {

                foreach( $_REQUEST['tsl-selected-email'] as $index => $email ){
                    $wpdb->get_results( "DELETE FROM $email_table WHERE this_index = " . $index, ARRAY_A);
                }

            }

            $reload = true;
        }

        foreach($this->settings_array as $setting ){
            if(  isset($_REQUEST[$setting['id']]) ){
                update_option($setting['id'], $_REQUEST[$setting['id']]);
                if( $setting['type'] == 'gravity_form' ){
                    foreach($setting['data']['fields'] as $field ){
                        $field_id = $setting['id'] . '_' .$field['slug'];
                        update_option( $field_id, $_REQUEST[$field_id]);
                    }
                }
			    $reload = true;
            }
        }

        if($reload){
            $tab = 'admin_log';
            if( isset($_REQUEST['tab'])) $tab = $_REQUEST['tab'];
            wp_redirect( '?page='.$this->plugin_slug .'&tab='.$tab );
            exit;
        }

    }

    function create_admin_page()
    {

        if (!current_user_can('manage_options')) return 'No one is home';

        $this->check_save();

        if (!isset($_REQUEST['tab'])) $_REQUEST['tab'] = 'admin_log';

        $html = '<br>';
        $html .= '<div class="mam-portal-admin-main" style="max-width:70em;">';
        $html .= mam_admin_settings::headline( __( $this->plugin_name . ' Settings' , 'mam-main' ) );
        $html .= '<h4>Mail Manager is a tool that manages email sending when a notification goes via email to more than 10 recipients. This ensures your site and app performance is not impacted by larger group notifications.</h4>';
        $html .= $this->add_page_tabs();

        switch ($_REQUEST['tab']) {
            case 'admin_settings':
                $html .= $this->admin_settings();
                break;
            case 'admin_log':
                $html .= $this->mail_alerts();
                break;
        }

        $html .= '</div>';

        echo $html;

    }

    function mail_alerts()
    {
        $html_line = '<div class="tsl-admin-settings-holder">';

        $dropdown[] = array( 'slug' => 'delete', 'name' => 'Delete' );
        $dropdown[] = array( 'slug' => 'resend', 'name' => 'Resend' );

        $html_line .= '<form id="mail_manager_form" method="POST">';
        $html_line .= '<input type="hidden" value="'.$_REQUEST['page'].'" name="page">';
        $html_line .= '<input type="hidden" value="'.$_REQUEST['tab'].'" name="tab">';

        $button = '<input name="manage-emails" id="manage-emails" style="float:right;margin-left:1em;" class="button button-primary button-large" value="Go" type="submit">';

        $html_line .= '<table style="width:20em;">';
        $html_line .= '<tr><td>'.mam_admin_settings::make_dropdown( 'mam-mail-actions' , $dropdown , '0' , '' , '', true ).'</td><td>'.$button.'</td></tr>';
        $html_line .= '</table>';

        $form_list = new mam_mail_manager_grid();
		$form_list->prepare_items();
		ob_start();
		echo $form_list->display();
		$html_line .= ob_get_contents();
		ob_end_clean();

		$html_line .= '</form>';

		$html_line .= '</div>';

        return $html_line;


    }

    function admin_settings()
    {

        $html_line = '<div class="tsl-admin-settings-holder">';

        $html_line .= '<form method="POST">';
        $html_line .= '<input type="hidden" value="'.$_REQUEST['page'].'" name="page">';

        $html_line .= mam_admin_settings::create_settings_html( $this->settings_array , 'general' );

		$html_line .= '<table class="tsl-admin-pref-table">';
		$html_line .= '<tr>';
		$html_line .= '<td></td>';
		$html_line .= '<td></td>';
		$html_line .= '<td>'.mam_admin_settings::submit_button().'</td>';
		$html_line .= '</tr>';
		$html_line .= '</table>';

		$html_line .= '</form>';

        $html_line .= '</div>';

        return $html_line;

    }

    function add_page_tabs(){

    	$current = 'admin_settings';
    	if(isset($_REQUEST['tab'])) $current = $_REQUEST['tab'];

		$tabs['admin_log'] = 'Mail Status Log';
		$tabs['admin_settings'] = 'Admin Settings';

		$html_line = '';

		$html_line .= '<div id="icon-themes" class="icon32"><br></div>';
		$html_line .= '<h2 class="nav-tab-wrapper">';

		foreach( $tabs as $tab => $name ){
			$class = ( $tab == $current ) ? ' nav-tab-active' : '';
			$html_line .= "<a class='nav-tab$class' href='?page=".$_REQUEST['page']."&tab=".$tab."'>$name</a>";

		}

		$html_line .= '</h2>';

		$html_line .= '<div class="local-app-tab-separator">&nbsp;</div>';

		return $html_line;

	}



}
