<?php
if ( ! class_exists( 'WP_List_Table' ) )
	require_once( ABSPATH . 'wp-admin/includes/class-wp-list-table.php' );

class mam_mail_manager_grid extends WP_List_Table {

	public $current_page;
	private $posts;

    function prepare_items() {

        $this->get_posts();

		$per_page = 20;
        $columns = $this->get_columns();
        $hidden = array();
        $sortable = array();
        $this->current_page = $this->get_pagenum();

        $this->_column_headers = array($columns, $hidden, $sortable);

		$args = array(
			'posts_per_page' => $per_page,
			'orderby' => 'plugin',
			'order' => 'ASC',
			'offset' => ( $this->current_page - 1 ) * $per_page );

		if ( ! empty( $_REQUEST['s'] ) )
			$args['s'] = $_REQUEST['s'];

		if ( ! empty( $_REQUEST['orderby'] ) ) {
			if ( 'left_column' == $_REQUEST['left_column'] )
				$args['orderby'] = 'left_column';
		}

		if ( ! empty( $_REQUEST['order'] ) ) {
			if ( 'asc' == strtolower( $_REQUEST['order'] ) )
				$args['order'] = 'ASC';
			elseif ( 'desc' == strtolower( $_REQUEST['order'] ) )
				$args['order'] = 'DESC';
		}

        $per_page     = $this->get_items_per_page( 'analytics_per_page', $per_page );


		$total_items = $this->get_grid_data_count();

		$this->set_pagination_args( array(
            'total_items' => $total_items,
            'per_page'    => $per_page
        ) );

        $this->items = $this->get_grid_data( $per_page , $this->current_page );

	}

	function get_columns() {

        $columns['column-zero'] = '';//'<input type="checkbox" id="tsl-select-all-emails">';
        $columns['column-six'] = __('Mail ID', 'mam-main');
        $columns['column-one'] = __('Date', 'mam-main');
        $columns['column-two'] = __('Recipient', 'mam-main');
        $columns['column-three'] = __('Error Message', 'mam-main');
        $columns['column-four'] = __('Retries', 'mam-main');
        $columns['column-five'] = __('Status', 'mam-main');


        return $columns;

	}

	function get_sortable_columns() {
		$columns = array(
			'column-one' => array( 'column-one', true ) );

		return $columns;
	}

	function get_bulk_actions() {
		$actions = array();

		return $actions;
	}

	function column_default( $item, $column_name ) {
		switch( $column_name ) {
            case 'column-zero':
			case 'column-one':
			case 'column-two':
			case 'column-three':
            case 'column-four':
            case 'column-five':
            case 'column-six':
			return $item[ $column_name ];
            default:
              return print_r( $item, true ) ;
            }
	}

    function get_grid_data( $per_page ){

        $items = array();

        $posts = $this->posts;

        $page_count = 0;
        $row_count = -1;

        $start_row = ( $this->current_page * $per_page ) - $per_page;

        $url=strtok($_SERVER["REQUEST_URI"],'?');

        foreach($posts as $post ){

            $row_count++;
            if($row_count < $start_row ) continue;

            $status = 'Queued';
            if( $post['send_status'] == 20 ){
                $status = 'Pending Retry';
            }else if( $post['send_status'] == 30 ){
                $status = 'Failed Retries';
            }

            $items[] = array(
                'column-zero' => '<input style="margin-left:8px;" type="checkbox" name="tsl-selected-email['.$post['this_index'].']" class="tsl-task-checkbox" value="1">',
                'column-six' => $post['this_index'],
                'column-one' => date( 'Y-m-d h:i A', strtotime( $post['modified'] )),
                'column-two' => $post['email'],
                'column-three' => $post['last_error'],
                'column-four' => $post['retry_count'],
                'column-five' => $status
            );

            if($page_count == $per_page ) return $items;
            $page_count++;


        }

        return $items;

    }

	function get_grid_data_count(){

        if(is_array($this->posts)) {
            return sizeof($this->posts);
        }
        return 0;

	}

    function get_posts()
    {

        global $wpdb;
        $table_name = $wpdb->prefix . 'tsl_mail_queue';
        $emails = $wpdb->get_results("SELECT * FROM $table_name WHERE send_status != 2", ARRAY_A);

        $this->posts = $emails;

    }

}
