<?php

add_action('wp_ajax_local_app_get_phone_data', 'local_app_get_phone_data', 1, 2);
add_action('wp_ajax_nopriv_local_app_get_phone_data', 'local_app_get_phone_data', 1, 2);

function local_app_get_phone_data($return_data = false, $single_button_id = false)
{

//    $_REQUEST['lat'] = 30.553295;
//    $_REQUEST['lon'] = -91.039225;
//    $_REQUEST['actual_lat'] = 30.553295;
//    $_REQUEST['actual_lon'] = -91.039225;

//    if( isset( $_REQUEST['pid'] ) && ( $_REQUEST['pid'] == 'F3D66752C5104E38B8528C5812DC8FE9' || $_REQUEST['pid'] == 'B4674932B8BA4B76B9DB7E97A900BCB9' || $_REQUEST['pid'] == '3BA70912930B4E0E97D5F3AB17F739DA' ))
//    {
//        //$_REQUEST['pid'] = '98A9E3E04ACD469386EA653191ABED40'; //christine
//        $_REQUEST['pid'] = '6FEB49921DDC4712B2D4C3C2F512677D';  //mealgenie
//    }

//    if( $_REQUEST['pid'] == 'FBD942800D1F4BC797EB4B80EA51E552') $_REQUEST['pid'] = '61DA98B3AF1A472A80B7128D00213032';
//
//    delete_user_meta( 87 , 'mam_app_token' );


    //items that are commented are pending delete after sufficient testing - Feb 22 2024

    $allow_caching = apply_filters( 'mam_main_allow_cache_json_elements', false );

    global $time_tracers, $mam_user_role, $wp_roles, $local_app_content, $local_app_form_array;
    $data_array = array();
    $app_array = array();
    $local_app_form_array = array();

    $time_start = microtime(true);

    $debug = apply_filters( 'mam_main_json_debug', false );

    $actual_link = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
    mamdebug('start_link', $actual_link);

    do_action('mam_update_current_user');
    global $mam_user, $mam_user_id, $is_cloning;

    do_action('mam_initial_phone_data');

    do_action('add_to_tracer', 'get_data_start');
//    do_action('mam_update_current_user');
//    global $mam_user, $mam_user_id, $is_cloning;

    tsl_mam_add_pn_ids();

    if( $is_cloning )
    {
        $data_array['is_cloning'] = 'yes';
        $data_array['home_right_customer_nav_button_show'] = 'yes';
        $data_array['home_right_customer_nav_button_action'] = 'api_call';
        $data_array['home_right_customer_nav_button_action_sub_action'] = 'reset_clone';
        $data_array['home_right_customer_nav_button'] = 'white_person';
    }


    if (isset($_REQUEST['radius']) && $_REQUEST['radius'] == 0) $_REQUEST['radius'] = 50;

    if ((!isset($_REQUEST['lat']) || strlen($_REQUEST['lat']) == 0 || $_REQUEST['lat'] == 0) && isset($_REQUEST['actual_lat'])) {
        $_REQUEST['lat'] = $_REQUEST['actual_lat'];
        $_REQUEST['lon'] = $_REQUEST['actual_lon'];
    }
    if ((!isset($_REQUEST['actual_lat']) || strlen($_REQUEST['actual_lat']) == 0 || $_REQUEST['actual_lat'] == 0) && isset($_REQUEST['lat'])) {
        $_REQUEST['actual_lat'] = $_REQUEST['lat'];
        $_REQUEST['actual_lon'] = $_REQUEST['lon'];
        $_REQUEST['no_gps'] = 'yes';
    }

    if ((!isset($_REQUEST['lat']) || strlen($_REQUEST['lat']) == 0 || $_REQUEST['lat'] == 0) && function_exists('geoip_detect2_get_info_from_ip')) {
        $user_ip = $_SERVER['HTTP_CLIENT_IP'] ?? $_SERVER['HTTP_X_FORWARDED_FOR'] ?? $_SERVER['REMOTE_ADDR'];
        $user_loc_rec = geoip_detect2_get_info_from_ip($user_ip, NULL);

        if (isset($user_loc_rec->location->latitude)) {
            $_REQUEST['lat'] = $user_loc_rec->location->latitude;
            $_REQUEST['lon'] = $user_loc_rec->location->longitude;
            $_REQUEST['city_name'] = $user_loc_rec->city->names['en'];
            $_REQUEST['actual_lat'] = $_REQUEST['lat'];
            $_REQUEST['actual_lon'] = $_REQUEST['lon'];
        }
    }

    if (!isset($_REQUEST['actual_lat']) && tsl_mam_get_option_value('tsl-setting-geofilter_default_lat')) {
        $_REQUEST['actual_lat'] = tsl_mam_get_option_value('tsl-setting-geofilter_default_lat');
        $_REQUEST['actual_lon'] = tsl_mam_get_option_value('tsl-setting-geofilter_default_lon');
        $_REQUEST['lat'] = tsl_mam_get_option_value('tsl-setting-geofilter_default_lat');
        $_REQUEST['lon'] = tsl_mam_get_option_value('tsl-setting-geofilter_default_lon');
    }

    //this checks to see if another plugin wants to override the data
    $external_cached_json = array();
    $external_cached_json = apply_filters('mam_local_app_data', $external_cached_json, $return_data);
    if ( sizeof($external_cached_json) > 0 && $return_data) return $external_cached_json;

    //this is a rarely used variable and should be removed in the future
    $_REQUEST['first_run'] = 'done';

    do_action('add_to_tracer', 'MAIN - ' . __LINE__);

    if ( $mam_user_id > 0 ){

        if( isset($_REQUEST['iosVoipToken']) && ! isset($data_array['is_cloning']))
        {
            update_user_meta( $mam_user_id, 'mam_ios_voip_token', $_REQUEST['iosVoipToken'] );
        }

        if (isset($_REQUEST['radius'])) {
            if ($_REQUEST['radius'] == 500) $_REQUEST['radius'] = 5000;
            update_user_meta( $mam_user_id, '_geofilter_radius', $_REQUEST['radius']);
        }

        if( isset( $_REQUEST['iosversion'] ) ){
            update_user_meta( $mam_user_id, 'iosversion', $_REQUEST['iosversion'] );
        }
        if( isset( $_REQUEST['andver'] ) ){
            update_user_meta( $mam_user_id, 'andversion', $_REQUEST['andver'] );
        }

        update_user_meta($mam_user->ID, 'mam_last_active', date('U'));
        delete_user_meta($mam_user->ID, 'mam_not_mgr_five_day_message');

        if (isset($_REQUEST['iap_product'])) {
            if (get_user_meta($mam_user->ID, 'iap_product', true) && get_user_meta($mam_user->ID, 'iap_product', true) != $_REQUEST['iap_product']) {
                do_action('mam_main_iap_subscription_has_changed', $mam_user->ID, get_user_meta($mam_user->ID, 'iap_product', true));
            }
            update_user_meta($mam_user->ID, 'iap_product', $_REQUEST['iap_product']);
        }
        if (isset($_REQUEST['iap_expiration_date'])) {
            update_user_meta($mam_user->ID, 'iap_expiration_date', $_REQUEST['iap_expiration_date']);
        }

        if (isset($_REQUEST['gmtoffset'])) {
            update_user_meta($mam_user->ID, 'gmtoffset', $_REQUEST['gmtoffset']);
            update_user_meta($mam_user->ID, 'dst', $_REQUEST['dst']);
        }

        if ( get_user_meta( $mam_user_id, '_app_lang' , true )) {
            $_REQUEST['app_lang'] = get_user_meta( $mam_user_id, '_app_lang', true);
        }

        $favorites = get_user_meta($mam_user_id, 'favorites', true);
        if (is_array($favorites) && sizeof($favorites) > 0) {
            $data_array['favorites'] = $favorites;
        }

        $reads = get_user_meta($mam_user_id, 'read_history', true);
        if (!is_array($reads) || sizeof($reads) == 0) {
            $reads = array();
            $reads['read_none'] = 1;
        }
        $data_array['read_history'] = $reads;

        $all_roles = $wp_roles->roles;
        foreach ($all_roles as $role_index => $role) {
            if (get_option('mam-user-roles-to-manage-' . $role_index) == 'yes') {
                foreach ( $mam_user->roles as $user_role) {
                    if ($user_role == $role_index) {
                        $mam_user_role = $role_index;
                        break;
                    }
                }
            }
        }

        if (isset($_REQUEST['deviceios'])) {
            update_user_meta( $mam_user_id, 'mam_app_ios_pn_token', $_REQUEST['deviceios']);
        }
        if (isset($_REQUEST['deviceand'])) {
            update_user_meta($mam_user_id, 'mam_app_android_pn_token', $_REQUEST['deviceand']);
        }

        if (isset($_REQUEST['actual_lat']) && $_REQUEST['actual_lat'] != 0) update_user_meta($mam_user_id, '_user_lat', $_REQUEST['actual_lat']);
        if (isset($_REQUEST['actual_lon']) && $_REQUEST['actual_lon'] != 0) update_user_meta($mam_user_id, '_user_lon', $_REQUEST['actual_lon']);

        if( $allow_caching ) {
            $forms = mam_cached_object_get( $mam_user_id, 'local_app_form_array' );
            if( is_array($forms) && sizeof($forms) > 0 ) $local_app_form_array = $forms;
        }

    }else{

        if (isset($_REQUEST['app_lang'])) {
            update_option($_REQUEST['pid'] . '-app_lang', $_REQUEST['app_lang']);
        } else if (get_option($_REQUEST['pid'] . '-app_lang')) {
            $_REQUEST['app_lang'] = get_option($_REQUEST['pid'] . '-app_lang');
        }

    }

    //delete after refactoring and testing
    $data_array['json_status'] = 'new_data';
//    $data_array['json_cursor'] = get_option('mam_cursor');

    do_action('add_to_tracer', 'MAIN - ' . __LINE__);
    $data_array['social']['facebook'] = ' ';
    $data_array['social']['google'] = ' ';
    $data_array['social']['instagram'] = ' ';
    $data_array['social']['linkedin'] = ' ';
    $data_array['social']['pintrest'] = ' ';
    $data_array['social']['twitter'] = ' ';
    $data_array['social']['website'] = ' ';
    $data_array['social']['youtube'] = ' ';

    if (get_option('local-app-social-facebook')) $data_array['social']['facebook'] = get_option('local-app-social-facebook');
    if (get_option('local-app-social-google')) $data_array['social']['google'] = get_option('local-app-social-google');
    if (get_option('local-app-social-instagram')) $data_array['social']['instagram'] = get_option('local-app-social-instagram');
    if (get_option('local-app-social-linkedin')) $data_array['social']['linkedin'] = get_option('local-app-social-linkedin');
    if (get_option('local-app-social-pintrest')) $data_array['social']['pintrest'] = get_option('local-app-social-pintrest');
    if (get_option('local-app-social-twitter')) $data_array['social']['twitter'] = get_option('local-app-social-twitter');
    if (get_option('local-app-social-website')) $data_array['social']['website'] = get_option('local-app-social-website');
    if (get_option('local-app-social-youtube')) $data_array['social']['youtube'] = get_option('local-app-social-youtube');

    $data_array['homePageIconDimensions'] = get_option('local-app-layout');

    if (get_option('local-app-images-app-icon')) {
        $data_array['app_icon']['url'] = wp_get_attachment_url(get_option('local-app-images-app-icon'));
        $data_array['app_icon']['extension'] = local_app_get_image_extension($data_array['app_icon']['url']);
    } else {
        $data_array['app_icon']['url'] = ' ';
    }

    if (get_option('local-app-images-launch-screen-1')) {
        $data_array['splash_screen_1']['url'] = wp_get_attachment_url(get_option('local-app-images-launch-screen-1'));
        $data_array['splash_screen_1']['extension'] = local_app_get_image_extension($data_array['splash_screen_1']['url']);
    } else {
        $data_array['splash_screen_1']['url'] = ' ';
    }

    if (get_option('local-app-images-featured-graphic')) {
        $data_array['featured_graphic']['url'] = wp_get_attachment_url(get_option('local-app-images-featured-graphic'));
        $data_array['featured_graphic']['extension'] = local_app_get_image_extension($data_array['featured_graphic']['url']);
    } else {
        $data_array['featured_graphic']['url'] = ' ';
    }

    if (get_option('local-app-images-launch-screen-2')) {
        $data_array['splash_screen_2']['url'] = wp_get_attachment_url(get_option('local-app-images-launch-screen-2'));
        $data_array['splash_screen_2']['extension'] = local_app_get_image_extension($data_array['splash_screen_2']['url']);
    } else {
        $data_array['splash_screen_2']['url'] = ' ';
    }

    if (get_option('local-app-images-background-screen-1')) {
        if (is_numeric(get_option('local-app-images-background-screen-1'))) {
            $data_array['background_screen_1']['url'] = wp_get_attachment_url(get_option('local-app-images-background-screen-1'));
            $data_array['background_screen_1']['extension'] = local_app_get_image_extension($data_array['background_screen_1']['url']);
            $data_array['background_screen_1']['image_id'] = get_option('local-app-images-background-screen-1');
        } else {
            $data_array['background_screen_1']['url'] = get_option('local-app-images-background-screen-1');
            $data_array['background_screen_1']['extension'] = local_app_get_image_extension($data_array['background_screen_1']['url']);
            $data_array['background_screen_1']['image_id'] = 1;
        }
    } else {
        $data_array['background_screen_1']['url'] = ' ';
    }

    $data_array['background_screen_2']['url'] = ' ';

    if (get_option('local-app-images-app-logo')) {
        $data_array['app_logo_image']['url'] = wp_get_attachment_url(get_option('local-app-images-app-logo'));
        $data_array['app_logo_image']['extension'] = local_app_get_image_extension($data_array['app_logo_image']['url']);
        $data_array['app_logo_image']['image_id'] = get_option('local-app-images-app-logo');
    } else {
        $data_array['app_logo_image']['url'] = ' ';
    }

    $role_info = new mam_user_roles_button_array();
    $button_array = $role_info->get_phone_data_array_button_array();
    $left_menu = $role_info->get_phone_data_left_menu();

    foreach ($button_array as $index => $value) {

        do_action('add_to_tracer', 'button_start ' . $value['name']);

        if( $allow_caching ) {
            $this_button = mam_cached_object_get($mam_user_id, $value['name']);
            if (is_array($this_button) && sizeof($this_button) > 0) {
                //mamdebug('cache ' . $value['name'], sizeof($this_button));
                $app_array[] = $this_button;
                //mamdebug('button', 'was cached');
                continue;
            }
        }

do_action('add_to_tracer', 'button_start ' . $value['name'] . ' = ' . __LINE__  );
        if ($single_button_id && $value['id'] != $single_button_id) continue;

        $button_time_start = microtime(true);

        $content_class = null;

        if( isset( $value['type'] ) && isset( $local_app_content[$value['type']] ) ) $content_class = $local_app_content[$value['type']]['class'];
        if ( ! is_null($content_class ) && class_exists($content_class)) {
            $this_button = array();

            $this_button['title'] = html_entity_decode(stripcslashes($value['name']));

            $this_button['icon'] = basename($value['icon']);
            $this_button['icon_url'] = $value['icon'];
            $this_button['image_id'] = 0;
            $this_button['id'] = $value['id'];
            $this_button['extension'] = 'png';

            $this_button['vc_type'] = $local_app_content[$value['type']]['vc_type'];

            if ($local_app_content[$value['type']]['content_type'] == 'Member Card') {
                $this_button['vc_type'] = 'html';
            }

            $content_class = new $content_class();
            if ($this_button['vc_type'] == 'html') {
                $this_button = $content_class->get_data_for_app($value['source'], $this_button);
            } else {

                $this_button['data'] = $content_class->get_data_for_app($value['source'], false, html_entity_decode(stripcslashes($value['name'])));

                if ($this_button['vc_type'] == 'list') $this_button['use_subcategories'] = 'YES';
            }
            $display_button = true;

            if (!$this_button['data']) {
                if ($this_button['vc_type'] == 'list' || $this_button['vc_type'] == 'offDirectory') {
                    $this_button['data'] = array('nodata' => 1);
                    $this_button['nodata'] = array('nodata' => 1);
                    $display_button = true;
                }else{
                    $this_button['data'] = ' ';
                }
            }

            do_action('add_to_tracer', 'button_pre_tab ' . $value['name']);
            $this_button['position'] = $index;
//            if (has_filter('mam_tab_manager')) {
                $this_button['class'] = $local_app_content[$value['type']]['class'];
                $this_button['tab_button_id'] = $value['id'];
                $this_button['tab_type'] = $value['type'];
                $this_button['tab_location'] = 'button';
                $this_button = apply_filters('mam_tab_manager', $this_button);
                if ($this_button['data']) {
                    $display_button = true;
                }

                if (($this_button['vc_type'] == 'list' || $this_button['vc_type'] == 'offDirectory') && isset($this_button['data'][0])) {
                    unset($this_button['data']['nodata']);
                    unset($this_button['nodata']);
                    $display_button = true;
                }

//            }

            $this_button = apply_filters('mam_final_button_settings', $this_button);
            unset($this_button['tab_button_id']);
            unset($this_button['tab_type']);
            unset($this_button['tab_button_id']);
            unset($this_button['class']);
            unset($this_button['tab_location']);

            do_action('add_to_tracer', 'button_end ' . $value['name']);
            $this_button['exec_time_end'] = microtime(true) - $button_time_start;

            if( $allow_caching ) {
                do_action('add_to_tracer', 'cachin' . ' = ' . __LINE__  );
                mam_cached_object_set($mam_user_id, $this_button, $value['name']);
            }

            if ($single_button_id) return $this_button;

            if ($display_button) $app_array[] = $this_button;

        }

    }
    do_action('add_to_tracer', 'MAIN - ' . __LINE__);

    json_validate($app_array, __LINE__);

    $data_array['homePageIcons'] = $app_array;

    $data_array['home_vc'] = 'home';
    $data_array['hide_back_button'] = 'no';

    do_action('add_to_tracer', 'Pre Left Menu ' . __LINE__);
    if( isset($left_menu) && is_array($left_menu) && sizeof($left_menu) > 0 ) {
        $data_array['left_menu'] = main_create_left_menu($left_menu, $data_array);
    }
    do_action('add_to_tracer', 'Post Left Menu ' . __LINE__);

    if ( isset( $data_array['left_menu'] ) && is_array( $data_array['left_menu'] ) && sizeof($data_array['left_menu']) > 0) {
        $data_array['has_left_menu'] = 'yes';
    }else{
        unset($data_array['left_menu']);
    }

    $data_array['ajax_url'] = admin_url('admin-ajax.php');

    do_action('add_to_tracer', 'Pre Get Phone Data ' . __LINE__);
    $data_array = apply_filters('tsl_get_phone_data_before_send', $data_array);
    do_action('add_to_tracer', 'Post Get Phone Data ' . __LINE__);
    //note - this is the new filter, we will be converting all the tsl_ prefixed filters to this filter
    $data_array = apply_filters('mam_get_phone_data_before_send', $data_array);
    do_action('add_to_tracer', 'Post Get Phone Data ' . __LINE__);

    if( sizeof($local_app_form_array) > 0  ) {
        $data_array['form_data'] = $local_app_form_array;
        if( $allow_caching ) mam_cached_object_set($mam_user_id, $local_app_form_array, 'local_app_form_array' );
    }

    do_action('add_to_tracer', 'MAIN - ' . __LINE__);
    $data_array = tsl_replace_null_with_empty_string($data_array);
    do_action('add_to_tracer', 'MAIN - ' . __LINE__);
    $data_array = tsl_clean_subcategories($data_array);
    do_action('add_to_tracer', 'MAIN - ' . __LINE__);
    $data_array = clean_notifications($data_array);

    do_action('add_to_tracer', 'MAM MAIN ' . __LINE__);

    $data_array['data'] = 'update';

    $data_array['tracers'] = $time_tracers;
    $data_array['ajax_start'] = $time_tracers['get_data_start'];
    $data_array['exec_time'] = microtime(true) - $time_start;


//    mamdebug('tracers', $time_tracers );
    mamdebug('request link', $data_array['exec_time'] . ' - ' . '<a href="' . $actual_link . '" target="_blank">' . $actual_link . '</a>');

    if ($return_data) {
        return $data_array;
    } else {
        do_action('add_to_tracer', 'get_data_start');
        do_action('mam_main_check_cache_for_main_json', $data_array);
        wp_send_json($data_array);
        die();
    }
}

function main_create_left_menu($button_array, $data_array)
{

    global $local_app_content;
    $app_array = array();

    foreach ($button_array as $index => $value) {
        do_action('add_to_tracer', 'left_button_start_ ' . $value['name']);
        $button_time_start = microtime(true);

        if( ! isset($local_app_content[$value['type']]['class'])) continue;
        $content_class = $local_app_content[$value['type']]['class'];
        if( class_exists($content_class)) {
            $this_button = array();

            $this_button['title'] = html_entity_decode(stripcslashes($value['name']));
            $this_button['icon'] = basename($value['icon']);
            $this_button['icon_url'] = $value['icon'];
            $this_button['image_id'] = 0;
            $this_button['menu_source'] = 'left';

            $parts = explode('.', $this_button['icon']);
            $this_button['extension'] = $parts[sizeof($parts) - 1];

            $this_button['vc_type'] = $local_app_content[$value['type']]['vc_type'];

            $content_class = new $content_class();
            if ($this_button['vc_type'] == 'html') {
                $this_button = $content_class->get_data_for_app($value['source'], $this_button);
            } else {
                $this_button['data'] = $content_class->get_data_for_app($value['source'], false, html_entity_decode(stripcslashes($value['name'])));
                if ($this_button['vc_type'] == 'list') $this_button['use_subcategories'] = 'yes';
            }

            if (isset($this_button['use_sub_dir'])) {
                $this_button['use_subcategories'] = $this_button['use_sub_dir'];
            }

            $display_button = true;
            if (!$this_button['data']) {
                if ($this_button['vc_type'] == 'list') {
                    $has_directory = true;
                    $display_button = false;
                }
                if ($this_button['vc_type'] == 'list' || $this_button['vc_type'] == 'offDirectory') {
                    $this_button['data'] = array('nodata' => 1);
                    $this_button['nodata'] = array('nodata' => 1);
                    $display_button = true;
                } else {
                    $this_button['data'] = ' ';
                }
            }

//            if (has_filter('mam_tab_manager')) {
                $this_button['class'] = $local_app_content[$value['type']]['class'];
                $this_button['position'] = $index;
                $this_button['tab_button_id'] = $value['id'];
                $this_button['tab_type'] = $value['type'];
                $this_button['tab_location'] = 'button';
                $this_button = apply_filters('mam_tab_manager', $this_button);
//                unset($this_button['tab_button_id']);
//                unset($this_button['tab_type']);
//                unset($this_button['tab_button_id']);
//                unset($this_button['class']);
//                unset($this_button['tab_location']);
                if ($this_button['data']) {
                    $display_button = true;
                }
//            }

            $this_button = apply_filters('mam_final_button_settings', $this_button);
            unset($this_button['tab_button_id']);
            unset($this_button['tab_type']);
            unset($this_button['tab_button_id']);
            unset($this_button['class']);
            unset($this_button['tab_location']);

            $this_button['exec_time_end'] = microtime(true) - $button_time_start;
            do_action('add_to_tracer', 'left_button_end_ ' . $value['name']);
            if ($display_button) $app_array[] = $this_button;
        }
    }

    return $app_array;
}

function tsl_replace_null_with_empty_string($array)
{
    foreach ($array as $key => $value) {
        if (is_array($value))
            $array[$key] = tsl_replace_null_with_empty_string($value);
        else {
            if (is_null($value))
                $array[$key] = " ";
        }
    }
    return $array;
}

function tsl_clean_subcategories($json_content)
{

    foreach ($json_content['homePageIcons'] as $index => $value) {
        if ($value['vc_type'] == 'list') {
            //add subcategory to each listing
            foreach ($value['data'] as $this_index => $this_value) {
                if (!isset($value['data'][$this_index]['subcategories'])) continue;
                foreach ($value['data'][$this_index]['subcategories'] as $sub_index => $sub_value) {
                    if (strlen($sub_value) < 2) {
                        unset($json_content['homePageIcons'][$index]['data'][$this_index]['subcategories'][$sub_index]);
                    }
                }
                if (isset($json_content['homePageIcons'][$index]['data'][$this_index]['subcategories']) && is_array($json_content['homePageIcons'][$index]['data'][$this_index]['subcategories']) && empty($json_content['homePageIcons'][$index]['data'][$this_index]['subcategories'])) {
                    $json_content['homePageIcons'][$index]['data'][$this_index]['subcategories'][0] = $value['title'];
                }
            }
        }
    }

    return $json_content;
}

function clean_notifications($data_array)
{

    $target_array = array();
    $id_array = array();

    foreach ($data_array['homePageIcons'] as $button_index => $item) {
        if (is_array($item['data'])) {

            foreach ($item['data'] as $index => $dataItem) {

                if (isset($dataItem['url'])) {
                    $target_array[] = $dataItem['url'];
                    $id_array[$dataItem['url']] = $dataItem['id'];
                }
                if (isset($dataItem['hiddenurl'])) {
                    $target_array[] = $dataItem['hiddenurl'];
                    $id_array[$dataItem['hiddenurl']] = $dataItem['id'];
                }

            }
        }
    }
    if(isset($data_array['left_menu'])) {
        foreach ($data_array['left_menu'] as $button_index => $item) {
            if (is_array($item['data'])) {

                foreach ($item['data'] as $dataItem) {
                    if (isset($dataItem['url'])) {
                        $target_array[] = $dataItem['url'];
                        $id_array[$dataItem['url']] = $dataItem['id'];
                    }
                    if (isset($dataItem['hiddenurl'])) {
                        $target_array[] = $dataItem['hiddenurl'];
                        $id_array[$dataItem['hiddenurl']] = $dataItem['id'];
                    }
                }
            }
        }
    }
    if (isset($data_array['notifications']) && is_array($data_array['notifications'])) {
        foreach ($data_array['notifications'] as $index => $notification) {

            if (!in_array($notification['target'], $target_array)) {
                unset($data_array['notifications'][$index]);
            } else {
                if ($data_array['notifications'][$index]['record_id'] == 0) {
                    $data_array['notifications'][$index]['record_id'] = $id_array[$notification['target']];
                }
            }

        }
    }

    if (isset($data_array['notifications']) && is_array($data_array['notifications']) && sizeof($data_array['notifications']) > 0) {
        $data_array['notifications'] = array_values($data_array['notifications']);
    } else {
        unset($data_array['notifications']);
    }


    return $data_array;

}

function tsl_mam_add_pn_ids()
{

    if (isset($_REQUEST['deviceios']) || isset($_REQUEST['deviceand'])) {

        if (isset($_REQUEST['deviceios'])) {
            $os = 'ios';
            $device = $_REQUEST['deviceios'];
        } else {
            $os = 'android';
            $device = $_REQUEST['deviceand'];
        }

        global $wpdb;

        $table_name = $wpdb->prefix . 'tsl_phone_tokens';
        $result = $wpdb->get_results("SELECT * FROM $table_name WHERE token = '" . $device . "'" );

        if (sizeof($result) == 0) {
            $wpdb->insert($table_name, array('account_code' => get_option('local-app-account_code'), 'connect_date' => current_time('mysql', 1), 'os_type' => $os, 'token' => $device));
        }

    }

}

function json_validate( $data_array , $line = ' ' )
{

    // decode the JSON data
    $result = json_encode( $data_array );

    // switch and check possible JSON errors
    switch (json_last_error()) {
        case JSON_ERROR_NONE:
            $error = ''; // JSON is valid // No error has occurred
            break;
        case JSON_ERROR_DEPTH:
            $error = 'The maximum stack depth has been exceeded.';
            break;
        case JSON_ERROR_STATE_MISMATCH:
            $error = 'Invalid or malformed JSON.';
            break;
        case JSON_ERROR_CTRL_CHAR:
            $error = 'Control character error, possibly incorrectly encoded.';
            break;
        case JSON_ERROR_SYNTAX:
            $error = 'Syntax error, malformed JSON.';
            break;
        // PHP >= 5.3.3
        case JSON_ERROR_UTF8:
            $error = 'Malformed UTF-8 characters, possibly incorrectly encoded.';
            break;
        // PHP >= 5.5.0
        case JSON_ERROR_RECURSION:
            $error = 'One or more recursive references in the value to be encoded.';
            break;
        // PHP >= 5.5.0
        case JSON_ERROR_INF_OR_NAN:
            $error = 'One or more NAN or INF values in the value to be encoded.';
            break;
        case JSON_ERROR_UNSUPPORTED_TYPE:
            $error = 'A value of a type that cannot be encoded was given.';
            break;
        default:
            $error = 'Unknown JSON error occured.';
            break;
    }

    if ($error !== '') {
        // throw the Exception or exit // or whatever :)
        print_r($line . ' - ' .$error);
        echo '<pre>';
        print_r(  $data_array );
        echo '</pre>';
        die();
    }

    // everything is OK
    return $result;
}

function local_app_get_image_extension($image)
{
    $parts = explode('.', $image);
    return $parts[sizeof($parts) - 1];
}
