<?php

add_action( 'save_post', 'mam_delete_cached_object' );
add_action( 'comment_post', 'delete_geodirectory_cache_after_review' );

add_action( 'mam_clear_cached_objects', 'mam_clear_cached_objects' );
add_action( 'mam_delete_cached_object', 'mam_delete_cached_object' );
add_filter( 'mam_cached_object_get', 'mam_cached_object_get_filter', 10, 3 );
add_action( 'mam_cached_object_set', 'mam_cached_object_set' , 10, 4 );


add_filter( 'mam_form_manager_add_or_update', 'form_manager_update_or_add', 10 , 2 );

function form_manager_update_or_add( $form_index, $form )
{

    global $local_app_form_array;

    foreach( $local_app_form_array as $index => $item ) {
        if ( isset($form['form_serial']) && isset( $item['form_serial']) && $item['form_serial'] == $form['form_serial']) {
            $local_app_form_array[$index] = $form;
            //mamdebug('form cache F', $item['form_serial'] );
            return (string)($index + 1);
        }
    }

//    mamdebug('form cache', 'not found');

    $local_app_form_array[] = $form;
    return (string)sizeof($local_app_form_array);


}


function mam_cached_object_get_filter( $content, $post_id = 0, $group = null )
{
    return mam_cached_object_get( $post_id, $group );
}

function mam_clear_cached_objects( )
{
    global $wpdb;
    $table_name = $wpdb->prefix . 'mam_object_cache_data';
    $wpdb->query( 'DELETE FROM '. $table_name .' WHERE post_id > 0' );
 }

function mam_delete_cached_object( $post_id = null , $group = null )
{
    if( $post_id )
    {
        global $wpdb;
        $table_name = $wpdb->prefix . 'mam_object_cache_data';
        if( ! $group  ) {
            $wpdb->query('DELETE FROM ' . $table_name . ' WHERE post_id = ' . $post_id);
        }else if( $group ){
            $wpdb->query('DELETE FROM ' . $table_name . ' WHERE post_id = ' . $post_id . ' AND cache_group LIKE "' . $group . '"');
        }
    }
}

function delete_geodirectory_cache_after_review( $comment_id )
{

    $comment = get_comment( $comment_id );
    $post_id = $comment->comment_post_ID ;
    mam_delete_cached_object( $post_id );

}

function mam_cached_object_set( $post_id, $object_value, $group, $expires = 999999 )
{

    global $wpdb;
    $table_name = $wpdb->prefix . 'mam_object_cache_data';
    $object_value = maybe_serialize( $object_value );

    if( ! mam_cached_object_get( $post_id, $group ) )
    {
        $wpdb->insert( $table_name, array( 'post_id' => $post_id, 'cache_group' => $group, 'object_data' => $object_value , 'expires' =>  $expires ));
    }else{
        $wpdb->update( $table_name, array( 'object_data' => $object_value , 'expires' => $expires ), array( 'post_id' => $post_id, 'cache_group' => $group ));
    }

}

function mam_cached_object_get( $post_id = 0, $group = null )
{

    if( $post_id == 0 || ! $group || strlen( $group ) == 0 ) return false;

    global $wpdb;
    $table_name = $wpdb->prefix . 'mam_object_cache_data';
    $results = $wpdb->get_results( 'SELECT * FROM '. $table_name .' WHERE post_id = ' .$post_id . ' AND cache_group LIKE "' . $group . '"' , ARRAY_A );

    if( !empty($results) )
    {
        return maybe_unserialize( $results[0]['object_data'] );
    }

    return false;

}
