<?php
/**
 * Created by PhpStorm.
 * User: Fred
 * Date: 2019-04-30
 * Time: 10:49
 */

class mam_message_and_notification_admin_settings
{

    public $settings_array = array();
    public $plugin_slug = 'mam-notification-manager';
    public $text_domain = 'mam-notification-manager';

    public function __construct()
    {

        $this->create_settings_array();

    }

    public function create_settings_array()
    {

        $notification_array = apply_filters( 'mam_notification_list' , array() );

        $sort = array();
        foreach($notification_array as $k=>$v) {
            $sort[$v['source']][] = $v;
        }
        ksort($sort);
        $new_sort_array = array();
        foreach ($sort as $sarray){
            $columns = array_column($sarray, 'title');
            array_multisort($columns, SORT_ASC, $sarray);
            $new_sort_array = array_merge($new_sort_array, $sarray);
        }
        $notification_array = $new_sort_array;
        foreach( $notification_array as $item )
        {
            $desc = '';
            if( isset($item['description']) ) $desc = $item['description'];
            if(array_key_exists('default_content', $item) && $item['default_content'] != '' && array_key_exists('default_on', $item) && !empty($item['default_on'])){
                $this->settings_array[] = array('catagory' => 'notifications', 'title' => trim($item['title']), 'variable' => 'none', 'type' => 'message_setting', 'id' => $item['slug'], 'environment' => 'backend', 'data' => '', 'replacements' => $item['replacements'], 'default_content' => $item['default_content'], 'default_on' => $item['default_on'], 'description' => $desc);
            }else {
                $this->settings_array[] = array('catagory' => 'notifications', 'title' => trim($item['title']), 'variable' => 'none', 'type' => 'message_setting', 'id' => $item['slug'], 'environment' => 'backend', 'data' => '', 'replacements' => $item['replacements'], 'description' => $desc);
            }

        }

    }

    function check_save()
    {

        $reload = false;

        foreach($this->settings_array as $setting ){
            if(  isset($_REQUEST['slug']) && $_REQUEST['slug'] == $setting['id'] && isset($_REQUEST['submit']) ){

                update_option( 'tsl_notification_subject_' . $setting['id'] , stripslashes( $_REQUEST['subject']) );
                update_option( 'tsl_notification_email_status_' . $setting['id'] , $_REQUEST['email']);
                update_option( 'tsl_notification_pn_status_' . $setting['id'] , $_REQUEST['pn']);
                update_option( 'tsl_notification_text_status_' . $setting['id'] , $_REQUEST['text_msg']);
                update_option( 'tsl_notification_email_text_' . $setting['id'] , stripslashes($_REQUEST['email_content'] ));
                update_option( 'tsl_notification_pn_text_' . $setting['id'] , stripslashes($_REQUEST['pn_content']));
                update_option( 'tsl_notification_text_text_' . $setting['id'] , stripslashes($_REQUEST['text_content']));
                update_option( 'tsl_notification_email_cc_' . $setting['id'] , $_REQUEST['email_cc_address']);
                update_option( 'tsl_notification_email_bcc_' . $setting['id'] , $_REQUEST['email_bcc_address']);
			    $reload = true;
            }
        }

        $reload = apply_filters( 'mam_notification_save_notification_type', $reload );

        if( isset($_REQUEST['submit']) && $_REQUEST['main'] ){
            if( isset($_REQUEST['mam_notification_use_cron'])){
                update_option( 'mam_notification_use_cron' , $_REQUEST['mam_notification_use_cron']);
            }else {
                delete_option( 'mam_notification_use_cron' );
        }
            $reload = true;
        }


        if($reload){
            wp_redirect('?page=' . $this->plugin_slug );
            exit;
        }

    }




    function create_admin_page()
    {

        if (!current_user_can('manage_options')) return 'No one is home';

        $html = '<div class="local-app-main-content-area">';
//        $html .= $this->add_page_tabs();
//
//        $html .= '<div class="mam-notification-manager-tab-holder">';
//
//        $current = 'notifications-settings';
//        if (isset($_REQUEST['tab'])) $current = $_REQUEST['tab'];
//
//        switch ($current) {
//            case 'notifications-settings':
                $html .= $this->get_notification_settings_tab();
//                break;
//            case 'notifications-listing':
//                $html .= $this->get_notifications_listing_tab();
//                break;
//        }

//        $html .= '</div>';

        $html .= '</div>';

        echo $html;

    }

    function add_page_tabs(){

        $current = 'notifications-settings';
        if(isset($_REQUEST['tab'])) $current = $_REQUEST['tab'];

        $tabs['notifications-settings'] = 'Notifications';
        $tabs['notifications-listing'] = 'Custom Notifications';

        $actual_link = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[SCRIPT_NAME]";
        $actual_link = str_replace('__wp__/','', $actual_link );

        $html_line = '';

        $html_line .= '<div id="icon-themes" class="icon32"><br></div>';
        $html_line .= '<h2 class="nav-tab-wrapper">';

        foreach( $tabs as $tab => $name ){
            $class = ( $tab == $current ) ? ' nav-tab-active' : '';
            $html_line .= "<a class='nav-tab$class' href='".$actual_link."?page=mam-notification-manager&tab=".$tab."'>$name</a>";

        }


        $html_line .= '</h2>';

        $html_line .= '<div class="local-app-tab-separator">&nbsp;</div>';

        return $html_line;

    }

    function get_notification_settings_tab(){

        $this->check_save();

        $html_line = '<div class="tsl-admin-settings-holder">';

        $html_line .= '<form method="POST">';
        $html_line .= '<input type="hidden" value="'.$_REQUEST['page'].'" name="page">';

        if( isset($_REQUEST['slug'])){

            $html_line .= '<a href="?page=mam-notification-manager">'.mam_admin_settings::headline(__('Notifications Settings', $this->text_domain)).'</a>';
            $html_line .= '<input type="hidden" value="'.$_REQUEST['slug'].'" name="slug">';

            foreach ($this->settings_array as $item) {

                if( $item['id'] == $_REQUEST['slug'] ) {

                    $subject_value = get_option( 'tsl_notification_subject_' . $item['id'] );

                    $email_status_value = get_option( 'tsl_notification_email_status_' . $item['id'] );
                    $pn_status_value = get_option( 'tsl_notification_pn_status_' . $item['id'] );
                    $text_status_value = get_option( 'tsl_notification_text_status_' . $item['id'] );

                    $cc_email = get_option( 'tsl_notification_email_cc_' . $item['id'] );
                    $bcc_email = get_option( 'tsl_notification_email_bcc_' . $item['id'] );

                    if( $email_status_value == 1 ) $email_status_value = 'checked';
                    if( $pn_status_value == 1 ) $pn_status_value = 'checked';
                    if( $text_status_value == 1 ) $text_status_value = 'checked';

                    $email_text = get_option( 'tsl_notification_email_text_' . $item['id'] );
                    $pn_text = get_option( 'tsl_notification_pn_text_' . $item['id'] );
                    $text_text = get_option( 'tsl_notification_text_text_' . $item['id'] );

                    if($subject_value == '' && $email_text == '' && $pn_text == '' && $text_text == '' && isset($item['default_content']) && isset($item['default_on'])){
                        $subject_value = $item['title'];
                        $email_text = $pn_text = $text_text = $item['default_content'];
                        if(!empty($item['default_on'])){
                            foreach ($item['default_on'] as $default_on){
                                if($default_on == 'email'){
                                    $email_status_value = 'checked';
                                }elseif($default_on == 'sms'){
                                    $text_status_value = 'checked';
                                }elseif($default_on == 'push'){
                                    $pn_status_value = 'checked';
                                }
                            }
                        }
                    }

                    $html_line .= mam_admin_settings::sub_heading($item['title']);

                    $html_line .= '<table class="tsl-admin-pref-table">';

                    $html_line .= '<tr>';
                    $html_line .= '<td style="font-weight: bold;">Message Subject</td>';
                    $html_line .= '<td><input type="text" name="subject" id="subject" value="'.$subject_value.'"></td>';
                    $html_line .= '</tr>';

                    $html_line .= '<tr>';
                    $html_line .= '<td style="font-weight: bold;">Email Message</td>';
                    $html_line .= '<td align="right" style="font-weight: bold;">Active&nbsp;&nbsp;<input type="checkbox" id="email" name="email" value="1" '.$email_status_value.'></td>';
                    $html_line .= '</tr>';
                    $html_line .= '<tr>';
                    //$html_line .= '<td colspan="2"><textarea id="email_content" name="email_content" style="width: 100%;" rows="8">'.$email_text.'</textarea></td>';
                    $html_line .= '<td colspan="2">';
                    ob_start();
                    wp_editor($email_text, "email_content", array());
                    $html_line .= ob_get_clean();
                    $html_line .= '</td>';
                    $html_line .= '</tr>';

                    $html_line .= '<tr>';
                    $html_line .= '<td>CC Email to (separate with commas if more than one)</td>';
                    $html_line .= '<td><input type="text" name="email_cc_address" value="'.$cc_email.'" style="width:100%;"></td>';
                    $html_line .= '</tr>';

                    $html_line .= '<tr>';
                    $html_line .= '<td>BCC Email to (separate with commas if more than one)</td>';
                    $html_line .= '<td><input type="text" name="email_bcc_address" value="'.$bcc_email.'" style="width:100%;"></td>';
                    $html_line .= '</tr>';

                    $html_line .= '<tr>';
                    $html_line .= '<td style="font-weight: bold;">Push Notification Message</td>';
                    $html_line .= '<td align="right" style="font-weight: bold;">Active&nbsp;&nbsp;<input type="checkbox" id="pn" name="pn" value="1"' . $pn_status_value. '></td>';
                    $html_line .= '</tr>';
                    $html_line .= '<tr>';
                    $html_line .= '<td colspan="2"><textarea id="pn_content" name="pn_content" style="width: 100%;" rows="8">'.$pn_text.'</textarea></td>';
                    $html_line .= '</tr>';

                    $html_line .= '<tr>';
                    $html_line .= '<td style="font-weight: bold;">Text Message</td>';
                    $html_line .= '<td align="right" style="font-weight: bold;">Active&nbsp;&nbsp;<input type="checkbox" id="text_msg" name="text_msg" value="1" '.$text_status_value.'></td>';
                    $html_line .= '</tr>';
                    $html_line .= '<tr>';
                    $html_line .= '<td colspan="2"><textarea id="text_content" name="text_content" style="width: 100%;" rows="8">'.$text_text.'</textarea></td>';
                    $html_line .= '</tr>';

                    $html_line .= apply_filters( 'mam_notifications_notification_types' , '' , $item['id'] );


                    $html_line .= '<tr>';
                    $html_line .= '<td style="font-weight: bold;" colspan="2"><br><br>Replacement Field Options</td>';
                    $html_line .= '</tr>';

                    $html_line .= '<tr>';
                    $html_line .= '<td colspan="2">Use these fields to replace variables in your message.  Each field has a starting [ and ending ]</td>';
                    $html_line .= '</tr>';

                    $html_line .= '<tr>';
                    $html_line .= '<td colspan="2">';

                    $replace_string = '[app_badges], [opt_out], [opt_out_url], ';

                    foreach ( $item['replacements'] as $replace ){
                        $replace_string .= '['. $replace . '], ';
                    }

                    $html_line .=  rtrim( $replace_string , ', ' );

                    $html_line .= '</td>';
                    $html_line .= '</tr>';

                    $html_line .= '</table>';

                    $select = '<select style="float:right;margin-right:1em;" id="mam-user-id">';
                    $select .= '<option value="0">Select User...</option>';
                    $users = get_users();
                    foreach( $users as $user )
                    {
                        $select .= '<option value="'.$user->ID.'">'.$user->data->user_email.'</option>';
                    }
                    $select.= '</option>';


                    $html_line .= '<table class="tsl-admin-pref-table">';
                    $html_line .= '<tr>';
                    $html_line .= '<td></td>';
                    $html_line .= '<td></td>';
                    $html_line .= '<td>' . mam_admin_settings::submit_button() . '<input name="mam-not-send-test" id="mam-not-send-test" style="float:right;margin-right:1em;" class="button button-primary button-large" value="Send Test Message" type="button"><span id="mam-not-message-sent" style="float:right;margin-right:1em;color:green;display: none;">Messge Sent</span>'.$select.'</td>';
                    $html_line .= '</tr>';
                    $html_line .= '</table>';



                }
            }

        }else {

            $html_line .= '<input type="hidden" value="1" name="main">';

            $html_line .= mam_admin_settings::headline(__('Notifications Settings', $this->text_domain));
            $html_line .= '<h4>Notifications are messages that are sent to users based on certain events.  You can enable or disable specific notifications and customize the content of the messages here.</h4>';

            ob_start();
            ?>
            <style>.column-title{width:50%}</style>
            <div id="poststuff">
                <div id="post-body" class="metabox-holder columns-12">
                    <div id="post-body-content">
                        <div class="meta-box-sortables ui-sortable">
                                <?php
                                if ( class_exists( 'Notifications_List' ) ) {

                                    $notification_list = new Notifications_List();
                                    $notification_list->get_table_data($this->settings_array);
                                    $notification_list->prepare_items();
                                    $notification_list->display();
                                }
                                ?>
                        </div>
                    </div>
                </div>
                <br class="clear">
            </div>
            <?php
            $html_line .= ob_get_clean();


            $html_line .= '<br><br>';
            $checked = '';
            if( get_option( 'mam_notification_use_cron' ) == 1 ) $checked = 'checked';
            $html_line .= mam_admin_settings::make_checkbox_html( 'mam_notification_use_cron', $checked , '1', 'Use CRON?' );
            $html_line .= '<div style="margin-left:2em">If checked, notifications will be sent in the background.  The background job runs every minute. This is only needed when you send large numbers of notifications.  Note that emails are automatically sent via cron job is more than 10 are sent at a time.</div>';
            $html_line .= '<br><br>';
            $html_line .= mam_admin_settings::make_standard_submit_html();

        }

        $html_line .= '</form>';

        $html_line .= '</div>';

        return $html_line;

    }

    function get_notifications_listing_tab(){

        $html_line = '';
        if(isset($_REQUEST['action']) && $_REQUEST['action'] == 'add-new'){
            $html_line .= $this->add_new_notification();
            return $html_line;
        }elseif(isset($_REQUEST['action']) && $_REQUEST['action'] == 'edit' && $_REQUEST['id'] > 0) {
            $html_line .= $this->edit_notification();
            return $html_line;
        }

        ob_start();
        $actual_link = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[SCRIPT_NAME]";
        ?>
        <a href="<?php echo $actual_link.'?page=mam-notification-manager&tab=notifications-listing&action=add-new';?>" class="button">Add New</a>
        <div id="poststuff">
            <div id="post-body" class="metabox-holder columns-12">
                <div id="post-body-content">
                    <div class="meta-box-sortables ui-sortable">
                        <form method="post">
                            <?php
                            $custom_notifications_list = new Custom_Notifications_List();
                            $custom_notifications_list->prepare_items();
                            $custom_notifications_list->display();
                            ?>
                        </form>
                    </div>
                </div>
            </div>
            <br class="clear">
        </div>
        <?php

        $html_line .= ob_get_clean();
        return $html_line;

    }

    function add_new_notification(){
        global $wpdb;
        if(isset($_POST['mam_custom_notification_title'])){
            $table_name = $wpdb->prefix . 'mam_custom_notifications';
            $title = trim($_POST['mam_custom_notification_title']);
            $slug = sanitize_title($_POST['mam_custom_notification_title']);
            $trigger = $_POST['mam_custom_notification_trigger'];
            $trigger_days = isset($_POST['mam_custom_notification_trigger_days']) ? $_POST['mam_custom_notification_trigger_days'] : "";
            $frequency = $_POST['mam_custom_notification_frequency'];
            $frequency_days = isset($_POST['mam_custom_notification_frequency_days']) ? $_POST['mam_custom_notification_frequency_days'] : "";
            $wpdb->query("INSERT INTO $table_name (`title`, `slug`, `trigger`, `trigger_days`, `frequency`, `frequency_days`) VALUES('".$title."', '".$slug."', '".$trigger."', '".$trigger_days."', '".$frequency."', '".$frequency_days."')");
            wp_redirect('?page=' . $this->plugin_slug.'&tab=notifications-listing');
            exit;
        }
        $html_line = '<form action="" method="post">';
        $html_line .= '<table class="form-table"><tbody>';
        $html_line .= '<tr><td>Title:</td><td><input type="text" name="mam_custom_notification_title" value="" class="regular-text"></td></tr>';
        $html_line .= '<tr><td>Trigger:</td><td><select name="mam_custom_notification_trigger" id="mam_custom_notification_trigger"><option value="">Select...</option><option value="first-login">First Login</option><option value="not-logged-in-xx-days">Not logged in in the past XX days</option></select> &nbsp; <input type="number" name="mam_custom_notification_trigger_days" id="mam_custom_notification_trigger_days" value="" min="1" style="vertical-align: middle;"></td></tr>';
        $html_line .= '<tr><td>Max frequency:</td><td><select name="mam_custom_notification_frequency" id="mam_custom_notification_frequency"><option value="">Select...</option><option value="one-time">Only one time</option><option value="once-per-two-weeks">Once per two weeks</option><option value="once-per-month">Once per Month</option><option value="every-xx-days">Every XX days</option></select> &nbsp; <input type="number" name="mam_custom_notification_frequency_days" id="mam_custom_notification_frequency_days" value="" min="1" style="vertical-align: middle;"></td></tr>';
        $html_line .= '<tr><td>&nbsp;</td><td><input type="submit" value="Submit" class="button button-primary button-large"></td></tr>';
        $html_line .= '</tbody></table>';
        $html_line .= '</form>';

        return $html_line;
    }

    function edit_notification(){
        global $wpdb;
        $table_name = $wpdb->prefix . 'mam_custom_notifications';
        if(isset($_POST['mam_custom_notification_title'])){
            $table_name = $wpdb->prefix . 'mam_custom_notifications';
            $title = trim($_POST['mam_custom_notification_title']);
            $trigger = $_POST['mam_custom_notification_trigger'];
            $trigger_days = isset($_POST['mam_custom_notification_trigger_days']) ? $_POST['mam_custom_notification_trigger_days'] : "";
            $frequency = $_POST['mam_custom_notification_frequency'];
            $frequency_days = isset($_POST['mam_custom_notification_frequency_days']) ? $_POST['mam_custom_notification_frequency_days'] : "";
            $wpdb->query("UPDATE $table_name SET `title`='".$title."', `trigger`='".$trigger."', `trigger_days`='".$trigger_days."', `frequency`='".$frequency."', `frequency_days`='".$frequency_days."' WHERE id='".$_REQUEST['id']."'");
            wp_redirect('?page=' . $this->plugin_slug.'&tab=notifications-listing');
            exit;
        }
        $this_notification = $wpdb->get_results("SELECT * FROM $table_name WHERE id='".$_REQUEST["id"]."'", ARRAY_A);
        if (!empty($this_notification)){
            $trigger_style = ($this_notification[0]["trigger"] == "not-logged-in-xx-days") ? "" : "display:none";
            $frequency_style = ($this_notification[0]["frequency"] == "every-xx-days") ? "" : "display:none";
            $html_line = '<form action="" method="post">';
            $html_line .= '<table class="form-table"><tbody>';
            $html_line .= '<tr><td>Title:</td><td><input type="text" name="mam_custom_notification_title" value="'.$this_notification[0]["title"].'" class="regular-text"></td></tr>';
            $html_line .= '<tr><td>Trigger:</td><td><select name="mam_custom_notification_trigger" id="mam_custom_notification_trigger"><option value="">Select...</option><option value="first-login" '.(($this_notification[0]["trigger"] == "first-login") ? "selected='selected'" : "").'>First Login</option><option value="not-logged-in-xx-days" '.(($this_notification[0]["trigger"] == "not-logged-in-xx-days") ? "selected='selected'" : "").'>Not logged in in the past XX days</option></select> &nbsp; <input type="number" name="mam_custom_notification_trigger_days" id="mam_custom_notification_trigger_days" value="'.$this_notification[0]["trigger_days"].'" min="1" style="vertical-align: middle; '.$trigger_style.'"></td></tr>';
            $html_line .= '<tr><td>Max frequency:</td><td><select name="mam_custom_notification_frequency" id="mam_custom_notification_frequency"><option value="">Select...</option><option value="one-time" '.(($this_notification[0]["frequency"] == "one-time") ? "selected='selected'" : "").'>Only one time</option><option value="once-per-two-weeks" '.(($this_notification[0]["frequency"] == "once-per-two-weeks") ? "selected='selected'" : "").'>Once per two weeks</option><option value="once-per-month" '.(($this_notification[0]["frequency"] == "once-per-month") ? "selected='selected'" : "").'>Once per Month</option><option value="every-xx-days" '.(($this_notification[0]["frequency"] == "every-xx-days") ? "selected='selected'" : "").'>Every XX days</option></select> &nbsp; <input type="number" name="mam_custom_notification_frequency_days" id="mam_custom_notification_frequency_days" value="'.$this_notification[0]["frequency_days"].'" min="1" style="vertical-align: middle; '.$frequency_style.'"></td></tr>';
            $html_line .= '<tr><td>&nbsp;</td><td><input type="submit" value="Submit" class="button button-primary button-large"></td></tr>';
            $html_line .= '</tbody></table>';
            $html_line .= '</form>';
        }else{
            $html_line = '<p>Record not found!</p>';
        }

        return $html_line;
    }
}
