<?php
/**
 * Created by PhpStorm.
 * User: Fred
 * Date: 2019-04-30
 * Time: 13:23
 */

class mam_notification_message_sender
{

    function send_message( $message_array )
    {

        $notification_array = apply_filters('mam_notification_list', array());

        $messages = array();
        if( isset( $message_array['message_type']) )
        {
            $messages[] = $message_array;
        }else{
            $messages = $message_array;
        }

        $use_cron_if_available = false;
        if( sizeof($messages) > 10 ) $use_cron_if_available = true;

        foreach( $messages as $data_array ) {

            if ($data_array['message_type'] == 'system_chat') {

                $this_array['title'] = 'New chat message';
                $this_array['message'] = wp_strip_all_tags($data_array['message']);
                $target = get_permalink($data_array['target']);
                if (strlen($target > 0)) {
                    $this_array['target'] = $target;
                } else {
                    $this_array['target'] = $data_array['target'];
                }
                $this_array['user_id'] = $data_array['recipient_id'];
                $this_array['immediate'] = true;
                $this_array['is_silent'] = false;

                if (isset($data_array['data'])) $this_array['data'] = $data_array['data'];

                $this_pn_array[] = $this_array;

                do_action( 'mam_notification_send_pn', $this_pn_array);

                return;

            } else {

                $existing_slugs = array();
                foreach ($notification_array as $item) {

                    if( in_array( $item['slug'] , $existing_slugs )) continue;
                    $existing_slugs[] = $item['slug'];

                    if ($item['slug'] == $data_array['message_type']) {

                        if ( $data_array['send_text'] && (isset($data_array['phone']) || get_user_meta($data_array['recipient_id'], 'billing_phone', true)) && (get_option('tsl_notification_text_status_' . $item['slug']) || ( is_array( $item['default_on']) && in_array('sms', $item['default_on'])))) {

                            $to = null;

                            if (get_user_meta($data_array['recipient_id'], 'billing_phone', true)) {
                                $to = '1' . str_replace('-', '', get_user_meta($data_array['recipient_id'], 'billing_phone', true));
                            } else {
                                $data_array['phone'] = str_replace('-', '', $data_array['phone']);
                                $data_array['phone'] = str_replace('(', '', $data_array['phone']);
                                $data_array['phone'] = str_replace(')', '', $data_array['phone']);
                                $data_array['phone'] = str_replace('+', '', $data_array['phone']);
                                $data_array['phone'] = str_replace(' ', '', $data_array['phone']);
                                if (strlen($data_array['phone']) == 10) {
                                    $to = '1' . $data_array['phone'];
                                } else if (strlen($data_array['phone']) == 11 && substr($data_array['phone'], 0, 1) == 1) {
                                    $to = $data_array['phone'];
                                } else {
                                    mamdebug('admin_alert', 'Invalid phone ' . $data_array['phone'] );
                                }
                            }

                            if(get_option('tsl_notification_text_text_' . $item['slug']) == '' && isset($item['default_content']) && $item['default_content'] != ''){
                                $content = $this->replace_values($item['default_content'], $data_array['replacements']);
                            }else{
                                $content = $this->replace_values(get_option('tsl_notification_text_text_' . $item['slug']), $data_array['replacements']);
                            }

                            if( $use_cron_if_available && get_option('mam_notification_use_cron') == 1 && isset($data_array['recipient_id'])) {
                                mam_cron_mail::add_to_push_notifications($data_array['recipient_id'], '', $content, $data_array['target'], true, false);
                            } else if ($to) {

                                $content .= PHP_EOL . PHP_EOL . 'To opt out reply STOP';

                                global $sms;
                                if ($sms) {
                                    $sms->to = array($to);
                                    $sms->msg = $content;
                                    $sms->SendSMS();
                                }
                            }

                            $this_array['title'] = 'No Subject';
                            $this_array['message'] = $content;
                            $this_array['target'] = get_permalink($data_array['target']);
                            $this_array['user_id'] = $data_array['recipient_id'];
                            $this_array['immediate'] = $data_array['send_now'];
                            $this_array['is_silent'] = $data_array['is_silent'];
                            $this_array['recipient_id'] = $data_array['recipient_id'];
                            $this_array['phone'] = $data_array['phone'];
                            if (isset($data_array['from_id'])) $this_array['from_id'] = $data_array['from_id'];

                            $this->add_to_history($this_array, 'sms');


                        } //end of send text message

                        $subject = $this->replace_values(get_option('tsl_notification_subject_' . $item['slug']), $data_array['replacements']);
                        if(trim($subject) == ''){
                            $subject = $this->replace_values($item['title'], $data_array['replacements']);
                        }

                        if (isset($data_array['send_email'])) {
                            //send via alternate channels
                            do_action('mam_notifications_notification_send_message', $data_array);
                        }

                        if ($data_array['send_email'] && isset($data_array['email']) && (get_option('tsl_notification_email_status_' . $item['slug']) || ( isset( $item['default_on'] ) && is_array( $item['default_on'] ) && in_array('email', $item['default_on'])))){

                            $processEmail = true;

                            if( strpos($item['default_content'], '[opt_out_url]') !== false || strpos($item['default_content'], '[opt_out]') !== false )
                            {

                                global $wpdb;
                                $table_name = $wpdb->prefix . 'mam_email_opted_out';
                                $opt_out = $wpdb->get_results("SELECT * FROM $table_name WHERE opted_out IS NOT NULL AND email = '" . $data_array['email'] . "'", ARRAY_A);

                                if (sizeof($opt_out) > 0) {
                                    $processEmail = false;
                                }
                            }

                            if (isset($data_array['force_email'])) {
                                $processEmail = true;
                            }

                            if ($processEmail) {

                                if(get_option('tsl_notification_email_text_' . $item['slug']) == '' && isset($item['default_content']) && $item['default_content'] != ''){
                                    $content = $this->replace_values($item['default_content'], $data_array['replacements'], $data_array['email']);
                                }else{
                                    $content = $this->replace_values(get_option('tsl_notification_email_text_' . $item['slug']), $data_array['replacements'], $data_array['email']);
                                }

                                $headers = array();
                                $cc_email = get_option( 'tsl_notification_email_cc_' . $item['slug'] );
                                $bcc_email = get_option( 'tsl_notification_email_bcc_' . $item['slug'] );
                                if( $cc_email != '' ){
                                    $cc_email = explode( ',', $cc_email );
                                    foreach($cc_email as $cc){
                                        $headers[] = 'Cc: ' . trim($cc);
                                    }
                                }
                                if( $bcc_email != '' ){
                                    $bcc_email = explode( ',', $bcc_email );
                                    foreach($bcc_email as $cc){
                                        $headers[] = 'Bcc: ' . trim($cc);
                                    }
                                }

                                if ( $use_cron_if_available && get_option('mam_notification_use_cron') == 1) {

                                    $sender_id = 0;
                                    if( isset($data_array['from_id'])){
                                        $sender_id = $data_array['from_id'];
                                    } else if( isset($_REQUEST['pid']) && $_REQUEST['pid'] != '' ) {
                                        $user = get_users(array('meta_key' => 'mam_app_token', 'meta_value' => $_REQUEST['pid']));
                                        if ($user) {
                                            $sender_id = $user[0]->ID;
                                        }
                                    }
                                    if( ! $sender_id && get_current_user_id() ) $sender_id = get_current_user_id();

                                    mam_cron_mail::add_to_mail($data_array['email'], $subject, $content, $headers, array(), null, null, $sender_id );
                                } else {
                                    wp_mail($data_array['email'], $subject, $content, $headers);
                                }

                                $data_array['title'] = $subject;
                                $data_array['message'] = $content;

                                $this->add_to_history($data_array, 'email');
                            }

                        }//end of send email message


                        if ($data_array['send_pn'] && isset($data_array['recipient_id']) && (get_option('tsl_notification_pn_status_' . $item['slug']) || ( is_array( $item['default_on'] ) && in_array('push', $item['default_on'])))) {

                            if(get_option('tsl_notification_pn_text_' . $item['slug']) == '' && isset($item['default_content']) && $item['default_content'] != ''){
                                $content = $this->replace_values($item['default_content'], $data_array['replacements']);
                            }else{
                                $content = $this->replace_values(get_option('tsl_notification_pn_text_' . $item['slug']), $data_array['replacements']);
                            }
                            $subject = $this->replace_values(get_option('tsl_notification_subject_' . $item['slug']), $data_array['replacements']);
                            if(trim($subject) == ''){
                                $subject = $this->replace_values($item['title'], $data_array['replacements']);
                            }

                            if( $use_cron_if_available && get_option('mam_notification_use_cron') == 1) {
                                mam_cron_mail::add_to_push_notifications($data_array['recipient_id'], $subject, $content, $data_array['target'], false, true, $data_array['is_silent']);
                            } else {

                                $this_array = array();
                                $this_array['title'] = stripslashes(wp_strip_all_tags($subject));
                                $this_array['message'] = $content;
                                $this_array['target'] = get_permalink($data_array['target']);
                                $this_array['user_id'] = $data_array['recipient_id'];
                                $this_array['immediate'] = $data_array['send_now'];
                                $this_array['is_silent'] = $data_array['is_silent'];

                                $this_pn_array = array();
                                $this_pn_array[] = $this_array;

                                global $wpdb;
                                $table_name = $wpdb->prefix . 'mam_notifications_manager';
                                $wpdb->insert($table_name, array('user_id' => $this_array['user_id'], 'title' => $this_array['title'], 'message' => $this_array['message'], 'target' => $this_array['target'], 'nonce' => "nononce", 'data_json' => "nothing", 'is_silent' => $this_array['is_silent']));

                                do_action('mam_notification_send_pn', $this_pn_array);

                            }
                            $this_array['title'] = stripslashes(wp_strip_all_tags($subject));
                            $this_array['message'] = $content;
                            $this_array['target'] = get_permalink($data_array['target']);
                            $this_array['user_id'] = $data_array['recipient_id'];
                            $this_array['immediate'] = $data_array['send_now'];
                            $this_array['is_silent'] = $data_array['is_silent'];
                            $this_array['recipient_id'] = $data_array['recipient_id'];
                            if (isset($data_array['from_id'])) $this_array['from_id'] = $data_array['from_id'];

                            $this->add_to_history($this_array, 'pn');

                        }//end of send push notification
                    }
                }
            }
        }
    }

    function add_to_history( $data_array , $type )
    {

        if( sizeof( $data_array) == 0 ) return;

        global $wpdb;

        $table_name = $wpdb->prefix . 'mam_email_history';

        if( isset($data_array['email'])) {
            $to_email = $data_array['email'];
        }
        if( $type == 'sms') $to_email = $data_array['phone'];

        $sender_id = 0;
        if( isset($data_array['from_id'])){
            $sender_id = $data_array['from_id'];
        } else if( isset($_REQUEST['pid']) && $_REQUEST['pid'] != '' ) {
            $user = get_users(array('meta_key' => 'mam_app_token', 'meta_value' => $_REQUEST['pid']));
            if ($user) {
                $sender_id = $user[0]->ID;
            }
        }
        if( ! $sender_id && get_current_user_id() ) $sender_id = get_current_user_id();

        $sql_array = array('user_id' => $sender_id, 'recipient_id' => $data_array['recipient_id'] , 'title' => $data_array['title'], 'message' => '', 'to_email' => $to_email, 'msg_type' => $type );

        $wpdb->insert($table_name, $sql_array );

    }

    function replace_values( $content , $replacements , $email = '' )
    {

        $client_code = '';
        if( is_array( $replacements ))
        {
            foreach ($replacements as $index => $replacement) {
                if( $index == 'client_code' ) $client_code = $replacement;
                if( $index == 'code' ) $client_code = $replacement;
                $content = str_replace('[' . $index . ']', $replacement, $content);
            }
        }

        $height = 40;
        $aspect = 135/40;
        $width = $height * $aspect;

        $url = get_option( 'mam-itunes-app-url' );
        $url = apply_filters( 'mam_app_badge_url', $url , $client_code );

        $ios_badge = '';
        if (get_option('mam-itunes-app-url')) {
            $ios_badge = '<a href="' . $url . '" target="_blank" style="display:inline-block;overflow:hidden;background:url(' . site_url() . '/wp-content/plugins/mam-main/images/ios-badge.png' . ') no-repeat;height:' . $height . 'px;;width:' . $width . 'px;background-size:contain;"></a>';
        }

        $url = get_option( 'mam-android-app-url' );
        $url = apply_filters( 'mam_app_badge_url', $url , $client_code );

        $and_badge = '';
        if (get_option('mam-android-app-url')) {
            $and_badge = '<a href="' . $url . '" target="_blank" style="display:inline-block;overflow:hidden;background:url(' . site_url() . '/wp-content/plugins/mam-main/images/android-badge.png' . ') no-repeat;height:' . $height . 'px;;width:' . $width . 'px;background-size:contain;"></a>';
        }

        $app_badge_html = '<table><tr><td>' . $ios_badge . '</td><td>' . $and_badge . '</td></tr></table>';
        $content = str_replace('[app_badges]', $app_badge_html, $content);

        if($email != '') {

            global $wpdb;
            $table_name = $wpdb->prefix . 'mam_email_opted_out';

            $opt_out = $wpdb->get_results("SELECT * FROM $table_name WHERE email = '" . $email . "'", ARRAY_A);

            if( sizeof($opt_out) > 0 ) {
                $code = $opt_out[0]['email_code'];
            }else{
                $code = uniqid();
                $wpdb->insert($table_name, array('email' => $email, 'email_code' => $code));
            }

            $opt_out = 'Click here to opt out of future messages: <a href="' . site_url() . '/wp-admin/admin-ajax.php?action=mam_notification_opt_out&code='.$code.'">Opt Out</a>';

            $content = str_replace('[opt_out_url]', '<a href="' . site_url() . '/wp-admin/admin-ajax.php?action=mam_notification_opt_out&code='.$code.'">Opt Out</a>', $content);
            $content = str_replace('[opt_out]', $opt_out, $content);
        }

        return $content;
    }
}
