<?php
if ( ! class_exists( 'WP_List_Table' ) )
	require_once( ABSPATH . 'wp-admin/includes/class-wp-list-table.php' );

class mam_notification_opt_out_grid extends WP_List_Table {

	public $current_page;

    function __construct() {
		parent::__construct( array(
			'singular' => 'post',
			'plural' => 'posts',
			'ajax' => true,
			'screen' => 'interval_list') );
	}

    function prepare_items() {

		$per_page = 10;
        $columns = $this->get_columns();
        $hidden = array();
        $sortable = array();

        $this->_column_headers = array($columns, $hidden, $sortable);

		$args = array(
			'posts_per_page' => $per_page,
			'orderby' => 'plugin',
			'order' => 'ASC',
			'offset' => ( $this->get_pagenum() - 1 ) * $per_page );

		if ( ! empty( $_REQUEST['s'] ) )
			$args['s'] = $_REQUEST['s'];

		if ( ! empty( $_REQUEST['orderby'] ) ) {
			if ( 'left_column' == $_REQUEST['left_column'] )
				$args['orderby'] = 'left_column';
		}

		if ( ! empty( $_REQUEST['order'] ) ) {
			if ( 'asc' == strtolower( $_REQUEST['order'] ) )
				$args['order'] = 'ASC';
			elseif ( 'desc' == strtolower( $_REQUEST['order'] ) )
				$args['order'] = 'DESC';
		}

        $per_page     = $this->get_items_per_page( 'analytics_per_page', $per_page );
        $current_page = $this->get_pagenum();

		$total_items = $this->get_grid_data_count();
		$total_pages = ceil( $total_items / $per_page );

		$this->set_pagination_args( array(
            'total_items' => $total_items,
            'per_page'    => $per_page
        ) );

        $this->items = $this->get_grid_data( $per_page , $current_page);

	}

	function get_columns() {

        $columns = array(
            'column-restore' => __( 'Restore', 'local-app-manger' ),
            'column-one' => __( 'Email Address', 'local-app-manger' ),
            'column-two' =>   __( 'Opt Out Date', 'local-app-manger' ),
        );

        return $columns;

	}

	function get_bulk_actions() {
		$actions = array();

		return $actions;
	}

	function column_default( $item, $column_name ) {
		switch( $column_name ) {
			case 'column-restore':
            case 'column-one':
			case 'column-two':
			return $item[ $column_name ];
            default:
              return print_r( $item, true ) ;
            }
	}

    function get_grid_data( $per_page , $current_page){

        $items = array();

        global $wpdb;

        $record_offset = $current_page * $per_page - $per_page;

        $table_name = $wpdb->prefix . 'mam_email_opted_out';
        $posts = $wpdb->get_results("SELECT * FROM $table_name WHERE opted_out IS NOT NULL ORDER BY opted_out DESC LIMIT ". $record_offset . ' , ' . $per_page, ARRAY_A);

        foreach($posts as $post ){

            $items[] = array(
                'column-restore' => '<input type="checkbox" name="mam_optout_email_code[]" value="' . $post['email_code'] . '"/>',
                'column-one' => $post['email'],
                'column-two' => date( 'M d, Y h:i A', $post['opted_out'] ),
            );
        }

        return $items;

    }

	function get_grid_data_count(){

        global $wpdb;
        $table_name = $wpdb->prefix . 'mam_email_opted_out';
        $opt_out = $wpdb->get_results("SELECT * FROM $table_name WHERE opted_out IS NOT NULL", ARRAY_A);

        if(is_array($opt_out)) {
            return sizeof($opt_out);
        }
        return 0;

	}

}
