<?php

class mam_rest_api_connection
{

    function register_routes()
    {

        register_rest_route('mam/v1', '/update', [
            'methods' => ['GET','POST'],
            'callback' => array( $this, 'handle_mam_update'),
            'permission_callback' => '__return_true', // Adjust based on your authentication requirements
            'args' => [
               '*' => [
                    'description' => 'Any parameters',
                    'type' => 'array',
                    'items' => [
                        'type' => 'mixed'
                    ],
               ]
            ],
        ]);

    }

    function handle_mam_update(WP_REST_Request $request)
    {

        //https://mealgeniestg.wpenginepowered.com/wp-json/mam/v1/update?subaction=mam_update_json&pingkey=sdfh89y7f8dostogas67of87sd&action=mam_main_ajax&pid=17AEE94511E94022A7469918DFEC4924&actual_lat=0.000000&actual_lon=0.000000&radius=50.000000&refreshJson=1&gmtoffset=-5.000000&dst=1&timestamp=1729886618.495383

        $_REQUEST = $request->get_params();
        $data_array = array();
        $data_array['status'] = 'success';

        $method = $_SERVER['REQUEST_METHOD'];
        mamdebug('request', $_REQUEST );
        mamdebug('request', $method );

        if( isset($_REQUEST['action']) && $_REQUEST['action'] == 'local_app_get_phone_data' )
        {
            $data_array = local_app_get_phone_data(true);
        }else if( isset( $_REQUEST['subaction'] )) {
            if ($_REQUEST['subaction'] == 'mam_update_json') {
                $data_array['jsonData'] = local_app_get_phone_data(true);
            }else if ($_REQUEST['subaction'] == 'mam_entered_background')
            {
                $data_array['status'] = 'success';
                wp_send_json($data_array);
                die();
            }else if (has_action($_REQUEST['subaction']))
            {

                do_action($_REQUEST['subaction']);
                if (isset($_REQUEST['reload'])) {
                    $data_array['status'] = 'success';
                    $data_array['jsonData'] = local_app_get_phone_data(true);
                }
            }else{
                do_action('mam_main_ajax');
            }
        }

        wp_send_json($data_array);
        die();

    }

}
