<?php
class mam_setcron_manager_admin_settings{

    /**
     * Function to display page content as tabs
     */
    function add_settings_page()
    {

        if (!current_user_can('manage_options')) return 'No one is home';

        $html = '<div class="local-app-main-content-area">';
        $html .= mam_admin_settings::headline(__('Scheduled Jobs List', 'mam-main'));
        $html .= '<h4>This is the list of jobs that can run in the background.  If your app requires them to run then you can see their status here.  If status and Next Run are not displayed, then you might need to setup the cron service in the Cronjob Settings tab</h4>';

        $html .= $this->add_page_tabs();

        $html .= '<div class="mam-setcron-tab-holder">';

        $current = 'cronjob-listing';
        if (isset($_REQUEST['tab'])) $current = $_REQUEST['tab'];

        switch ($current) {
            case 'cronjob-listing':
                $html .= $this->get_cronjob_listing_tab();
                break;
            case 'cronjob-settings':
                $html .= $this->get_cronjob_settings_tab();
                break;
        }

        $html .= '</div>';

        $html .= '</div>';

        echo $html;

    }

    /**
     * Function to add page tab
     */
    function add_page_tabs(){

        $current = 'cronjob-listing';
        if(isset($_REQUEST['tab'])) $current = $_REQUEST['tab'];

        $tabs['cronjob-listing'] = 'Scheduled Jobs';
        $tabs['cronjob-settings'] = 'Cronjob Settings';

        $actual_link = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[SCRIPT_NAME]";
        $actual_link = str_replace('__wp__/','', $actual_link );

        $html_line = '';

        $html_line .= '<div id="icon-themes" class="icon32"><br></div>';
        $html_line .= '<h2 class="nav-tab-wrapper">';

        foreach( $tabs as $tab => $name ){
            $class = ( $tab == $current ) ? ' nav-tab-active' : '';
            $html_line .= "<a class='nav-tab$class' href='".$actual_link."?page=mam-setcron-manager&tab=".$tab."'>$name</a>";

        }


        $html_line .= '</h2>';

        $html_line .= '<div class="local-app-tab-separator">&nbsp;</div>';

        return $html_line;

    }

    /**
     * Function to display available cron jobs
     */
    function get_cronjob_listing_tab(){

        ob_start();
        ?>
        <div id="poststuff">
            <div id="post-body" class="metabox-holder columns-12">
                <div id="post-body-content">
                    <div class="meta-box-sortables ui-sortable">
                        <form method="post">
                            <?php
                            if ( class_exists( 'Cron_List' ) ) {
                                $cron_list = new Cron_List();
                                $cron_list->prepare_items();
                                $cron_list->display();
                            }
                            ?>
                        </form>
                    </div>
                </div>
            </div>
            <br class="clear">
        </div>
        <?php

        return ob_get_clean();
    }

    /**
     * Function to display form to save cron job api key
     */
    function get_cronjob_settings_tab(){

        $html = '<h4>Cron jobs can be run using the WPCron service or by using FastCron. If your site gets infrequent traffic, or you need higher reliability running scheduled jobs then we recommend using FastCron. To use FastCron, go to <a href="https://app.fastcron.com/signup?r=QN3EFATB" target="_blank">FastCron</a> and setup and account.  Then enter your API key below.</h4>';

        $setcron_api = (trim(get_option('tsl-setting-setcron-api', true)) == 1) ? '' : trim(get_option('tsl-setting-setcron-api', true));
        $html .= '<form method="post">';
        $html .= '<table class="form-table">';
        $html .= '<tbody>';
        $html .= '<tr>';
        $html .= '<th scope="row"><label for="setcron_api">API Key</label></th>';
        $html .= '<td><input name="setcron_api" type="text" id="setcron_api" value="'.$setcron_api.'" class="regular-text"></td>';
        $html .= '</tr>';
        $html .= '</tbody>';
        $html .= '</table>';
        $html .= '<p class="submit">';
        $html .= wp_nonce_field( 'mam_setcron_settings_nonce', 'mam_setcron_settings_nonce', true, false );
        $html .= get_submit_button( __( 'Save Changes' ), 'primary', 'mam_setcron_settings', false );
        $html .= '</p>';
        $html .= '</form>';

        return $html;
    }

    /**
     * Process a save settings
     */
    function mam_setcron_save_settings() {

        if( empty( $_POST['mam_setcron_settings'] ) )
            return;

        if( ! wp_verify_nonce( $_POST['mam_setcron_settings_nonce'], 'mam_setcron_settings_nonce' ) )
            return;

        if( ! current_user_can( 'manage_options' ) )
            return;

        $old_api = get_option('tsl-setting-setcron-api', true);
        if(trim($old_api) != trim($_POST['setcron_api'])){
            update_option('tsl-setting-setcron-api', trim($_POST['setcron_api']));

        }
        $this->mam_setcron_manager_register();
    }

    function mam_setcron_manager_register(){

        $args = array(
            'url' => admin_url('admin-ajax.php?action=mam_setcron_processor')
        );
        if ( class_exists( 'tsl_setcron_manager' ) ) {
            $tsl_setcron_manager = new tsl_setcron_manager(admin_url('admin-ajax.php'));
            $tsl_setcron_manager->set_main_cron_job($args);
        }
    }
}
