<?php

class mam_setcron_manager{

    public function add_setcron_manager_page()
    {
        $mam_setcron_manager_admin_settings = new mam_setcron_manager_admin_settings();
        $mam_setcron_manager_admin_settings->add_settings_page();
    }

    function mam_setcron_processor(){

        $timezoneString = wp_timezone_string();
        if( strpos( $timezoneString, ':' ) !== false ) {
            list($hours, $minutes) = explode(':', $timezoneString);
            $seconds = $hours * 60 * 60 + $minutes * 60;
            $timezoneString = timezone_name_from_abbr('', $seconds, 1);
            if ($timezoneString === false) $timezoneString = timezone_name_from_abbr('', $seconds, 0);
        }
        date_default_timezone_set($timezoneString );

        $available_crons = apply_filters( 'mam_cron_manager', array() );
        if(!empty($available_crons)){
            foreach($available_crons as $cron){
                $this_cron_settings = get_option($cron['action'], true);
                if( ! is_array( $this_cron_settings )){
                    $this_cron_settings = array();
                    $this_cron_settings['last_run'] = date('M d, Y H:i:s', strtotime('-15 minutes'));
                    $this_cron_settings['next_run'] = date('M d, Y H:i:s', strtotime('-15 minutes'));
                    if(array_key_exists('run_at', $cron)){
                        $cron['run_at'] = str_pad($cron['run_at'],  4, "0", STR_PAD_RIGHT);
                        $results['next_run'] = date('M d, Y H:i:s', strtotime(date('M d, Y').' '.$cron['run_at']));
                        if(strtotime($results['next_run']) < strtotime(date('M d, Y g:i:s A'))){
                            $results['next_run'] = date('M d, Y g:i:s A', strtotime( '+'.$cron['frequency'].' minutes', strtotime(date('M d, Y').' '.$cron['run_at'].'00')));
                            update_option( $cron['action'], $results, false );
                        }
                    }else{
                        $results['next_run'] = date('M d, Y H:i:s', strtotime('+'.$cron['frequency'].' minutes', strtotime(date( 'M d, Y H:i:s' ))));
                        update_option( $cron['action'], $results, false );
                    }
                }

                $next_run_date = date('M d, Y H:i:s', strtotime('-15 minutes'));
                if(array_key_exists('next_run', $this_cron_settings)){
                    $next_run_date = $this_cron_settings['next_run'];
                }

                $current_time = date('M d, Y H:i:s');
                if( strtotime($next_run_date) < strtotime($current_time) ){
                    $results = apply_filters($cron['action'], array() );
                    $results['last_run'] = $current_time;
                    if(array_key_exists('run_at', $cron)){
                        $cron['run_at'] = str_pad($cron['run_at'],  4, "0", STR_PAD_RIGHT);
                        $results['next_run'] = date('M d, Y H:i:s', strtotime(date('M d, Y').' '.$cron['run_at']));
                        if(strtotime($results['next_run']) < strtotime($current_time)){
                            $results['next_run'] = date('M d, Y g:i:s A', strtotime( '+'.$cron['frequency'].' minutes', strtotime(date('M d, Y').' '.$cron['run_at'].'00')));
                        }
                    }else{
                        $results['next_run'] = date('M d, Y H:i:s', strtotime($current_time) + ($cron['frequency']*60));
                    }

                    update_option( $cron['action'], $results, false );
                }
            }
        }
        $status['done'] = 'success';
        wp_send_json($status);
        die();
    }

}
