<?php

class tsl_setcron_manager
{


    private $api_token = '';
    private $base_url = 'https://www.fastcron.com/api/v1/';
    private $target_url = null;


    function __construct( $target_url = null )
    {

        $this->target_url = $target_url;
        $this->api_token = (trim(get_option('tsl-setting-setcron-api', true)) == 1) ? '' : trim(get_option('tsl-setting-setcron-api', true));

    }

    function set_main_cron_job( $args = array() )
    {

        $cron_jobs = $this->get_all_cron_jobs();

        $cron_exists = false;

        foreach( $cron_jobs as $cron_job ) {

            $pos = strpos($cron_job['url'], $this->target_url);

            if ($pos !== false) {
                $cron_exists = true;
            }
        }

        if( !$cron_exists ) {

            $url_parts = parse_url( $this->target_url );
            $url_parts['host'];

            if (!isset($args['url'])) $args['url'] = $this->target_url;
            if (!isset($args['expression'])) $args['expression'] = '1 minute';
            if (!isset($args['name'])) $args['name'] = 'Mobile App MangerJob Runner';

            $get_string = '';

            foreach( $args as $index => $value )
            {
                $get_string .= '&'.$index.'='.$value;
            }

            $url = $this->base_url . 'cron.add?token='.$this->api_token . $get_string;

            $response = wp_remote_get( $url );

            if ( is_array( $response ) && ! is_wp_error( $response ) ) {
                $body    = json_decode($response['body'], true);
                if( $body['status'] == 'success' ) {
                    update_option('tsl-setting-setcron-id', $body['data']['id']);
                    return true;
                }

                if( function_exists( 'mamdebug')) mamdebug( 'cron_add_failed', $url );
                if( function_exists( 'mamdebug')) mamdebug( 'cron_add_failed', $body );

                return false;

            }else{
                //admin error log
                if( function_exists( 'mamdebug')) mamdebug( 'cron_list_failed', $url );
            }

        }

        return true;

    }

    function get_cron_job_logs()
    {

        $cron_jobs = $this->get_all_cron_jobs();

        foreach( $cron_jobs as $cron_job ) {

            $pos = strpos($cron_job['url'], $this->target_url);

            if ($pos !== false) {

                $url = $this->base_url . 'cron.logs?token='.$this->api_token . '&id=' . $cron_job['id'];

                $response = wp_remote_get( $url );

                if ( is_array( $response ) && ! is_wp_error( $response ) ) {

                    $body    = json_decode($response['body'], true);
                    if( $body['status'] == 'success' ) return $body['data'];

                    if( function_exists( 'mamdebug')) mamdebug( 'cron_logs_failed', $url );
                    if( function_exists( 'mamdebug')) mamdebug( 'cron_logs_failed', $body );

                    return array();
                }else{
                    //admin error log
                    if( function_exists( 'mamdebug')) mamdebug( 'cron_logs_failed', $url );

                    return array();
                }
            }
        }

        return array();

    }


    function disable_cron_job()
    {

        $cron_jobs = $this->get_all_cron_jobs();

        foreach( $cron_jobs as $cron_job ) {

            $pos = strpos($cron_job['url'], $this->target_url);

            if ($pos !== false) {

                $url = $this->base_url . 'cron.disable?token='.$this->api_token . '&id=' . $cron_job['id'];

                $response = wp_remote_get( $url );

                if ( is_array( $response ) && ! is_wp_error( $response ) ) {
                    $body    = json_decode($response['body'], true);
                    if( $body['status'] == 'success' ) return true;

                    if( function_exists( 'mamdebug')) mamdebug( 'cron_disable_failed', $url );
                    if( function_exists( 'mamdebug')) mamdebug( 'cron_disable_failed', $body );

                    return false;
                }else{
                    //admin error log
                    if( function_exists( 'mamdebug')) mamdebug( 'cron_disable_failed', $url );

                    return false;
                }
            }
        }

        return true;

    }

    function enable_cron_job()
    {

        $cron_jobs = $this->get_all_cron_jobs();

        foreach( $cron_jobs as $cron_job ) {

            $pos = strpos($cron_job['url'], $this->target_url);

            if ($pos !== false) {

                $url = $this->base_url . 'cron.enable?token='.$this->api_token . '&id=' . $cron_job['id'];

                $response = wp_remote_get( $url );

                if ( is_array( $response ) && ! is_wp_error( $response ) ) {
                    $body    = json_decode($response['body'], true);
                    if( $body['status'] == 'success' ) return true;

                    if( function_exists( 'mamdebug')) mamdebug( 'cron_enable_failed', $url );
                    if( function_exists( 'mamdebug')) mamdebug( 'cron_enable_failed', $body );

                    return false;
                }else{
                    //admin error log
                    if( function_exists( 'mamdebug')) mamdebug( 'cron_enable_failed', $url );

                    return false;
                }
            }
        }

        return true;

    }

    function get_all_cron_jobs()
    {

        $url = $this->base_url . 'cron.list?token='.$this->api_token;

        $response = wp_remote_get( $url );

        if ( is_array( $response ) && ! is_wp_error( $response ) ) {
            $body    = json_decode($response['body'], true);
            return $body['data'];

        }else{
            //admin error log
            if( function_exists( 'mamdebug')) mamdebug( 'cron_list_failed', $url );
        }

        return array();

    }




}
