<?php

class mam_setup_wizard
{

    private $steps = array();
    private $step = '';

    function initial_launch()
    {

        if( isset( $_REQUEST['skip-mam-wizard']))
        {
            if( isset( $_REQUEST['reset'])) {
                delete_option( 'mam_wizard_step');
            }
            update_option( 'mam_setup_wizard', 'yes' );
            wp_redirect( admin_url() . 'admin.php?page=local_app_setup' );
            exit;
        }else if( isset( $_REQUEST['step-complete']))
        {
            update_option( 'mam_setup_wizard', 'no' );
            $this->complete_step();
        }else if( isset( $_REQUEST['current-step'] ))
        {
            update_option( 'mam_wizard_step', $_REQUEST['current-step']);
        }
        if( ! get_option('mam_setup_wizard') == 'yes' && isset($_REQUEST['page']) && $_REQUEST['page'] != 'mam-setup-wizard' )
        {
            wp_redirect( admin_url() . 'admin.php?page=mam-setup-wizard' );
            exit;
        }

    }

    function complete_step()
    {
        $this->setup_wizard();
        $this->steps[$this->step]['view']( true );
    }

    function insert_step_number()
    {
        $position = array_search( $this->step, array_keys( $this->steps )) + 1;

        if( count($this->steps) > 0 )
        {
            $percentage = floor($position / count($this->steps) * 100);
        }else{
            $percentage = 0;
        }

        $html = '<div class="progress-container">';
        $html .= '<div class="progress-fill" style="width: ' . $percentage . '%"></div>';
        $html .= '<span class="progress-label"><h2 style="color:white;">Step ' . $position . ' of ' . count($this->steps) . '</h2></span>';
        $html .= '</div>';

        return $html;

    }

    function setup_wizard_screens()
    {
        $wizard_type = 'default';
        if( isset( $_REQUEST['go']) && $_REQUEST['go'] == 'publish' )
        {
            $wizard_type = 'publish';
        }

        $this->setup_wizard( $wizard_type );
        $position = array_search( $this->step, array_keys( $this->steps )) + 1;

        $html = '<div id="fullscreen-container">';
        $html .= '<div id="fullscreen-content">';
        $html .= $this->set_screen_title();
        $html .= $this->insert_step_number();

        if( count($this->steps) > 0 ) {
            $html .= $this->steps[$this->step]['view']();
        }

        if( $position > 1 )
        {
            $html .= '<a href="' . esc_url(admin_url()) . 'admin.php?page=mam-setup-wizard&current-step=' . array_keys( $this->steps )[$position - 2] . '" class="back-button">Previous Step</a>';
        }
        if( $position == count($this->steps) ) {
            $html .= '<a href="' . esc_url(admin_url()) . 'admin.php?page=local_app_setup&skip-mam-wizard=yes&reset=1" class="next-button">Finish</a>';
        }else {
            $html .= '<a href="' . esc_url(admin_url()) . 'admin.php?page=mam-setup-wizard&step-complete=' . $this->step . '" class="next-button">Next Step</a>';
        }
        $html .= '<a href="'. esc_url(admin_url()) .'admin.php?page=local_app_setup&skip-mam-wizard=yes" class="skip-button">Skip Wizard</a>';

        $html .= '</div>';
        $html .= '</div>';

        return $html;
    }

    public function setup_wizard(  $wizard_type = 'default' ) {
		if ( isset( $_REQUEST['page'] ) && $_REQUEST['page'] != 'mam-setup-wizard' ) {
			return;
		}
        if( $wizard_type == 'default' ) {

            $default_steps = array(
                'app_welcome' => array(
                    'name' => __('Welcome to the App Setup Wizard', 'mam-main'),
                    'view' => array($this, 'mam_setup_welcome'),
                ),
                'app_home' => array(
                    'name' => __('Home Screen Setup', 'mam-main'),
                    'view' => array($this, 'mam_setup_home_screen'),
                ),
                'general_settings' => array(
                    'name' => __('General Settings', 'mam-main'),
                    'view' => array($this, 'mam_setup_general'),
                ),
                'navigation' => array(
                    'name' => __('App Navigation', 'mam-main'),
                    'view' => array($this, 'mam_setup_navigation'),
                ),
                'get_api_key' => array(
                    'name' => __('Activate', 'mam-main'),
                    'view' => array($this, 'mam_get_api_key'),
                ),
                'test_flight' => array(
                    'name' => __('View on the Demo App!', 'mam-main'),
                    'view' => array($this, 'mam_setup_test_flight'),
                ),
            );
        }else{
            $default_steps = array(
                'app_welcome' => array(
                    'name' => __("Let's get ready to publish your app!", 'mam-main'),
                    'view' => array($this, 'mam_publish_welcome'),
                ),
                'app_home' => array(
                    'name' => __('App Store accounts', 'mam-main'),
                    'view' => array($this, 'mam_setup_app_store_accounts'),
                )
            );
        }

		if ( ! current_user_can( 'install_plugins' ) ) {
			unset( $default_steps['get_api_key'] );
		}

		$this->steps = apply_filters( 'mam_setup_wizard_steps', $default_steps );

        foreach( $this->steps as $step => $data )
        {
            if( isset($_REQUEST['step-complete']) && $_REQUEST['step-complete'] == $step )
            {
                $position = array_search( $step, array_keys( $this->steps ));
                $next_step = array_keys( $this->steps )[$position + 1];
                if( $wizard_type == 'default' ) {
                    update_option('mam_wizard_step', $next_step);
                }else{
                    update_option('mam_pub_wizard_step', $next_step);
                }
                wp_redirect( admin_url() . 'admin.php?page=mam-setup-wizard' );
                exit;
            }
        }

        if( $wizard_type == 'default' ) {
            if (get_option('mam_wizard_step')) {
                $this->step = get_option('mam_wizard_step');
            } else {
                $this->step = 'app_welcome';
                update_option('mam_wizard_step', $this->step);
            }
        }else{
            if (get_option('mam_pub_wizard_step')) {
                $this->step = get_option('mam_pub_wizard_step');
            } else {
                $this->step = 'mam_publish_welcome';
                update_option('mam_pub_wizard_step', $this->step);
            }
        }

	}

    function mam_publish_welcome()
    {
        $html = 'content';

        return $html;
    }

    function mam_setup_app_store_accounts()
    {
        $html = 'content';

        return $html;
    }

    function set_screen_title()
    {
        return '<div class="wizard-title"><h1>'. $this->steps[$this->step]['name'] .'</h1></div>';
    }

    function mam_setup_welcome( $complete = false )
    {
        $html = 'content';

        return $html;
    }

    function mam_setup_home_screen( $complete = false )
    {

        if( $complete )
        {
            mamdebug('wizard complete', 'mam-setup-wizard');
            //do setup home screen stack tasks
            return;
        }

        global $tsl_local_app_image_url;

        $html = '<p>Here you can setup the home screen of your app. You can add a logo, background image, and more.</p>';
        $html .= '<p>You can customize the layout at any time in the App Settings Manager.</p>';
        $html .= '<p>Select a home screen layout to get started.</p>';
        $html .= '<div class="home-screen-layouts">';
        $html .= '<div class="home-screen-layout"><img src="'.$tsl_local_app_image_url.'includes/setup-wizard/images/screen_1.png" alt="Screen One" style="height:30em;"/></div>';
        $html .= '<div class="home-screen-layout"><img src="'.$tsl_local_app_image_url.'includes/setup-wizard/images/screen_1.png" alt="Screen Two" style="height:30em;"/></div>';
        $html .= '<div class="home-screen-layout"><img src="'.$tsl_local_app_image_url.'includes/setup-wizard/images/screen_1.png" alt="Screen Three" style="height:30em;"/></div>';
        $html .= '<div class="home-screen-layout"><img src="'.$tsl_local_app_image_url.'includes/setup-wizard/images/screen_1.png" alt="Screen Four" style="height:30em;"/></div>';
        $html .= '</div>';

        return $html;
    }

    function mam_setup_navigation( $complete = false )
    {
        $html = 'content';

        return $html;
    }

    function mam_setup_general( $complete = false )
    {
        $html = 'content';

        return $html;
    }

    function mam_get_api_key( $complete = false )
    {

        if (!current_user_can('manage_options'))
        {
            $html = 'you do not have permission to view this page';
        }else {

//            delete_option('mam-main-software-manager-api');

            if (isset($_REQUEST['nonce']) && isset($_REQUEST['api_key']) && strlen($_REQUEST['api_key']) > 0) {
                if (wp_verify_nonce($_REQUEST['nonce'], 'set-api-key')) {
                    update_option('mam-main-software-manager-api', $_REQUEST['api_key']);
                }
            }

            if (!empty($_POST) && isset($_REQUEST['get-api-key']) & array_key_exists('get_software_api', $_POST)) {
                $nonce = wp_create_nonce('set-api-key');
                $request_url = 'https://tinyscreenlabs.com/wp-admin/admin-ajax.php?action=wc_private_repo_get_api_key&return_url=' . admin_url('admin.php') . '&site_url=' . $_SERVER['SERVER_NAME'] . '&page='.$_REQUEST['page'].'&nonce=' . $nonce . '&ajaxurl=' . admin_url('admin-ajax.php');
                wp_redirect($request_url);
                die();
            }

            if (strlen(get_option('mam-main-software-manager-api')) <= 1) {
                $html = '<form action="" method="POST">';
                $html .= '<input type="hidden" id="source" name="source" value="wizard">';
                $html .= '<input type="hidden" id="get-api-key" name="get-api-key" value="1">';
                $html .= '<input type="hidden" id="page" name="page" value="'.$_REQUEST['page'].'">';
                $html .= '<p>API key is required to add the plugins required to create your app. Please click on below button to get API key from Tinyscreenlabs.com.</p>';
                $html .= '<p class="submit"><input type="submit" name="get_software_api" id="get_software_api" class="button button-primary" value="Get API Key"></p>';
                $html .= '</form>';
            }else{
                $html = '<p>API key has been set</p>';
                $html .= 'Click Install and Activate to install the required plugins';
                $html .= '<div>Plugins to be installed:</div>';
                $html .= '<div>Plugin 1</div>';
                $html .= '<div>Plugin 2</div>';
                $html .= '<div>Plugin 3</div>';
                $html .= '<form action="" method="POST">';
                $html .= '<input type="hidden" id="activate-install" name="activate-install" value="1">';
                $html .= '<input type="hidden" id="nonce" name="nonce" value="' . wp_create_nonce('activate-plugin') . '">';
                $html .= '<input type="hidden" id="page" name="page" value="'.$_REQUEST['page'].'">';
                $html .= '<p class="submit"><input type="submit" name="activate_install" id="activate_install" class="button button-primary" value="Install and Activate"></p>';
                $html .= '</form>';
            }
        }

        return $html;
    }

    function mam_setup_test_flight( $complete = false )
    {

         $html = 'content';

        return $html;
    }


    function setup_roles()
    {
        $roles = apply_filters( 'mam_wizard_roles', array());

        global $wp_roles;
        if ( ! isset( $wp_roles ) ) $wp_roles = new WP_Roles();

        $capabilities = $wp_roles->get_role('subscriber');

        foreach ($roles as $slug =>  $role) {
            if( ! isset( $wp_roles->roles[$slug] ) )
            {
                add_role( $slug, $role, $capabilities->capabilities  );
            }else{
                $wp_roles->roles[$slug]['name'] = $role;
                $wp_roles->role_names[$slug] = $role;
            }
        }
    }

}
