<?php
class mam_support_manager_admin_settings
{

    public $text_domain = 'mam-support-manager';

    function add_support_manager_page(){

        if (!current_user_can('manage_options')) return 'No one is home';

        $html = '<div class="local-app-main-content-area">';
        $html .= mam_admin_settings::headline(__('Support Manager', $this->text_domain));
        $html .= $this->add_page_tabs();

        $html .= '<div class="mam-support-manager-tab-holder">';

        $current = 'support-tickets';
        if (isset($_REQUEST['tab'])) $current = $_REQUEST['tab'];

        switch ($current) {
            case 'support-tickets':
                $html .= $this->get_support_ticket_listing_tab();
                break;
            case 'create-support-ticket':
                $html .= $this->create_support_ticket_tab();
                break;
        }

        $html .= '</div>';

        $html .= '</div>';

        echo $html;

    }

    function add_page_tabs(){

        $current = 'support-tickets';
        if(isset($_REQUEST['tab'])) $current = $_REQUEST['tab'];

        $tabs['support-tickets'] = 'Support Tickets';
        $tabs['create-support-ticket'] = 'Create Ticket';

        $actual_link = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[SCRIPT_NAME]";

        $actual_link = str_replace('__wp__/','', $actual_link );

        $html_line = '';

        $html_line .= '<div id="icon-themes" class="icon32"><br></div>';
        $html_line .= '<h2 class="nav-tab-wrapper">';

        foreach( $tabs as $tab => $name ){
            $class = ( $tab == $current ) ? ' nav-tab-active' : '';
            $html_line .= "<a class='nav-tab$class' href='".$actual_link."?page=mam-support-manager&tab=".$tab."'>$name</a>";

        }


        $html_line .= '</h2>';

        $html_line .= '<div class="local-app-tab-separator">&nbsp;</div>';

        return $html_line;

    }

    function get_support_ticket_listing_tab(){

        $html_line = '';
        ob_start();
        ?>
        <div id="poststuff">
            <div id="post-body" class="metabox-holder columns-12">
                <div id="post-body-content">
                    <div class="meta-box-sortables ui-sortable">
                        <form method="post">
                            <?php
                            if ( class_exists( 'Support_Ticket_List' ) ) {
                                $ticket_list = new Support_Ticket_List();
                                $ticket_list->prepare_items();
                                $ticket_list->display();
                            }
                            ?>
                        </form>
                    </div>
                </div>
            </div>
            <br class="clear">
        </div>
        <?php
        $html_line .= ob_get_clean();

        return $html_line;
    }

    function create_support_ticket_tab(){

        $html = '<form method="post">';
        $html .= '<table class="form-table"><tbody>';
        $html .= '<tr><th>Issue Title</th><td><input type="text" class="regular-text" value="" name="issue_text"></td></tr>';
        $html .= '<tr><th>Issue Description</th><td><textarea class="regular-text" name="issue_desc"></textarea></td></tr>';
        $html .= '<tr><th>Issue File</th><td><input type="file" class="regular-text" value="" name="issue_file"></td></tr>';
        $html .= '<tr><td colspan="2"><button type="submit" class="button button-primary">Submit</button></td></tr>';
        $html .= '</tbody></table>';
        $html .= '<p class="submit">';
        $html .= wp_nonce_field( 'mam_support_manager_nonce', 'mam_support_manager_nonce', true, false );
        $html .= get_submit_button( __( 'Submit' ), 'primary', 'mam_support_manager', false );
        $html .= '</p>';
        $html .= '</form>';
        return $html;

    }

    function mam_support_manager_save_settings(){
        if( empty( $_POST['mam_support_manager'] ) )
            return;

        if( ! wp_verify_nonce( $_POST['mam_support_manager_nonce'], 'mam_support_manager_nonce' ) )
            return;

        if( ! current_user_can( 'manage_options' ) )
            return;


    }

}
