<?php

class mam_user_role_form_manager
{
    private $root = 'woocommerce_';
    private $plugin_slug = 'mam-user-roles';
    private $user;
    private $user_id;

    function __construct()
    {

        do_action( 'mam_update_current_user' );
        $current_user = wp_get_current_user();
        $this->user = $current_user;
        $this->user_id = $current_user->ID;

    }

    function process_last_json_check( $data_array )
    {

        do_action( 'mam_update_current_user' );
        $current_user = wp_get_current_user();
        $this->user = $current_user;
        $this->user_id = $current_user->ID;

        $has_action = false;
        if( isset($_REQUEST['subaction']) && $_REQUEST['subaction'] == 'mam_update_json' ) $has_action = true;
        if( isset( $_REQUEST['action'] ) && ( $_REQUEST['action'] == 'mam_user_roles_cred_handler' || $_REQUEST['action'] == 'advanced_settings_ajax_handler' || $_REQUEST['action'] == 'local_app_get_phone_data' ))
        {
            $has_action = true;
        }

        if( $has_action && isset( $data_array['initial_form_to_display'] )  ) {

            $exclude_fields = apply_filters( 'mam_initial_form_exclude_fields', array(), $this->user );
            $data_array['has_initial_form_to_display'] = 'no';

            if ( $this->user_id && $data_array['initial_form_to_display'] > 0 ) {

                global $local_app_form_array;
                $form_id = $data_array['initial_form_to_display'];


                foreach ($local_app_form_array as $formItem) {
                    if (isset($formItem['formid']) && $formItem['formid'] == $form_id) {
                        $form = $formItem;
                    } else {
                        continue;
                    }
                    unset($data_array['initial_form_to_display']);
                    unset($data_array['has_initial_form_to_display']);

                    $hasAllRequired = true;
                    foreach ($form['fields'] as $index => $field) {
                        if( ( !in_array($field['id'], $exclude_fields) && $field['required'] == 1 ) && ( ! isset( $field['value'] ) ||  strlen($field['value']) == 0 ) && $field['special_handling'] != 25 ) {
                            $hasAllRequired = false;
                        }
                    }

                    if (!$hasAllRequired) {
                        $local_app_form_array[] = $form;
                        $data_array['initial_form_to_display'] = sizeof($local_app_form_array);
                        $data_array['has_initial_form_to_display'] = 'yes';
                    }
                }
            }
        }

        return $data_array;


    }

    function save_user_profile()
    {

        if ($this->user) {
            $fields = $this->mam_gf_get_form_settings( array() , true );
            $values = apply_filters( 'mam_gf_get_form_data' , $fields , 'woocommerce_user_billing_address_form_' );
            $values = apply_filters( 'mam_user_roles_modify_user_profile_values_before_save', $values );

            $first_name_val = null;
            $last_name_val = null;
            $display_name_val = null;
            $request_account_delete = '';
            $confirm_account_delete = 'NO';

            foreach( $values as $index => $item )
            {

                $value = $item['value'];

                switch ( $index )
                {
                    case 'user-availability':
                        $form_data = json_decode($_REQUEST['formdata'], true);
                        foreach( $form_data as $field )
                        {
                            if( $field['field_id'] == get_option( 'woocommerce_user_billing_address_form_user-availability'))
                            {
                                if( $field['dayOfTheWeek'] == 'Sun') $dow_index = 0;
                                if( $field['dayOfTheWeek'] == 'Mon') $dow_index = 1;
                                if( $field['dayOfTheWeek'] == 'Tue') $dow_index = 2;
                                if( $field['dayOfTheWeek'] == 'Wed') $dow_index = 3;
                                if( $field['dayOfTheWeek'] == 'Thu') $dow_index = 4;
                                if( $field['dayOfTheWeek'] == 'Fri') $dow_index = 5;
                                if( $field['dayOfTheWeek'] == 'Sat') $dow_index = 6;

                                update_user_meta( $this->user_id, 'user-avail-dow-'.$dow_index , $field['dowStatus']);

                                if( strpos( $field['value'], 'end' ) > 0 )
                                {
                                    $parts = explode('-', $field['value'] );
                                    if( is_array( $parts) && sizeof($parts) == 3) {
                                        update_user_meta($this->user_id, 'user-avail-end-' . $dow_index, $parts[2]);
                                    }
                                }else if( strpos( $field['value'], 'start' ) > 0 )
                                {
                                    $parts = explode('-', $field['value'] );
                                    if( is_array( $parts) && sizeof($parts) == 3) {
                                        update_user_meta($this->user_id, 'user-avail-start-' . $dow_index, $parts[2]);
                                    }
                                }
                            }
                        }
                        break;
                    case 'user-avatar':
                        if( is_array( $value ) && sizeof( $value ) > 0 ){
                            $image_id = attachment_url_to_postid( $value[0] );
                            $image = wp_get_attachment_image_src( $image_id );
                            if( $image ) {
                                update_post_meta($image_id, 'media_type', 'user-avatar');
                                update_user_meta($this->user_id, $index, $image[0]);
                                update_user_meta($this->user_id, '_user_avatar', $image[0]);
                            }
                        }
                        break;
                    case 'user-first-name':
                        update_user_meta( $this->user_id, 'first_name', $value );
                        update_user_meta( $this->user_id, 'billing_first_name', $value );
                        $first_name_val = $value;
                        break;
                    case 'user-last-name':
                        update_user_meta ( $this->user_id, 'last_name', $value );
                        update_user_meta ( $this->user_id, 'billing_last_name', $value );
                        $last_name_val = $value;
                        break;
                    case 'user-display-name':
                        update_user_meta ( $this->user_id, 'display_name', $value );
                        $display_name_val = $value;
                        break;
                    case 'street':
                        update_user_meta ( $this->user_id, 'billing_address_1', $value );
                        break;
                    case 'city':
                        update_user_meta ( $this->user_id, 'billing_city', $value );
                        break;
                    case 'state':
                        if( $value == "Select state..." )
                        {
                            return array('status' => 'success', 'process_normal' => false, 'send_notifcations' => false, 'type' => 'error', 'message' => 'Please select a state');
                        }
                        update_user_meta ( $this->user_id, 'billing_state', $value );
                        break;
                    case 'zip':
                        update_user_meta ( $this->user_id, 'billing_postcode', $value );
                        break;
                    case 'phone':
                        update_user_meta ( $this->user_id, 'billing_phone', $value );
                        break;
                    case 'company':
                        update_user_meta ( $this->user_id, 'billing_company', $value );
                        break;
                    case 'email':
                        update_user_meta ( $this->user_id, 'billing_email', $value );
                        break;
                    case 'request-account-delete':
                        $request_account_delete = (is_array($value) ? $value[0] : '');
                        break;
                    case 'confirm-account-delete':
                        $confirm_account_delete = $value;
                        break;
                    default:
                        update_user_meta ( $this->user_id, $index, $value );
                }
            }

            if($request_account_delete != '' && $confirm_account_delete == 'YES' && apply_filters( 'mam_user_roles_delete_user', true, $this->user )){
                if ( wp_delete_user( $this->user_id ) ) {
                    return array('status' => 'success', 'process_normal' => false, 'send_notifcations' => false, 'type' => 'refresh_return', 'message' => 'Your account has been deleted...', 'hard_reload' => 'yes' );
                }
            }
            if($request_account_delete != '' && strtoupper( $confirm_account_delete ) != 'YES'){
                return array('status' => 'error', 'process_normal' => false, 'send_notifcations' => false, 'type' => 'error', 'message' => 'You must type YES in all caps to confirm you want your account deleted.');
            }
            if(! $display_name_val && ( $first_name_val || $last_name_val ))
            {
                update_user_meta ( $this->user_id, 'display_name', trim( $first_name_val . ' ' . $last_name_val ));
            }

            $args = array(
                'ID' => $this->user_id,
                'nickname' => $first_name_val . ' ' . $last_name_val,
                'display_name' => $display_name_val,
                'first_name' => $first_name_val ,
                'last_name' =>  $last_name_val,
            );
            wp_update_user($args);

            do_action( 'mam_after_update_user_profile' , $values );

            return array('status' => 'success', 'process_normal' => false, 'send_notifcations' => false, 'type' => 'refresh_return', 'message' => apply_filters( 'mam_user_roles_profile_update_message', 'Your profile info has been saved...'));

        }

        return  array('send_json' => 'yes', 'status' => 'success', 'process_normal' => true, 'send_notifcations' => true, 'type' => 'refresh_return', 'message' => "You don't appear to be logged in...go to the home screen and login");

    }

    function mam_populate_user_profile_form( $form  ){
do_action('add_to_tracer', 'mam_main ' . __LINE__);
            if( isset( $form['formid'] ) && get_option( 'woocommerce_user_billing_address_form' ) == $form['formid'] ) {

                $form['no_persist'] = 'yes';

                do_action( 'mam_update_current_user' );
                global $mam_user_id;
                $user = $mam_user_id;

                if ($user > 0) {

                    $field_slug = 'first-name';
                    $first_name = get_option('woocommerce_user_billing_address_form_user-' . $field_slug);
                    $field_slug = 'last-name';
                    $last_name = get_option('woocommerce_user_billing_address_form_user-' . $field_slug);
                    $field_slug = 'display-name';
                    $display_name = get_option('woocommerce_user_billing_address_form_user-' . $field_slug);
                    $street = get_option('woocommerce_user_billing_address_form_street');
                    $field_slug = 'city';
                    $city = get_option('woocommerce_user_billing_address_form_' . $field_slug);
                    $state = get_option('woocommerce_user_billing_address_form_state' );
                    $zip = get_option('woocommerce_user_billing_address_form_zip');
                    $field_slug = 'phone';
                    $phone = get_option('woocommerce_user_billing_address_form_' . $field_slug);
                    $email = get_option('woocommerce_user_billing_address_form_email');
                    $field_slug = 'company';
                    $company = get_option('woocommerce_user_billing_address_form_user-' . $field_slug);
                    $notifications = get_option('woocommerce_user_billing_address_form_notifications');
                    $field_slug = 'user-avatar';
                    $avatar = get_option('woocommerce_user_billing_address_form_user-' . $field_slug);

                    $userdata = get_userdata( $user );

                    foreach( $form['fields'] as $index => $field ){
                        if($field['id'] == $first_name ){
                            if( strlen( get_user_meta ($user, 'billing_first_name', true) ) > 0 ) {
                                $form['fields'][$index]['value'] = get_user_meta($user, 'billing_first_name', true);
                            }else if( strlen( get_user_meta ($user, 'first_name', true) ) > 0 ) {
                                $form['fields'][$index]['value'] = get_user_meta($user, 'first_name', true);
                            }else if( strlen( $userdata->user_firstname ) > 0 ){
                                $form['fields'][$index]['value'] = $userdata->user_firstname;
                            }
                        }
                        if($field['id'] == $avatar ){
                            if( strlen( get_user_meta ($user, 'user-avatar', true) ) > 0 ) {
                                $form['fields'][$index]['image_url'] = get_user_meta($user, 'user-avatar', true);
                            }else if( strlen( get_user_meta ($user, '_user_avatar', true) ) > 0 ) {
                                $form['fields'][$index]['image_url'] = get_user_meta($user, '_user_avatar', true);
                            }
                            $form['fields'][$index]['special_handling'] = '25';
                        }
                        if($field['id'] == $email ){
                            $form['fields'][ $index ]['value'] = $userdata->user_email;
                        }
                        if($field['id'] == $last_name ){
                            if( strlen( get_user_meta ($user, 'billing_last_name', true) ) > 0 ) {
                                $form['fields'][$index]['value'] = get_user_meta($user, 'billing_last_name', true);
                            }else if( strlen( get_user_meta ($user, 'last_name', true) ) > 0 ) {
                                $form['fields'][$index]['value'] = get_user_meta($user, 'last_name', true);
                            }else if( strlen( $userdata->user_lastname ) > 0 ){
                                $form['fields'][$index]['value'] = $userdata->user_lastname;
                            }
                        }
                        if($field['id'] == $display_name ){
                            if( $userdata->data->display_name != $userdata->user_email )
                            {
                                $form['fields'][$index]['value'] = $userdata->data->display_name;
                            }
                        }
                        if($field['id'] == $street ){
                            $form['fields'][ $index ]['value'] = get_user_meta ($user, 'billing_address_1', true);
                        }
                        if($field['id'] == $city ){
                            $form['fields'][ $index ]['value'] = get_user_meta ($user, 'billing_city', true);
                        }
                        if($field['id'] == $state ){
                            $form['fields'][ $index ]['value'] = get_user_meta ($user, 'billing_state', true);
                        }
                        if($field['id'] == $zip ){
                            $form['fields'][ $index ]['value'] = get_user_meta ($user, 'billing_postcode', true);
                        }
                        if($field['id'] == $phone ){
                            $form['fields'][ $index ]['value'] = get_user_meta ($user, 'billing_phone', true);
                        }
                        if($field['id'] == $company ){
                            $form['fields'][ $index ]['value'] = get_user_meta ($user, 'billing_company', true);
                        }
                        if($field['id'] == $notifications ){
                            $form['fields'][ $index ]['value'] = get_user_meta ($user, 'notification_prefs', true);
                        }
                    }
                }
            }
do_action('add_to_tracer', 'mam_main ' . __LINE__);
            return $form;

        }



    function mam_gf_get_form_settings($settings_array, $fields_only = false )
    {

        $fields = array();
        $fields[] = array('title' => 'User Avatar', 'slug' => 'user-avatar');
        $fields[] = array('title' => 'Notifications Preferences', 'slug' => 'notifications');
        $fields[] = array('title' => 'Email', 'slug' => 'email');
        $fields[] = array('title' => 'First Name', 'slug' => 'user-first-name');
        $fields[] = array('title' => 'Last Name', 'slug' => 'user-last-name');
        $fields[] = array('title' => 'Display Name', 'slug' => 'user-display-name');
        $fields[] = array('title' => 'Street', 'slug' => 'street');
        $fields[] = array('title' => 'City', 'slug' => 'city');
        $fields[] = array('title' => 'State', 'slug' => 'state');
        $fields[] = array('title' => 'ZIP', 'slug' => 'zip');
        $fields[] = array('title' => 'Phone', 'slug' => 'phone');
        $fields[] = array('title' => 'Company', 'slug' => 'company');
        $fields[] = array('title' => 'User Availability', 'slug' => 'user-availability');
        $fields[] = array('title' => 'Request account delete', 'slug' => 'request-account-delete');
        $fields[] = array('title' => 'Confirm account delete', 'slug' => 'confirm-account-delete');

        $addl_fields = apply_filters( 'mam_add_fields_to_user_profile' , array() );
        foreach( $addl_fields as $field ) {
            $fields[] = array('title' => $field['title'], 'slug' => $field['meta_key'] );
        }

        if( $fields_only ) return $fields;

        $slug = 'user_billing_address_form';
        $name = 'User Profile';

        $template_fields = array();
        $template_fields[] = array( 'field_id' => 1, 'slug' => 'user-avatar' , 'special_handling' => 25 );
        $template_fields[] = array( 'field_id' => 2, 'slug' => 'notifications' , 'special_handling' => 23 );
        $template_fields[] = array( 'field_id' => 3, 'slug' => 'user-first-name' );

        $template = array( 'form_name' => 'user_profile.json' , 'template_fields' => $template_fields , 'location' => 'mam-main/forms' );

        $form = array('type' => 'form_info', 'title' => $name, 'slug' => $slug, 'root' => $this->root, 'fields' => $fields);
        $settings_array[] = array('catagory' => 'general', 'title' => __($name, $this->plugin_slug), 'variable' => 'none', 'type' => 'gravity_form', 'id' => $this->root . $slug, 'environment' => 'backend', 'data' => $form , 'template' => $template , 'plugin_name' => 'MAM Main' );

        return $settings_array;

    }

    function mam_hide_user_avatar_media( $query ){

        if ( ! is_admin() ) {
            return;
        }

        $actual_link = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
        if( strpos( $actual_link, 'upload.php') || (array_key_exists('action', $_POST) && $_POST['action'] == 'query-attachments')) {
            // Modify the query.
            $query->set('meta_query', [
                [
                    'key' => 'media_type',
                    'compare' => 'NOT EXISTS',
                ]
            ]);
        }
    }

}
