<?php

class mam_notification_manager
{

    private $app_version = '1.0';
    private $database_verson = 21;
    private $admin_slug = 'mam-notification-manager';
    private $nonce;
    private $user;

    public function __construct()
    {

        if (isset($_REQUEST['pid'])) {
            $this->user = get_users(array('meta_key' => 'mam_app_token', 'meta_value' => trim($_REQUEST['pid'])));
        }

    }

    function send_push_notification( $data_array )
    {

        $handler = new mam_user_roles_manager();
        $handler->get_p8_file();

        $this->nonce = wp_create_nonce('tsl_notification_manager');

        global $wpdb, $pem_cert_file;;
        $table_name = $wpdb->prefix . 'mam_notifications_manager';

        $iosTokens = array();
        $androidTokens = array();
        $message = '';
        $data = '';
        $target = 0;
        $isSilent = false;
mamdebug('send_push_notification', $data_array );
        foreach( $data_array as $item ) {

            if (!empty($item['user_id']) && ((!empty($item['title']) && !empty($item['message']) || $item['is_silent'] == 1))) {

                if( strlen( $pem_cert_file ) ){

                    $message = $item['message'];
                    $target = $item['target'];

                if ($item['user_id'] < 1) continue;
                $pushMessage = false;

                $iosToken = get_user_meta($item['user_id'], 'mam_app_ios_pn_token', true);
                $androidToken = get_user_meta($item['user_id'], 'mam_app_android_pn_token', true);

                if (!$iosToken && !$androidToken) continue;

                if (strlen($iosToken) > 0) {
                    $iosTokens[] = $iosToken;
                    $pushMessage = true;
                }
                mamdebug( 'androidToken', $item['user_id'] . ' - ' . $androidToken  );

                if (strlen($androidToken) > 0 && ! in_array( $androidToken, $androidTokens )) {
                    $androidTokens[] = $androidToken;
                    $pushMessage = true;
                }

                if (!$pushMessage) {
                    continue;
                }

                $data = $item['data'];

                $data['result'] = 'success';
                $data['pns'] = $item['data'];

                if( isset( $item['action']) ){
                    $data['action'] = $item['action'];
                }

                unset( $data['pns']['conversation'] );
                unset( $data['data']['conversation'] );
                unset( $data['conversation'] );

                if( ! isset( $item['target'] )) $item['target'] = '';

                $isSilent = $item['is_silent'];

                }

            }else {

                mamdebug( 'admin_alert', 'MAM User Roles - Did not send PN' );

            }

        }

        if (sizeof($iosTokens) > 0) {
            $handler = new mam_send_ios_push_notification();
            $title = 'Notification';
            $handler->sendiosPush( $message, $target, $title, $iosTokens, $data, $isSilent);
        }
        if (sizeof($androidTokens) > 0) {
            mamdebug('android pre', $androidTokens );
            $handler = new mam_send_ios_push_notification();
            $title = 'Notification';
            $handler->SendAndroidPushNotifications( $message, $target, $title, $androidTokens, $data, $isSilent );
        }


    }

    public static function send_email( $data_array )
    {

        $nonce = wp_create_nonce('tsl_notification_manager');

        global $wpdb;
        $table_name = $wpdb->prefix . 'mam_email_manager';

        foreach($data_array as $item ) {

            if( ( !empty($item['user_id']) || !empty($item['email']) )  && !empty($item['title']) && !empty($item['message'])  ) {

                if(empty($item['user_id'])) $item['user_id'] = 0;

                $data = '';
                if( !empty($item['data']) ) $data = json_encode( $item['data'] );

                $wpdb->insert($table_name, array('user_id' => $item['user_id'], 'title' => $item['title'], 'message' => $item['message'] , 'email' => $item['email'], 'nonce' => $nonce , 'data_json' => $data ));

            }
        }

    }

    function check_for_push_notifications()
    {

        $send_emails = $this->send_queued_emails();

        $json['sent_emails'] = $send_emails;

        global $wpdb;
        $table_name = $wpdb->prefix . 'mam_notifications_manager';
        $result = $wpdb->get_results("SELECT nonce FROM $table_name WHERE pn_status = 0 GROUP BY nonce", ARRAY_A);

        if(sizeof($result) > 0) {
            $this->nonce = $result[0]['nonce'];

            $json['results'] = $result;

            //call traffic manager to send notification
            $account = '&account=' . get_option('local-app-account_code');
            $account .= '&nonce=' . $this->nonce;
            $url = 'https://tinyscreenlabs.com/wp-admin/admin-ajax.php?action=tsl_traffic_manager_send_single_push_notification' . $account . '&ajax_url=' . admin_url('admin-ajax.php');

            $json['url'] = $url;

            $args = array( 'timeout'     => 50 );

            $response = wp_remote_get($url , $args );

            if (is_array($response) && !is_wp_error($response)) {
                $data = json_decode(wp_remote_retrieve_body($response), true);

                global $wpdb;
                $table_name = $wpdb->prefix . 'mam_notifications_manager';
                $wpdb->get_results("UPDATE $table_name SET pn_status = 1 WHERE pn_status = 0 AND nonce = '" . $data['nonce'] . "'", ARRAY_A);

                $json['status'] = 'Sent PNs';

                wp_send_json( $json );
                die();

            }
        }

        $json['status'] = 'No PNS sent';

        wp_send_json( $json );
        die();
    }

    function send_queued_emails()
    {

        global $wpdb;
        $table_name = $wpdb->prefix . 'mam_email_manager';
        $result = $wpdb->get_results("SELECT * FROM $table_name WHERE email_status = 0", ARRAY_A);

        $send_emails = 0;

        foreach ($result as $index => $item ) {

            if( empty($item['email'])) {

                $user = get_user($item['user_id']);

                if ($user) {
                    $item['email'] = $user->user_email;

                }
            }

            if( ! empty($item['email'])) {

                wp_mail($item['email'], $item['title'], $item['message']);

                $send_emails++;

            }

            $wpdb->get_results("UPDATE $table_name SET email_status = 1 WHERE this_index = '" . $item['this_index'] . "'", ARRAY_A);

        }

        return $send_emails;
    }


    function manage_phone_data( $data_array ){

        return $this->get_notifications_for_user($data_array);

    }

    function get_notifications_for_user( $data_array = array() ){

        if (isset($_REQUEST['pid'])) {

            $this->user = get_users(array('meta_key' => 'mam_app_token', 'meta_value' => trim($_REQUEST['pid'])));

            if ($this->user) {

                $user = $this->user;
                $data_array['status'] = 'success';

                $user_id = $user[0]->ID;

                global $wpdb;
                $table_name = $wpdb->prefix . 'mam_notifications_manager';
                $result = $wpdb->get_results("SELECT * FROM $table_name WHERE title != 'New chat message' AND pn_status < 3 AND user_id = $user_id ORDER BY this_index DESC", ARRAY_A);

                if(sizeof($result) > 0){

                    foreach($result as $index => $item){

                        unset($result[$index]['data_json']);
                        unset($result[$index]['is_silent']);
                        $newformat = $this->convertDatetoLocalTime( $item['notification_date'] );
                        $result[$index]['notification_date'] = $newformat;
                    }

                    $data_array['notifications'] =  $result;
                    $data_array['show_notifications_button'] = 'yes';
                }

            }else{
                $data_array['status'] = 'error';
                $data_array['reason'] = 'User Not Logged In';
            }
        }else{
                $data_array['status'] = 'error';
                $data_array['reason'] = 'Phone ID (pid) not set';
        }

        return $data_array;

    }

    function convertDatetoLocalTime( $startDate , $returnDate = false  ){

        $timezone = new DateTimeZone( '+0000' );
        $startDate = DateTime::createFromFormat('Y-m-d H:i:s', $startDate , $timezone);

        if( $this->user && !isset( $_REQUEST['gmtoffset'] ) && get_user_meta( $this->user[0]->ID, 'gmtoffset', true )) {
            $_REQUEST['gmtoffset'] = get_user_meta( $this->user[0]->ID, 'gmtoffset', true );
        }
        if( $this->user && !isset( $_REQUEST['dst'] ) && get_user_meta( $this->user[0]->ID, 'dst', true )) {
            $_REQUEST['dst'] = get_user_meta( $this->user[0]->ID, 'dst', true );
        }

        if(isset( $_REQUEST['gmtoffset'] )){
            $_REQUEST['gmtoffset'] = urldecode($_REQUEST['gmtoffset']);
            $dst = 0;
            if(isset( $_REQUEST['dst'] )) $dst = $_REQUEST['dst'];
            $seconds =  $_REQUEST['gmtoffset']*60*60;
            $tz = timezone_name_from_abbr("", $seconds, $dst );
            $timezone = new DateTimeZone($tz);
            $startDate->setTimezone($timezone);
        }

        if( $returnDate ) return $startDate;

        return $startDate->format('M d, Y h:i A');


    }

    function remove_notification(){

        if (isset($_REQUEST['pid'])) {

            $user = get_users(array('meta_key' => 'mam_app_token', 'meta_value' => $_REQUEST['pid']));
            if ($user) {

                $user_id = $user[0]->ID;

                global $wpdb;
                $table_name = $wpdb->prefix . 'mam_notifications_manager';

                $wpdb->get_results("UPDATE $table_name SET pn_status = 3 WHERE this_index = ".$_REQUEST['post_id']." AND user_id = $user_id", ARRAY_A);

            }
        }
        return 'no user';
    }

    function mark_notification_read(){

        if (isset($_REQUEST['pid'])) {

            $user = get_users(array('meta_key' => 'mam_app_token', 'meta_value' => $_REQUEST['pid']));
            if ($user) {

                $user_id = $user[0]->ID;

                global $wpdb;
                $table_name = $wpdb->prefix . 'mam_notifications_manager';

                $wpdb->get_results("UPDATE $table_name SET pn_status = 2 WHERE this_index = ".$_REQUEST['post_id']." AND user_id = $user_id", ARRAY_A);

            }
        }
    }

}
