<?php

require_once 'local-app-qrcode.php';
require_once 'local-app-campaign-grid.php';
require_once 'local-app-app-setup-class.php';
require_once 'local-app-dashboard-class.php';
require_once 'local-app-notifications-class.php';
require_once 'local-app-submit-class.php';
//require_once 'local-app-website-class.php';

add_action( 'wp_ajax_local_app_ajax_handler', 'local_app_ajax_handler' );
add_action( 'wp_ajax_nopriv_local_app_ajax_handler', 'local_app_ajax_handler' );

function local_app_ajax_handler(){

    $update_status = array('status' => 'Shove off');

     if(current_user_can( 'manage_options' )) {

        if(isset($_REQUEST['subaction'])){

            switch($_REQUEST['subaction']){
                case 'tsl_add_newsletter':
                    if(isset($_REQUEST['email'])) {
                        $querystring = 'https://tinyscreenlabs.com/wp-admin/admin-ajax.php?action=tsl_newsletter_add&email_address=' . $_REQUEST['email'] . '&ajax_url=' . admin_url('admin-ajax.php');
                        wp_remote_get($querystring);
                        update_option('local-app-newsletter-nag', true);
                    }
                    break;
                case 'tsl_no_add_newsletter';
                    update_option('local-app-newsletter-nag' , true );
                    break;
            }

        }
    }
    wp_send_json( $update_status );
    die();

}

add_action( 'wp_ajax_local_app_set_admin_message', 'local_app_set_admin_message' );
add_action( 'wp_ajax_nopriv_local_app_set_admin_message', 'local_app_set_admin_message' );

function local_app_set_admin_message(){

    if(isset($_REQUEST['admin_message'])){
        update_option('local-app-admin-message-main' , $_REQUEST['admin_message']);
    }
}

add_action( 'wp_ajax_local_app_get_help_topic', 'local_app_get_help_topic' );
add_action( 'wp_ajax_nopriv_local_app_get_help_topic', 'local_app_get_help_topic' );

function local_app_get_help_topic(){

    $help = new local_app_dashboard();
    $update_status['content'] = $help->local_app_get_help_content('content' , $_REQUEST['help_id']);

    wp_send_json( $update_status );
    die();

}

function local_app_get_qtip_message($message_id){

    return local_app_get_lang($message_id);
}

function get_p8_file()
{

    global $local_app_plugins_dir;

    $key = get_option( 'ios_pn_pem_certs');
    $pem_cert_file = $local_app_plugins_dir . 'mam-main/pemcerts/' . $key;

    if( file_exists( $pem_cert_file )) {
        update_option('pem_cert_date', date('U'));
        return $pem_cert_file;
    }

    $pem_cert_file = dirname(__FILE__) . '/pemcerts/57fbd2a7218af.p8';
    if( file_exists( $pem_cert_file )) {
        return $pem_cert_file;
    }else{
        return false;
    }


}

function local_app_setup_page(){

    $has_p8 = true;
    $html_line = '<div class="local-app-main-content-area">';
    switch($_REQUEST['page']) {
        case 'local_app_setup':
            $html_line .= mam_admin_settings::headline(__('Main App Navigation Settings', 'mam-main'));
            $html_line .= '<h4>Setup your main navigation items for the bottom tab bar and left menu. You can also select which roles will be available on the app using the User Roles tab.</h4>';
            break;
        case 'local_app_publish':
            $html_line .= mam_admin_settings::headline(__('Submit App to App Stores', 'mam-main'));
            break;
        case 'local_app_notifications':
            $html_line .= mam_admin_settings::headline(__('Send Broadcast Push Notifications', 'mam-main'));
            $pem_cert_file = get_p8_file();
            if(  ! $pem_cert_file ){
                $html_line .= '<h4>Push notifications not setup. Go to <a href="/wp-admin/admin.php?page=mam-app-settings&tab=mam-notifications&role=mam-all">App Settings</a> to setup push notifications.</h4>';
                $has_p8 = false;
            }
            break;
    }

    switch($_REQUEST['page']){

        case 'local_app_setup':
            $html_line .= local_app_add_app_setup_tabs();
            $module = new local_app_setup();
            $html_line .= $module->local_app_app_setup_content_page();
            break;
        case 'local_app_publish':
            if( 1 == 2 && get_option('mam-customer-id') == '' ){
                $querystring = 'https://tinyscreenlabs.com/wp-admin/admin-ajax.php?action=tsl_is_publishable&ajax_url=' . admin_url('admin-ajax.php');
                $response = wp_remote_get($querystring);
                $body = wp_remote_retrieve_body($response);

                // Parse the JSON response
                $status = json_decode($body, true);
                if(array_key_exists('status', $status) && $status['status'] == 0){
                    if(array_key_exists('products', $status) && is_array($status['products']) && !empty($status['products'])){
                        $add_to_cart_link = 'https://tinyscreenlabs.com/dashboard/';
                        if(array_key_exists('account_id', $status) && $status['account_id'] != ''){
                            $add_to_cart_link .= '?id=' . $status["account_id"] .'&tab=tsl-add-to-cart';
                        }
                        $html_line .= '<table class="wp-list-table widefat fixed striped"><thead><tr><th>Product Name</th><th>Product SKU</th><th>Price</th></tr></thead><tbody>';
                        $total = 0;
                        foreach ($status['products'] as $product) {
                            $html_line .= '<tr><td>' . $product['title'] . '</td><td>' . $product['sku'] . '</td><td>' . $product['price'] . '</td></tr>';
                            $total = $total + $product['price'];
                        }
                        $html_line .= '</tbody></table>';
                        $html_line  .= '<div class="product-total"><span>Total:</span><span>$'.$total.'</span><div class="purchase-button"><a href="'.$add_to_cart_link.'" class="button action" target="_blank">Purchase</a></div></div>';
                    }
                }

            }else{
                $html_line .= local_app_add_app_setup_tabs();
                $module = new local_app_submit();
                $html_line .= $module->local_app_setup_publish_page();
            }
            break;
        case 'local_app_notifications':
            if( $has_p8 ) {
                //$html_line .= local_app_add_app_setup_tabs();
                $module = new local_app_notifications();
                $html_line .= $module->local_app_setup_notifications_page();
            }
            break;
    }

    $html_line .= '<div id="local-app-growl-container"></div>';

    echo $html_line;


}

function local_app_add_page_tabs(){

    $current = 'local_app_metrics';
    if(isset($_REQUEST['page'])) $current = $_REQUEST['page'];

    $tabs = array( 'local_app_setup' => 'App Setup' , 'local_app_notifications' => 'App Store Keys and Settings', 'local_app_publish' => 'Submit App' );

    $html_line = '';

    $html_line .= '<div id="icon-themes" class="icon32"><br></div>';
    $html_line .= '<h2 class="nav-tab-wrapper">';

    foreach( $tabs as $tab => $name ){
        $class = ( $tab == $current ) ? ' nav-tab-active' : '';
        $html_line .= "<a class='nav-tab$class' href='?page=".$tab."'>$name</a>";

    }
    $html_line .= '</h2>';

    $html_line .= '<div class="local-app-tab-separator">&nbsp;</div>';

    return $html_line;

}

function local_app_has_supported_plugins(){

    global $local_app_content;

    foreach($local_app_content as $plugin) {

        if (method_exists($plugin['class'] , 'settings')) {
            return true;
        }
    }

    return false;
}

function local_app_add_app_setup_tabs(){

    $current = 'homepage';
    if(isset($_REQUEST['tab'])) $current = $_REQUEST['tab'];

    $tabs = array();

    switch($_REQUEST['page']){
        case 'local_app_setup':
                $tabs = array('homepage' => 'Main Navigation', 'left_menu' => 'Left Menu',  'plugin_settings' => 'User Roles');  //,  'support' => 'Help & Support' 'social' => 'Social', 'images' => 'Images',
            break;
        case 'local_app_notifications':
            $tabs = array( 'homepage' => 'Notifications' , 'history' => 'History' ); //,  'support' => 'Help & Support'
            break;
        case 'local_app_publish':
            if(isset($_REQUEST['tab'])){
                $current = $_REQUEST['tab'];
            }else{
                $current = 'apple';
            }

            $tabs = array( 'apple' => 'APP Store' );
            //$tabs['android'] = 'Android';
            //$tabs['test_users'] = 'Test Users';
            $tabs['support'] = 'Publishing Wizard';

            break;
    }

    $html_line = '';

    if( sizeof( $tabs) > 0 ){

        $html_line .= '<div id="icon-themes" class="icon32"><br></div>';
        $html_line .= '<h2 class="nav-tab-wrapper">';

        foreach ($tabs as $tab => $name) {
            $this_role = '';
            if( isset( $_REQUEST['this-role']) && ( $tab == 'left_menu' || $tab == 'homepage' ) ){
                $this_role = '&this-role='.$_REQUEST['this-role'];
            }
            $class = ($tab == $current) ? ' nav-tab-active' : '';
            $html_line .= "<a class='nav-tab$class' href='?page=" . $_REQUEST['page'] . "&tab=".$tab.$this_role."'>$name</a>";

        }
        $html_line .= '</h2>';
    }

    $html_line .= '<div id="local_app_dialog" class="wp-dialog" title="Message" style="display: none;"></div>';
    return $html_line;
}



function local_app_sksort(&$array, $subkey="id", $sort_ascending=false) {

    $temp_array = array();

    if( ! is_array( $array ) || sizeof( $array ) == 0 ) return;

    if (count($array))
        $temp_array[key($array)] = array_shift($array);

    foreach($array as $key => $val){
        $offset = 0;
        $found = false;
        foreach($temp_array as $tmp_key => $tmp_val)
        {
            if( isset( $val[$subkey] ) && isset( $tmp_val[$subkey] ) && ! is_array($tmp_val[$subkey]) && ! is_array($val[$subkey]) && !$found && strtolower($val[$subkey]) > strtolower( $tmp_val[$subkey] ))
            {
                $temp_array = array_merge(    (array)array_slice($temp_array,0,$offset),
                                            array($key => $val),
                                            array_slice($temp_array,$offset)
                                          );
                $found = true;
            }
            $offset++;
        }
        if(!$found) $temp_array = array_merge($temp_array, array($key => $val));
    }

    if ($sort_ascending) $array = array_reverse($temp_array);

    else $array = $temp_array;
}

function local_app_clear_options(){

    global $wpdb;

    $plugin_options = $wpdb->get_results( "SELECT option_name FROM $wpdb->options WHERE option_name LIKE 'local-app-%'" );

    foreach( $plugin_options as $option ) {
        delete_option( $option->option_name );
    }

}

function tsl_publish_your_app_button($id){

    return '';

}

if (!function_exists('write_log')) {
    function write_log ( $log )  {
        if ( is_array( $log ) || is_object( $log ) ) {
            error_log( print_r( $log, true ) );
        } else {
            error_log( $log );
        }
    }
}

function local_app_get_url_by_shortcode($shortcode) {
	global $wpdb;

	$url = '';

	$sql = 'SELECT ID
		FROM ' . $wpdb->posts . '
		WHERE
			post_type = "page"
			AND post_status="publish"
			AND post_content LIKE "%' . $shortcode . '%"';

	if ($id = $wpdb->get_var($sql)) {
		$url = get_permalink($id);
	}

	return $url;
}

add_shortcode( 'local-app-login-success' , 'local_app_update_phone_id' );

function local_app_update_phone_id(){

    if(!isset($_REQUEST['pid'])) return '';

    global $wpdb;
    $table_name = $wpdb->prefix . 'local_app_phone_ids';
    $phone_id = $wpdb->get_results( "SELECT * FROM $table_name WHERE pid = '".$_REQUEST['pid']."'" , ARRAY_A);

    $user_id = get_current_user_id();

    if(!$phone_id){
        if($user_id > 0) $wpdb->insert($table_name , array( 'pid' => $_REQUEST['pid'] , 'user_id' => $user_id ) );
    }else{
        if($user_id > 0) $wpdb->update($table_name , array( 'user_id' => $user_id ) , array('pid' => $_REQUEST['pid'] ));
    }

    return 'Success';

}

function local_app_login_redirect( $redirect_to, $request, $user )
{
    local_app_update_phone_id();

	return local_app_get_url_by_shortcode('local-app-login-success') . '?tsllogin=1&pid='.$_REQUEST['pid'];

}
if(isset($_REQUEST['pid'])) {
    add_filter('login_redirect', 'local_app_login_redirect', 10, 3);
}

