if (typeof local_app !== 'function') {

    var local_app = function () {

        var dialog;
        var selected_image_url = '';
        var api_key_value = '';
        var api_key_value_set = false;
        var processing = false;
        var is_tour_saving = false;

        jQuery( '#content-sections-list').sortable();

        jQuery( '#selected-layout' ).on('change',  function()
        {
           setUrlParameter('layout_id', jQuery( '#selected-layout' ).val() );

        });

        this.set_background_color = function(){
            var background_url = jQuery('#local-app-phone-screen-image' ).attr('src');
            if(background_url) jQuery('.local-app-button-section-icon').css('background' , "url('"+background_url + "') 350px , 50px no-repeat");
        };

        this.send_feedback = function() {
            //tsl_contact_form_subject
            var subject = jQuery('#tsl_contact_form_subject').val();
            var email = jQuery('#tsl_contact_form_email').val();
            var message = jQuery('#tsl_contact_form_message').val();
            var send_email = true;

            if (!subject) {
                jQuery('#tsl_contact_form_subject').css('outline', '1px solid red');
                send_email = false;
            }
            if (!email) {
                jQuery('#tsl_contact_form_email').css('outline', '1px solid red');
                send_email = false;
            }
            if (!message) {
                jQuery('#tsl_contact_form_message').css('outline', '1px solid red');
                send_email = false;
            }

            if (send_email) {

                jQuery('.local-app-modal').show();

                var data = {
                    'action': 'local_app_send_help_message',
                    'email': email,
                    'subject': subject,
                    'message': message
                };

                jQuery.post(ajaxurl, data, function (result) {
                    if (result) {
                        console.log(result);
                        jQuery('.tsl_message_confirmation').show().text(result.status).fadeOut(5000);
                        jQuery('#tsl_contact_form_subject').val('').css('outline','');
                        jQuery('#tsl_contact_form_email').css('outline','');
                        jQuery('#tsl_contact_form_message').val('').css('outline','');
                    }
                    jQuery('.local-app-modal').hide();
                });
            }
        }

        this.get_help = function(help_id){

            jQuery('.local_app_help_topic_item').removeClass('local-app-help-topic-item-active');
            jQuery('#local_app_help_topic_item_'+help_id).addClass("local-app-help-topic-item-active")
            jQuery('.local-app-modal').show();

            var data = {
                'action': 'local_app_get_help_topic',
                'help_id': help_id
            };

            jQuery.post(ajaxurl, data, function (result) {
                if (result) {
                    jQuery('.local-app-modal').hide();
                    jQuery('.local-app-help-holder-content-info').html(result['content']);
                    jQuery('.if').gifplayer();
                    //jQuery('.if').gifplayer();
                }
            });
        };

        this.save_social_media = function(){

            jQuery('#local-app-update-social-media-button').attr('disabled', true);
            local_app.create_growl("Saving" , "Saving Changes");

            var data = {
                'action': 'local_app_save_social',
                'facebook': jQuery('#local-app-facebook').val().trim(),
                'instagram': jQuery('#local-app-instagram').val().trim(),
                'linkedin': jQuery('#local-app-linkedin').val().trim(),
                'pintrest': jQuery('#local-app-pintrest').val().trim(),
                'twitter': jQuery('#local-app-twitter').val().trim(),
                'website': jQuery('#local-app-website').val().trim(),
                'youtube': jQuery('#local-app-youtube').val().trim()
            };

            jQuery.post(ajaxurl, data, function (result) {
                if (result) {

                }
            });

        }

        this.update_addon_api_key = function(product_id){


        }

        this.update_api_key = function(product_id){

            if(local_app.validateEmail(jQuery('#local-app-update-api-key-email').val())) {

                var api_key = '';
                if(product_id){
                    api_key = jQuery('#local-app-update-api-addon-key-'+product_id).val().trim()
                }else{
                    api_key = jQuery('#local-app-update-api-key-key').val().trim();
                    product_id = 0;
                }

                var data = {
                    'action': 'local_app_activate_api',
                    'api_key': api_key,
                    'email': jQuery('#local-app-update-api-key-email').val().trim(),
                    'product_id': product_id
                };

                if(product_id){
                    jQuery('#local-app-update-api-addon-key-'+product_id).css('background-color', 'gray').attr('disabled', 'disabled');
                }else {
                    jQuery('#local-app-update-api-key').css('background-color', 'gray').attr('disabled', 'disabled');
                }

                jQuery.post(ajaxurl, data, function (result) {
                    if (result) {
                        if (result.status == "success") {

                            var url = window.location.href;
                            var res = url.replace("tab=api_key", "tab=apple");
                            window.location.href = res;
/**
                        }else if(result.status == 'Exceeded maximum number of activations'){
                            var buttons = {
                                "Move API Key": function () {
                                    local_app.move_api_key();
                                    dialog.dialog("close");
                                },
                                "Cancel": function(){
                                    dialog.dialog("close");
                                }
                            };
                            var message = 'This API Key is alreay in use on another server.  You can move this key by clicking the "Move API Key" button.  This will turn off any updates to any apps connected to the other site and we will remove the app from the app stores immediately.';
                            local_app.show_alert_message(message, null, null, "Move API Key", buttons);
**/
                        } else {
                            jQuery('#local-app-api-error-message').html('Error: ' + result.status).show();
                            if(product_id){
                                jQuery('#local-app-update-api-addon-key-'+product_id).css('background-color', '#0085ba').removeAttr('disabled');
                            }else {
                                jQuery('#local-app-update-api-key').css('background-color', '#0085ba').removeAttr('disabled');
                            }
                        }
                    }else{
                        //some network error occoure
                        jQuery('#local-app-api-error-message').html('Error:  A network error occourred. Please try again.' ).show();
                        if(product_id){
                            jQuery('#local-app-update-api-addon-key-'+product_id).css('background-color', '#0085ba').removeAttr('disabled');
                        }else {
                            jQuery('#local-app-update-api-key').css('background-color', '#0085ba').removeAttr('disabled');
                        }
                    }
                });
            }else{
                if(product_id){
                    jQuery('#local-app-update-api-addon-key-'+product_id).css('background-color', '#0085ba').removeAttr('disabled');
                }else {
                    jQuery('#local-app-update-api-key').css('background-color', '#0085ba').removeAttr('disabled');
                }
                jQuery('#local-app-api-error-message').html('Error: API Key / Email Combination are incorrect.  Please check and re-enter.' ).show();
            }
        }

        this.move_api_key = function(){

            var data = {
                'action': 'local_app_disable_api'
            };

            jQuery.post(ajaxurl, data, function (result) {
                console.log(result);
                local_app.update_api_key();
            });
        }

        this.disable_api = function(){
            var buttons = {
                "Continue": function () {
                    local_app.disable_api_key();
                    dialog.dialog("close");
                },
                "Cancel": function(){
                    dialog.dialog("close");
                }
            };
            var message = jQuery('#local-app-disable-api').html();
            local_app.show_alert_message(message, null, null, "Disable API Key", buttons);
        }

        this.disable_api_key = function(){

            jQuery('#local-app-disable-api-request').css('background-color', 'gray').attr('disabled', 'disabled');

            var data = {
                'action': 'local_app_disable_api'
            };

            jQuery.post(ajaxurl, data, function (result) {
                location.reload(true);
            });

        }

        this.set_app_store_handlers = function(){

            jQuery(window).bind('beforeunload', function(){

                if( (jQuery('.local-app-publish-save-draft-button').length && jQuery('.local-app-publish-save-draft-button').attr('disabled') == undefined ) || (jQuery('#local-app-update-social-media-button').length && jQuery('#local-app-update-social-media-button').attr('disabled') == undefined )) {
                    return 'You have unsaved changes. Are you sure you want to leave?';
                }
            });

            /*jQuery('.local-app-app-store-field').change(function(){
                jQuery('.local-app-publish-save-draft-button').css('background-color', '#0085ba').removeAttr('disabled');
                jQuery('.local-app-publish-on-app-store-button').css('background-color', 'gray').attr('disabled', 'disabled');

            });*/

            jQuery('.local-app-app-store-field').on('keyup keypress', function(e) {
                var code = e.keyCode || e.which;
                if (code == 13) {
                    e.preventDefault();
                    jQuery('.local-app-publish-save-draft-button').css('background-color', '#0085ba').removeAttr('disabled');
                    //jQuery('.local-app-publish-on-app-store-button').css('background-color', 'gray').attr('disabled', 'disabled');
                    jQuery('.local-app-publish-save-settings-button').trigger('click');
                }
            });

            jQuery('.local-app-app-store-check').unbind().click(function(){
                    jQuery('.local-app-publish-save-draft-button').css('background-color', '#0085ba').removeAttr('disabled');
                    jQuery('.local-app-publish-on-app-store-button').css('background-color', 'gray').attr('disabled', 'disabled');
            });
        }

        this.set_app_store_button = function(ostype){

            var ok_to_publish = true;

            if(ostype == 1) {

                jQuery('.local-app-app-store-field').each(function(){
                    if(!jQuery(this).val()  && !jQuery(this).hasClass('local-app-app-store-field-optional')) ok_to_publish = false;
                })

                jQuery(localapp_vars.ratings).each(function (index, value) {
                    if (!jQuery("input[name='" + value['id'] + "']:checked").val()) {
                        ok_to_publish = false;
                        jQuery("input[name='" + value['id'] + "']").css('outline', '1px solid red');
                    }
                });

                //isset icon image


                //isset splash screen images

            }else{
                jQuery('.local-app-app-store-field').each(function(){
                    if(!jQuery(this).val()) ok_to_publish = false;
                })
            }

            return ok_to_publish;
        }

        this.save_app_settings = function(){
            var ios_app_name = jQuery("#local-app-ios-app-name").val();
            var ios_bundle_id = jQuery("#local-app-ios-bundle-id").val();
            var android_bundle_id = jQuery("#local-app-android-bundle-id").val();
            var ios_team_id = jQuery("#local-app-ios-team-id").val();
            var ios_camera_message = jQuery("#local-app-ios-camera-message").val();
            var ios_gps_message = jQuery("#local-app-ios-gps-message").val();
            var ios_contacts_message = jQuery("#local-app-ios-contacts-message").val();
            var ios_nfc_message = jQuery("#local-app-ios-nfc-message").val();
            var ios_google_plist = jQuery("#local-app-ios-google-plist").val();
            var ios_version_number = jQuery("#local-app-ios-version-number").val();
            var android_version_number = jQuery("#local-app-android-version-number").val();
            var ios_build_number = jQuery("#local-app-ios-build-number").val();
            var android_build_number = jQuery("#local-app-android-build-number").val();
            var ios_google_places_api = jQuery("#local-app-ios-google-places-api").val();
            var ios_entitlements = jQuery('.entitlements-table').find('input[type="checkbox"]:checked').serialize();
            var launch_screen_bg = jQuery('#local-app-ios-launch-screen-bg').val();
            var app_icon_image = jQuery('.local-app-images-app-icon').next('input[name="local-app-images-app-icon"]').val();
            var app_icon_bg = jQuery('#local-app-ios-app-icon-bg').val();
            var launch_screen_1 = jQuery('.local-app-images-launch-screen-1').next('input[name="local-app-images-launch-screen-1"]').val();
            var launch_screen_2 = jQuery('.local-app-images-launch-screen-2').next('input[name="local-app-images-launch-screen-2"]').val();
            var app_channel = jQuery('.local-app-ios-app-channel').val();

            var data = {
                'action': 'local_app_save_publish_app_settings',
                'ios_app_name': ios_app_name,
                'ios_bundle_id': ios_bundle_id,
                'android_bundle_id': android_bundle_id,
                'ios_team_id': ios_team_id,
                'ios_camera_message': ios_camera_message,
                'ios_gps_message': ios_gps_message,
                'ios_contacts_message': ios_contacts_message,
                'ios_nfc_message': ios_nfc_message,
                'ios_google_plist': ios_google_plist,
                'ios_google_places_api': ios_google_places_api,
                'ios_version_number': ios_version_number,
                'android_version_number': android_version_number,
                'ios_build_number': ios_build_number,
                'android_build_number': android_build_number,
                'ios_entitlements': ios_entitlements,
                'ios_app_launch_screen_bg': launch_screen_bg,
                'app_icon_image': app_icon_image,
                'app_icon_bg': app_icon_bg,
                'launch_screen_1': launch_screen_1,
                'launch_screen_2': launch_screen_2,
                'app_channel': app_channel,
            };
            jQuery.post(ajaxurl, data, function (result) {
                if(result){
                    /*local_app.create_growl("Changes Saved", "All changes have been saved.");*/
                    window.location = window.location.href;
                }
            });
        }

        this.send_app_publish_request = function(ostype , action_code, confirmation){

            if(!confirmation && action_code == 2){
                var buttons = {
                    "Continue": {
                        click: function () {
                            local_app.send_app_publish_request(ostype , action_code, 1);
                            dialog.dialog("close");
                        },
                        text: 'Continue',
                        class: 'continue-dialog'
                    },
                    "Cancel": {
                        click: function(){
                            dialog.dialog("close");
                        },
                        text: 'Cancel',
                        class: 'close-dialog'
                    },
                };

                if(ostype == 1){
                    var message = '';
                    if(local_app_status.ios_publish_status){
                        if(local_app_status.ios_publish_status.indexOf('Publish requested') > -1){
                            message = '<p>Your app review is underway. By submitting the app you will cancel and restart the review process with a new application. This will restart the review process which takes 1 - 2 days.</p><p>You can always make changes to the look and feel of your app using the App Setup tab.  These changes are instantly updated on your apps and do not require you to re-publish the app.</p><p>Click continue to submit your app.</p>';
                        }
                        if(local_app_status.ios_publish_status.indexOf('Publish on') > -1){
                            message = '<p>Your app is currently available in the App store. Updates to the app will be available in 1 - 2 days. Only changes to the conetnt on this page require an app update.  Content and App Setup items are automatically updated on the app.</p><p>You can always make changes to the look and feel of your app using the App Setup tab.  These changes are instantly updated on your apps and do not require you to re-publish the app.</p><p>Click continue to submit your app.</p>';
                        }
                    }else {
                        message = '<p>This will start the process to upload an updated version of your app to iTunes. This process takes 20-30 minutes and you will get an email from Apple when completed.</p>';
                    }
                    local_app.show_alert_message(message, 400, null, "Publish on iTunes", buttons);
                }else{
                    var message = '';
                    if(local_app_status.android_publish_status){
                        if(local_app_status.android_publish_status.indexOf('Publish requested') > -1){
                            message = '<p>Your app review is underway. By submitting the app you will cancel and restart the review process with a new application. This will restart the review process which takes 1 - 2 days.</p><p>You can always make changes to the look and feel of your app using the App Setup tab.  These changes are instantly updated on your apps and do not require you to re-publish the app.</p><p>Click continue to submit your app.</p>';
                        }
                        if(local_app_status.android_publish_status.indexOf('Publish on') > -1){
                            message = '<p>Your app is currently available in the App store. Updates to the app will be available in 1 - 2 days. Only changes to the conetnt on this page require an app update.  Content and App Setup items are automatically updated on the app.</p><p>You can always make changes to the look and feel of your app using the App Setup tab.  These changes are instantly updated on your apps and do not require you to re-publish the app.</p><p>Click continue to submit your app.</p>';
                        }
                    }else {
                        message = '<p>This will start the process to upload an updated version of your app to iTunes. This process takes 20-30 minutes and you will get an email from Apple when completed.</p>';
                    }
                    local_app.show_alert_message(message, 400, null, "Publish on Google Play", buttons);
                }

                return;
            }

            if(jQuery('.local-app-publish-save-draft-button').attr('disabled') == 'disabled' && action_code == 1 ) return;
            if(jQuery('.local-app-publish-on-app-store-button').attr('disabled') == 'disabled' && action_code == 2 ) return;

            local_app.create_growl("Saving" , "Saving Changes");
            jQuery('.local-app-publish-save-draft-button').css('background-color', 'gray').attr('disabled', 'disabled');

            //check for errors
            if(ostype == 1) {
                var is_checked = 0;
                if(jQuery('#local-app-ios-use-tsl-title:checked').length) {
                    is_checked = 1;
                }

                var data_array = [];

                /*jQuery(localapp_vars.ratings).each(function(index , value){
                    data_array[index] = jQuery("input[name='"+value['id']+"']:checked").val();
                    localapp_vars.ratings[index]['checked'] = jQuery("input[name='"+value['id']+"']:checked").val();
                });*/

                var data = {
                    'action': 'local_app_publish_in_phone',
                    'ostype': ostype,
                    'save_action' : action_code,
                    'app_name': jQuery('#local-app-ios-app-name').val().trim(),
                    //'app_title': jQuery('#local-app-ios-app-title').val().trim(),
                    //'use_tsl_name': is_checked,
                    //'description': jQuery('#local-app-app-description').val().trim(),
                    //'keywords': jQuery('#local-app-ios-app-keywords').val().trim(),
                    //'support_url': jQuery('#local-app-ios-app-support-url').val().trim(),
                    //'privacy_url': jQuery('#local-app-ios-app-privacy-url').val().trim(),
                    //'marketing_url': jQuery('#local-app-ios-app-marketing-url').val().trim(),
                    //'copyright': jQuery('#local-app-ios-app-copyright').val().trim(),
                    //'primary_cat': jQuery('#local-app-primary-category').val().trim(),
                    //'secondary_cat': jQuery('#local-app-secondary-category').val().trim(),
                    //'rating_array': data_array
                    'camera_message': jQuery('#local-app-ios-camera-message').val().trim(),
                    'gps_message': jQuery('#local-app-ios-gps-message').val().trim(),
                    'contacts_message': jQuery('#local-app-ios-contacts-message').val().trim(),
                    //'review_type': jQuery('.local-app-app-store-field[name="local-app-ios-submit-type"]:checked').val().trim(),
                    'google_plist': jQuery('#local-app-ios-google-plist').val().trim(),
                    'version_number': jQuery('#local-app-ios-version-number').val().trim(),
                    'build_number': jQuery('#local-app-ios-build-number').val().trim(),
                };
            }else{
                var is_checked = 0;
                if(jQuery('#local-app-android-use-tsl-title:checked').length) {
                    is_checked = 1;
                }

                var data_array = [];

                /*jQuery(localandroid_vars.questions).each(function(index , value){
                    data_array[index] = jQuery("input[name='"+value['id']+"']:checked").val();
                    localandroid_vars.questions[index]['checked'] = jQuery("input[name='"+value['id']+"']:checked").val();
                });*/

                var data = {
                    'action': 'local_app_publish_in_phone',
                    'ostype': ostype,
                    'save_action' : action_code,
                    'app_name': jQuery('#local-app-ios-app-name').val().trim(),
                    // 'app_title': jQuery('#local-app-android-app-title').val().trim(),
                    // 'use_tsl_name': is_checked,
                    // 'full_description': jQuery('#local-app-app-full-description').val().trim(),
                    // 'short_description': jQuery('#local-app-app-short-description').val().trim(),
                    // 'website': jQuery('#local-app-android-app-website').val().trim(),
                    // 'privacy': jQuery('#local-app-android-app-privacy').val().trim(),
                    // 'email': jQuery('#local-app-android-app-email').val().trim(),
                    // 'primary_cat': jQuery('#local-app-primary-category').val().trim(),
                    // 'secondary_cat': jQuery('#local-app-secondary-category').val().trim(),
                    // 'app_rating_category' : jQuery('#local-app-android-category-id').text().trim(),
                    // 'rating_array': data_array
                    'camera_message': jQuery('#local-app-ios-camera-message').val().trim(),
                    'gps_message': jQuery('#local-app-ios-gps-message').val().trim(),
                    'contacts_message': jQuery('#local-app-ios-contacts-message').val().trim(),
                    'google_plist': jQuery('#local-app-ios-google-plist').val().trim(),
                    'version_number': jQuery('#local-app-android-version-number').val().trim(),
                    'build_number': jQuery('#local-app-android-build-number').val().trim(),
                };
            }

            jQuery('.local-app-publish-on-app-store-button').css('background-color', 'gray').attr('disabled', 'disabled');

            jQuery.post(ajaxurl, data, function (result) {
                if(result){
                    if(ostype == 1) {
                        if(action_code == 2) jQuery('#local-app-ios-publish-status').html('<strong>Status:</strong> '+result.status);
                        if(action_code == 1) local_app.create_growl("Changes Saved", "All changes have been saved but not yet published to iTunes.");
                    }else{
                        if(action_code == 2) jQuery('#local-app-ios-publish-status').html('<strong>Status:</strong> '+result.status);
                        if(action_code == 1) local_app.create_growl("Changes Saved", "All changes have been saved but not yet published to Google Play.");
                    }

                }
                if(local_app.set_app_store_button(ostype && action_code != 2)) jQuery('.local-app-publish-on-app-store-button').css('background-color', '#0085ba').removeAttr('disabled');

            });
        }

        this.upload_app_plist_file = function(file){
            var text_field = jQuery(file).prev('.local-app-app-store-field');
            var file = jQuery(file)[0].files[0];
            var validExtensions = ['plist']; //array of valid extensions
            var fileName = file.name;
            var fileNameExt = fileName.substr(fileName.lastIndexOf('.') + 1);
            if (jQuery.inArray(fileNameExt, validExtensions) == -1){
                alert("Invalid file type");
                return false;
            }
            var datafile = new FormData();
            datafile.append('action', 'local_app_save_plist_file');
            datafile.append('file', file);
            jQuery.ajax({
                url: ajaxurl,
                type: 'post',
                data: datafile,
                contentType: false,
                processData: false,
                success: function(response){
                    if(response.status == 200){
                        jQuery(text_field).val(response.url);
                    }
                }
            });
        }

        this.open_android_category_dialog = function(){

                var buttons = {
                    "Save": function () {
                        local_app.android_save_category();
                        jQuery('.local-app-publish-save-draft-button').css('background-color', '#0085ba').removeAttr('disabled');
                        jQuery('.local-app-publish-on-app-store-button').css('background-color', 'gray').attr('disabled', 'disabled');
                        dialog.dialog("close");
                    },
                    "Cancel": function(){
                        dialog.dialog("close");
                    }
                };

                local_app.show_alert_message(local_app.create_android_category_list(), 600, 800, "Select an Android App Category", buttons);

        }

        this.create_android_category_list = function(){

            var current_cat = jQuery('.local-app-android-category-id').text();

            var html_line = '<div class="local-app-js-android-category-select">';
            html_line = html_line.concat('<table>');

            jQuery(localandroid_vars.categories).each(function (index, value) {

                var is_checked = '';
                if(value['id'] == current_cat) is_checked = 'checked';

                html_line = html_line.concat('<tr>');
                html_line = html_line.concat('<td>');
                html_line = html_line.concat('<input class="local-app-android-category-check" type="radio" name="android_app_cat" value="'+value['id']+ '" ' + is_checked+'>');
                html_line = html_line.concat('</td>');
                html_line = html_line.concat('<td>');
                html_line = html_line.concat('<strong>'+value['title']+'</strong><br>');
                html_line = html_line.concat(value['desc']);
                html_line = html_line.concat('</td>');
                html_line = html_line.concat('<tr>');
            });


            html_line = html_line.concat('</table>');
            html_line = html_line.concat('</div>');

            return html_line;

        }

        this.android_save_category = function(){

            var selected_cat = jQuery("input[name='android_app_cat']:checked").val();

            jQuery(localandroid_vars.categories).each(function(index , value) {
                if(value['id'] == selected_cat){
                    jQuery('.local-app-android-category-title').html(value['title']);
                    jQuery('.local-app-android-category-desc').html(value['desc']);
                    jQuery('#local-app-android-category-id').html(value['id']);
                }
            });

        }

        this.send_app_preview_request = function(ostype){

            var data = {
                'action': 'local_app_preview_in_phone',
                'ostype' : ostype
            };

            jQuery.post(ajaxurl, data, function (result) {
                if(result){
                    console.log(result);
                }
            });
        }

        this.show_saving_message = function(){

            local_app.create_growl("Saving" , "Saving Changes");

            jQuery('.local-app-setup-publish-saved-div').hide();
            jQuery('.local-app-setup-publish-saving-div').hide();
            jQuery('.local-app-setup-publishing-to-app-div').hide();
            jQuery('.local-app-setup-publish-to-app-div').hide();
            if(local_app_status.has_acct > 0) jQuery('.local-app-setup-publish-div').show();
            jQuery('#local-app-update-content-button').css('background-color', 'gray').attr('disabled', 'disabled');
            jQuery('#local-app-update-content-button-1').css('background-color', 'gray').attr('disabled', 'disabled');
        };

        this.show_saved_message = function(publish_page){

            if(local_app_status.has_acct > 0) {
                if(publish_page){
                    if(publish_page == 3){
                        local_app.create_growl("Changes Saved", "Member card changes have been saved.");
                    }else {
                        local_app.create_growl("Changes Saved", "Image has been saved but not yet published.");
                    }
                }else {
                    local_app.create_growl("Changes Saved", "All changes have been saved but not yet pushed to your mobile app.");
                }
            }else{
                local_app.create_growl("Changes Saved", "All changes have been saved.");
            }
            jQuery('#local-app-update-content-button').css('background-color', '#0085ba').removeAttr('disabled');
            jQuery('#local-app-update-content-button-1').css('background-color', '#0085ba').removeAttr('disabled');
            jQuery('.local-app-setup-publish-saving-div').hide();

        };

        this.save_app_image = function(image_location , image_id, membercard){

            local_app.show_saving_message();
            var id = '';

            var this_action = 'local_app_update_image';
            var show_message = '';

            if(membercard){
                this_action = 'local_app_update_membercard_data';
                id = jQuery('#local-app-membercard-member-level').val();
                show_message = 3;
            }

            var data = {
                'action': this_action,
                'image_location' : image_location,
                'image_id': image_id,
                'id': id
            };

            jQuery.post(ajaxurl, data, function (result) {
                if(result){
                    //show saved message
                    if(membercard){
                       // localapp_tsl_membercard_info = result;
                    }

                    if(image_location == 'local-app-images-featured-graphic' || image_location == 'local-app-images-app-icon' || image_location == 'local-app-images-launch-screen-1' || image_location == 'local-app-images-launch-screen-2' ) {
                        local_app.show_saved_message(1);
                        if (local_app.set_app_store_button(1)) jQuery('.local-app-publish-on-app-store-button').css('background-color', '#0085ba').removeAttr('disabled');
                    }else if(image_location == 'local-app-images-android-app-icon'){
                        local_app.show_saved_message(1);
                        if (local_app.set_app_store_button(2)) jQuery('.local-app-publish-on-app-store-button').css('background-color', '#0085ba').removeAttr('disabled');
                    }else {
                        local_app.show_saved_message(show_message);
                    }
                }
                local_app.set_background_color();
            });
        };

        this.save_app_data = function(id , data_type , data_name , data_value, membercard){

            //check to see if data hase changed
            if(data_type == 'button' && data_name == 'name'){
                if(jQuery('#local-app-button-title-'+id ).data('button_name') == data_value ) {
                    return;
                }
            }

            local_app.show_saving_message();

            var this_role;
            if(jQuery('#this-role').length ){
                this_role = jQuery('#this-role').val();
            }

            var menu = 'main';
            if(localapp_tsl_location){
                menu = localapp_tsl_location;
            }

            var this_action = 'local_app_update_button_data';
            if(membercard){
                this_action = 'local_app_update_membercard_data';
            }

            var data = {
                'action': this_action,
                'id' : id,
                'data_type' : data_type,
                'data_name' : data_name,
                'data_value': data_value,
                'data_location': menu
            };

            if(this_role) data['this_role'] = this_role;

            jQuery.post(ajaxurl, data, function (result) {
                if(result){

                    //show saved message
                    var show_message = '';
                    if(membercard) show_message = 3;
                    local_app.show_saved_message(show_message);

                    if(data_type == 'button_delete'){
                        jQuery('.local-app-phone-image').each(function () {
                            if(jQuery(this).data('id') == data_value) {
                                jQuery(this).remove();
                                local_app.manage_add_button();
                            }
                        });
                        var order = [];
                        jQuery('.local-app-button-section').each(function (index, value) {
                            order.push(jQuery(this).data('id'));
                        });
                        local_app.phone_sim_reorder_buttons(order);
                    }
                    //reorder iphone images
                    if(data_type == 'button_order'){
                        local_app.phone_sim_reorder_buttons(data_value);
                    }
                    if(data_type == 'button'){
                        if(data_name == 'name'){
                            jQuery('#local-app-button-title-'+id).data('button_name' , data_value);
                        }
                        jQuery('.local-app-phone-image').each(function () {
                            if(jQuery(this).data('id') == id) {
                                var this_id = jQuery(this).prop('id');
                                if(data_name == 'name'){
                                    jQuery('#'+this_id+' .local-app-icon-text').text(data_value);
                                }
                                if(data_name == 'icon') jQuery('#'+this_id+' .local-app-icon-image-frame').attr('src',data_value);
                            }
                        });
                    }
                }
            });
        };

        this.phone_sim_reorder_buttons = function(new_order){

            if( ! new_order) {

                var new_order = [];
                jQuery('.local-app-phone-image').each(function () {
                    new_order.push(jQuery(this).data('id'));
                });
            }

            var num_buttons = new_order.length;
            var screen_width = 260;
            var holder_width = 100;
            var row = [];
            var gutter = 0;
            var vertical_gutter_offset = 0;
            var left_offset = 0;

            switch (num_buttons) {
                case 1:
                    row[1] = 1;
                    break;
                case 2:
                    row[1] = 2;
                    break;
                case 3:
                    row[1] = 3;
                    break;
                case 4:
                    row[1] = 4;
//                    row[2] = 2;
//                    vertical_gutter_offset = 40;
                    break;
                case 5:
                    row[1] = 3;
                    row[2] = 2;
                    left_offset = 45;
                    break;
                case 6:
                    row[1] = 3;
                    row[2] = 3;
                    break;
                case 7:
                    row[1] = 4;
                    row[2] = 3;
                    break;
                case 8:
                    row[1] = 4;
                    row[2] = 4;
                    break;
                case 9:
                    row[1] = 3;
                    row[2] = 3;
                    row[3] = 3;
                    break;
                case 10:
                    row[1] = 4;
                    row[2] = 3;
                    row[3] = 3;
                    break;
                case 11:
                    row[1] = 4;
                    row[2] = 4;
                    row[3] = 3;
                    break;
                case 12:
                    row[1] = 4;
                    row[2] = 4;
                    row[3] = 4;
                    break;
            }

            switch(row[1]){
                case 1:
                    holder_width = 100;
                    break;
                case 2:
                    holder_width = 100;
                    break;
                case 3:
                    holder_width = 80;
                    break;
                case 4:
                    holder_width = 50;
                    break;
            }

            gutter = Math.floor((screen_width - (holder_width * row[1])) / (row[1] + 1));

            var cur_row = 1;
            var cur_col = 1;
            var row_length = row.length - 1;
            var row_height = (row_length * holder_width) + (row_length * gutter) - gutter - holder_width + 30 - vertical_gutter_offset;

            jQuery('.local-app-phone-screen .local-app-icon-image-frame').removeClass('local-app-icon-image-frame-4 local-app-icon-image-frame-3 local-app-icon-image-frame-2 local-app-icon-image-frame-1');
            jQuery('.local-app-phone-screen .local-app-icon-image-frame').addClass('local-app-icon-image-frame-'+row[1]);

            jQuery('.local-app-icon-text').removeClass('local-app-icon-text-4 local-app-icon-text-3 local-app-icon-text-2 local-app-icon-text-1');
            jQuery('.local-app-icon-text').addClass('local-app-icon-text-'+row[1]);

            jQuery('.local-app-icon-image').removeClass('local-app-icon-image-4 local-app-icon-image-3 local-app-icon-image-2 local-app-icon-image-1');
            jQuery('.local-app-icon-image').addClass('local-app-icon-image-'+row[1]);



            jQuery(new_order).each(function(index , value) {

                var col_left = ((cur_col - 1) * holder_width) + (cur_col * gutter);

                if(row[1] == 4 && row[cur_row] == 3){
                    col_left = col_left + (holder_width / 2);
                }
                if(num_buttons == 5 && cur_row == 2){
                    col_left = col_left + left_offset;
                }

                jQuery('.local-app-phone-image').each(function () {
                    if (jQuery(this).data('id') == value) {
                        jQuery(this).css('bottom' , row_height + 'px');
                        jQuery(this).css('left' , col_left + 'px');
                        jQuery(this).css('width' , holder_width + 'px');
                        jQuery(this).css('height' , holder_width + 'px');
                    }
                });

                if (cur_col == row[cur_row]) {
                    cur_col = 1;
                    cur_row++;
                    row_height = row_height - holder_width - gutter - 10 + vertical_gutter_offset;
                } else {
                    cur_col++;
                }

            });

        };

        this.print_help = function(){

            var css_file = local_app_image_url + 'css/wp-local-app-print.css';

            jQuery('.local-app-help-holder-content-info').printThis({
                loadCSS: css_file
            });

        }

        this.remove_button = function(button_id){
            jQuery('#local-app-button-section-'+button_id).remove();
            //send ajax call
            local_app.save_app_data(button_id , 'button_delete' , 'delete' , button_id);
        };

        this.delete_campaign = function(){

            var data = {
                'action': 'local_app_delete_campaign',
                'campaign_id' : jQuery('#local-app-campaign-id').val()
            };

            jQuery.post(ajaxurl, data, function (result) {
                if(result){
                    //show saved message
                    var url = jQuery('#local-app-campaign-root-url').val();
                    window.location.assign( url );
                }
            });
        }

        this.save_campaign = function(){

            var data = {
                'action': 'local_app_update_campaign',
                'campaign_id' : jQuery('#local-app-campaign-id').val(),
                'campaign_name': jQuery('#local-app-campaign-name').val()
            };

            jQuery.post(ajaxurl, data, function (result) {
                if(result){
                    //show saved message
                    var url = jQuery('#local-app-campaign-root-url').val();
                    window.location.assign( url );
                }
            });

        }

        this.remove_app_logo = function(membercard){

            if(membercard){
                jQuery('.local-app-phone-app-logo').html('');
                jQuery('.local-app-images-membercard-logo').html('');
                local_app.save_app_image('local-app-images-membercard-logo', '' , true);
            }else {
                jQuery('.local-app-phone-app-logo').html('');
                jQuery('.local-app-images-app-logo').html('');
                local_app.save_app_image('local-app-images-app-logo', '');
            }
        }


        this.set_add_api_key_button = function(){

            var api_key_email = jQuery('#local-app-update-api-key-email').val();
            if(api_key_value != jQuery('#local-app-update-api-key-key').val() && api_key_email.length > 0){
                jQuery('#local-app-update-api-key').css('background-color', '#0085ba').removeAttr('disabled');
            }else{
                jQuery('#local-app-update-api-key').css('background-color', 'gray').attr('disabled', 'disabled');
            }
        }

        this.update_min_items_dd = function(){
            var current_selected = jQuery('.local-app-tour-min-steps').val();
            var count_of_items = jQuery('.local-app-button-section').size() - 1;

            var html_line = '';
            for(var x = 1;x<count_of_items + 1;x++){
                var selected = '';
                var s = '';
                if(x == current_selected) selected = 'selected';
                if(x > 1) s = 's';
                html_line = html_line.concat('<option value="'+x+'" '+selected+'>'+x+' Item'+s+'</option>');
            }

            jQuery('.local-app-tour-min-steps').html(html_line);
        };

        this.set_buttons_sortable = function () {

            if(jQuery('#local-app-update-api-key-key').length && ! api_key_value_set ){
                api_key_value_set = true;
                api_key_value = jQuery('#local-app-update-api-key-key').val();

                jQuery('#local-app-update-api-key-key').on('keyup keypress', function(){
                    local_app.set_add_api_key_button();
                })
                jQuery('#local-app-update-api-key-email').on('keyup keypress', function(){
                    local_app.set_add_api_key_button();
                })
            }

            local_app.set_background_color();

            local_app.set_app_store_handlers();


            jQuery('.local-app-social-field').on('keyup keypress', function(e) {
                jQuery('#local-app-update-social-media-button').attr('disabled', false);
            });

            jQuery('#local-app-primary-category').change(function() {

                var selected_val = jQuery('#local-app-primary-category').val();
                jQuery('#local-app-secondary-category').find('*').attr('disabled', false);
                jQuery("#local-app-secondary-category option").each(function(i){
                    if(jQuery(this).val() == selected_val){
                        jQuery(this).attr('disabled', true);
                    }
                });

            })

            jQuery('#local-app-secondary-category').change(function() {
                var selected_val = jQuery('#local-app-secondary-category').val();
                jQuery('#local-app-primary-category').find('*').attr('disabled', false);
                jQuery("#local-app-primary-category option").each(function(i){
                    if(jQuery(this).val() == selected_val){
                        jQuery(this).attr('disabled', true);
                    }
                });

            })

            jQuery("#local-app-tour-sort").sortable({
                stop: function (event, ui) {
                    jQuery('#local-app-tour-save-button').removeAttr('disabled');
                }
            });

            jQuery("#local-app-buttons-sort").sortable({
                stop: function (event, ui) {
                    var order = [];
                    jQuery('.local-app-button-section').each(function (index, value) {
                        order.push(jQuery(this).data('id'));
                    });
                    local_app.save_app_data(0 , 'button_order' , 'order' , order);

                }
            });

            // jQuery('#local-app-button-use-text').unbind().click(function(){
            //
            //     local_app.save_app_data(0 , 'global_button_options' , 3 , jQuery('#local-app-button-use-text:checked').length);
            //     if(jQuery('#local-app-button-use-text:checked').length) {
            //         jQuery('.local-app-icon-text').show();
            //     }else {
            //         jQuery('.local-app-icon-text').hide();
            //     }
            //
            // })

            jQuery('#local-app-campaign-save-button-div').css('background-color', 'gray').attr('disabled', 'disabled');

            jQuery('#local-app-campaign-name').unbind().focusout(function(){
                if(jQuery('#local-app-campaign-name').val()){
                    jQuery('#local-app-campaign-save-button-div').css('background-color', '#0085ba').removeAttr('disabled');
                }else{
                    jQuery('#local-app-campaign-save-button-div').css('background-color', 'gray').attr('disabled', 'disabled');
                }
            });

            jQuery('#local-app-campaign-name').unbind().keyup(function(){
                if(jQuery('#local-app-campaign-name').val()){
                    jQuery('#local-app-campaign-save-button-div').css('background-color', '#0085ba').removeAttr('disabled');
                }else{
                    jQuery('#local-app-campaign-save-button-div').css('background-color', 'gray').attr('disabled', 'disabled');
                }
            });

            //todo fix local-app-tour-title handlers
            jQuery('.local-app-tour-field').unbind().on('keyup keypress', function(e) {
                jQuery('#local-app-tour-save-button').removeAttr('disabled');
            });
            jQuery('.local-app-tour-field-dd').unbind().change(function(){
                jQuery('#local-app-tour-save-button').removeAttr('disabled');
            });

            jQuery('.local-app-tour-activity-type').unbind().change(function(){
                if(jQuery(this).val() == 'gps'){
                    jQuery(this).closest('tr').next('tr').show();
                }else{
                    jQuery(this).closest('tr').next('tr').hide();
                }
            })

            jQuery('#local-app-tour-save-button').click(function() {

                if(!is_tour_saving){
                    is_tour_saving = true;

                    var process_save = true;
                    jQuery('.local-app-tour-field').css('border', '');
                    //check for empty fields

                    jQuery('.local-app-tour-options').find('.local-app-tour-field').each(function(){
                        if(jQuery(this).val().length == 0){
                            process_save = false;
                            jQuery(this).css('border', 'solid 1px red');
                        }
                    })

                    jQuery('#local-app-tour-sort').find('.local-app-tour-field').each(function(){
                        if(jQuery(this).val().length == 0){
                            process_save = false;
                            jQuery(this).css('border', 'solid 1px red');
                        }
                    })


                    if(process_save) {
                        var tour_type = jQuery('.local-app-tour-type').text();
                        var tour_id = jQuery('.local-app-tour-id').text();
                        var tour_name = jQuery('.local-app-tour-name').val();
                        var distance_units = jQuery('.local-app-tour-distance-units').val();
                        var start_date = '';
                        var end_date = '';
                        var event_description = '';
                        var min_found_items = '';
                        var organizer = '';
                        if (tour_type == 'Quest') {

                            organizer = jQuery('.local-app-tour-organizer-email').val();
                            start_date = jQuery('.local-app-tour-start-date').datepicker('getDate') / 1000;
                            end_date = jQuery('.local-app-tour-end-date').datepicker('getDate') / 1000;
                            event_description = jQuery('.local-app-quest-description').val();
                            min_found_items = jQuery('.local-app-tour-min-steps').val();
                        }

                        var steps = [];
                        jQuery('.local-app-button-section').each(function () {
                            if (jQuery(this).is(":visible")) {
                                //add data to array
                                var this_step = {};
                                this_step['title'] = jQuery(this).find('.local-app-tour-title').val();
                                this_step['listing'] = jQuery(this).find('.local-app-tour-step-listing').val();
                                this_step['lat'] = jQuery(this).find('.local-app-tour-step-listing').find(":selected").data('lat');
                                this_step['lon'] = jQuery(this).find('.local-app-tour-step-listing').find(":selected").data('lon');
                                this_step['description'] = jQuery(this).find('.local-app-quest-step-description').val();
                                this_step['type'] = jQuery(this).find('.local-app-tour-activity-type').val();
                                this_step['radius'] = jQuery(this).find('.local-app-tour-radius').val();
                                steps.push(this_step);
                            }
                        });

                        var data = {
                            'action': 'local_app_save_quest',
                            'tour_type': tour_type,
                            'tour_id': tour_id,
                            'tour_name': tour_name,
                            'distance_units': distance_units,
                            'start_date': start_date,
                            'end_date': end_date,
                            'event_description': event_description,
                            'min_found_items': min_found_items,
                            'organizer': organizer,
                            'steps': steps

                        };

                        jQuery.post(ajaxurl, data, function (result) {
                            if (result) {
                                console.log(result);
                                jQuery('.local-app-tour-id').text(result.tour_id);
                                jQuery('#local-app-tour-save-button').attr('disabled', 'disabled');
                                is_tour_saving = false;
                            }
                        });
                    }else {
                        is_tour_saving = false;
                    }
                }
            });


            jQuery('.local-app-status-switch').unbind().change(function(){

                var data = {
                    'action': 'local_app_save_quest_status',
                    'status_val': jQuery(this).data('value'),
                    'tour_id': jQuery(this).data('id')
                };

                if(jQuery(this).data('value') == 0) {
                    jQuery(this).data("value", 1);
                }else{
                    jQuery(this).data("value", 0);
                }

                jQuery.post(ajaxurl, data, function (result) {
                    if (result) {

                    }
                });

            });

            jQuery('.local-app-button-section-new-tour-step').unbind().click(function(){


                var html_line = jQuery('.local-app-button-section-prototype').clone().show();
                jQuery('#local-app-tour-sort').append(html_line);

                jQuery('.local-app-button-section-prototype').each(function(){

                    if(jQuery(this).is(":visible")){
                        jQuery(this).removeClass('local-app-button-section-prototype');
                    }
                });

                local_app.update_min_items_dd();
                local_app.set_buttons_sortable();

            });


            jQuery('.local-app-tour-delete-message-text').click(function () {
                jQuery(this).closest('.local-app-button-section').remove();
                local_app.update_min_items_dd();
            });


            jQuery('.local-app-button-title').on('keyup keypress', function(e) {
                var code = e.keyCode || e.which;
                if (code == 13) {
                    e.preventDefault();
                    var this_id = jQuery(this).data('id');
                    local_app.save_app_data(this_id , 'button' , 'name' , jQuery(this).val());
                }
            });

            jQuery('.local-app-button-title').focusout(function(){
                var this_id = jQuery(this).data('id');
                local_app.save_app_data(this_id , 'button' , 'name' , jQuery(this).val());
            });


            jQuery( '.mam-image-setting' ).unbind().click(function(){
               // e.preventDefault();

                var textfield = jQuery(this);

                var image = wp.media({
                    title: 'Select or Upload Image',
                    multiple: false
                }).open();

                local_app.set_media_to_custom(7);

                image.on( 'select', function() {
                    var attachment = image.state().get('selection').first().toJSON();
                    var aspect_ratio = false;
                    var image_type = true;

                    if(attachment.subtype == "gif"){
                        image_type = false;
                    }

                    if(!image_type){
                        var buttons = {
                            "Close": function () {
                                dialog.dialog("close");
                            }
                        };
                        local_app.show_alert_message("<p>The selected image is a gif.  Please use a png or jpeg in order to be properly displayed in Android and iOS.</p><p>Please select another image in the media library.</p>" , null , null , "Image Type Error" , buttons);
                    }else{
                        if( textfield.prev().is("img") ){
                            textfield.prev().remove();
                        }
                        textfield.before('<img src="' + attachment.url + '" style="height:25px;padding-right:5px;vertical-align : middle;">');

                        textfield.val( attachment.url );
                    }
                })
            });

            //for file upload
            jQuery( '.mam-file-setting' ).unbind().click(function(){
                jQuery(this).next('input[type=file]').trigger('click');
            });

            jQuery( '.mam-file-upload-field' ).unbind().change(function(){
                var text_field = jQuery(this).prev('.mam-file-setting');
                var file = jQuery(this)[0].files[0];
                var datafile = new FormData();
                datafile.append('action', 'local_app_save_file');
                datafile.append('file', file);
                jQuery.ajax({
                    url: ajaxurl,
                    type: 'post',
                    data: datafile,
                    contentType: false,
                    processData: false,
                    success: function(response){
                        if(response.status == 200){
                            jQuery(text_field).val(response.path);
                        }
                    }
                });
            });

            jQuery('.local-app-images-placeholder').unbind().click(function (e) {
                e.preventDefault();

                var image = wp.media({
                    title: 'Upload Placeholder Image',
                    multiple: false
                }).open();

                local_app.set_media_to_custom(3);

                selected_image_url = '';
                image.on('close' , function(){
                    //handle custom image selection here
                    if(selected_image_url){

                        jQuery('.local-app-images-placeholder').html('<img src="' + selected_image_url + '" style="width:100px;height:50px;">');
                        local_app.save_app_image('local-app-images-placeholder', selected_image_url);

                    }
                })

                image.on( 'select', function() {
                    var attachment = image.state().get('selection').first().toJSON();
                    var aspect_ratio = false;
                    var image_type = true;

                    if(attachment.width / attachment.height == 2){
                        aspect_ratio = true;
                    }

                    if(attachment.subtype == "gif"){
                        image_type = false;
                    }

                    if(attachment.height < 50 || attachment.width < 100) {
                        var buttons = {
                            "Close": function() {
                                dialog.dialog( "close" );
                            }
                        };
                        local_app.show_alert_message("<p>The selected image is the wrong size - the placeholder image must be at least 100 x 50 pixels.</p><p>Please select another image in the media library.</p>", null, null, "Image Size Error", buttons);
                    }else if(! aspect_ratio){
                        var buttons = {
                            "Close": function() {
                                dialog.dialog( "close" );
                            }
                        };

                        local_app.show_alert_message("<p>The selected image is the wrong aspect ratio - the placeholder image must be 2:1 aspect ratio (for example 200 x 100 pixels).</p><p>Please select another image in the media library.</p>" , null , null , "Image Size Error" , buttons);
                    }else if(!image_type){
                        var buttons = {
                            "Close": function () {
                                dialog.dialog("close");
                            }
                        };
                        local_app.show_alert_message("<p>The selected image is a gif.  Please use a png or jpeg in order to be properly displayed in Android and iOS.</p><p>Please select another image in the media library.</p>" , null , null , "Image Type Error" , buttons);
                    }else {
                        jQuery('.local-app-images-placeholder').html('<img src="' + attachment.url + '" style="width:100px;height:50px;">');
                        local_app.save_app_image('local-app-images-placeholder', attachment.id);
                    }
                })
            });

            jQuery('.local-app-images-app-logo').unbind().click(function (e) {
                e.preventDefault();

                var image = wp.media({
                    title: 'Upload App Logo Image',
                    multiple: false
                }).open();

                local_app.set_media_to_custom(7);

                image.on( 'select', function() {
                    var attachment = image.state().get('selection').first().toJSON();
                    var aspect_ratio = false;
                    var image_type = true;

                    if(attachment.subtype == "gif"){
                        image_type = false;
                    }

                    if(attachment.width / attachment.height == 1){
                        aspect_ratio = true;
                    }

                    if(attachment.height < 200 || attachment.width < 200) {
                        var buttons = {
                            "Close": function() {
                                dialog.dialog( "close" );
                            }
                        };
                        local_app.show_alert_message("<p>The selected image is the wrong size - the App Logo image must be at least 200 x 200 pixels.</p><p>Please select another image in the media library.</p>", null, null, "Image Size Error", buttons);

                    }else if(!image_type){
                        var buttons = {
                            "Close": function () {
                                dialog.dialog("close");
                            }
                        };
                        local_app.show_alert_message("<p>The selected image is a gif.  Please use a png or jpeg in order to be properly displayed in Android and iOS.</p><p>Please select another image in the media library.</p>" , null , null , "Image Type Error" , buttons);
                    }else {
                        jQuery('.local-app-phone-app-logo').html('<img src="' + attachment.url + '" style="width:200px;height:200px;display:block;margin:auto;">');
                        jQuery('.local-app-images-app-logo').html('<img src="' + attachment.url + '" style="width:200px;height:200px;">');
                        local_app.save_app_image('local-app-images-app-logo', attachment.id);
                    }
                })
            });

            jQuery('.local-app-images-app-icon').unbind().click(function (e) {
                e.preventDefault();

                var image = wp.media({
                    title: 'Upload App Icon Image',
                    multiple: false
                }).open();

                //local_app.set_media_to_custom(4);

                image.on( 'select', function() {
                    var attachment = image.state().get('selection').first().toJSON();
                    if(attachment.height != 1024 || attachment.width != 1024){
                        /*var buttons = {
                            "Close": function() {
                                dialog.dialog( "close" );
                            }
                        };
                        local_app.show_alert_message("<p>The selected image is the wrong size - the image must be exactly 1024px x 1024px.</p><p>Please select another image in the media library.</p>" , null , null , "Image Size Error", buttons);*/
                        local_app.resize_image(attachment.id, 1024, 'local-app-images-app-icon');
                    }else {
                        jQuery('.local-app-images-app-icon').html('<img src="' + attachment.url + '" style="width:250px;height:250px;">');
                        //local_app.save_app_image('local-app-images-app-icon', attachment.id);
                        jQuery('.local-app-images-app-icon').next('input[name="local-app-images-app-icon"]').val(attachment.id);
                    }
                })
            });

            jQuery('.local-app-images-android-app-icon').unbind().click(function (e) {
                e.preventDefault();

                var image = wp.media({
                title: 'Upload App Icon Image',
                multiple: false
                }).open();

                local_app.set_media_to_custom(5);

                image.on( 'select', function() {
                    var attachment = image.state().get('selection').first().toJSON();
                    if(attachment.height != 512 || attachment.width != 512){
                    var buttons = {
                            "Close": function() {
                                dialog.dialog( "close" );
                            }
                        };
                        local_app.show_alert_message("<p>The selected image is the wrong size - the image must be exactly 512px x 512px.</p><p>Please select another image in the media library.</p>", null , null, "Image Size Error", buttons);
                    }else {
                        jQuery('.local-app-images-android-app-icon').html('<img src="' + attachment.url + '" style="width:250px;height:250px;">');
                        local_app.save_app_image('local-app-images-android-app-icon', attachment.id);
                    }
                })
            });


            jQuery('.local-app-images-featured-graphic').unbind().click(function (e) {
                e.preventDefault();
                var image = wp.media({
                title: 'Upload Launch Screen Image',
                multiple: false
                }).open();

                local_app.set_media_to_custom(6);

                image.on( 'select', function() {
                    var attachment = image.state().get('selection').first().toJSON();
                    if(attachment.height != 500 || attachment.width != 1024){
                        var buttons = {
                            "Close": function() {
                                dialog.dialog( "close" );
                            }
                        };
                        local_app.show_alert_message("<p>The selected image is the wrong size - the image must be exactly 1024 x 500 pixels.</p><p>Please select another image in the media library.</p>",null,null,"Image Size Error", buttons);
                    }else {
                        jQuery('.local-app-images-featured-graphic').html('<img src="' + attachment.url + '" style="width:512px;height:250px;">');
                        local_app.save_app_image('local-app-images-featured-graphic', attachment.id);
                    }
                })

            });

            jQuery('.local-app-images-launch-screen-1').unbind().click(function (e) {
                e.preventDefault();
                var image = wp.media({
                    title: 'Upload Launch Screen Image',
                    multiple: false
                }).open();

                local_app.set_media_to_custom(2);

                selected_image_url = '';
                image.on('close' , function(){
                    //handle custom image selection here
                    if(selected_image_url){

                        jQuery('.local-app-images-launch-screen-1').html('<img src="' + selected_image_url + '" style="width:268px;height:476px;">');

                        //local_app.save_app_image('local-app-images-launch-screen-1', selected_image_url);

                        var insertAt = selected_image_url.lastIndexOf('.');
                        var second_url = selected_image_url.substring(0,insertAt) + '.IP4.png';

                        jQuery('.local-app-images-launch-screen-2').html('<img src="' + second_url + '" style="width:277px;height:600px;">');
                        //local_app.save_app_image('local-app-images-launch-screen-2', second_url);


                    }
                })

                image.on( 'select', function() {

                    var attachment = image.state().get('selection').first().toJSON();
                    // if(attachment.height != 1136 || attachment.width != 640){
                    //     var buttons = {
                    //         "Close": function() {
                    //             dialog.dialog( "close" );
                    //         }
                    //     };
                    //     local_app.show_alert_message("<p>The selected image is the wrong size - the image must be exactly 1136 x 640 pixels.</p><p>Please select another image in the media library.</p>",null,null,"Image Size Error", buttons);
                    // }else {
                        jQuery('.local-app-images-launch-screen-1').html('<img src="' + attachment.url + '" style="width:268px;height:476px;">');
                        jQuery('.local-app-images-launch-screen-1').next('input[name="local-app-images-launch-screen-1"]').val(attachment.id);
                        //local_app.save_app_image('local-app-images-launch-screen-1', attachment.id);
                    // }
                })

            });

            jQuery('.local-app-images-launch-screen-2').unbind().click(function (e) {
                e.preventDefault();
                var image = wp.media({
                title: 'Upload Launch Screen Image',
                multiple: false
                }).open();

                local_app.set_media_to_custom(2);

                selected_image_url = '';
                image.on('close' , function(){
                    //handle custom image selection here
                    if(selected_image_url){

                        jQuery('.local-app-images-launch-screen-1').html('<img src="' + selected_image_url + '" style="width:268px;height:476px;">');

                        //local_app.save_app_image('local-app-images-launch-screen-1', selected_image_url);

                        var insertAt = selected_image_url.lastIndexOf('.');
                        var second_url = selected_image_url.substring(0,insertAt) + '.IP4.png';

                        jQuery('.local-app-images-launch-screen-2').html('<img src="' + second_url + '" style="width:277px;height:600px">');
                        //local_app.save_app_image('local-app-images-launch-screen-2', second_url);


                    }
                })


                image.on( 'select', function() {
                    var attachment = image.state().get('selection').first().toJSON();
                    if(attachment.height != 2436 || attachment.width != 1125){
                        var buttons = {
                            "Close": function() {
                                dialog.dialog( "close" );
                            }
                        };
                        local_app.show_alert_message("<p>The selected image is the wrong size - the image must be exactly 2436 x 1135 pixels.</p><p>Please select another image in the media library.</p>", null, null, "Image Size Error", buttons);
                    }else {
                        jQuery('.local-app-images-launch-screen-2').html('<img src="' + attachment.url + '" style="width:277px;height:600px">');
                        jQuery('.local-app-images-launch-screen-2').next('input[name="local-app-images-launch-screen-2"]').val(attachment.id);
                        //local_app.save_app_image('local-app-images-launch-screen-2', attachment.id);
                    }
                })
            });

            jQuery('.local-app-images-background-screen-1').unbind().click(function (e) {
                e.preventDefault();

                var image = wp.media({
                title: 'Upload background Screen Image',
                multiple: false
                }).open();

                local_app.set_media_to_custom(2);

                selected_image_url = '';
                image.on('close' , function(){
                    //handle custom image selection here
                    if(selected_image_url){

                        var icon_html = '';
                        jQuery('.local-app-phone-image').each(function () {
                            icon_html = icon_html.concat(jQuery('<div />').append(jQuery(this).clone()).html());
                        });
                        //var app_icon_html = jQuery('.local-app-phone-app-logo')[0].outerHTML;

                        jQuery('.local-app-images-background-screen-1').html('<img src="' + selected_image_url + '" style="width:268px;height:476px;">');
                        //jQuery('.local-app-phone-screen').html(app_icon_html + '<img id="local-app-phone-screen-image" src="' + selected_image_url + '" style="width:268px;height:476px;">' + icon_html);

                        local_app.save_app_image('local-app-images-background-screen-1', selected_image_url);

                        var insertAt = selected_image_url.lastIndexOf('.');
                        var second_url = selected_image_url.substring(0,insertAt) + '.IP4.png';

                        jQuery('.local-app-images-background-screen-2').html('<img src="' + second_url + '" style="width:277px;height:600px">');
                        local_app.save_app_image('local-app-images-background-screen-2', second_url);


                    }
                })

                image.on( 'select', function() {
                    var attachment = image.state().get('selection').first().toJSON();
                    // if(attachment.height != 1136 || attachment.width != 640){
                    //     var buttons = {
                    //         "Close": function() {
                    //             dialog.dialog( "close" );
                    //         }
                    //     };
                    //     local_app.show_alert_message("<p>The selected image is the wrong size - the image must be exactly 1136 x 640 pixels.</p><p>Please select another image in the media library.</p>", null, null, "Image Size Error", buttons);
                    // }else {
                        var icon_html = '';
                        jQuery('.local-app-phone-image').each(function () {
                            icon_html = icon_html.concat(jQuery('<div />').append(jQuery(this).clone()).html());
                        });

                        // var app_icon_html = jQuery('.local-app-phone-app-logo')[0].outerHTML;
                        //
                        jQuery('.local-app-images-background-screen-1').html('<img src="' + attachment.url + '" style="width:268px;height:476px;">');
                        // jQuery('.local-app-phone-screen').html(app_icon_html + '<img id="local-app-phone-screen-image" src="' + attachment.url + '" style="width:268px;height:476px;">' + icon_html);

                        local_app.save_app_image('local-app-images-background-screen-1', attachment.id);

                    // }
                })
            });

            jQuery('.local-app-images-background-screen-2').unbind().click(function (e) {
                e.preventDefault();

                var image = wp.media({
                title: 'Upload background Screen Image',
                multiple: false
                }).open();

                local_app.set_media_to_custom(2);

                selected_image_url = '';
                image.on('close' , function(){
                    //handle custom image selection here
                    if(selected_image_url){

                        var icon_html = '';
                        jQuery('.local-app-phone-image').each(function () {
                            icon_html = icon_html.concat(jQuery('<div />').append(jQuery(this).clone()).html());
                        });
                        //var app_icon_html = jQuery('.local-app-phone-app-logo')[0].outerHTML;

                        jQuery('.local-app-images-background-screen-1').html('<img src="' + selected_image_url + '" style="width:268px;height:476px;">');
                        //jQuery('.local-app-phone-screen').html(app_icon_html + '<img id="local-app-phone-screen-image" src="' + selected_image_url + '" style="width:268px;height:476px;">' + icon_html);

                        local_app.save_app_image('local-app-images-background-screen-1', selected_image_url);

                        var insertAt = selected_image_url.lastIndexOf('.');
                        var second_url = selected_image_url.substring(0,insertAt) + '.IP4.png';

                        jQuery('.local-app-images-background-screen-2').html('<img src="' + second_url + '" style="width:277px;height:600px">');
                        local_app.save_app_image('local-app-images-background-screen-2', second_url);


                    }
                })

                image.on( 'select', function() {
                    var attachment = image.state().get('selection').first().toJSON();
                    if(attachment.height != 2436 || attachment.width != 1125){
                        var buttons = {
                            "Close": function() {
                                dialog.dialog( "close" );
                            }
                        };
                        local_app.show_alert_message("<p>The selected image is the wrong size - the image must be exactly 2436 x 1125 pixels.</p><p>Please select another image in the media library.</p>", null, null, "Image Size Error", buttons);
                    }else {
                        jQuery('.local-app-images-background-screen-2').html('<img src="' + attachment.url + '" style="width:277px;height:600px">');
                        local_app.save_app_image('local-app-images-background-screen-2', attachment.id);
                    }
                })
            });


            local_app.apply_change_content_type();

            jQuery('.local-app-content-type').unbind().change(function(){

                local_app.hide_source_error_message();

                var html_line = '';
                var this_id = jQuery(this).data('id');
                var data_type = jQuery(this).val();
                var data_value = '';


                html_line = jQuery('.local-app-blank-content-'+data_type).html();
                html_line = html_line.replace(/BLANK_ID/g , this_id);

                jQuery('.local-app-listing-count').each(function(){
                    if(jQuery(this).data('id') == this_id){
                        jQuery(this).hide();
                    }
                })

                jQuery('.local-app-content-type-parent').each(function(){
                    if(jQuery(this).data('id') == this_id){
                        jQuery(this).html(html_line);
                        data_value = jQuery(this).val();
                    }
                })

                local_app.apply_change_content_type();

                local_app.save_app_data(this_id , 'content' , data_type , data_value);

            });

            jQuery('.local-app-button-section-new-icon').unbind().click(function(){


                var html_line = '';
                html_line = local_app.create_new_button();

                jQuery('#local-app-buttons-sort').append(html_line);

                var order = [];
                jQuery('.local-app-button-section').each(function (index, value) {
                    order.push(jQuery(this).data('id'));
                });

                local_app.manage_add_button();
                local_app.apply_change_content_type();
                local_app.set_buttons_sortable();

//                local_app.change_icon_font(jQuery('#local-app-global-font-family').val() , jQuery('#local-app-global-font-size').val());

            });

            jQuery('.local-app-button-section-icon-holder').unbind().click(function(e){

                e.preventDefault();
                var this_item = jQuery(this);
                var this_id = this_item.data('id');

                var button_name = jQuery('#local-app-button-title-' + this_id).val();
                if(button_name){
                    button_name = ' for ' + button_name;
                }else{
                    button_name = '';
                }

                var image = wp.media({
                    title: 'Select Icon Image' + button_name,
                    multiple: false
                }).open();

                local_app.set_media_to_custom(1);

                selected_image_url = '';
                image.on('close' , function(){
                    //handle custom image selection here
                    if(selected_image_url){
                        var html  = '<img class="local-app-icon-image-frame" src="'+selected_image_url+'">';

                        this_item.html(html);
                        local_app.save_app_data(this_id , 'button' , 'icon' , selected_image_url );
                    }
                })

                image.on( 'select', function() {
                    var attachment = image.state().get('selection').first().toJSON();
                    var html  = '<img class="local-app-icon-image-frame" src="'+attachment.url+'">';

                    this_item.html(html);
                    local_app.save_app_data(this_id , 'button' , 'icon' , attachment.url);
                })
            });

            jQuery("#local-app-generate-launch-screen").on("click", function(){
               var bg_color = jQuery("#local-app-ios-launch-screen-bg").val();
               var app_icon = jQuery(".local-app-images-app-icon img").attr('src');
                var data = {
                    'action': 'local_app_generate_launch_screen',
                    'bg_color': bg_color,
                    'app_icon': app_icon
                };

                jQuery.post(ajaxurl, data, function (result) {
                    if (result.status == 200) {
                        jQuery('.local-app-images-launch-screen-1').html('<img src="' + result.launch_screen_1 + '" style="width:268px;height:476px">');
                        jQuery('.local-app-images-launch-screen-1').next('input[name="local-app-images-launch-screen-1"]').val(result.launch_screen_1_id);
                        //local_app.save_app_image('local-app-images-launch-screen-1', result.launch_screen_1);

                        jQuery('.local-app-images-launch-screen-2').html('<img src="' + result.launch_screen_2 + '" style="width:277px;height:600px">');
                        jQuery('.local-app-images-launch-screen-2').next('input[name="local-app-images-launch-screen-2"]').val(result.launch_screen_2_id);
                        //local_app.save_app_image('local-app-images-launch-screen-2', result.launch_screen_2);

                        local_app.create_growl("Image Generated", "Launch screen generated.");
                    }
                });
            });
        }

        this.add_button_icon_tab = function(){

            jQuery('.media-router').append('<a class="media-menu-item" id="local-app-button-icons" href="#">Button Icon Sets</a>');

            jQuery('.media-menu-item').click(function(){
                jQuery('.media-menu-item').removeClass('active');
                jQuery(this).addClass('active');
                if(jQuery(this).text() == 'Button Icon Sets') {
                    jQuery('.attachments-browser .attachments').hide();
                    jQuery('.attachment-filters').hide();
                    jQuery('#media-search-input').hide();
                    jQuery('.media-sidebar').hide();
                    if(jQuery('#local-app-icon-browser').length){
                        jQuery('#local-app-icon-browser').show();
                    }else {
                        var images = '';

                        jQuery(local_app_button_icons).each(function(index, value){
                            images = images.concat('<div class="js--select-attachment type-image subtype-png portrait" style="float:left;">');
                            images = images.concat('<div class="thumbnail" >');
                            images = images.concat('<div class="centered">');
                            images = images.concat('<img alt="" draggable="false" src="'+value.file_location+'" style="margin:15px;width:60px;height:60px;">');
                            images = images.concat('</div>');
                            images = images.concat('</div>');
                            images = images.concat('</div>');
                        })


                        jQuery('.attachments-browser').append('<div id="local-app-icon-browser" class="local-app-icon-browser attachments ui-sortable ui-sortable-disabled" >'+images+'</div>');
                    }
                }else{
                    jQuery('.attachments-browser .attachments').show();
                    jQuery('.media-toolbar').show();
                    jQuery('.media-sidebar').show();
                    jQuery('#local-app-icon-browser').hide();
                    jQuery('#media-search-input').show();
                }
            })
            jQuery('#local-app-button-icons').click();
        }

        this.manage_add_button = function(){

            if(jQuery('.local-app-button-section').length > 11){
                jQuery('.local-app-button-section-new-icon').hide();
                jQuery('#local-app-button-section-new-icon-message').hide();
            }else{
                jQuery('.local-app-button-section-new-icon').show();
                jQuery('#local-app-button-section-new-icon-message').show();
            }

        }

        this.apply_change_content_type = function(){

            jQuery('.local-app-button-section-expand').click(function () {
                var this_id = jQuery(this).data('id');

                if (jQuery('#local-app-button-options-section-' + jQuery(this).data('id')).height() > 20) {
                    jQuery(this).find(">:first-child").addClass('fa-angle-down');
                    jQuery(this).find(">:first-child").removeClass('fa-angle-up');
                    jQuery('#local-app-button-options-section-' + jQuery(this).data('id')).animate({height: "0"}, 'slow', function () {
                        jQuery('#local-app-button-options-section-' + this_id).hide();
                    });
                } else {
                    jQuery(this).find(">:first-child").removeClass('fa-angle-down');
                    jQuery(this).find(">:first-child").addClass('fa-angle-up');
                    jQuery('#local-app-button-options-section-' + jQuery(this).data('id')).show().animate({height: "10em"}, 'slow');
                }
            });

            jQuery('.local-app-content-source-dd').change( function() {

                var data_value = jQuery(this).val();
                var this_id = jQuery(this).data('id');
                var data_type = '';
                var source_valid = true;

                if(data_value == 0){
                    return;
                }else {
                    jQuery("option[value='0']", this).remove();
                }

                jQuery('.local-app-listing-count').each(function(){
                    if(jQuery(this).data('id') == this_id){
                        jQuery(this).hide();
                    }
                })

                jQuery('.local-app-content-type').each(function(){
                    if(jQuery(this).data('id') == this_id){
                        data_type = jQuery(this).val();
                        if(data_type == 'Web_URL'){
                            local_app.hide_source_error_message(this_id);
                            var result = validate({website: data_value}, {website: {url: true}});
                            if(result){
                                source_valid = false;
                                var message = 'Web URL is not valid.';
                                if(data_value.search('http') < 0){
                                    message = 'Web URL is not valid.  Might be missing http://';
                                }
                                local_app.show_source_error_message(message , this_id);
                            }
                        };
                    }
                });


                if(source_valid) local_app.save_app_data(this_id , 'content' , data_type , data_value);

            });

            jQuery('#local-app-website').change(function(){
                var data_value = jQuery(this).val();
                local_app.hide_source_error_message('social-website-error');
                var result = validate({website: data_value}, {website: {url: true}});
                if(result){

                    var message = 'Web URL is not valid.';
                    if(data_value.search('http') < 0){
                        jQuery('#local-app-update-social-media-button').attr('disabled', true);
                        message = 'Web URL is not valid.  Might be missing http://';
                    }else{
                        jQuery('#local-app-update-social-media-button').attr('disabled', false);
                    }
                    local_app.show_source_error_message(message , 'social-website-error');
                }
            });

            jQuery('.local-app-content-source').on('keyup keypress', function(e) {
                var code = e.keyCode || e.which;
                if (code == 13) {
                    e.preventDefault();
                local_app.hide_source_error_message();

                var data_value = jQuery(this).val();
                var this_id = jQuery(this).data('id');
                var data_type = '';
                var source_valid = true;

                if(data_value == 0){
                    return;
                }else {
                    jQuery("option[value='0']", this).remove();
                }

                jQuery('.local-app-content-type').each(function(){
                    if(jQuery(this).data('id') == this_id){
                        data_type = jQuery(this).val();
                        if(data_type == 'Web_URL'){
                            local_app.hide_source_error_message(this_id);
                            var result = validate({website: data_value}, {website: {url: true}});
                            if(result){
                                source_valid = false;
                                var message = 'Web URL is not valid.';
                                if(data_value.search('http') < 0){
                                    message = 'Web URL is not valid.  Might be missing http://';
                                }
                                local_app.show_source_error_message(message , this_id);
                            }
                        };
                    }
                });

                if(source_valid) local_app.save_app_data(this_id , 'content' , data_type , data_value);
                }
            });

            jQuery('.local-app-content-source').blur(function(){

                local_app.hide_source_error_message();

                var data_value = jQuery(this).val();
                var this_id = jQuery(this).data('id');
                var data_type = '';
                var source_valid = true;

                if(data_value == 0){
                    return;
                }else {
                    jQuery("option[value='0']", this).remove();
                }

                jQuery('.local-app-content-type').each(function(){
                    if(jQuery(this).data('id') == this_id){
                        data_type = jQuery(this).val();
                        if(data_type == 'Web_URL'){
                            local_app.hide_source_error_message(this_id);
                            var result = validate({website: data_value}, {website: {url: true}});
                            if(result){
                                source_valid = false;
                                var message = 'Web URL is not valid.';
                                if(data_value.search('http') < 0){
                                    message = 'Web URL is not valid.  Might be missing http://';
                                }
                                local_app.show_source_error_message(message , this_id);
                            }
                        };
                    }
                });

                if(source_valid) local_app.save_app_data(this_id , 'content' , data_type , data_value);
            });
        }

        this.hide_source_error_message = function(this_id){

            jQuery('.local-app-source-error').each(function(){
                if(jQuery(this).data('id') == this_id){
                    jQuery(this).hide();
                }
            })
        }

        this.show_source_error_message = function(message , this_id){

            jQuery('.local-app-source-error').each(function(){
                if(jQuery(this).data('id') == this_id){
                    jQuery(this).text(message).show();
                }
            })
        }

        this.guid = function() {
          function s4() {
            return Math.floor((1 + Math.random()) * 0x10000)
              .toString(16)
              .substring(1);
          }
          return s4() + s4() + '-' + s4() + '-' + s4() + '-' +
            s4() + '-' + s4() + s4() + s4();
        }

        this.create_new_button = function(){

            var uuid = local_app.guid();
            var image_number = jQuery('.local-app-button-section').length + 1;
            var image_url = local_app_image_url + '/includes/icons/default/icon_'+image_number+'.png';

            var row_width = 1;
            switch(image_number){
                case 1:
                    row_width = 1;
                    break;
                case 2:
                case 4:
                    row_width = 2;
                    break;
                case 3:
                case 5:
                case 6:
                case 9:
                    row_width = 3;
                    break;
                case 7:
                case 8:
                case 10:
                case 11:
                case 12:
                    row_width = 4;
                    break;
            }

            var image = '<img class="local-app-icon-image-frame" src="'+image_url+'">';

            var html = '<div class="local-app-button-section" id="local-app-button-section-'+uuid+'" data-id="'+uuid+'">';
            html = html.concat('<table class="local-app-button-section-header">');
            html = html.concat('<tr class="local-app-background">');
            html = html.concat('<td data-id="'+uuid+'" class="local-app-button-section-expand" id="local-app-button-expand-'+uuid+'"><span data-id="'+uuid+'" class="local-app-button-section-expand-icon fa fa-angle-down">&nbsp;</span>');
            html = html.concat('</td>');
            html = html.concat('<td class="local-app-button-section-title local-app-background"><input data-id="'+uuid+'" class="local-app-button-title" id="local-app-button-title-'+uuid+'" type="text" value="Button"></td>');
            html = html.concat('<td class="local-app-button-section-icon" id="local-app-button-icon-'+uuid+'">');
            html = html.concat('<div data-id="'+uuid+'" class="local-app-button-section-icon-holder local-app-icon-image-no-frame">'+image+'</div>');
            html = html.concat('</td>');
            html = html.concat('<td class="local-app-button-section-options" id="local-app-button-options-'+uuid+'">');
            html = html.concat('<table class="local-app-button-table-options">');
            html = html.concat('<tr>');
            html = html.concat('<td>Text:</td>');
            html = html.concat('<td>&nbsp;<input type="checkbox" id="local-app-button-show-text-'+uuid+'" value="1"></td>');
            html = html.concat('</tr>');
            html = html.concat('<tr>');
            html = html.concat('<td>Image:</td>');
            html = html.concat('<td>&nbsp;<input type="checkbox" id="local-app-button-show-icon-'+uuid+'" value="1"></td>');
            html = html.concat('</tr>');
            html = html.concat('</table>');
            html = html.concat('</td>');
            html = html.concat('<td class="local-app-button-section-move" id="local-app-button-move-'+uuid+'"><span class="local-app-button-section-move-icon fa fa-arrows-alt-v">&nbsp;</span></td>');
            html = html.concat('</tr>');
            html = html.concat('</table>');
            html = html.concat('<div id="local-app-button-options-section-'+uuid+'" class="local-app-button-section-options" style="display: block; height: 10em">');
            html = html.concat('<table class="local-app-button-content-table">');
            html = html.concat('<tr>');
            html = html.concat('<td>Content Type:</td>');
            html = html.concat('<td>');
            var content_type = jQuery('.local-app-blank-content-type').html();
            html = html.concat(content_type);
            html = html.concat('</td>');
            html = html.concat('</tr>');
            html = html.concat('<tr>');
            html = html.concat('<td>Content Source:</td>');
            html = html.concat('<td>');
            html = html.concat('<div class="local-app-content-type-parent" data-id="'+uuid+'">');
            var content_source = jQuery('.local-app-blank-content-source .local-app-content-type-parent').html();
            content_source = content_source.replace('data-id="blank"', 'data-id="'+uuid+'"');
            html = html.concat(content_source);
            html = html.concat('</div>');
            html = html.concat('</td>');
            html = html.concat('</tr>');
            html = html.concat('</table>');
            html = html.concat('<div class="local-app-button-delete-message"><a class="local-app-button-delete-message-text" onclick="local_app.remove_button(\''+uuid+'\')">Delete Button</a></div>');
            html = html.concat('</div>');
            html = html.concat('</div>');

            html = html.replace('blank_type_id', uuid);

            var icon_line = '<div id="bpm_'+uuid+'" style="bottom:105px;left:5px;width:80px;height:80px;" class="local-app-phone-image local-app-icon-image-no-frame local-app-icon-standards" data-cols="" data-id="'+uuid+'">';
            icon_line = icon_line.concat('<div class="local-app-icon-image local-app-icon-image-'+row_width+'"><img src="'+image_url+'" class="local-app-icon-image-frame local-app-icon-image-frame-'+row_width+'"></div>');
            icon_line = icon_line.concat('<div style="font-size:12px" class="local-app-icon-text local-app-icon-text-'+row_width+'">Button</div>');
            icon_line = icon_line.concat('</div>');

            jQuery('.local-app-phone-screen').append(icon_line);

            local_app.phone_sim_reorder_buttons();

            local_app.save_app_data(uuid , 'new_button' , 'new_button' , image_number);

            return html;
        }

        this.create_campaign_chart = function(){

            var ctx = document.getElementById("local-app-scan-chart").getContext("2d");

            if(ctx && local_app_params){

                var lineChartData = {
                    labels: local_app_params.labels,
                    datasets: [{
                        fillColor: "rgba(220,220,220,0)",
                        strokeColor: "rgba(220,180,0,1)",
                        pointColor: "rgba(220,180,0,1)",
                        data: local_app_params.scan_data.ios
                    }, {
                        fillColor: "rgba(151,187,205,0)",
                        strokeColor: "rgba(151,187,205,1)",
                        pointColor: "rgba(151,187,205,1)",
                        data: local_app_params.scan_data.android
                    }]
                };

                Chart.defaults.global.responsive = true;
                Chart.defaults.global.scaleLineColor = "black";
                Chart.defaults.global.scaleFontSize = 16;

                var ctx = document.getElementById("local-app-scan-chart").getContext("2d");
                var LineChartDemo = new Chart(ctx).Line(lineChartData, {
                    bezierCurve: false,
                    scaleShowVerticalLines: false,
                    scaleGridLineColor: "black"
                });

            }else{
                console.log('chart not found');
            }
        }

        this.show_preview_sent_message = function(){

        }

        this.validateEmail = function(mail)
        {
            if (/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(mail))
            {
                return (true)
            }
            return (false)
        }

        this.send_preview_to_phone = function() {

            //jQuery('#local-app-ios-preview-request-window').attr('disabled', 'disabled');
            local_app.send_preview_to_phone_execute();

        }

        this.send_preview_to_phone_execute = function(){

            if(local_app.validateEmail(jQuery('#local-app-user-email-address-window').val())) {

                jQuery('#local-app-get-email-error').hide();
                jQuery('#local-app-get-email-success').show();
                var data = {
                    'action': 'local_app_send_preview',
                    'email_address': jQuery('#local-app-user-email-address-window').val()
                };

                jQuery.post(ajaxurl, data, function (result) {
                    if (result) {
                        //show saved message
                        jQuery('#local-app-get-email-success').hide();
                        dialog.dialog( "close" );
                        jQuery('#local-app-ios-preview-request').removeAttr('disabled');
                        local_app.show_preview_sent_message();
                    }
                });
            }else{
                jQuery('#local-app-get-email-success').hide();
                jQuery('#local-app-get-email-error').show();
            }
        }

        this.show_preview_alert_message = function(){
            var html_data = jQuery('#local-app-preview-to-demo-app').html();
            html_data = html_data.replace('local-app-user-email-address' , 'local-app-user-email-address-window');
            html_data = html_data.replace('local-app-ios-preview-request' , 'local-app-ios-preview-request-window');

            local_app.show_alert_message(html_data , 600, 650, 'Preview On Your Phone');
        };

        this.show_alert_message = function(message , height , width , title, buttons){
            if(!height) height = 250;
            if(!width) width = 400;
            if(!title) title = 'Message';

            dialog = jQuery( "#local_app_dialog" ).dialog({
                closeOnEscape: false,
                height: height,
                width: width,
                modal: true,
                title: title,
                open: function(event, ui) {

                    jQuery(".ui-dialog-titlebar-close").hide();

                    var html_line = message;

                    jQuery('#local_app_dialog').html(html_line);

                },
                buttons: buttons
            });
        }

        this.create_growl = function(title, message) {

            var persistent = false;

            var position = {
                    target: [0, 0],
                    container: jQuery('#local-app-growl-container')
                };

            var target = jQuery('.qtip.jgrowl:visible:last');

            jQuery('<div/>').qtip({
                content: {
                    text: message
                },
                position: position,
                show: {
                    event: false,
                    ready: true,
                    effect: function () {
                        jQuery(this).stop(0, 1).animate({height: 'toggle'}, 400, 'swing');
                    },
                    delay: 0,
                    persistent: persistent
                },
                hide: {
                    event: false,
                    effect: function (api) {
                        jQuery(this).stop(0, 1).animate({height: 'toggle'}, 400, 'swing');
                    }
                },
                style: {
                    width: 250,
                    classes: 'qtip-bootstrap',
                    tip: false
                },
                events: {
                    render: function (event, api) {
                        if (!api.options.show.persistent) {
                            jQuery(this).bind('mouseover mouseout', function (e) {
                                    var lifespan = 5000;

                                    clearTimeout(api.timer);
                                    if (e.type !== 'mouseover') {
                                        api.timer = setTimeout(function () {
                                            api.hide(e)
                                        }, lifespan);
                                    }
                                })
                                .triggerHandler('mouseout');
                        }
                    }
                }
            });
        }

        this.close_onboarding = function(){

            var data = {
                'action': 'local_app_set_onboarding_status'
            };

            jQuery.post(ajaxurl, data, function (result) {
                if (result) {

                }
            });
        }

        this.show_onboarding = function() {

            if (jQuery('.local-app-button-section').length > 0) {
                var buttons = {
                        "Get the Previewer App": function(){
                            dialog.dialog( "close" );
                            local_app.show_preview_alert_message();
                        },
                        "Edit My App": function() {
                            dialog.dialog( "close" );
                            local_app.close_onboarding();
                        }
                    };

            }else{
                var buttons = {
                    "Edit My App": function () {
                        dialog.dialog("close");
                        local_app.close_onboarding();
                    }
                };
            }
            var html_line = jQuery('#local-app-onboarding').html();

            local_app.show_alert_message(html_line , 550 , 600, 'Welcome to your mobile app designer' , buttons);

        }

        this.hide_preview_dialog = function(){
            dialog.dialog( "close" );
        }



        this.set_media_to_custom = function(image_type){

            switch(image_type){
                case 1:
                    //button icon
                    jQuery('.media-router a:nth-child(2)').click();
                    jQuery('.media-router a:nth-child(3)').show();
                    jQuery('.media-router a:nth-child(4)').hide();
                    jQuery('.media-router a:nth-child(5)').hide();
                    break;
                case 2:
                    //background
                    jQuery('.media-router a:nth-child(2)').click();
                    jQuery('.media-router a:nth-child(3)').hide();
                    jQuery('.media-router a:nth-child(4)').show();
                    jQuery('.media-router a:nth-child(5)').hide();
                    break;
                case 3:
                    //placeholder
                    jQuery('.media-router a:nth-child(2)').click();
                    jQuery('.media-router a:nth-child(3)').hide();
                    jQuery('.media-router a:nth-child(4)').hide();
                    jQuery('.media-router a:nth-child(5)').show();
                    break;
                case 4:
                case 5:
                case 6:
                case 7:
                    jQuery('.media-router a:nth-child(2)').click();
                    jQuery('.media-router a:nth-child(3)').hide();
                    jQuery('.media-router a:nth-child(4)').hide();
                    jQuery('.media-router a:nth-child(5)').hide();
                    break;
            }

        }

        this.media_library_sets_list = function(){

            var html_line = '';
            var last_icon_class = '';
            var has_sets = true;

            if (typeof localapp_tsl_media_icons_sets === 'undefined' || !localapp_tsl_media_icons_sets) {
                last_icon_class = 'local-app-icon-set-item-last';
                has_sets = false;
            }

//            html_line = html_line.concat('<div class="local-app-icon-set-item local-app-help-topic-item-active '+last_icon_class+'" data-id="999999" onclick="local_app.show_icon_set(999999);">All Icons</div>');

            if(has_sets){
                jQuery(localapp_tsl_media_icons_sets).each(function(index , value){
                    if(index == localapp_tsl_media_icons_sets.length - 1) last_icon_class = 'local-app-icon-set-item-last';
                    html_line = html_line.concat('<div class="local-app-icon-set-item '+last_icon_class+'" data-id="'+index+'" onclick="local_app.show_icon_set('+index+');">'+value['name']+'</div>');
                })
            }

            return html_line;
        }

        this.show_icon_set = function(selected_item){

            jQuery('.tsl-image-button-select').attr('disabled', 'disabled');
            jQuery('.tsl-media-lib-select').removeClass('tsl-media-selected');

            jQuery('#tsl-icon-selector-background').css('background-color','white');

            jQuery('.local-app-icon-set-item').removeClass('local-app-help-topic-item-active');

            jQuery('.local-app-icon-set-item').each(function(){
                if(jQuery(this).data('id') == selected_item){
                    jQuery(this).addClass('local-app-help-topic-item-active');
                }
            })

            jQuery(localapp_tsl_media_icons_sets).each(function(index , value){
                if(index == selected_item) jQuery('#tsl-icon-selector-background').css('background-color', value['background']);
            });

            if(selected_item == 999999){
                //show all
                jQuery('.tsl-media-lib-icon-holder').show();
                jQuery('#tsl-icon-selector-background').css('background-color','#9e9e9e');
            }else {
                jQuery('.tsl-media-lib-icon-holder').each(function () {
                    if(jQuery(this).data('setid') == selected_item){
                        jQuery(this).show();
                    }else{
                        jQuery(this).hide();
                    }
                })
            }

        }

        this.create_media_library = function(library){

            jQuery('.tsl-media-lib-holder').remove();

            var html_line = '<div class="tsl-media-lib-holder">';

            switch(library){
                case 1:
                    //icons
                    html_line = html_line.concat('<table style="width:100%;">');



                    html_line = html_line.concat('<tr><td class="local-app-help-holder-topics" valign="top" style="width:200px;">'+this.media_library_sets_list()+'</td><td style="width:2em"></td> <td id="tsl-icon-selector-background" class="tsl-icon-selector-background" style="background-color: #9e9e9e" valign="top" >');
                    jQuery(localapp_tsl_media_icons.icons).each(function(index , value){
                        html_line = html_line.concat('<div class="tsl-media-lib-icon-holder" data-setid="'+value['set_id']+'"><img class="tsl-media-lib-icon-image tsl-media-lib-select " src="'+value['image_url'] +'"><p>'+value['image_name']+'</p></div>');
                    })

                    html_line = html_line.concat('</td></tr>');

                    html_line = html_line.concat('</table>');
                    break;
                case 2:
                    //backgrounds
                    jQuery(localapp_tsl_media_icons.backgrounds).each(function(index , value){
                        var name = '';
                        var parts = value.split('/');
                        name = parts[parts.length - 1];
                        var parts = name.split('.');
                        name = parts[0];
                        html_line = html_line.concat('<div class="tsl-media-lib-background-holder"><img class="tsl-media-lib-background-image tsl-media-lib-select" src="'+value+'" ><div class="tsl-media-lib-image-name">'+name+'</div></div>');
                    })
                    break;
                case 3:
                    //placeholders
                    jQuery(localapp_tsl_media_icons.placeholders).each(function(index , value){
                        html_line = html_line.concat('<div class="tsl-media-lib-placeholder-holder"><img class="tsl-media-lib-placeholder-image tsl-media-lib-select" src="'+value+'"></div>');
                    })
                    break;
            }

            html_line = html_line.concat('</div>');

            return html_line;

        };

        this.setup_media = function(){

            wp.media.view.MediaFrame.Select = wp.media.view.MediaFrame.Select.extend({

                browseRouter: function( routerView ) {
                  "use strict";

                  routerView.set({
                    upload: {
                      text:     "Upload",
                      priority: 20
                    },
                    browse: {
                      text:     "Media Library",
                      priority: 40
                    },
                    tsl_icons: {
                      text:     "TSL Icons",
                      priority: 50
                    }
                  });
                }
            });

            wp.media.view.Router = wp.media.view.Router.extend({
                select : function(id){
                  var view = this.get( id );
                  this.deselect();
                  if(view && view.$el)
                    view.$el.addClass('active');

                    setTimeout(function () {
                        jQuery('.tsl-image-button-select').remove();
                        jQuery('.media-toolbar-primary').append('<button class="button media-button button-primary button-large tsl-image-button-select" type="button" disabled>Select TSL Image</button>');
                    },100);
                     if(id == "tsl_icons"){
                        //unselect any currently selected image
                        jQuery('.tsl-image-button-select').show();
                        jQuery('.media-button-select').hide();

                        //show the icon library
                         setTimeout(function () {
                             jQuery(".media-frame-content").html(local_app.create_media_library(1));


                             jQuery('.tsl-image-button-select').unbind().on('click', function (e) {
                                //set selected image id

                                 //close modal window
                                 jQuery('.tsl-image-button-select').remove();
                                 jQuery('.media-modal-close').click();

                             });
                         }, 100);

                      }else if(id == "tsl_backgrounds"){
                        //unselect any currently selected image
                        jQuery('.tsl-image-button-select').show();
                        jQuery('.media-button-select').hide();

                        //show the icon library
                        setTimeout(function () {
                             jQuery(".media-frame-content").html(local_app.create_media_library(2));
                        }, 100);

                         jQuery('.tsl-image-button-select').unbind().click(function (e) {
                             //set selected image id

                             //close modal window
                             jQuery('.tsl-image-button-select').remove();
                             jQuery('.media-modal-close').click();
                         });

                     }else if(id == "tsl_placeholders"){
                        //unselect any currently selected image
                        jQuery('.tsl-image-button-select').show();
                        jQuery('.media-button-select').hide();

                         //show the icon library
                         setTimeout(function () {
                             jQuery(".media-frame-content").html(local_app.create_media_library(3));
                         }, 100);

                         jQuery('.tsl-image-button-select').unbind().click(function (e) {
                             //set selected image id

                             //close modal window
                             jQuery('.tsl-image-button-select').remove();
                             jQuery('.media-modal-close').click();
                         });

                      }else{
                         jQuery('.tsl-image-button-select').hide();
                         jQuery('.media-button-select').show();
                         selected_image_url = '';
                     }

                    setTimeout(function () {
                    jQuery('.tsl-media-lib-select').on('click', function(){
                        if(jQuery(this).hasClass('tsl-media-selected')){
                            jQuery(this).removeClass('tsl-media-selected');
                            jQuery('.tsl-image-button-select').attr('disabled', 'disabled');
                            selected_image_url = '';
                        }else {
                            jQuery('.tsl-media-lib-select').removeClass('tsl-media-selected');
                            jQuery(this).addClass('tsl-media-selected');
                            jQuery('.tsl-image-button-select').removeAttr('disabled');
                            selected_image_url = jQuery(this).prop('src');
                        }

                    });
                    }, 100);


                }
            });

        }

        this.local_app_notification_history = function(){

            jQuery('body').css('cursor','wait');

            if (!jQuery('#local_app_dialog').length) {
                jQuery('body').append('<div id="local_app_dialog"></div>');
            }

            var buttons = {
                "Close": function () {
                    dialog.dialog("close");
                }
            };

            var target_source = '';
            var target_type = '';
            if(localapp_notification_id){
                target_type = localapp_notification_id.type;
                target_source = localapp_notification_id.id;
            }

            var data = {
                'action'   : 'local_app_get_notification_history',
                'type'   : target_type,
                'source'   : target_source
            };

            jQuery.post(ajaxurl, data, function (result) {
                if(result){
                    var message = '<div style="overflow: auto;"><table style="width:100%;">';
                    jQuery(result).each( function(index, value){
                        message = message.concat('<tr><td colspan="2">'+value.message+'</td></tr>');
                        message = message.concat('<tr><td style="width:50%">Sent: '+value.send_date+'</td><td style="width:50%">By: '+value.sent_by_name+'</td></tr>');
                        message = message.concat('<tr><td colspan="2"><hr></td></tr>');
                    })
                    message = message.concat('</table></div>');

                    local_app.show_alert_message(message, 450, 500, "Notification History", buttons);
                    jQuery('body').css('cursor','default');
                }
            });

        }

        this.local_app_duplicate_notification = function(){

            var message = '<div style="overflow: auto;">';
            message = message.concat('<p>This was a duplicate notification so it was not processed.</p>');
            message = message.concat('</div>');

            var buttons = {
                "Close": function () {
                    dialog.dialog("close");
                }
            };

            local_app.show_alert_message(message, 300, 500, "Duplicate Notification", buttons);
        }

        this.local_app_send_app_notification = function(type){

            jQuery('body').css('cursor','wait');

            var target_source = '';

            /*var hours = jQuery('#local-app-send-hours option:selected').val();
            hours = this.pad_zeros(hours);
            hours = hours + ':00:00';

            var date_stamp  = new Date(jQuery('#local-app-send-date').datepicker('getDate'));
            var this_month = this.pad_zeros(date_stamp.getMonth() + 1);

            var date_value = date_stamp.getFullYear() + '-' + this_month + '-' + date_stamp.getDate() + ' ' + hours;*/
            var target_type = '';
            var target_name = '';
            var random_users  = 0;

            if(type==1) {
                if (typeof(localapp_notification_id) != "undefined"){
                    target_type = localapp_notification_id.type;
                    target_source = localapp_notification_id.id;
                }
            }else{
                //general
                target_source = jQuery('#local-app-notification-target option:selected').val();
                target_type = 'button';
                target_name = jQuery('#local-app-notification-title').val();
            }

            if(jQuery('#local-app-notification-random-count').length){
                random_users = jQuery('#local-app-notification-random-count').val();
            }

            var data = {
                'action'      : 'local_app_send_notification',
                'message'     : jQuery('#local-app-notification-message').val(),
                'type'        : target_type,
                //'date'        : date_value,
                'date'        : '',
                'target_name' : target_name,
                'page_type'   : type,
                'random_users': random_users,
                'source'      : target_source
            };

            jQuery.post(ajaxurl, data, function (result) {
                console.log(result);
                if(result){
                    dialog.dialog("close");
                    jQuery('#local-app-notification-history').show();
                    jQuery('#local-app-notification-message').val('');
                    jQuery('#local-app-notification-title').val('');
                    if(result.status == 'duplicate'){
                        local_app.local_app_duplicate_notification();
                    }
                }
                jQuery('body').css('cursor','default');
            });
        }

        this.pad_zeros = function(value){
            if(value < 10){
                value = '0' + value;
            }

            return value;
        }

        this.local_app_confirm_notification = function(type){

            if (!jQuery('#local_app_dialog').length) {
                jQuery('body').append('<div id="local_app_dialog"></div>');
            }

            var message_text = jQuery('#local-app-notification-message').val();
            var empty_message = false;

            if(message_text.length) {
                var buttons = {
                    "Continue": function () {
                        local_app.local_app_send_app_notification(type);
                    },
                    "Cancel": function () {
                        dialog.dialog("close");
                    }
                };
            }else{
                var buttons = {
                    "Cancel": function () {
                        dialog.dialog("close");
                    }
                };
                message_text = 'No Message entered.  Please try again.';
                empty_message = true;
            }


            //var message_date = jQuery('#local-app-send-date').datepicker({ dateFormat: 'dd-mm-yy'}).val()  + ' at ' + jQuery('#local-app-send-hours option:selected').text();
            var message_target = '';
            var message_title = null;

            if(type==2){
                //general
                if(jQuery('#local-app-notification-target').val() < 999){
                    message_target = jQuery('#local-app-notification-target option:selected').text();
                }
                message_title = jQuery('#local-app-notification-title').val();
            }

            var message = '<div class="local-app-notification-confirmation">';
            if(empty_message){
                message = message.concat('<p style="font-weight: bold">' + message_text + '</p>');
            }else {
                message = message.concat('<p>The following notification will be sent to your iPhone and Android users:</p>');

                if(message_title){
                    message = message.concat('<p>The message title for Android is:</p>');
                    message = message.concat('<p style="font-weight: bold">'+message_title + '</p>');
                }
                message = message.concat('<p>The message body is:</p>');
                message = message.concat('<p style="font-weight: bold">' + message_text + '</p>');
                if (message_target) {
                    message = message.concat('<p>The notification will open the <span style="font-weight: bold">' + message_target + '</span> button on the app.</p>');
                } else {
                    if(type==1) {
                        message = message.concat('<p>The notification will open this page on the app.</p>');
                    }else{
                        message = message.concat('<p>The notification will be a general notice and will not open content on the app.</p>');
                    }
                }
                //message = message.concat('<p>Scheduled date and time:  ');
                //message = message.concat('<span style="font-weight: bold">' + message_date + '</span></p>');
                //message = message.concat('<p>Notifications scheduled at or before the current date and time will be sent immediately. Otherwise, the notification will be sent at the selected date and time.</p>');
            }
            message = message.concat('</div>');

            local_app.show_alert_message(message, 550, 500, "Confirm Notification", buttons);
        }

        this.resize_image = function(image_id, size, element){
            var bg = jQuery('.'+element).prev('table').find('input[class="mam-color-picker"]').val();
            var data = {
                'action': 'local_app_resize_image',
                'image_id' : image_id,
                'size' : size,
                'bg' : bg,
            };

            jQuery.post(ajaxurl, data, function (result) {
                if (result.status == 200) {
                    jQuery('.'+element).html('<img src="' + result.attach_url + '" style="width:250px;height:250px;">');
                    //local_app.save_app_image(element, result.attach_id);
                    jQuery('.'+element).next('input[name="'+element+'"]').val(result.attach_id);
                }
            });
        }

    }

}

function setUrlParameter(key, value) {
  const url = new URL(window.location.href);  // Create a URL object with the current location
  url.searchParams.set(key, value);  // Set the key-value pair in the query string
console.log(url.toString());
  // Update and reload the browser location
  window.location.href = url.toString();
}

jQuery(document).ready(function(){

    jQuery('span[title]').qtip({
        style: {
            classes: 'qtip-bootstrap'
        },
        position: {
            viewport: jQuery(window)
        }});
    jQuery('a[title]').qtip({
        style: {
            classes: 'qtip-bootstrap'
        },
        position: {
            viewport: jQuery(window)
        }});
    jQuery('td[title]').qtip({
        style: {
            classes: 'qtip-bootstrap'
        },
        position: {
            viewport: jQuery(window)
        }});
    jQuery('img[title]').qtip({
        style: {
            classes: 'qtip-bootstrap'
        },
        position: {
            viewport: jQuery(window)
        }});
    jQuery('input[title]').qtip({
        style: {
            classes: 'qtip-bootstrap'
        },
        position: {
            viewport: jQuery(window)
        }});

    jQuery('.gif').gifplayer();

    jQuery( ".local-app-datepicker" ).datepicker();
    jQuery( ".local-app-datepicker" ).datepicker("setDate", "-0d");

    jQuery('#mam-not-send-test').click( function ()
    {

        const queryString = window.location.search;
        const urlParams = new URLSearchParams(queryString);

        var email = 0;
        if(jQuery("#email").is(':checked'))
        {
            email = 1;
        }
        var pn = 0;
        if(jQuery("#pn").is(':checked'))
        {
            pn = 1;
        }
        var sms = 0;
        if(jQuery("#text_msg").is(':checked'))
        {
            sms = 1;
        }

        var data = {
            'action': 'mam_main_send_test_not',
            'slug': urlParams.get('slug'),
            'subject': jQuery( '#subject').val(),
            'email_content': jQuery( '#email_content').val(),
            'pn_content': jQuery( '#pn_content').val(),
            'text_content': jQuery( '#text_content').val(),
            'email': email,
            'pn': pn,
            'sms':sms,
            'user_id': jQuery( '#mam-user-id' ).val()
        };

        jQuery.post(ajaxurl, data, function (result) {
            if (result) {
                jQuery('#mam-not-message-sent').show().fadeOut(5000);
            }
        })

    })

    try {

        local_app = new local_app;
        if(localapp_editor && localapp_editor == '1'){
            local_app.setup_media();
        }
        local_app.set_buttons_sortable();

        jQuery( ".local-app-tour-datepicker" ).datepicker({
            onSelect: function(dateText) {
                 jQuery('#local-app-tour-save-button').removeAttr('disabled');
            }
        });


        // if(localapp_status.status == 0){
        //     local_app.show_onboarding();
        // }

        if(jQuery('#local-app-scan-chart').length) {
            local_app.create_campaign_chart();
        }

        if ( typeof(localapp_tsl_membercard_info) !== "undefined" && localapp_tsl_membercard_info !== null ) {
            local_app.set_membership_card_handlers();
        }



    }catch(err){
        alert(err.message);
    }

    jQuery('#mam-clone-role-content').on("click", function(){
        var this_element = jQuery(this);
        this_element.addClass('processing');

        var data = {
            'action': 'mam_clone_role_content'
        };

        data['form'] = jQuery(this).parents('form').serialize();

        jQuery.post(ajaxurl, data, function (result) {
            this_element.removeClass('processing');
            if (result.status == 200) {
                local_app.create_growl("Changes Saved", result.message);
                setTimeout(function(){
                    window.location.reload();
                }, 3000);
            }else{
                local_app.create_growl("Error!", result.message);
                jQuery("#local-app-growl-container .qtip").css("background-color", "#ff0000");
            }
        });

    });
});
